var g_functionNameThatWillBeCalled = "";
var g_functionThatWillBeCalled = null;
var g_globalContext;
var g_isCustomCacheInitialized;
var g_customIdCache;
var g_crtCustomIdValue;
if (g_isCustomCacheInitialized !== true) {
    g_isCustomCacheInitialized = true;
    g_customIdCache = {};
    g_crtCustomIdValue = 0;
}

function WrapInjectedFunction(funcName, func) {
    g_functionNameThatWillBeCalled = funcName;
    g_functionThatWillBeCalled = func;
}

function WrapInGlobalContext(func) {
    if ("undefined" == typeof g_globalContext) {
        g_globalContext = {};
    }
    g_globalContext.__EnrichContextFunc = func;
    g_globalContext.__EnrichContextFunc();
    g_globalContext.__EnrichContextFunc = null;
}
//xbrowser
WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.xbrowser = function () {
        var isMozilla = false;
        var isEdgeBrowser = false;
        var modeSingleFrame = false;
        var isIOSplatform = false;
        var chromeVersion = 0;
        return {
            init: function () {
                isEdgeBrowser = typeof CSS !== 'undefined' && CSS.supports("(-ms-ime-align:auto)");
                isMozilla = window.mozInnerScreenX !== undefined;
                chromeVersion = parseInt((/Chrome\/([0-9]+)/.exec(navigator.userAgent) || ["0", "0"])[1]);
                modeSingleFrame = isEdgeBrowser || (chromeVersion > 0 && chromeVersion < 41);
                if (chrome.tabs && !chrome.tabs.getSelected) {
                    chrome.tabs.getSelected = function (wndId, response) {
                        return chrome.tabs.query({active: true, windowId: wndId}, function (tabsArray) {
                            response(tabsArray[0]);
                        });
                    };
                }
                if (chrome.extension && !chrome.extension.onMessage) {
                    chrome.extension.onMessage = {
                        addListener: function (callback) {
                            return chrome.runtime.onMessage.addListener(callback);
                        }, removeListener: function (callback) {
                            return chrome.runtime.onMessage.removeListener(callback);
                        }
                    };
                }
                if (chrome.tabs && !chrome.tabs.getZoom) {
                    chrome.tabs.getZoom = function (tabId, callback) {
                        gcontext.TraceMessage("Warning: chrome.tabs.getZoom() is undefined. Return 100% zoom. User Agent: " + navigator.userAgent);
                        callback(1);
                    };
                }
                var iDevices = ['iPad Simulator', 'iPhone Simulator', 'iPod Simulator', 'iPad', 'iPhone', 'iPod'];
                if (navigator.platform) {
                    while (iDevices.length) {
                        if (navigator.platform === iDevices.pop()) {
                            isIOSplatform = true;
                        }
                    }
                }
            }, tabs: {
                sendMessage: function (tabId, message, frameId, responseCallback) {
                    gcontext.TraceMessage("Single frame mode: \"" + modeSingleFrame + "\", userAgent: " + navigator.userAgent);
                    if (modeSingleFrame) {
                        chrome.tabs.sendMessage(tabId, message, responseCallback);
                    } else {
                        chrome.tabs.sendMessage(tabId, message, {frameId: frameId}, responseCallback);
                    }
                }
            }, isFirefox: function () {
                return isMozilla
            }, isEdge: function () {
                return isEdgeBrowser
            }, isModeSingleFrame: function () {
                return modeSingleFrame;
            }, isIOS: function () {
                return isIOSplatform;
            }
        }
    }();
    gcontext.xbrowser.init();
});

WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.g_traceEnabled = false;
    gcontext.EnableTracing = function () {
        gcontext.g_traceEnabled = true;
    }
    gcontext.EnableContentTracing = function () {
        onEnableContentTracing();
    }
    gcontext.DisableTracing = function () {
        gcontext.g_traceEnabled = false;
    }
    gcontext.IsTracingEnabled = function () {
        return gcontext.g_traceEnabled;
    }
    gcontext.TraceMessage = function (msg) {
        if (gcontext.g_traceEnabled) {
            try {
                console.log("[Background] : " + msg);
            } catch (e) {
            }
        }
    }
    gcontext.DebugMessage = function (msg) {
        if (gcontext.g_traceEnabled) {
            try {
                console.log("[Debug Background] : " + msg);
            } catch (e) {
            }
        }
    }
    gcontext.TraceError = function (msg) {
        if (gcontext.g_traceEnabled) {
            try {
                console.error("[Background] : " + msg);
            } catch (e) {
            }
        }
    }
    gcontext.EnumObjectProps = function (obj, enumValues) {
        if (obj == null) {
            return "<null object>";
        }
        var msg = "";
        for (var prop in obj) {
            var crtObj = null;
            try {
                crtObj = obj[prop];
            } catch (e) {
                crtObj = null;
            }
            if (crtObj == null) {
                continue;
            }
            var propVal = "";
            if (typeof (crtObj) === "function") {
                propVal = "function {...}";
            } else if (crtObj.toString == null) {
                propVal = "<" + typeof (crtObj) + ">";
            } else {
                var MAX_VAL = 30;
                propVal = crtObj.toString();
                if (propVal.length > MAX_VAL) {
                    propVal = propVal.slice(0, MAX_VAL) + "...";
                }
            }
            msg += prop;
            msg += (enumValues === true ? "=[" + propVal + "]\n" : ", ");
        }
        return msg;
    }
});

var N_TRUE = 1;
var N_FALSE = 0;
WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.MatchChars = function (c1, c2) {
        // empty pattern like ' ' or /s+
        var bpsPattern = c1.replace(/\s+/ig, "");
        if (bpsPattern === "") {
            var bpsText = c2.replace(/\s+/ig, "");
            return (bpsText === "");
        }

        return (c1 === '?') || (c1 === c2);
    }
    gcontext.MatchCharsPrefix = function (c1, c2) {
        return (c1 === '?') || (c2 === '?') || (c1 === c2);
    }
    gcontext.ComputePrefixFunction = function (pattern, beginPattern, patternLen) {
        var state = -1;
        var pi = new Array(patternLen);
        pi[0] = state;
        var i;
        for (i = 1; i < patternLen; ++i) {
            while (state > -1 && !gcontext.MatchCharsPrefix(pattern[beginPattern + state + 1], pattern[beginPattern + i])) {
                state = pi[state];
            }
            if (gcontext.MatchCharsPrefix(pattern[beginPattern + i], pattern[beginPattern + state + 1])) {
                state++;
            }
            pi[i] = state;
        }
        return pi;
    }
    gcontext.StringWildcardMatch = function (psPattern, psText, caseSensitive) {
        caseSensitive = typeof caseSensitive === "undefined" ? true : caseSensitive;
        if (psPattern == null) {
            psPattern = "";
        }
        if (psText == null) {
            psText = "";
        }

        gcontext.TraceMessage("StrWildcardMatch(psPattern: \"" + psPattern + "\" psText: \"" + psText + "\" caseSensitive: " + caseSensitive.toString() + ")");
        // psPattern is null, return true ?
        if (psPattern === "") {
            // return (psText === "");
            return true;
        }

        if (!caseSensitive) {
            psPattern = psPattern.toLowerCase();
            psText = psText.toLowerCase();
        }

        var beginPattern = 0;
        var beginText = 0;
        var endPattern = psPattern.length - 1;
        var endText = psText.length - 1;

        // if the pattern is not begining with '*'
        // then match the prefix
        if (psPattern[beginPattern] != '*') {
            while (psPattern[beginPattern] != '*' && beginPattern <= endPattern && beginText <= endText) {
                if (!gcontext.MatchChars(psPattern[beginPattern], psText[beginText])) {
                    return false;
                }
                ++beginPattern;
                ++beginText;
            }
        }

        // if the pattern is not ending with '*'
        // then match the suffix
        if (psPattern[endPattern] != '*') {
            while (psPattern[endPattern] != '*' && beginPattern <= endPattern && beginText <= endText) {
                if (!gcontext.MatchChars(psPattern[endPattern], psText[endText])) {
                    return false;
                }
                --endPattern;
                --endText;
            }
        }

        // if there are no more characters in the pattern
        // then there was no '*' character, in which case
        // the string should have matched completely
        if (beginPattern > endPattern) {
            return (beginText > endText);
        }

        // the pattern should look like *s1*s2*...*sn*
        // if not, the string does not match the pattern
        if (psPattern[beginPattern] != '*' || psPattern[endPattern] != '*') {
            return false;
        }

        while (beginPattern <= endPattern) {
            while (psPattern[beginPattern] == '*' && beginPattern <= endPattern) {
                beginPattern++;
            }
            if (beginPattern > endPattern) {
                break;
            }
            var substrLen = 0;
            while (psPattern[beginPattern + substrLen] != '*') {
                ++substrLen;
            }
            var pi = gcontext.ComputePrefixFunction(psPattern, beginPattern, substrLen);
            var state = -1;
            var canMatch = false;
            for (; beginText <= endText; ++beginText) {
                while (state > -1 && !gcontext.MatchChars(psPattern[beginPattern + state + 1], psText[beginText])) {
                    state = pi[state];
                }
                if (gcontext.MatchChars(psPattern[beginPattern + state + 1], psText[beginText])) {
                    state++;
                }
                if (state == substrLen - 1) {
                    canMatch = true;
                    break;
                }
            }

            // we could not find a match
            // therefore the string does not match the pattern
            if (!canMatch) {
                return false;
            }
            beginPattern += substrLen;
            ++beginText;
        }
        return true;
    }
    gcontext.DeleteForbiddenCharacters = function (text) {
        if (text == null || text.length === 0) {
            return "";
        }
        var out_text = text.replace(/\r/g, " ");
        out_text = out_text.replace(/\n/g, " ");
        return out_text;
    }
    gcontext.TruncateStringUsingWildcard = function (text, maxLen) {
        if (text == null) {
            return "";
        }
        if (text.length <= maxLen) {
            return text;
        }
        var out_text = text.slice(0, maxLen);
        out_text += "*";
        return out_text;
    }
    gcontext.ConcatObjects = function (o1, o2) {
        var result = {};
        if (o1 != null) {
            result = o1;
        }
        if (o2 != null) {
            for (var prop in o2) {
                result[prop] = o2[prop];
            }
        }
        return result;
    }
    gcontext.IsObjectEmpty = function (obj) {
        if (obj == null) {
            return true;
        }
        for (var prop in obj) {
            if (obj.hasOwnProperty(prop)) {
                return false;
            }
        }
        return true;
    }
    gcontext.TrimWhiteSpaces = function (text) {
        // Trim the standard white spaces.
        var out_text = text.trim();

        // Trim special white space characters.
        var whiteSpaceCodes = [0x200E, 0x2022];
        while (out_text.length !== 0 && whiteSpaceCodes.indexOf(out_text.charCodeAt(0)) !== -1) {
            out_text = out_text.slice(1);
        }

        while (out_text.length !== 0 && whiteSpaceCodes.indexOf(out_text.charCodeAt(out_text.length - 1)) !== -1) {
            out_text = out_text.slice(0, out_text.length - 1);
        }

        return out_text;
    }
    gcontext.IsWhiteSpaceCharacter = function (ch) {
        return ch === '\t' || ch === '\r' || ch === '\n' || ch === ' ' || ch === '\u200E' || ch === '\u2022';
    }
    gcontext.UiRect = function UiRect(left, top, width, height) {
        return {
            left: left, top: top, right: left + width, bottom: top + height, getWidth: function () {
                return this.right - this.left;
            }, getHeight: function () {
                return this.bottom - this.top;
            }, Intersects: function (rc2) {
                return (this.right > rc2.left && this.left < rc2.right) && (this.bottom > rc2.top && this.top < rc2.bottom);
            }, Contains: function (point) {
                return ((point.x >= this.left && point.x <= this.right) && (point.y >= this.top && point.y <= this.bottom));
            }, Scale: function (factor) {
                return UiRect(this.left * factor, this.top * factor, this.getWidth() * factor, this.getHeight() * factor);
            }, ScaleInv: function (factor) {
                return UiRect(this.left / factor, this.top / factor, this.getWidth() / factor, this.getHeight() / factor);
            }, IsEqual: function (rc2) {
                return this.left === rc2.left && this.top === rc2.top && this.right === rc2.right && this.bottom === rc2.bottom;
            }, Offset: function (dx, dy) {
                return UiRect(this.left + dx, this.top + dy, this.getWidth(), this.getHeight());
            }, MathRound: function () {
                return UiRect(Math.round(this.left), Math.round(this.top), Math.round(this.getWidth()), Math.round(this.getHeight()));
            }, Union: function (rc2) {
                var resultLeft = Math.min(this.left, rc2.left);
                var resultTop = Math.min(this.top, rc2.top);
                var resultRight = Math.max(this.right, rc2.right);
                var resultBottom = Math.max(this.bottom, rc2.bottom);
                return UiRect(resultLeft, resultTop, resultRight - resultLeft, resultBottom - resultTop);
            }, ContainsRect: function (rc2) {
                var p1 = {x: rc2.left, y: rc2.top};
                var p2 = {x: rc2.left, y: rc2.bottom};
                var p3 = {x: rc2.right, y: rc2.top};
                var p4 = {x: rc2.right, y: rc2.bottom};
                return this.Contains(p1) && this.Contains(p2) && this.Contains(p3) && this.Contains(p4);
            }, toString: function () {
                return "(" + left + " " + top + " " + width + " " + height + ")";
            }
        };
    }
    gcontext.RectToString = function (rect) {
        return "[" + rect.left + " " + rect.top + " " + rect.right + " " + rect.bottom + "]";
    }
    gcontext.UnformatSpecialJsCharacters = function (code) {
        var out_unformattedCode = code;
        out_unformattedCode = out_unformattedCode.replace(/%CR%/g, "\r");
        out_unformattedCode = out_unformattedCode.replace(/%LF%/g, "\n");
        return out_unformattedCode
    }
    gcontext.ExecuteWithRetry = function (predicateFunc, coreFunc, debugTag) {
        var initTimeout = 30000;
        var timeout = 100;
        var maxTries = initTimeout / timeout;
        var fnWrapper = function () {
            if (predicateFunc() === true) {
                coreFunc();
            } else {
                maxTries--;
                if (maxTries >= 0) {
                    gcontext.TraceMessage("ExecuteWithRetry: condition for " + debugTag + " is false; retrying later");
                    setTimeout(fnWrapper, timeout);
                } else {
                    gcontext.TraceMessage("ExecuteWithRetry: timed out while waiting to execute '" + debugTag + "'");
                }
            }
        };
        fnWrapper();
    }
    gcontext.Stopwatch = function () {
        var m_startTime;
        var m_msTimeout;
        var m_bTimeoutElapsed;
        return {
            Start: function (msTimeout) {
                m_msTimeout = msTimeout;
                m_bTimeoutElapsed = N_FALSE;
                m_startTime = new Date().getTime();
            }, TimeoutElapsed: function () {
                if (m_bTimeoutElapsed === N_FALSE) {
                    var crtTime = new Date().getTime();
                    if (crtTime - m_startTime > m_msTimeout)
                        m_bTimeoutElapsed = N_TRUE;
                }
                return m_bTimeoutElapsed;
            }
        };
    }
    gcontext.ChainCalls = function (arr, onEach, onFinal) {
        var isNonEmptyArr = arr && ("number" === typeof (arr.length)) && 0 !== arr.length;
        var max = isNonEmptyArr ? arr.length : 0;
        var process = function (i) {
            if (max === i) {
                onFinal(true, max);
            } else {
                var next = function (itsOk) {
                    if ('boolean' === typeof itsOk && !itsOk) {
                        onFinal(false, i);
                    } else {
                        process(i + 1);
                    }
                }
                onEach(next, i);
            }
        }
        process(0);
    }
});

WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.MAX_ATTR_LEN = 64;
    gcontext.UIE_CF_CLICK_MASK = 0x00000003;
    gcontext.UIE_CF_SINGLE = 0x00000000;
    gcontext.UIE_CF_DOUBLE = 0x00000001;
    gcontext.UIE_CF_HOVER = 0x00000002;
    gcontext.UIE_CF_BUTTON_MASK = 0x0000000C;
    gcontext.UIE_CF_LEFT = 0x00000000;
    gcontext.UIE_CF_RIGHT = 0x00000004;
    gcontext.UIE_CF_MIDDLE = 0x00000008;
    gcontext.UIE_CF_SCREEN_COORDS = 0x00000010;
    gcontext.UIE_CF_DOWN = 0x00001000;
    gcontext.UIE_CF_UP = 0x00002000;
    gcontext.UIE_CF_MOD_CTRL = 0x00004000;
    gcontext.UIE_CF_MOD_ALT = 0x00008000;
    gcontext.UIE_CF_MOD_SHIFT = 0x00010000;
    gcontext.HTML_LEFT_BUTTON = 0;
    gcontext.HTML_MIDDLE_BUTTON = 1;
    gcontext.HTML_RIGHT_BUTTON = 2;
    gcontext.HTML_CLICK_SINGLE = 0;
    gcontext.HTML_CLICK_DOUBLE = 1;
    gcontext.HTML_CLICK_HOVERONLY = 2;
    gcontext.CLICK_OFFSET_X = 2;
    gcontext.CLICK_OFFSET_Y = 2;
    gcontext.UI_EVENT = 0;
    gcontext.g_skipAttrInCompatible = ['css-selector', 'readystate', 'role', 'selecteditems', 'url'];
    gcontext.g_getCustomAttrMap = {
        "url": function (elem) {
            if (elem.ownerDocument)
                return elem.ownerDocument.URL;
            return "";
        }, "htmlwindowname": function (elem) {
            if (window.name) {
                return window.name;
            } else {
                return "";
            }
        }, "title": function (elem) {
            if (elem.ownerDocument)
                return elem.ownerDocument.title;
            return "";
        }, "cookie": function (elem) {
            if (elem.ownerDocument)
                return elem.ownerDocument.cookie;
            return "";
        }, "readystate": function (elem) {
            if (!elem.ownerDocument || elem.ownerDocument.readyState !== "complete") {
                return "0";
            }
            if (gcontext.IsSapFioriElement(elem)) {
                return gcontext.GetSapReadyState(elem);
            }
            return "1";
        }, "innertext": function (elem) {
            return gcontext.DeleteForbiddenCharacters(elem.textContent);
        }, "innertextshort": function (elem) {
            return gcontext.GetAttributeShortValue(elem, "innertext");
        }, "outertext": function (elem) {
            return gcontext.DeleteForbiddenCharacters(elem.textContent);
        }, "outertextshort": function (elem) {
            return gcontext.GetAttributeShortValue(elem, "outertext");
        }, "innerhtml": function (elem) {
            return elem.innerHTML;
        }, "innerhtmlshort": function (elem) {
            return gcontext.GetAttributeShortValue(elem, "innerhtml");
        }, "outerhtml": function (elem) {
            return elem.outerHTML;
        }, "outerhtmlshort": function (elem) {
            return gcontext.GetAttributeShortValue(elem, "outerhtml");
        }, "tag": function (elem) {
            return elem.tagName;
        }, "parentid": function (elem) {
            return gcontext.GetParentAttributeValue(elem, "id");
        }, "parentname": function (elem) {
            return gcontext.GetParentAttributeValue(elem, "name");
        }, "parentclass": function (elem) {
            return gcontext.GetParentAttributeValue(elem, "class");
        }, "parenttag": function (elem) {
            return elem.parentNode ? elem.parentNode.tagName : "";
        }, "tablerow": function (elem) {
            var r = gcontext.GetTableRowAndCol(elem, {getRow: true}).row;
            return r < 0 ? "" : r;
        }, "tablecol": function (elem) {
            var c = gcontext.GetTableRowAndCol(elem, {getCol: true}).col;
            return c < 0 ? "" : c;
        }, "rowname": function (elem) {
            return gcontext.GetTableRowName(elem);
        }, "colname": function (elem) {
            return gcontext.GetTableColName(elem);
        }, "columncount": function (elem) {
            return gcontext.GetTableColCount(elem);
        }, "rowcount": function (elem) {
            return gcontext.GetTableRowCount(elem);
        }, "checked": function (elem) {
            return gcontext.GetCheckedAttribute(elem);
        }, "role": function (elem) {
            return "element";
        }, "aastate": function (elem) {
            if (elem.disabled === true)
                return "disabled";
            return "enabled";
        }, "aaname": function (elem) {
            return gcontext.getAccName(elem);
        }, "aanameshort": function (elem) {
            return gcontext.GetAttributeShortValue(elem, "aaname");
        }, "css-selector": function (elem) {
            return gcontext.getCssSelector(elem);
        }, "xpath": function (elem) {
            return gcontext.getXpathSelector(elem);
        }, "selecteditem": function (elem) {
            return gcontext.GetSelectedItemTxt(elem);
        }, "selecteditems": function (elem) {
            return gcontext.GetSelectedItemsTxt(elem);
        }, "isleaf": function (elem) {
            return (gcontext.isLeafElement(elem) ? "1" : "0");
        }, "ui5-id": function (elem) {
            return gcontext.GetSapId(elem);
        }, "ui5-class": function (elem) {
            return gcontext.GetSapClass(elem);
        }, "ui5-role": function (elem) {
            return gcontext.GetSapRole(elem);
        }, "ui5-type": function (elem) {
            return gcontext.GetSapType(elem);
        }, "ui5-label": function (elem) {
            return gcontext.GetSapLabel(elem);
        }, "ui5-tooltip": function (elem) {
            return gcontext.GetSapTooltip(elem);
        }, "ui5-tablerow": function (elem) {
            return gcontext.GetSapTableRowIndex(elem);
        }, "ui5-tablecol": function (elem) {
            return gcontext.GetSapTableColIndex(elem);
        }, "aria-role": function (elem) {
            return elem.getAttribute("role")
        },
    };
    gcontext.GetSelectedItemTxt = function (e) {
        var items = gcontext.GetSelectedItems(e, 0);
        if (items && items.length > 0) {
            return items[0];
        }
        return "";
    }
    gcontext.GetSelectedItemsTxt = function (e) {
        var items = gcontext.GetSelectedItems(e, 0);
        var txt = "";
        for (var i = 0; i < items.length; ++i) {
            if (txt) {
                txt = txt + ", ";
            }
            txt = txt + "\"";
            txt = txt + items[i];
            txt = txt + "\"";
        }
        txt = "{ " + txt;
        txt = txt + " }";
        return txt;
    }
    gcontext.IsBrowserSettingsUrl = function (url) {
        if (url && ((url.indexOf("chrome://") === 0) || (url.indexOf("edge://") === 0) || (url.indexOf("about:") === 0))) {
            return true;
        }
        return false;
    }
    gcontext.GetAttributeValue = function (element, attrName) {
        var out_attrValue = "";
        var getCustomAttrFunc = gcontext.g_getCustomAttrMap[attrName.toLowerCase()];
        var rawAttrVal;
        var sapAttrPrefix = gcontext.g_sapFioriDefines.propertyBasedAttrPrefix;
        if (getCustomAttrFunc != null)
            rawAttrVal = getCustomAttrFunc(element); else if (attrName.slice(0, sapAttrPrefix.length) === sapAttrPrefix)
            rawAttrVal = gcontext.GetSapPropertyBasedAttribute(element, attrName); else
            rawAttrVal = element.getAttribute(attrName);
        if (typeof (rawAttrVal) === "boolean")
            out_attrValue = (rawAttrVal ? "1" : "0"); else if (rawAttrVal != null && rawAttrVal.toString != null)
            out_attrValue = rawAttrVal.toString();
        return out_attrValue;
    }
    gcontext.GetParentAttributeValue = function (element, attrName) {
        var out_attrValue = "";
        gcontext.ForEachAncestor(element, function (crtAncestor) {
            out_attrValue = gcontext.GetAttributeValue(crtAncestor, attrName);
            if (out_attrValue.length !== 0) {
                return false;
            }
            return true;
        });
        return out_attrValue;
    }
    gcontext.GetParentByTag = function (element, tagName) {
        var out_parentElem = null;
        gcontext.ForEachAncestor(element, function (crtAncestor) {
            if (crtAncestor.tagName.toLowerCase() === tagName) {
                out_parentElem = crtAncestor;
                return false;
            }
            return true;
        });
        return out_parentElem;
    }
    gcontext.GetFirstChildText = function (parentElem, tag, index) {
        var children = parentElem.getElementsByTagName(tag);
        if (children == null) {
            return "";
        }
        if (index > children.length - 1) {
            return "";
        }
        var text = children.item(index).textContent;
        return gcontext.DeleteForbiddenCharacters(text);
    }
    gcontext.GetTableRowCount = function (e) {
        var tagName = e.tagName.toLowerCase();
        if (tagName !== "table") {
            return "";
        }
        var rows = e.getElementsByTagName("tr");
        if (rows !== null) {
            return rows.length.toString();
        }
        return "";
    }
    gcontext.GetTableColCount = function (e) {
        var tagName = e.tagName.toLowerCase();
        if (tagName !== "table") {
            return "";
        }
        var rows = e.getElementsByTagName("tr");
        if ((rows !== null) && (rows.length > 0)) {
            var tds = rows.item(0).getElementsByTagName("td");
            if ((tds !== null) && (tds.length > 0)) {
                return tds.length.toString();
            }
            var ths = rows.item(0).getElementsByTagName("th");
            if ((ths !== null) && (ths.length > 0)) {
                return ths.length.toString();
            }
        }
        return "";
    }
    gcontext.GetTableRowName = function (elem) {
        var parentRow = gcontext.GetParentByTag(elem, "tr");
        if (!parentRow) {
            return "";
        }
        var text = gcontext.GetFirstChildText(parentRow, "th", 0);
        if (text === "") {
            text = gcontext.GetFirstChildText(parentRow, "td", 0);
        }
        return text;
    }
    gcontext.GetTableColName = function (elem) {
        var table = gcontext.GetParentByTag(elem, "table");
        if (!table) {
            return "";
        }
        var colIndex = gcontext.GetTableRowAndCol(elem, {getCol: true}).col;
        if (colIndex < 1) {
            return "";
        }
        var text = gcontext.GetFirstChildText(table, "th", colIndex - 1);
        if (text === "") {
            text = gcontext.GetFirstChildText(table, "td", colIndex - 1);
        }
        return text;
    }
    gcontext.GetTableRowAndCol = function (cellElem, inputFlags) {
        var out_rowAndCol = {row: -1, col: -1};
        var tagName = cellElem.tagName.toLowerCase();
        if (tagName !== "td" && tagName !== "th") {
            var parentCell = gcontext.GetParentByTag(cellElem, "td");
            if (parentCell === null) {
                parentCell = gcontext.GetParentByTag(cellElem, "th");
                if (parentCell === null) {
                    return out_rowAndCol;
                }
            }
            cellElem = parentCell;
        }
        var rowParent = gcontext.GetParentByTag(cellElem, "tr");
        if (rowParent == null)
            return out_rowAndCol;
        if (inputFlags.getCol === true)
            out_rowAndCol.col = gcontext.ComputeIndexInParent(cellElem, rowParent);
        if (inputFlags.getRow === true) {
            var tableParent = gcontext.GetParentByTag(rowParent, "table");
            if (tableParent == null)
                return out_rowAndCol;
            out_rowAndCol.row = gcontext.ComputeIndexInParent(rowParent, tableParent);
        }
        return out_rowAndCol;
    }
    gcontext.ComputeIndexInParent = function (element, parent) {
        var out_index = -1;
        var i;
        var refCustomId = gcontext.GenerateCustomIdForElement(element);
        var children = parent.getElementsByTagName(element.tagName);
        if (children == null)
            return out_index;
        for (i = 0; i < children.length; ++i) {
            if (gcontext.GetCustomIdForElement(children.item(i)) === refCustomId) {
                out_index = i + 1;
                break;
            }
        }
        return out_index;
    };
    gcontext.FindElementUsingXpath = function (xpath, root) {
        var doc = root || document;
        var out_element = [];
        var xresult = doc.evaluate(xpath, doc, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
        var currentNode;
        while (currentNode = xresult.iterateNext()) {
            out_element.push(currentNode);
        }
        return out_element;
    };
    gcontext.FindElementUsingCssSelector = function (cssSelector, root) {
        function cssFilter(cs) {
            // 过滤css 如果以数字开头，需要用加上ascii码\\3
            // 例： 拾取 #1 > div > a 转换后 #\\31 > div > a
            // 例： 拾取 #123 > div > a 转换后 #\\31 23 > div > a  (注意中间空格)

            function insert(soure, start, newStr) {
                return soure.slice(0, start) + newStr + soure.slice(start);
            }

            function isStartWithNum(str) {
                return str.match(/^\d/);
            }

            if (cs.indexOf("#") > -1) {
                var filterStrs = cs.split(" > ");
                for (var i = 0; i < filterStrs.length; i++) {
                    if (filterStrs[i].indexOf("#") == 0 && isStartWithNum(filterStrs[i].charAt(1))) {
                        var str = filterStrs[i].trim();
                        var newStr = insert(str, 1, "\\3");
                        if (str.length > 2) {
                            newStr = insert(newStr, 4, " ");
                        }
                        filterStrs[i] = newStr;
                    }
                }

                return filterStrs.join(" > ");
            }

            return cs;
        }

        var doc = root || document;
        var out_element = doc.querySelectorAll(cssFilter(cssSelector));
        return out_element;
    };
    gcontext.ElementHasAttributeValues = function (element, attrMap, fuzzyScoreStats) {
        if (element == null) {
            return false;
        }
        if (gcontext.IsObjectEmpty(attrMap)) {
            if (typeof fuzzyScoreStats !== "undefined") {
                fuzzyScoreStats.accept(1.0);
            }
            return true;
        }
        var out_match = true;
        for (var attrName in attrMap) {
            if (gcontext.g_skipAttrInCompatible.indexOf(attrName) < 0) {
                var crtValue = gcontext.GetAttributeValue(element, attrName);
                var matchRes = gcontext.HasAttributeValue(attrMap[attrName]) && attrMap[attrName].Matches(crtValue, fuzzyScoreStats);
                if (matchRes === false) {
                    var paramValue = gcontext.GetActiveValueString(attrMap[attrName]);
                    // gcontext.TraceMessage("ElementHasAttributeValues: value of " + attrName + " not match --> current:[" + crtValue + "] vs param:[" + paramValue + "]");
                    out_match = false;
                    break;
                }
            }
        }
        return out_match;
    }
    gcontext.FindElementUsingAttributes = function (htmlCollection, index, attrMap) {
        var out_element = null;
        var i;
        if (htmlCollection == null)
            return out_element;
        var crtIndex = 0;
        for (i = 0; i < htmlCollection.length; ++i) {
            var crtElem = htmlCollection[i];
            if (gcontext.ElementHasAttributeValues(crtElem, attrMap) === true) {
                ++crtIndex;
                if (crtIndex === index) {
                    out_element = crtElem;
                    break;
                }
            }
        }
        return out_element;
    };
    gcontext.DoubleSummaryStatistics = function () {
        this.max = 0.0;
        this.min = Number.MAX_VALUE;
        this.average = 0;
        this.sum = 0;
        this.count = 0;
        this.accept = function (value) {
            gcontext.TraceMessage("DoubleSummaryStatistics: accept " + value);
            ++this.count;
            if (value > this.max) this.max = value;
            if (value < this.min) this.min = value;
            this.sum += value;
            this.average = this.sum / this.count;
        };
    };
    gcontext.FindElementCollectionUsingAttributes = function (htmlCollection, params) {
        var out_results = new gcontext.ResultsCollection(params.maxElems);
        if (htmlCollection == null) {
            return out_results;
        }
        var i;
        var crtIndex = 0;
        for (i = 0; i < htmlCollection.length; ++i) {
            var crtElem = htmlCollection[i];
            var fuzzyScoreStats = new gcontext.DoubleSummaryStatistics();
            if (gcontext.ElementHasAttributeValues(crtElem, params.attrMap, fuzzyScoreStats) === true) {
                var matchingScore = fuzzyScoreStats.average;
                gcontext.TraceMessage("FindElementCollectionUsingAttributes: matchingScore =" + matchingScore);
                if (!params.useTagFuzzyLevel || matchingScore >= params.tagFuzzyLevel) {
                    out_results.Accept(new gcontext.HtmlSearchResult(crtElem, matchingScore));
                }
                if (out_results.IsFull()) {
                    gcontext.TraceMessage("FindElementCollectionUsingAttributes: breaking the loop");
                    break;
                }
            }
        }
        return out_results;
    };
    gcontext.checkTabUsingAttributes = function (isCompatible, tab, params) {
        var fuzzyScoreStats = new gcontext.DoubleSummaryStatistics();

        if (isCompatible == 0) {
            var out_results = true;
            // 新版本tile与url and关系

            var hasTitleValue = gcontext.HasAttributeValue(params.attrMap["title"]);
            if (hasTitleValue && !params.attrMap["title"].Matches(tab.title, fuzzyScoreStats)) {
                out_results = false;
            }

            var hasUrlValue = gcontext.HasAttributeValue(params.attrMap["url"]);
            if (hasUrlValue && !params.attrMap["url"].Matches(tab.url, fuzzyScoreStats)) {
                out_results = false;
            }

            return out_results;
        } else {
            // 旧版本tile与url or关系
            var out_results = false;

            if (gcontext.HasAttributeValue(params.attrMap["title"]) && params.attrMap["title"].Matches(tab.title, fuzzyScoreStats)) {
                out_results = true;
            }

            if (gcontext.HasAttributeValue(params.attrMap["url"]) && params.attrMap["url"].Matches(tab.url, fuzzyScoreStats)) {
                out_results = true;
            }

            return out_results;
        }
    };
    gcontext.FindTabCollectionUsingAttributes = function (params, OnFinishedCallback) {
        FindTabCollectionUsingAttributesByCompatible(0, params, OnFinishedCallback);
    };
    gcontext.FindTabCollectionUsingAttributesByCompatible = function (compatible, params, OnFinishedCallback) {
        var out_results = new gcontext.ResultsCollection(params.maxElems);
        var OnAllTabsProcessed = function () {
            gcontext.TraceMessage("GetMatchingTabs: filteredTabs.length=" + out_results.GetResults().length);
            OnFinishedCallback(out_results);
        };
        var queryOptions = {};
        chrome.tabs.query(queryOptions, function (tabList) {
            var tabCount = tabList ? tabList.length : 0;
            if (tabCount == 0) {
                OnAllTabsProcessed();
            } else {
                gcontext.TraceMessage("onGetHtmlElemById: tab count = " + tabList.length);
                var ProcessTab = function (tab) {
                    gcontext.TraceMessage("onGetHtmlElemById:ProcessTab tab.url = " + tab.url);
                    var fuzzyScoreStats = new gcontext.DoubleSummaryStatistics();
                    var MatchesSyncAttributes = function (tab) {
                        if (compatible == 0) {
                            // 新版本tile与url and关系
                            if ((!gcontext.HasAttributeValue(params.attrMap["title"]) || params.attrMap["title"].Matches(tab.title, fuzzyScoreStats)) &&
                                (!gcontext.HasAttributeValue(params.attrMap["url"]) || params.attrMap["url"].Matches(tab.url, fuzzyScoreStats))) {
                                return true;
                            }
                        } else {
                            // 旧版本tile与url or关系
                            if (gcontext.HasAttributeValue(params.attrMap["title"]) && params.attrMap["title"].Matches(tab.title, fuzzyScoreStats)) {
                                return true;
                            }

                            if (gcontext.HasAttributeValue(params.attrMap["url"]) && params.attrMap["url"].Matches(tab.url, fuzzyScoreStats)) {
                                return true;
                            }
                        }
                        return false;
                    };
                    if (MatchesSyncAttributes(tab)) {
                        if (!gcontext.HasAttributeValue(params.attrMap["htmlwindowname"])) {
                            var matchingScore = fuzzyScoreStats.average;
                            if (!params.useTagFuzzyLevel || matchingScore >= params.tagFuzzyLevel) {
                                out_results.Accept(new gcontext.TabSearchResult(tab, matchingScore));
                            }
                            OnTabProcessed();
                        } else if (gcontext.IsBrowserSettingsUrl(tab.url)) {
                            gcontext.TraceMessage("onGetHtmlElemById: skipping tab.id: " + tab.id + ", tab.url: " + tab.url);
                            OnTabProcessed();
                        } else {
                            chrome.tabs.executeScript(tab.id, {code: "window.name"}, function (result) {
                                var windowName = '' + result;
                                if (params.attrMap["htmlwindowname"].Matches(windowName, fuzzyScoreStats)) {
                                    var matchingScore = fuzzyScoreStats.average;
                                    if (!params.useTagFuzzyLevel || matchingScore >= params.tagFuzzyLevel) {
                                        out_results.Accept(new gcontext.TabSearchResult(tab, matchingScore));
                                    }
                                }
                                OnTabProcessed();
                            });
                        }
                    } else {
                        OnTabProcessed();
                    }
                };
                var OnTabProcessed = function () {
                    --tabCount;
                    if (tabCount <= 0) {
                        OnAllTabsProcessed();
                    }
                };
                for (var i = 0; i < tabList.length; ++i) {
                    ProcessTab(tabList[i]);
                }
            }
        });
    }
    gcontext.GetIndexForAttributeList = function (htmlCollection, targetCustomId, attrMap) {
        gcontext.TraceMessage("GetIndexForAttributeList: enter targetCustomId=" + targetCustomId);
        var out_index = 0;
        var i = 0;
        var found = false;
        var unique = true;
        for (i = 0; i < htmlCollection.length; ++i) {
            var crtElem = htmlCollection[i];
            var crtCustomId = gcontext.GetCustomIdForElement(crtElem);
            if (found === false && crtCustomId === targetCustomId) {
                gcontext.TraceMessage("GetIndexForAttributeList: element reached");
                found = true;
                ++out_index;
                if (out_index > 1) {
                    unique = false;
                    break;
                }
            } else if (gcontext.ElementHasAttributeValues(crtElem, attrMap)) {
                gcontext.TraceMessage("GetIndexForAttributeList: attributes match");
                if (found) {
                    unique = false;
                    break;
                } else
                    ++out_index;
            }
        }
        if (found === false) {
            out_index = -1;
        } else if (unique === true && out_index === 1) {
            out_index = 0;
        }
        gcontext.TraceMessage("GetIndexForAttributeList: return index=" + out_index);
        return out_index;
    }
    gcontext.GetTruncatedAttributeValue = function (targetElement, attrName) {
        var resValue = null;
        var attrVal = gcontext.GetAttributeValue(targetElement, attrName);
        if (attrVal.length !== 0) {
            resValue = ((attrName === "css-selector" || attrName === "xpath") ? attrVal : gcontext.TruncateStringUsingWildcard(attrVal, gcontext.MAX_ATTR_LEN));
        }
        return resValue;
    }
    gcontext.GetAttributeShortValue = function (element, attrName) {
        const maxAttrValueLength = 512;
        var attrValue = gcontext.GetAttributeValue(element, attrName);
        if (attrValue.length > maxAttrValueLength) {
            return gcontext.TruncateStringUsingWildcard(attrValue, maxAttrValueLength);
        }
        return attrValue;
    }
    gcontext.GetAttrNameShort = function (attrName) {
        function Result(shortAttrName, isDifferent) {
            return {shortAttrName: shortAttrName, isDifferent: isDifferent};
        }

        if (attrName === "innertext") {
            return Result("innertextshort", true);
        } else if (attrName === "outertext") {
            return Result("outertextshort", true);
        } else if (attrName === "innerhtml") {
            return Result("innerhtmlshort", true);
        } else if (attrName === "outerhtml") {
            return Result("outerhtmlshort", true);
        } else if (attrName === "aaname") {
            return Result("aanameshort", true);
        }
        return Result(attrName, false);
    }
    gcontext.GetSelectorAttributeListResult = function (tagName, attrMap, index, retCode) {
        var out_result = {tagName: tagName, attrMap: gcontext.ActiveValueStringMap(attrMap), index: index, retCode: retCode};
        return out_result;
    }
    gcontext.isLeafElement = function (e) {
        if (!e) {
            return false;
        }
        return (e.children.length === 0);
    }
    gcontext.shouldAddAAName = function (e) {
        var t = e.tagName.toLowerCase();
        var acceptedTags = ["a", "label", "img", "input", "button", "textarea", "area", "select", "table", "th"];
        if (acceptedTags.indexOf(t) !== -1) {
            return true;
        }
        if (((t === "div") || (t === "span")) && (e.textContent.length <= 32)) {
            return true;
        }
        var acceptedParentTags = ["a", "label", "button", "select", "th"];
        while (true) {
            var p = e.parentElement;
            if (p === null) {
                break;
            }
            t = p.tagName.toLowerCase();
            if (acceptedParentTags.indexOf(t) !== -1) {
                return true;
            }
            e = p;
        }
        return false;
    }
    gcontext.GetSelectorAttributeList = function (rootDocument, targetCustomId, parentId, targetTagName, computeIndex) {
        gcontext.TraceMessage("GetSelectorAttributeList: enter targetCustomId=[" + targetCustomId + "] parentId=[" + parentId + "] targetTagName=[" + targetTagName + "]");
        if (targetCustomId == null) {
            gcontext.TraceMessage("GetSelectorAttributeList: invalid input, return error");
            return gcontext.GetSelectorAttributeListResult("", {}, -1, N_FALSE);
        }
        var targetElement = gcontext.GetElementFromCustomId(targetCustomId);
        if (targetElement == null) {
            gcontext.TraceMessage("GetSelectorAttributeList: targetCustomId=" + targetCustomId + " not found in the cache");
            return gcontext.GetSelectorAttributeListResult("", {}, -1, N_FALSE);
        }
        var isSapFioriElement = gcontext.IsSapFioriElement(targetElement);
        if (isSapFioriElement) {
            return gcontext.GetSapFioriSelectorAttributeList(rootDocument, targetElement, targetCustomId, parentId, targetTagName, computeIndex);
        }
        var getAllDocuments = gcontext.xbrowser.isModeSingleFrame();
        var htmlCollection = gcontext.GetHtmlCollectionForParentId(rootDocument, getAllDocuments, parentId, targetTagName);
        if (htmlCollection == null) {
            gcontext.TraceMessage("OnGetHtmlIdInfo: GetHtmlCollectionForParentId('" + parentId + "') failed");
            return gcontext.GetSelectorAttributeListResult("", {}, -1, N_FALSE);
        }
        var attrLists = ["tag", "type", "aria-role", "id", "name", "parentid", "parentname"];
        if (gcontext.shouldAddAAName(targetElement)) {
            attrLists.push("aaname");
        }
        if (gcontext.isLeafElement(targetElement)) {
            attrLists.push("isleaf");
        }
        attrLists.push("xpath");
        attrLists.push("css-selector");
        attrLists.push("tabindex");
        attrLists.push("tableRow");
        attrLists.push("tableCol");
        attrLists.push("href");
        if (gcontext.ElementIsFrame(targetElement)) {
            attrLists.splice(3, 0, "src");
        } else {
            attrLists.push("src");
        }
        var bestIndex = 1000000;
        if (computeIndex == 0)
            bestIndex = 0;

        var attrMap = {};
        attrLists = gcontext.GetUniqueElementsFromArray(attrLists);
        for (var phaseIdx = 0; phaseIdx < attrLists.length; ++phaseIdx) {
            var crntAttrName = attrLists[phaseIdx];
            var crntAttrValue = gcontext.GetTruncatedAttributeValue(targetElement, crntAttrName);
            if (crntAttrValue) {
                if (crntAttrName === "css-selector" && computeIndex > 0) {
                    if (bestIndex <= 1) {
                        continue;
                    }
                    var cssSelector = crntAttrValue;
                    var getAllDocuments = gcontext.xbrowser.isModeSingleFrame();
                    htmlCollection = gcontext.GetHtmlCollectionForParentId(rootDocument, getAllDocuments, parentId, targetTagName, cssSelector);
                    if (htmlCollection === null) {
                        gcontext.TraceMessage("OnGetHtmlIdInfo: GetHtmlCollectionForParentId('" + parentId + "') failed");
                        return gcontext.GetSelectorAttributeListResult("", {}, -1, N_FALSE);
                    }
                }
                attrMap[crntAttrName] = new gcontext.AttributeValue(crntAttrValue);
                if (computeIndex > 0) {
                    var crntIndex = gcontext.GetIndexForAttributeList(htmlCollection, targetCustomId, attrMap);
                    if (crntIndex === -1) {
                        gcontext.TraceMessage("GetSelectorAttributeList: index == -1, return error");
                        return gcontext.GetSelectorAttributeListResult("", {}, -1, N_FALSE);
                    }
                    if (crntIndex < bestIndex) {
                        bestIndex = crntIndex;
                    } else {
                        delete attrMap[crntAttrName];
                    }
                    if (bestIndex === 0) {
                        gcontext.TraceMessage("GetSelectorAttributeList: index == 0, return success");
                        if (Object.keys(attrMap).length === 1 && gcontext.ElementIsFrame(targetElement)) {
                            var extraAttrList = ["id", "name", "src"];
                            for (var i = 0; i < extraAttrList.length; i += 1) {
                                var attrName = extraAttrList[i];
                                var attrValue = gcontext.GetTruncatedAttributeValue(targetElement, attrName);
                                if (attrValue) {
                                    gcontext.TraceMessage("OnGetHtmlIdInfo: Frame selector has only one attribute. Added extra \"" + attrName + "\"=\"" + attrValue + "\" to make it more precise");
                                    attrMap[attrName] = new gcontext.AttributeValue(attrValue);
                                    break;
                                }
                            }
                            if (Object.keys(attrMap).length === 1) {
                                gcontext.TraceMessage("OnGetHtmlIdInfo: Warning, frame selector has only \"tag\" attribute and extra attributes could not be added");
                            }
                        }
                        return gcontext.GetSelectorAttributeListResult(targetElement.tagName, attrMap, 0, N_TRUE);
                    }
                }
            }
        }
        return gcontext.GetSelectorAttributeListResult(targetElement.tagName, attrMap, bestIndex, N_TRUE);
    }
    gcontext.GetAttrValueListForElement = function (element) {
        var result = {};
        if (element !== null) {
            var attrNames = gcontext.GetAttributeListForElement(element);
            var staticAttrNames = ["innertext", "outertext", "innerhtml", "outerhtml", "tag", "parentid", "class", "parentname", "parentclass", "aaname", "aastate", "role", "cookie", "readystate", "url", "checked", "isleaf", "css-selector", "selecteditem", "selecteditems"];
            var allAttrNames = staticAttrNames.concat(attrNames);
            for (var n = 0; n < allAttrNames.length; ++n) {
                var attrName = allAttrNames[n];
                if (attrName !== gcontext.CUSTOM_ID_ATTR_NAME) {
                    var attrNameShort = gcontext.GetAttrNameShort(attrName).shortAttrName;
                    var crntVal = gcontext.GetAttributeValue(element, attrNameShort);
                    if (crntVal !== null && crntVal.length !== 0) {
                        result[attrName] = crntVal;
                    }
                }
            }
        } else {
            result["title"] = document.title;
            result["url"] = document.URL;
            result["cookies"] = document.cookie;
            result["readystate"] = (document.readyState === "complete" ? "1" : "0");
            result["text"] = (document.body ? gcontext.DeleteForbiddenCharacters(document.body.textContent) : "");
        }
        return result;
    }
    gcontext.GetSelectorAttributeNames = function (element) {
        if (element == null) {
            return [];
        }
        var allAttrNames = ["action", "alt", "aaname", "href", "id", "innertext", "name", "parentid", "parentname", "parentclass", "src", "tabindex", "tableCol", "tableRow", "colName", "rowName", "tag", "title", "type", "class", "css-selector", "isleaf", "aria-label", "aria-role"];
        if (gcontext.IsSapFioriElement(element)) {
            var sapFioriAttrNames = gcontext.GetSapFioriAttributeNames(element);
            allAttrNames = allAttrNames.concat(sapFioriAttrNames);
        }
        return allAttrNames;
    }
    gcontext.GetAllSelectorAttributesForElement = function (element, attrExclusionMap) {
        var result = {};
        if (element !== null) {
            var allAttrNames = gcontext.GetSelectorAttributeNames(element);
            for (var n = 0; n < allAttrNames.length; ++n) {
                var attrName = allAttrNames[n];
                var shortAttrRes = gcontext.GetAttrNameShort(attrName);
                var excludedAttrValue = (attrExclusionMap != null ? attrExclusionMap[attrName] : null);
                if (excludedAttrValue == null) {
                    var crntVal = gcontext.GetAttributeValue(element, shortAttrRes.shortAttrName);
                    if (crntVal !== null && crntVal.length !== 0) {
                        result[shortAttrRes.shortAttrName] = crntVal;
                    }
                } else if (shortAttrRes.isDifferent) {
                    result[shortAttrRes.shortAttrName] = excludedAttrValue;
                }
            }
        }
        return result;
    }
    gcontext.GetAttributeListForElement = function (element) {
        var out_attrList = [];
        if (element == null || element.attributes == null)
            return out_attrList;
        var tagName = element.tagName.toLowerCase();
        if ((tagName === "th") || (tagName === "td") || (gcontext.GetParentByTag(element, "td") !== null) || (gcontext.GetParentByTag(element, "th") !== null)) {
            out_attrList.push("tableRow");
            out_attrList.push("tableCol");
            out_attrList.push("rowName");
            out_attrList.push("colName");
        }
        if (tagName === "table") {
            out_attrList.push("rowCount");
            out_attrList.push("columnCount");
        }
        for (var i = 0; i < element.attributes.length; ++i) {
            var crtAttrName = element.attributes.item(i).nodeName;
            if (crtAttrName != null && crtAttrName.length > 0 && crtAttrName.toLowerCase() !== "checked" && crtAttrName !== gcontext.CUSTOM_ID_ATTR_NAME && crtAttrName !== gcontext.g_sapFioriDefines.SAP_FIORI_CUSTOM_ID_ATTR_NAME) {
                out_attrList.push(crtAttrName);
            }
        }
        if (gcontext.IsSapFioriElement(element)) {
            var sapFioriAttrNames = gcontext.GetSapFioriAttributeNames(element);
            out_attrList = out_attrList.concat(sapFioriAttrNames);
        }
        out_attrList.push("aria-role");
        return out_attrList;
    }
    gcontext.GetHtmlCollectionForParentElement = function (parentElem, tagName, cssSelector) {
        if (!tagName) {
            tagName = "*";
        }
        tagName = tagName.toLowerCase();
        var out_collection = [];
        var i;
        var isCssSelectorValid = ((cssSelector !== undefined) && (cssSelector !== null));
        if (isCssSelectorValid) {
            try {
                var elements = parentElem.querySelectorAll(cssSelector);
                for (i = 0; i < elements.length; ++i) {
                    if ((tagName === "*") || (tagName === elements.item(i).tagName.toLowerCase())) {
                        out_collection.push(elements.item(i));
                    }
                }
            } catch (e) {
                gcontext.TraceMessage("GetHtmlCollectionForParentElement exception: " + e);
                isCssSelectorValid = false;
                out_collection = [];
            }
        }
        if (!isCssSelectorValid) {
            var elements = parentElem.getElementsByTagName(tagName);
            gcontext.TraceMessage("GetHtmlCollectionForParentElement: getElementsByTagName(tag='" + tagName + "') returned " + elements.length + " elements");
            for (i = 0; i < elements.length; ++i) {
                out_collection.push(elements.item(i));
            }
        }
        return out_collection;
    }
    gcontext.GetHtmlCollectionForParentId = function (rootDocument, getAllDocuments, parentId, tagName, cssSelector) {
        gcontext.TraceMessage("GetHtmlCollectionForParentId: enter parentId=" + parentId + " tagName=" + tagName);
        var i;
        var out_collection = [];
        if (parentId != null && parentId.length > 0) {
            var parentElem = gcontext.GetElementFromCustomId(parentId);
            if (parentElem == null) {
                gcontext.TraceMessage("GetHtmlCollectionForParentId: parentId=" + parentId + " not found in the cache");
                return null;
            }
            out_collection = gcontext.GetHtmlCollectionForParentElement(parentElem, tagName, cssSelector);
        } else {
            var docs = [rootDocument];
            if (getAllDocuments && gcontext.IsMainFrame(window)) {
                docs = gcontext.GetDocumentList(rootDocument);
            }
            for (i = 0; i < docs.length; ++i)
                out_collection = out_collection.concat(gcontext.GetHtmlCollectionForParentElement(docs[i], tagName, cssSelector));
            if (out_collection.length === 0)
                out_collection = null;
        }
        gcontext.TraceMessage("GetHtmlCollectionForParentId: return");
        return out_collection;
    }
    gcontext.GetDirectChildrenCollectionForParentElement = function (parentElem, tagName) {
        var i;
        var out_collection = [];
        for (i = 0; i < parentElem.children.length; ++i) {
            var crtElem = parentElem.children.item(i);
            if (tagName == null || tagName.length === 0 || crtElem.tagName.toLowerCase() === tagName)
                out_collection.push(crtElem);
        }
        return out_collection;
    }
    gcontext.GetDirectChildrenCollectionForParentId = function (rootDocument, getAllDocuments, parentId, tagName) {
        gcontext.TraceMessage("GetDirectChildrenCollectionForParentId: enter tagName=[" + tagName + "]");
        var i;
        var out_collection = [];
        if (parentId != null && parentId.length > 0) {
            var parentElem = gcontext.GetElementFromCustomId(parentId);
            if (parentElem == null) {
                gcontext.TraceMessage("GetDirectChildrenCollectionForParentId: parentId=" + parentId + " not found in the cache");
                return null;
            }
            gcontext.TraceMessage("GetDirectChildrenCollectionForParentId: calling GetDirectChildrenCollectionForParentElement on parentId");
            out_collection = gcontext.GetDirectChildrenCollectionForParentElement(parentElem, tagName);
        } else {
            gcontext.TraceMessage("GetDirectChildrenCollectionForParentId: calling GetDirectChildrenCollectionForParentElement on each doc");
            var docs = [rootDocument];
            if (getAllDocuments) {
                docs = gcontext.GetDocumentList(rootDocument);
            }
            for (i = 0; i < docs.length; ++i) {
                var docElem = docs[i].documentElement;
                if (docElem.tagName.toLowerCase() === tagName)
                    out_collection.push(docElem);
                out_collection = out_collection.concat(gcontext.GetDirectChildrenCollectionForParentElement(docElem, tagName));
            }
            if (out_collection.length === 0)
                out_collection = null;
        }
        gcontext.TraceMessage("GetDirectChildrenCollectionForParentId: return");
        return out_collection;
    }
    gcontext.GetFrameParent = function (rootDoc, frameElement) {
        var out_frameParent = null;
        var customIdToSearch = gcontext.GenerateCustomIdForElement(frameElement);
        var frames = gcontext.GetFrameList(rootDoc);
        var frameIdx = 0;
        for (frameIdx = 0; frameIdx < frames.length && out_frameParent == null; ++frameIdx) {
            var crtFrame = frames[frameIdx];
            var crtDoc = gcontext.GetSafeContentDocument(crtFrame);
            if (crtDoc) {
                var children = crtDoc.getElementsByTagName(frameElement.tagName);
                var childIdx = 0;
                for (childIdx = 0; childIdx < children.length; ++childIdx) {
                    var crtElem = children.item(childIdx);
                    var crtCustomId = gcontext.GetCustomIdForElement(crtElem);
                    if (crtCustomId === customIdToSearch) {
                        out_frameParent = crtFrame;
                        break;
                    }
                }
            }
        }
        return out_frameParent;
    }
    gcontext.GetElementClientBoundingCssRectangle = function (rootDoc, element) {
        var htmlRc = element.getBoundingClientRect();
        var out_rc = gcontext.UiRect(htmlRc.left, htmlRc.top, htmlRc.width, htmlRc.height);
        if (gcontext.IsMainFrame(window)) {
            var parent = gcontext.GetFrameParent(rootDoc, element);
            while (parent) {
                htmlRc = parent.getBoundingClientRect();
                gcontext.TraceMessage("GetElementClientCssRectangle: offsetting with (" + htmlRc.left, htmlRc.top + ")");
                out_rc = out_rc.Offset(htmlRc.left, htmlRc.top);
                parent = gcontext.GetFrameParent(rootDoc, parent);
            }
        }
        return out_rc;
    }
    gcontext.GetElementClientInnerCssRectangle = function (element) {
        var htmlRc = element.getBoundingClientRect();
        return gcontext.UiRect(htmlRc.left + element.clientLeft, htmlRc.top + element.clientTop, element.clientWidth, element.clientHeight);
    }
    gcontext.GetTextFromSelection = function (selectElement) {
        var out_text = "";
        if (selectElement.size <= 1 && selectElement.multiple === false) {
            if (selectElement.selectedIndex === -1)
                return out_text;
            out_text = selectElement.item(selectElement.selectedIndex).text;
        }
        return out_text;
    }
    gcontext.GetFullTextFromSelect = function (selectElement) {
        var out_text = "";
        var i;
        var options = selectElement.getElementsByTagName("option");
        for (i = 0; i < options.length; ++i) {
            var option = options.item(i);
            if (option.text && option.text.length > 0)
                out_text += option.text + "\n";
        }
        return out_text;
    }
    gcontext.GetTextContentFromElement = function (element) {
        var out_text = "";
        var tag = element.tagName.toLowerCase();
        if (tag === "select")
            out_text = gcontext.GetTextFromSelection(element); else
            out_text = gcontext.TrimWhiteSpaces(element.textContent);
        return out_text;
    }
    gcontext.GetIntCssProperty = function (style, propName, unitSuffix, defaultValue) {
        var out_intValue = defaultValue;
        var propValue = style.getPropertyValue(propName);
        if (propValue != null && propValue.length > 0) {
            if (propValue.length > unitSuffix.length && propValue.slice(propValue.length - unitSuffix.length) === unitSuffix) {
                var numericPart = propValue.slice(0, propValue.length - unitSuffix.length);
                out_intValue = parseInt(numericPart);
            }
        }
        return out_intValue;
    }
    gcontext.GetElementMarginFromParent = function (htmlWindow, element) {
        var out_marginSize = 0;
        if (element == null || element.parentNode == null)
            return out_marginSize;
        var elementRect = element.getBoundingClientRect();
        for (var ancestor = element.parentNode; ancestor != null && ancestor.nodeType === ancestor.ELEMENT_NODE; ancestor = ancestor.parentNode) {
            var ancestorRect = ancestor.getBoundingClientRect();
            if (ancestorRect.width > elementRect.width && ancestorRect.height > elementRect.height)
                break;
            if (ancestorRect.width === elementRect.width && ancestorRect.height === elementRect.height) {
                var style = htmlWindow.getComputedStyle(ancestor);
                var borderSize = gcontext.GetIntCssProperty(style, "margin-left", "px", 0) +
                    gcontext.GetIntCssProperty(style, "margin-right", "px", 0);
                if (borderSize > out_marginSize)
                    out_marginSize = borderSize;
            }
        }
        return out_marginSize;
    }
    gcontext.TextRectInfo = function (text, rect, lineWidth, endsWithWhitespace) {
        return {text: text, rect: rect, lineWidth: lineWidth, endsWithWhitespace: endsWithWhitespace};
    }
    gcontext.CreateTextExtractorObject = function (htmlWindow, rootDocument, element, separators) {
        var out_textRectInfos = [];
        var LINE_OVERFLOW_TOLERANCE = 1;
        var m_spanElem = null;
        var m_elemRect = null;
        var m_elemCustomId = "", m_parentElemCustomId = "";
        var m_srcStyle = null;
        var m_borderLeft = 0, m_borderTop = 0, m_borderRight = 0;
        var m_initialOffsetForSpacing = {x: 0, y: 0};
        var m_crtOffsetForSpacing = {x: 0, y: 0};
        var m_maxLineRight = 0;
        var m_lineWidth = 0, m_lineHeight = 0;
        var m_totalTextHeight = 0;

        function GetNonWhitespaceWordExtentsUsingSpan(word) {
            m_spanElem.textContent = word;
            var rc = m_spanElem.getBoundingClientRect();
            return {width: rc.width, height: rc.height};
        }

        var DUMMY_BORDER_CHAR = "x";
        var m_dummyBorderCharWidth = 0;

        function GetDummyBorderCharWidth() {
            if (m_dummyBorderCharWidth !== 0)
                return m_dummyBorderCharWidth;
            m_dummyBorderCharWidth = GetNonWhitespaceWordExtentsUsingSpan(DUMMY_BORDER_CHAR).width;
            return m_dummyBorderCharWidth;
        }

        function GetWordExtentsUsingSpan(word) {
            if (word.length === 0)
                return {width: 0, height: 0};
            var extraHeading = "";
            var extraTrailing = "";
            var extraHeadingWidth = 0;
            var extraTrailingWidth = 0;
            if (gcontext.IsWhiteSpaceCharacter(word.charAt(0))) {
                extraHeading = DUMMY_BORDER_CHAR;
                extraHeadingWidth = GetDummyBorderCharWidth();
            }
            if (gcontext.IsWhiteSpaceCharacter(word.charAt(word.length - 1))) {
                extraTrailing = DUMMY_BORDER_CHAR;
                extraTrailingWidth = GetDummyBorderCharWidth();
            }
            var wordExt = GetNonWhitespaceWordExtentsUsingSpan(extraHeading + word + extraTrailing);
            return {width: wordExt.width - extraHeadingWidth - extraTrailingWidth, height: wordExt.height};
        }

        return {
            BeginAccumulateTextRectInfo: function () {
                if (element == null)
                    return false;
                var doc = element.ownerDocument;
                m_srcStyle = htmlWindow.getComputedStyle(element);
                m_spanElem = doc.createElement("span");
                var cssProps = ["font-family", "font-size", "font-size-adjust", "font-stretch", "font-style", "font-variant", "font-weight", "text-align", "text-align-last", "text-decoration", "text-indent", "text-justify", "text-overflow", "text-shadow", "text-transform", "text-autospace", "text-kashida-space", "text-underline-position", "direction", "zoom"];
                for (i = 0; i < cssProps.length; ++i) {
                    var propName = cssProps[i];
                    var propValue = m_srcStyle.getPropertyValue(propName);
                    if (propValue != null && propValue.length > 0) {
                        var propPriority = m_srcStyle.getPropertyPriority(propName);
                        m_spanElem.style.setProperty(propName, propValue, propPriority);
                    }
                }
                m_spanElem.style.setProperty("resize", "both", "");
                m_spanElem.style.setProperty("display", "inline-block", "");
                doc.body.appendChild(m_spanElem);
                m_borderLeft = gcontext.GetIntCssProperty(m_srcStyle, "padding-left", "px", 0);
                m_borderTop = gcontext.GetIntCssProperty(m_srcStyle, "padding-top", "px", 0);
                m_borderRight = gcontext.GetIntCssProperty(m_srcStyle, "padding-right", "px", 0);
                m_elemRect = gcontext.GetElementClientBoundingCssRectangle(rootDocument, element);
                m_elemCustomId = gcontext.GenerateCustomIdForElement(element);
                m_parentElemCustomId = gcontext.GenerateCustomIdForElement(element.parentNode);
                m_initialOffsetForSpacing.x = m_elemRect.left + m_borderLeft;
                m_initialOffsetForSpacing.y = m_elemRect.top + m_borderTop;
                m_maxLineRight = m_elemRect.right - m_borderRight;
                m_crtOffsetForSpacing.x = m_initialOffsetForSpacing.x;
                m_crtOffsetForSpacing.y = m_initialOffsetForSpacing.y;
                m_lineWidth = (m_elemRect.right - m_borderRight) - (m_elemRect.left + m_borderLeft);
                m_lineHeight = gcontext.GetIntCssProperty(m_srcStyle, "line-height", "px", 0);
                m_totalTextHeight = m_lineHeight;
                gcontext.TraceMessage("BeginAccumulateTextRectInfo: m_lineHeight=" + m_lineHeight);
                gcontext.TraceMessage("BeginAccumulateTextRectInfo: m_maxLineRight=" + m_maxLineRight);
                gcontext.TraceMessage("BeginAccumulateTextRectInfo: m_initialOffsetForSpacing=" + gcontext.EnumObjectProps(m_initialOffsetForSpacing, true));
                gcontext.TraceMessage("BeginAccumulateTextRectInfo: m_elemRect=" + m_elemRect.toString());
                gcontext.TraceMessage("BeginAccumulateTextRectInfo: border LTR = (" + m_borderLeft + " " + m_borderTop + " " + m_borderRight + ")");
                return true;
            }, GetRects: function () {
                return out_textRectInfos;
            }, EndAccumulateTextRectInfo: function () {
                if (m_srcStyle != null) {
                    var i = 0;
                    var borderTopCorrection = 0;
                    var verticalAlign = m_srcStyle.getPropertyValue("vertical-align");
                    if (verticalAlign === "middle") {
                        var centeredBorderTop = (m_elemRect.getHeight() - m_totalTextHeight) / 2;
                        gcontext.TraceMessage("GetTextBorderTopCorrectionFromCss: totalTextHeight=" + m_totalTextHeight + " centeredBorderTop=" + centeredBorderTop);
                        borderTopCorrection = centeredBorderTop - m_borderTop;
                    } else if (verticalAlign === "baseline" || verticalAlign === "bottom") {
                        var bottomAlignedBorderTop = m_elemRect.getHeight() - m_totalTextHeight;
                        gcontext.TraceMessage("GetTextBorderTopCorrectionFromCss: totalTextHeight=" + m_totalTextHeight + " bottomAlignedBorderTop=" + bottomAlignedBorderTop);
                        borderTopCorrection = bottomAlignedBorderTop - m_borderTop;
                    }
                    if (borderTopCorrection !== 0) {
                        for (i = 0; i < out_textRectInfos.length; ++i)
                            out_textRectInfos[i].rect = out_textRectInfos[i].rect.Offset(0, borderTopCorrection);
                    }
                }
                if (out_textRectInfos.length !== 0)
                    out_textRectInfos[out_textRectInfos.length - 1].endsWithWhitespace = true;
                if (m_spanElem != null) {
                    element.ownerDocument.body.removeChild(m_spanElem);
                    m_spanElem = null;
                }
                gcontext.TraceMessage("EndAccumulateTextRectInfo: return");
                return out_textRectInfos;
            }, AdvanceTextOffsets: function (advanceX) {
                var newOffsetX = m_crtOffsetForSpacing.x + advanceX;
                var lineOverflow = newOffsetX - m_maxLineRight;
                if (lineOverflow >= LINE_OVERFLOW_TOLERANCE) {
                    m_crtOffsetForSpacing.x = m_initialOffsetForSpacing.x;
                    m_crtOffsetForSpacing.y += m_lineHeight;
                    m_totalTextHeight += m_lineHeight;
                } else
                    m_crtOffsetForSpacing.x = newOffsetX;
            }, AccumulateTextRectInfo: function (text) {
                if (text == null || text.length === 0)
                    return false;
                if (m_spanElem == null)
                    return false;
                var m_crtWordForSpacing = "", m_crtWord = "";
                var CharType = {WORD: 0, SEPARATOR: 1, WHITESPACE: 2};

                function GetCharType(ch) {
                    if (gcontext.IsWhiteSpaceCharacter(ch))
                        return CharType.WHITESPACE;
                    if (separators.indexOf(ch) !== -1)
                        return CharType.SEPARATOR;
                    return CharType.WORD;
                }

                function RectContains(rect, point) {
                    return ((point.x >= rect.left && point.x < rect.right) && (point.y >= rect.top && point.y < rect.bottom));
                }

                function CheckNewLineAndUpdateSpacingOffsets() {
                    var out_wordExtForSpacing = GetWordExtentsUsingSpan(m_crtWordForSpacing);
                    if (m_lineHeight === 0 && out_wordExtForSpacing.height > m_lineHeight) {
                        m_lineHeight = out_wordExtForSpacing.height;
                        m_totalTextHeight = m_lineHeight;
                        gcontext.TraceMessage("AccumulateTextRectInfo::CheckNewLineAndUpdateSpacingOffsets: m_lineHeight=" + m_lineHeight);
                    }
                    var wordExt = GetWordExtentsUsingSpan(m_crtWord);
                    var checkOverlappingElements = true;
                    var INNER_TOLERANCE = 2;
                    if (wordExt.width < (2 * INNER_TOLERANCE) || wordExt.height < (2 * INNER_TOLERANCE)) {
                        checkOverlappingElements = false;
                    }
                    while (checkOverlappingElements === true) {
                        checkOverlappingElements = false;
                        if (m_crtWord.length > 0) {
                            var points = [{
                                x: m_crtOffsetForSpacing.x + wordExt.width / 2,
                                y: m_crtOffsetForSpacing.y + wordExt.height / 2,
                                name: "middle"
                            }, {
                                x: m_crtOffsetForSpacing.x + INNER_TOLERANCE,
                                y: m_crtOffsetForSpacing.y + INNER_TOLERANCE,
                                name: "left-top"
                            }, {
                                x: m_crtOffsetForSpacing.x + wordExt.width - INNER_TOLERANCE,
                                y: m_crtOffsetForSpacing.y + INNER_TOLERANCE,
                                name: "right-top"
                            }, {
                                x: m_crtOffsetForSpacing.x + INNER_TOLERANCE,
                                y: m_crtOffsetForSpacing.y + wordExt.height - INNER_TOLERANCE,
                                name: "left-bottom"
                            }, {x: m_crtOffsetForSpacing.x + wordExt.width - INNER_TOLERANCE, y: m_crtOffsetForSpacing.y + wordExt.height - INNER_TOLERANCE, name: "right-bottom"}];
                            for (var i = 0; i < points.length; ++i) {
                                var crtPoint = points[i];
                                if (crtPoint.x <= m_maxLineRight) {
                                    var elemAtPoint = element.ownerDocument.elementFromPoint(crtPoint.x, crtPoint.y);
                                    if (elemAtPoint != null) {
                                        var htmlRectAtPoint = elemAtPoint.getBoundingClientRect();
                                        var customIdAtPoint = gcontext.GetCustomIdForElement(elemAtPoint);
                                        if (htmlRectAtPoint != null && htmlRectAtPoint.left > -5 && htmlRectAtPoint.top > -5 && htmlRectAtPoint.width > 0 && htmlRectAtPoint.height > 0 && RectContains(htmlRectAtPoint, crtPoint) && customIdAtPoint !== m_elemCustomId && customIdAtPoint !== m_parentElemCustomId) {
                                            var spacingGapX = gcontext.GetElementMarginFromParent(htmlWindow, elemAtPoint);
                                            gcontext.TraceMessage("AccumulateTextRectInfo::CheckNewLineAndUpdateSpacingOffsets: crtWord=[" + m_crtWord +
                                                "]: there is an element with tag [" + elemAtPoint.tagName +
                                                "]");
                                            m_crtOffsetForSpacing.x = htmlRectAtPoint.right + spacingGapX;
                                            checkOverlappingElements = true;
                                            break;
                                        }
                                    }
                                }
                            }
                        }
                        var lineOverflow = (m_crtOffsetForSpacing.x + wordExt.width) - m_maxLineRight;
                        if (lineOverflow >= LINE_OVERFLOW_TOLERANCE) {
                            gcontext.TraceMessage("AccumulateTextRectInfo::CheckNewLineAndUpdateSpacingOffsets: [" + m_crtWord +
                                "] overflows the right margin by " + lineOverflow + " pixels");
                            m_crtOffsetForSpacing.x = m_initialOffsetForSpacing.x;
                            m_crtOffsetForSpacing.y += m_lineHeight;
                            gcontext.TraceMessage("AccumulateTextRectInfo::CheckNewLineAndUpdateSpacingOffsets: m_crtOffsetForSpacing after correction " +
                                gcontext.EnumObjectProps(m_crtOffsetForSpacing, true));
                            m_totalTextHeight += m_lineHeight;
                            if (m_crtOffsetForSpacing.y >= m_elemRect.bottom) {
                                gcontext.TraceMessage("AccumulateTextRectInfo::CheckNewLineAndUpdateSpacingOffsets: m_crtOffsetForSpacing.y=" + m_crtOffsetForSpacing.y +
                                    " overflows the bottom side " + m_elemRect.bottom + " of the element rectangle");
                                break;
                            }
                            checkOverlappingElements = true;
                        }
                    }
                    return out_wordExtForSpacing;
                }

                if (separators == null || separators.length === 0)
                    separators = "`;:'\",.!?/\\|";
                var i = 0;
                var parserState = CharType.WORD;
                var crtXOffsetInWord = 0;
                for (i = 0; i < text.length; ++i) {
                    var ch = text.charAt(i);
                    var chType = GetCharType(ch);
                    if (parserState === CharType.WORD) {
                        if (chType === CharType.SEPARATOR || chType === CharType.WHITESPACE) {
                            if (m_crtWord.length > 0) {
                                var wordExt = CheckNewLineAndUpdateSpacingOffsets();
                                var wordInfo = gcontext.TextRectInfo(m_crtWord, gcontext.UiRect(m_crtOffsetForSpacing.x, m_crtOffsetForSpacing.y, wordExt.width, wordExt.height), m_lineWidth, chType === CharType.WHITESPACE);
                                out_textRectInfos.push(wordInfo);
                                gcontext.TraceMessage("AccumulateTextRectInfo: adding word [" + wordInfo.text +
                                    "] rect " + wordInfo.rect.toString());
                                m_crtWordForSpacing += ch;
                                m_crtWord = ch.toString();
                                crtXOffsetInWord = wordExt.width;
                                parserState = chType;
                            } else {
                                m_crtWordForSpacing = m_crtWord = ch.toString();
                                crtXOffsetInWord = 0;
                                parserState = chType;
                            }
                        } else {
                            m_crtWordForSpacing += ch;
                            m_crtWord += ch;
                        }
                    } else if (parserState === CharType.SEPARATOR) {
                        if (chType === CharType.WORD || chType === CharType.WHITESPACE) {
                            var spacingExt = CheckNewLineAndUpdateSpacingOffsets();
                            var wordExt = GetWordExtentsUsingSpan(m_crtWord);
                            var wordInfo = gcontext.TextRectInfo(m_crtWord, gcontext.UiRect(m_crtOffsetForSpacing.x + crtXOffsetInWord, m_crtOffsetForSpacing.y, wordExt.width, wordExt.height), m_lineWidth, chType === CharType.WHITESPACE);
                            out_textRectInfos.push(wordInfo);
                            m_crtWordForSpacing = m_crtWord = ch.toString();
                            m_crtOffsetForSpacing.x += spacingExt.width;
                            crtXOffsetInWord = 0;
                            parserState = chType;
                        } else {
                            CheckNewLineAndUpdateSpacingOffsets();
                            var wordExt = GetWordExtentsUsingSpan(m_crtWord);
                            var wordInfo = gcontext.TextRectInfo(m_crtWord, gcontext.UiRect(m_crtOffsetForSpacing.x + crtXOffsetInWord, m_crtOffsetForSpacing.y, wordExt.width, wordExt.height), m_lineWidth, false);
                            out_textRectInfos.push(wordInfo);
                            m_crtWordForSpacing += ch;
                            m_crtWord = ch.toString();
                            crtXOffsetInWord += wordExt.width;
                        }
                    } else if (parserState === CharType.WHITESPACE) {
                        if (chType === CharType.WORD || chType === CharType.SEPARATOR) {
                            var spacingExt = CheckNewLineAndUpdateSpacingOffsets();
                            m_crtWordForSpacing = m_crtWord = ch.toString();
                            m_crtOffsetForSpacing.x += spacingExt.width;
                            crtXOffsetInWord = 0;
                            parserState = chType;
                        } else {
                            CheckNewLineAndUpdateSpacingOffsets();
                            m_crtWordForSpacing += ch;
                            m_crtWord = "";
                            crtXOffsetInWord = 0;
                        }
                    }
                }
                var spacingExt = CheckNewLineAndUpdateSpacingOffsets();
                if (parserState !== CharType.WHITESPACE && m_crtWord.length > 0) {
                    var wordExt = GetWordExtentsUsingSpan(m_crtWord);
                    var wordInfo = gcontext.TextRectInfo(m_crtWord, gcontext.UiRect(m_crtOffsetForSpacing.x + crtXOffsetInWord, m_crtOffsetForSpacing.y, wordExt.width, wordExt.height), m_lineWidth, false);
                    out_textRectInfos.push(wordInfo);
                    gcontext.TraceMessage("AccumulateTextRectInfo: adding last word [" + wordInfo.text +
                        "] rect " + wordInfo.rect.toString());
                }
                m_crtOffsetForSpacing.x += spacingExt.width;
                return true;
            }
        }
    }
    gcontext.FormattedTextInfoResult = function () {
        function TextLine(lineWidth) {
            return {
                textInfos: [], lineWidth: lineWidth, AddTextInfo: function (textInfo) {
                    this.textInfos.push(textInfo);
                }, AddTextInfoArray: function (textInfoArray) {
                    this.textInfos = this.textInfos.concat(textInfoArray);
                }, PushTextInfosAtTheStart: function (additionalTextInfos) {
                    var out_overflowingWordsAtTheEnd = [];
                    if (additionalTextInfos.length === 0 || this.textInfos.length === 0)
                        return out_overflowingWordsAtTheEnd;
                    gcontext.TraceMessage("PushTextInfosAtTheStart: additionalTextInfos[0]=" + additionalTextInfos[0].text);
                    gcontext.TraceMessage("PushTextInfosAtTheStart: this.textInfos[0]=" + this.textInfos[0].text);
                    var i = 0;
                    var totalWidth = additionalTextInfos[0].rect.getWidth();
                    for (i = 1; i < additionalTextInfos.length; ++i)
                        totalWidth += additionalTextInfos[i].rect.getWidth();
                    gcontext.TraceMessage("PushTextInfosAtTheStart: totalWidth=" + totalWidth);
                    var startTrimIdx = -1;
                    for (i = 0; i < this.textInfos.length; ++i) {
                        this.textInfos[i].rect = this.textInfos[i].rect.Offset(totalWidth, 0);
                        if (this.textInfos[i].rect.right - this.textInfos[0].rect.left > lineWidth) {
                            startTrimIdx = i;
                            break;
                        }
                    }
                    if (startTrimIdx !== -1)
                        out_overflowingWordsAtTheEnd = this.textInfos.splice(startTrimIdx, this.textInfos.length - startTrimIdx);
                    this.textInfos = additionalTextInfos.concat(this.textInfos);
                    return out_overflowingWordsAtTheEnd;
                }
            };
        }

        return {
            lines: [], AddLine: function (lineWidth) {
                this.lines.push(TextLine(lineWidth));
            }, AddTextInfo: function (textInfo) {
                if (this.lines.length === 0)
                    return;
                this.lines[this.lines.length - 1].AddTextInfo(textInfo);
            }, AddTextInfoArray: function (textInfoArray) {
                if (this.lines.length === 0)
                    return;
                this.lines[this.lines.length - 1].AddTextInfoArray(textInfoArray);
            }, ShiftTextInfosAndReformat: function (lineIdxToShift, numWordsToShift) {
                if (lineIdxToShift >= this.lines.length || numWordsToShift <= 0)
                    return;
                var line = this.lines[lineIdxToShift];
                if (numWordsToShift > line.textInfos.length)
                    return;
                var wordsToShift = line.textInfos.splice(line.textInfos.length - numWordsToShift, numWordsToShift);
                var i = 0, j = 0;
                for (i = lineIdxToShift + 1; i < this.lines.length; ++i) {
                    line = this.lines[i];
                    if (line.textInfos.length !== 0) {
                        var shiftWidth = -(wordsToShift[0].rect.left - line.textInfos[0].rect.left);
                        var shiftHeight = -(wordsToShift[0].rect.top - line.textInfos[0].rect.top);
                        gcontext.TraceMessage("ShiftTextInfosAndReformat: shiftWidth=" + shiftWidth + " shiftHeight=" + shiftHeight);
                        for (j = 0; j < wordsToShift.length; ++j)
                            wordsToShift[j].rect = wordsToShift[j].rect.Offset(shiftWidth, shiftHeight);
                    }
                    wordsToShift = line.PushTextInfosAtTheStart(wordsToShift);
                    if (wordsToShift.length === 0)
                        break;
                }
                if (wordsToShift.length !== 0) {
                    line = this.lines[this.lines.length - 1];
                    if (line.textInfos.length !== 0) {
                        var shiftWidth = -(wordsToShift[0].left - line.textInfos[0].left);
                        var shiftHeight = -(wordsToShift[0].top - line.textInfos[0].top);
                        for (j = 0; j < wordsToShift.length; ++j)
                            wordsToShift[j].rect = wordsToShift[j].rect.Offset(shiftWidth, shiftHeight);
                    }
                    this.AddLine(line.lineWidth);
                    this.AddTextInfoArray(wordsToShift);
                }
            }, GetFilteredText: function (filterRect) {
                var out_text = "";
                var out_textRectInfo = [];
                var lineIdx = 0;
                for (lineIdx = 0; lineIdx < this.lines.length; ++lineIdx) {
                    var crtLine = this.lines[lineIdx];
                    var textInfoIdx = 0;
                    for (textInfoIdx = 0; textInfoIdx < crtLine.textInfos.length; ++textInfoIdx) {
                        textInfo = crtLine.textInfos[textInfoIdx];
                        if (filterRect.Intersects(textInfo.rect)) {
                            out_textRectInfo.push(textInfo);
                            out_text += textInfo.text;
                            if (textInfo.endsWithWhitespace)
                                out_text += " ";
                        }
                    }
                    if (lineIdx !== this.lines.length - 1)
                        out_text += "\r\n";
                }
                return {text: out_text, textRectInfo: out_textRectInfo};
            }
        };
    }
    gcontext.FormatTextRectInfoArray = function (textRectInfo, newLineTolerance, runStopwatch) {
        var out_formattedTextInfo = gcontext.FormattedTextInfoResult();
        textRectInfo.sort(function (e1, e2) {
            var rc1 = e1.rect;
            var rc2 = e2.rect;
            if (rc1.top >= rc2.bottom - newLineTolerance)
                return 1;
            if (rc2.top >= rc1.bottom - newLineTolerance)
                return -1;
            if (rc1.left >= rc2.right - newLineTolerance)
                return 1;
            if (rc2.left >= rc1.right - newLineTolerance)
                return -1;
            return 0;
        });
        var timeoutCheckCounter = 0;
        var i = 0, j = 0, startLineIdx = 0;
        while (startLineIdx < textRectInfo.length) {
            if (timeoutCheckCounter >= 300) {
                if (runStopwatch.TimeoutElapsed())
                    break;
                timeoutCheckCounter = 0;
            }
            var startLineInfo = textRectInfo[startLineIdx];
            var maxLineWidth = startLineInfo.lineWidth;
            var endLineIdx = startLineIdx + 1;
            while (endLineIdx < textRectInfo.length) {
                var endLineInfo = textRectInfo[endLineIdx];
                if (endLineInfo.rect.top >= startLineInfo.rect.bottom - newLineTolerance)
                    break;
                if (endLineInfo.lineWidth > maxLineWidth)
                    maxLineWidth = endLineInfo.lineWidth;
                ++endLineIdx;
            }
            out_formattedTextInfo.AddLine(maxLineWidth);
            for (i = startLineIdx; i < endLineIdx; ++i) {
                var srcTextInfo = textRectInfo[i];
                var destTextInfo = gcontext.TextRectInfo(srcTextInfo.text, srcTextInfo.rect, maxLineWidth, srcTextInfo.endsWithWhitespace);
                timeoutCheckCounter += 1;
                out_formattedTextInfo.AddTextInfo(destTextInfo);
            }
            startLineIdx = endLineIdx;
        }
        for (i = 0; i < out_formattedTextInfo.lines.length - 1; ++i) {
            if (timeoutCheckCounter >= 100) {
                if (runStopwatch.TimeoutElapsed())
                    break;
                timeoutCheckCounter = 0;
            }
            var crtLine = out_formattedTextInfo.lines[i];
            if (crtLine.textInfos.length !== 0) {
                var lastTextWithSpaceIdx = crtLine.textInfos.length - 1;
                while (lastTextWithSpaceIdx >= 0) {
                    if (crtLine.textInfos[lastTextWithSpaceIdx].endsWithWhitespace === true)
                        break;
                    --lastTextWithSpaceIdx;
                }
                if (lastTextWithSpaceIdx >= 0 && lastTextWithSpaceIdx < crtLine.textInfos.length - 1) {
                    var numWordsToShift = crtLine.textInfos.length - lastTextWithSpaceIdx - 1;
                    gcontext.TraceMessage("FormatTextRectInfoArray: starting to shift with word [" + crtLine.textInfos[lastTextWithSpaceIdx + 1].text + "]");
                    timeoutCheckCounter += 1;
                    out_formattedTextInfo.ShiftTextInfosAndReformat(i, numWordsToShift);
                }
            }
        }
        return out_formattedTextInfo;
    }
    gcontext.GetSelectedItems = function (selectElement, getAll) {
        getAll = (getAll !== 0);
        if (gcontext.SapFioriIsElementSelectable(selectElement)) {
            return gcontext.SapFioriGetSelectedItems(selectElement, getAll);
        }
        var out_selectedItems = [];
        var options = selectElement.getElementsByTagName("option");
        for (var i = 0; i < options.length; ++i) {
            var option = options.item(i);
            if (option.text != null) {
                if (getAll === true || (getAll === false && option.selected)) {
                    out_selectedItems.push(option.text);
                }
            }
        }
        return out_selectedItems;
    }
    gcontext.AddHiddenSpansForInputValues = function (htmlDoc) {
        var out_addedNodes = [];
        var i;
        var collection = htmlDoc.getElementsByTagName("input");
        for (i = 0; i < collection.length; ++i) {
            var elem = collection.item(i);
            var type = elem.type;
            var value = elem.value;
            if (type !== "hidden" && type !== "checkbox" && type !== "radio" && type !== "image" && value != null) {
                var tempElem = htmlDoc.createElement("span");
                tempElem.innerText = value;
                if (tempElem.style)
                    tempElem.style.display = "none";
                if (elem.parentNode) {
                    var newNode = elem.parentNode.insertBefore(tempElem, elem);
                    if (newNode)
                        out_addedNodes.push(newNode);
                }
            }
        }
        collection = htmlDoc.getElementsByTagName("textarea");
        for (i = 0; i < collection.length; ++i) {
            var elem = collection.item(i);
            var type = elem.type;
            var value = elem.value;
            if (value != null) {
                var tempElem = htmlDoc.createElement("span");
                tempElem.innerText = value;
                if (tempElem.style)
                    tempElem.style.display = "none";
                if (elem.parentNode) {
                    var newNode = elem.parentNode.insertBefore(tempElem, elem);
                    if (newNode)
                        out_addedNodes.push(newNode);
                }
            }
        }
        return out_addedNodes;
    }
    gcontext.SendKeysToHtmlElement = function (targetElement, htmlWindow, text, append) {
        if (targetElement == null) {
            return;
        }
        gcontext.RaiseUiEvent(targetElement, "focus", htmlWindow);
        var tagName = targetElement.tagName.toLowerCase();
        var setValue = ((tagName === "input" || tagName === "textarea") && targetElement.value !== undefined);
        var isAppendingValue = append;
        var upperCaseText = text.toUpperCase();
        for (var i = 0; i < text.length; ++i) {
            var keyCode = upperCaseText.charCodeAt(i);
            var charCode = text.charCodeAt(i);
            var letter = text[i];
            if (gcontext.RaiseKeyEvent(targetElement, "keydown", htmlWindow, keyCode, 0, letter)) {
                gcontext.RaiseKeyEvent(targetElement, "keypress", htmlWindow, charCode, charCode, letter);
            }
            gcontext.RaiseInputEvent(targetElement, "beforeinput", "insertText", letter, htmlWindow);
            if (!gcontext.xbrowser.isIOS()) {
                gcontext.RaiseTextEvent(targetElement, "textInput", letter, htmlWindow);
            }
            var lastValue = targetElement.value;
            if (setValue === true) {
                if (isAppendingValue) {
                    targetElement.value = targetElement.value + letter;
                } else {
                    targetElement.value = letter;
                }
            }
            isAppendingValue = N_TRUE;
            gcontext.RaiseInputEvent(targetElement, "input", "insertText", letter, htmlWindow, lastValue);
            gcontext.RaiseKeyEvent(targetElement, "keyup", htmlWindow, keyCode, 0, letter);
        }
        if (setValue === true) {
        } else if (targetElement.isContentEditable) {
            if (append) {
                targetElement.innerText = targetElement.innerText + text;
            } else {
                targetElement.innerText = text;
            }
        } else if (gcontext.IsSapFioriElement(targetElement)) {
            gcontext.SapFioriWriteText(targetElement, text, append);
        }
        gcontext.RaiseUiEvent(targetElement, "change", htmlWindow);
    }
    gcontext.RaiseClickEvent = function (element, view, button, clickType, screenX, screenY, clientX, clientY, ctrlOn, altOn, shiftOn) {
        if (view == null || element == null)
            return false;
        var doc = element.ownerDocument;
        if (doc == null)
            return false;
        var types = null;
        if (button == 2 && clickType == gcontext.HTML_CLICK_SINGLE) {
            types = ["mouseover", "mousemove", "mousedown", "mouseup", "contextmenu"];
        } else {
            types = (clickType == gcontext.HTML_CLICK_DOUBLE ? ["mouseover", "mousemove", "mousedown", "mouseup", "click", "mousedown", "mouseup", "click", "dblclick"] : clickType == gcontext.HTML_CLICK_HOVERONLY ? ["mouseover", "mouseenter", "mousemove"] : ["mouseover", "mousemove", "mousedown", "mouseup", "click"]);
        }
        var canBubble = true;
        var cancelable = true;
        var detail = 1;
        var relatedTarget = null;
        for (var i = 0; i < types.length; ++i) {
            try {
                var event = doc.createEvent("MouseEvents");
                if (event == null)
                    return false;
                event.rpaSimulatedEvent = true;
                event.initMouseEvent(types[i], canBubble, cancelable, view, detail, screenX, screenY, clientX, clientY, ctrlOn, altOn, shiftOn, false, button, relatedTarget);
                element.dispatchEvent(event);
            } catch (err) {
                gcontext.TraceMessage("RaiseClickEvent exception: " + err.message);
            }
        }
        return true;
    }
    gcontext.RaiseKeyEvent = function (element, type, view, keyCode, charCode, charStr) {
        if (view == null || element == null) {
            return true;
        }
        var canBubble = true;
        var cancelable = true;
        try {
            var event = new KeyboardEvent(type, {
                "bubbles": canBubble,
                "cancelable": cancelable,
                "view": view,
                "key": charStr,
                "ctrlKey": false,
                "shiftKey": false,
                "altKey": false,
                "charCode": charCode,
                "keyCode": keyCode,
            });
            event.rpaSimulatedEvent = true;
            return element.dispatchEvent(event);
        } catch (err) {
            gcontext.TraceMessage("RaiseKeyEvent exception: " + err.message);
            return false;
        }
    }
    gcontext.RaiseUiEvent = function (element, type, view) {
        if (view == null || element == null)
            return false;
        var doc = element.ownerDocument;
        if (doc == null)
            return false;
        var canBubble = true;
        var cancelable = false;
        var detail = 1;
        var event = doc.createEvent("UIEvents");
        if (event == null)
            return false;
        try {
            event.rpaSimulatedEvent = true;
            event.initUIEvent(type, canBubble, cancelable, view, detail);
            element.dispatchEvent(event);
        } catch (err) {
            gcontext.TraceMessage("RaiseUiEvent exception: " + err.message);
        }
        return true;
    }
    gcontext.RaiseInputEvent = function (element, type, inputType, data, view, lastValue) {
        if (view == null || element == null)
            return false;
        try {
            var event = new InputEvent(type, {inputType: inputType, data: data});
            event.rpaSimulatedEvent = true;
            try {
                event.simulated = true;
                var tracker = element._valueTracker;
                if (lastValue && tracker) {
                    tracker.setValue(lastValue);
                }
            } catch (err) {
                gcontext.TraceMessage("RaiseInputEvent exception: " + err.message);
            }
            element.dispatchEvent(event);
        } catch (err) {
            gcontext.TraceMessage("RaiseInputEvent exception: " + err.message);
        }
        return true;
    }
    gcontext.RaiseTextEvent = function (element, type, data, view) {
        if (view == null || element == null)
            return false;
        var doc = element.ownerDocument;
        if (doc == null)
            return false;
        var bubbles = true;
        var cancelable = true;
        var detail = 0;
        var event = doc.createEvent("TextEvent");
        try {
            event.initTextEvent(type, bubbles, cancelable, view, data, null, null);
            event.rpaSimulatedEvent = true;
            element.dispatchEvent(event);
        } catch (err) {
            gcontext.TraceMessage("RaiseTextEvent exception: " + err.message);
        }
        return true;
    }
    gcontext.getCssSelector = function (e) {
        var isElement = function (e) {
            return e && e.nodeType === Node.ELEMENT_NODE;
        };
        var nthChild = function (el, nth = 1) {
            if (el) {
                return nthChild(el.previousElementSibling, nth + 1);
            } else {
                return nth - 1;
            }
        };
        var elementPath = function (el, path = []) {
            if (isElement(el)) {
                var tag = el.nodeName.toLowerCase(), id = (el.id.length != 0 && el.id);
                if (id) {
                    return elementPath(null, path.concat(['#' + id]));
                } else {
                    return elementPath(el.parentNode, path.concat([tag + ':nth-child(' + nthChild(el) + ')']));
                }
            } else {
                return path.reverse().join(" > ");
            }
        };

        return elementPath(e, []);
    }
    gcontext.getXpathSelector = function (e) {
        if (e.id !== "") {
            // id --> //*[@id="xPath"]
            return '//*[@id=\"' + e.id + '\"]';
        }

        // body --> /html/body
        // 'e == document.body' may not be equal in frameset document, so we add a new expression 'e.nodeName == "BODY"' to check it
        if (e == document.body || e.nodeName == "BODY") {
            return '/html/' + e.tagName.toLowerCase();
        }

        // position in parent childs
        var index = 1;
        // parent childs
        var siblings = e.parentNode.childNodes;

        for (var i = 0, l = siblings.length; i < l; i++) {
            var sibling = siblings[i];
            if (sibling == e) {
                // find parent xpath
                return gcontext.getXpathSelector(e.parentNode) + '/' + e.tagName.toLowerCase() + '[' + (index) + ']';
            } else if (sibling.nodeType == 1 && sibling.tagName == e.tagName) {
                // not this
                index++;
            }
        }
    }
    gcontext.ElementIsFrame = function (e) {
        var out_isFrame = N_FALSE;
        if (e && e.tagName) {
            var tagName = e.tagName.toLowerCase();
            if (tagName === "frame" || tagName === "iframe")
                out_isFrame = N_TRUE;
        }
        return out_isFrame;
    }
    gcontext.IsMainFrame = function (frameWindow) {
        return (frameWindow.parent === frameWindow || frameWindow.parent === null);
    };
    gcontext.GetCheckedAttribute = function (elem) {
        var targetElement = gcontext.TryGetCheckableFromElement(elem);
        var type = gcontext.TryGetAttributeLowercase(targetElement, "type");
        if (type === "checkbox" || type === "radio") {
            return targetElement.checked;
        } else if (gcontext.SapFioriIsElementCheckable(elem)) {
            return gcontext.SapFioriGetChecked(elem);
        }
        return null;
    };
    gcontext.TryGetCheckableFromElement = function (elem) {
        var targetElement = elem;
        var tagName = gcontext.TryGetAttributeLowercase(elem, "tagName");
        if (tagName === "label") {
            var forId = elem.htmlFor;
            if (forId != null && forId.length !== 0) {
                var labelTarget = elem.ownerDocument.getElementById(forId);
                var type = gcontext.TryGetAttributeLowercase(labelTarget, "type");
                if ((type === "checkbox" || type === "radio") && labelTarget.checked != null) {
                    targetElement = labelTarget;
                }
            }
        }
        return targetElement;
    };
    gcontext.TryGetAttributeLowercase = function (target, property) {
        if (target == undefined || target[property] == undefined) {
            return undefined;
        }
        return target[property].toLowerCase();
    };
    gcontext.ForEachAncestor = function (targetElement, onEachAncestorCb) {
        if (targetElement == null) {
            return;
        }
        var crtElement = targetElement.parentElement;
        while (crtElement != null) {
            if (!onEachAncestorCb(crtElement)) {
                break;
            }
            crtElement = crtElement.parentElement;
        }
    }
    gcontext.HtmlElementToString = function (elem) {
        if (elem == null) {
            return "<null element>";
        }
        var maxInnertextLen = 30;
        var innerText = gcontext.GetAttributeValue(elem, "innertextshort");
        innertext = gcontext.TrimWhiteSpaces(innerText);
        if (innerText.length > maxInnertextLen) {
            innerText = innerText.slice(0, maxInnertextLen) + "...";
        }
        var className = gcontext.GetAttributeValue(elem, "class");
        var htmlId = gcontext.GetAttributeValue(elem, "id");
        return "<" + elem.tagName
            + (innerText !== "" ? " innertext='" + innerText + "'" : "")
            + (className !== "" ? " class='" + className + "'" : "")
            + (htmlId !== "" ? " id='" + htmlId + "'" : "")
            + ">";
    }
    gcontext.GetUniqueElementsFromArray = function (arr) {
        var uniquenessFilter = function (value, index, self) {
            return self.indexOf(value) === index;
        }
        return arr.filter(uniquenessFilter);
    }
});

// ------------------------------------------------------------------------
// window.outerWidth    :   浏览器物理宽度
// window.outerHeight   :   浏览器物理高度（在全屏状态下等于电脑分辨率高度 - 底层导航栏高度）
// window.innerWidth    :   浏览器内部视窗宽度，包含纵向滚动条宽度
// window.innerHeight   :   浏览器内部视窗高度，包含横向滚动条宽度
// ------------------------------------------------------------------------
WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.GetPageRenderOffsets = function (refPageRenderOfsX, refPageRenderOfsY, pageZoomFactor, windowParams) {
        var windowObj = window;
        if (windowParams)
            windowObj = windowParams;
        if (refPageRenderOfsX > 0 || refPageRenderOfsY > 0)
            return {x: refPageRenderOfsX, y: refPageRenderOfsY};
        var innerWidthPixels = windowObj.innerWidth * pageZoomFactor; // 算出来是100%浏览器不放大的宽度
        var innerHeightPixels = windowObj.innerHeight * pageZoomFactor;
        var resizeBorderSizeWidth = (windowObj.outerWidth - innerWidthPixels) / 2; // 浏览器边框
        var resizeBorderSizeHeight = windowObj.outerHeight - innerHeightPixels - resizeBorderSizeWidth; // 浏览器工具栏、tab高度之和

        // pageZoomFactor --> 浏览器缩放
        // windowObj.devicePixelRatio --> 屏幕缩放
        // 返回值需要与屏幕缩放比例相乘得到实际的值
        // 注意: 如果电脑屏幕缩放(1.25)+浏览器缩放(1.5)，那么windowObj.devicePixelRatio取出的值是两者相乘(1.25x1.5=1.875),但这边只能用电脑屏幕缩放相乘
        var clientToCssScaleFactor = windowObj.devicePixelRatio / pageZoomFactor;
        return {x: resizeBorderSizeWidth * clientToCssScaleFactor, y: resizeBorderSizeHeight * clientToCssScaleFactor};
    }
    gcontext.CssToScreenRect = function (cssRect, renderParams, useClientCoordinates, windowParams) {
        var windowObj = window;
        if (windowParams)
            windowObj = windowParams;
        var clientToCssScaleFactor = windowObj.devicePixelRatio;
        var finalRectangle = gcontext.CssToClientRect(cssRect, clientToCssScaleFactor);
        var isFirefox = (windowObj.mozInnerScreenX !== undefined);
        var pageRenderOfs = {x: 0, y: 0};
        if (isFirefox === false) {
            pageRenderOfs = gcontext.GetPageRenderOffsets(renderParams.pageRenderOfsX, renderParams.pageRenderOfsY, renderParams.pageZoomValue, windowParams);
        }
        finalRectangle = finalRectangle.Offset(pageRenderOfs.x, pageRenderOfs.y);
        if (useClientCoordinates === N_FALSE) {
            var windowLeft = isFirefox ? (windowObj.mozInnerScreenX * clientToCssScaleFactor) : renderParams.windowLeft;
            var windowTop = isFirefox ? (windowObj.mozInnerScreenY * clientToCssScaleFactor) : renderParams.windowTop;
            finalRectangle = finalRectangle.Offset(windowLeft, windowTop);
        }
        return finalRectangle;
    }
    gcontext.CssToClientRect = function (cssRect, zoomFactor) {
        return cssRect.Scale(zoomFactor).MathRound();
    }
    gcontext.ScreenToCssPos = function (screenPos, renderParams) {
        var clientToCssScaleFactor = window.devicePixelRatio;
        var isFirefox = (window.mozInnerScreenX !== undefined);
        var windowLeft = isFirefox ? (window.mozInnerScreenX * clientToCssScaleFactor) : (renderParams.windowLeft);
        var windowTop = isFirefox ? (window.mozInnerScreenY * clientToCssScaleFactor) : (renderParams.windowTop);
        var pageRenderOfs = {x: 0, y: 0};
        if (isFirefox == false) {
            pageRenderOfs = gcontext.GetPageRenderOffsets(renderParams.pageRenderOfsX, renderParams.pageRenderOfsY, renderParams.pageZoomValue);
        }
        var screenX = screenPos.x;
        var screenY = screenPos.y;
        var clientPos = {x: screenX - windowLeft - pageRenderOfs.x, y: screenY - windowTop - pageRenderOfs.y};
        var cssPos = gcontext.ClientToCssPos(clientPos, clientToCssScaleFactor);
        return cssPos;
    }
    gcontext.ScreenToCssRect = function (screenRect, renderParams) {
        var clientToCssScaleFactor = window.devicePixelRatio;
        var isFirefox = (window.mozInnerScreenX !== undefined);
        var windowLeft = isFirefox ? (window.mozInnerScreenX * clientToCssScaleFactor) : (renderParams.windowLeft);
        var windowTop = isFirefox ? (window.mozInnerScreenY * clientToCssScaleFactor) : (renderParams.windowTop);
        var pageRenderOfs = {x: 0, y: 0};
        if (isFirefox == false) {
            pageRenderOfs = gcontext.GetPageRenderOffsets(renderParams.pageRenderOfsX, renderParams.pageRenderOfsY, renderParams.pageZoomValue);
        }
        var clientOffsetX = windowLeft + pageRenderOfs.x;
        var clientOffsetY = windowTop + pageRenderOfs.y;
        var clientRect = screenRect.Offset(-clientOffsetX, -clientOffsetY);
        var cssRect = gcontext.ClientToCssRect(clientRect, clientToCssScaleFactor);
        return cssRect;
    }
    gcontext.ClientToCssRect = function (clientRect, zoomFactor) {
        return clientRect.ScaleInv(zoomFactor).MathRound();
    }
    gcontext.ClientToCssPos = function (clientPos, zoomFactor) {
        return {x: Math.round(clientPos.x / zoomFactor), y: Math.round(clientPos.y / zoomFactor)};
    }
    gcontext.GetChromeWindowScreenCoords = function (chromeWindow) {
        return {left: chromeWindow.left, top: chromeWindow.top};
    }
    gcontext.InitKeyboardEvent = function (event, type, canBubble, cancelable, view, keyCode, charCode, ctrlOn, altOn, shiftOn) {
        if (event.initKeyboardEvent) {
            event.initKeyboardEvent(type, canBubble, cancelable, view, ctrlOn, altOn, shiftOn, false, keyCode, charCode);
        } else {
            event.initKeyEvent(type, canBubble, cancelable, view, ctrlOn, altOn, shiftOn, false, keyCode, charCode);
        }
    }
    gcontext.CreateBackgroundPageComm = function (portName) {
        var m_crtRequestId = 0;
        var m_returnMap = {};
        var m_msgPort = chrome.runtime.connect({name: portName});
        m_msgPort.onMessage.addListener(function (message) {
            if (message.returnId !== undefined) {
                DismissReturnCallback(message.returnId, message);
            }
        });

        function RegisterReturnCallback(returnFunc) {
            ++m_crtRequestId;
            m_returnMap[m_crtRequestId] = returnFunc;
            return m_crtRequestId;
        }

        function DismissReturnCallback(returnId, params) {
            var returnFunc = m_returnMap[returnId];
            if (returnFunc !== undefined) {
                returnFunc(params);
                delete m_returnMap[returnId];
            }
        }

        return {
            CallFunction: function (functionName, inputParams, returnFunc) {
                if (returnFunc !== undefined)
                    inputParams.requestId = RegisterReturnCallback(returnFunc);
                inputParams.functionCall = functionName;
                m_msgPort.postMessage(inputParams);
            }, Disconnect: function () {
                m_msgPort.disconnect();
            }
        };
    }
});

WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.CUSTOM_ID_SEPARATOR = "|";
    gcontext.CUSTOM_ID_ATTR_NAME = "rpa_custom_id";
    if (window.parent !== window) {
        gcontext.CUSTOM_ID_ATTR_NAME = "rpa_inframe_custom_id"
    }
    gcontext.ResetCustomIdCache = function () {
        gcontext.g_customIdCache = {};
        gcontext.g_crtCustomIdValue = 0;
    }
    if ("undefined" != typeof g_crtCustomIdValue) {
        gcontext.g_customIdCache = g_customIdCache;
        gcontext.g_crtCustomIdValue = g_crtCustomIdValue;
    } else {
        if (typeof window.g_rpa_wd_cache !== "undefined") {
            gcontext.g_customIdCache = window.g_rpa_wd_cache.g_customIdCache;
            gcontext.g_crtCustomIdValue = window.g_rpa_wd_cache.g_crtCustomIdValue;
        } else {
            console.error("assert: you should not be on this branch");
        }
    }
    gcontext.GenerateCustomId = function () {
        if ("undefined" != typeof g_crtCustomIdValue) {
            g_crtCustomIdValue++;
            gcontext.g_crtCustomIdValue = g_crtCustomIdValue;
        } else {
            if (typeof window.g_rpa_wd_cache !== "undefined") {
                window.g_rpa_wd_cache.g_crtCustomIdValue++;
                gcontext.g_crtCustomIdValue = window.g_rpa_wd_cache.g_crtCustomIdValue;
            } else {
                console.error("GenerateCustomId: assert: you should not be on this branch");
            }
        }
        return gcontext.g_crtCustomIdValue.toString();
    }
    gcontext.GenerateCustomIdForElement = function (elem) {
        var out_customId = "";
        if (elem == null || elem.nodeType !== elem.ELEMENT_NODE)
            return out_customId;
        var attrCheck = gcontext.GetCustomIdForElement(elem);
        if (attrCheck != "") {
            out_customId = attrCheck;
        } else {
            out_customId = gcontext.GenerateCustomId();
            elem.setAttribute(gcontext.CUSTOM_ID_ATTR_NAME, out_customId);
            if (gcontext.IsSapFioriFramework(elem)) {
                gcontext.SapFioriAddHtmlDomAttribute(elem, gcontext.CUSTOM_ID_ATTR_NAME, out_customId);
            }
            gcontext.g_customIdCache[out_customId] = elem;
        }
        return out_customId;
    }
    gcontext.GetCustomIdForElement = function (elem) {
        var out_customId = "";
        if (elem == null || elem.nodeType !== elem.ELEMENT_NODE)
            return out_customId;
        var attrCheck = elem.getAttribute(gcontext.CUSTOM_ID_ATTR_NAME);
        if (attrCheck == null) {
            attrCheck = elem.getAttribute(gcontext.g_sapFioriDefines.SAP_FIORI_CUSTOM_ID_ATTR_NAME);
            if (attrCheck != null) {
                elem.setAttribute(gcontext.CUSTOM_ID_ATTR_NAME, attrCheck);
            }
        }
        if (attrCheck != null)
            out_customId = attrCheck;
        return out_customId;
    }
    gcontext.GetElementFromCustomId = function (customId) {
        var element = gcontext.g_customIdCache[customId];
        if (element && gcontext.IsSapFioriElement(element)) {
            element = document.getElementById(element.id);
            gcontext.g_customIdCache[customId] = element;
        }
        return element;
    }
    gcontext.ComputeCustomIdWithTabAndFrame_Impl = function (tabId, frameId, customIdNoTab) {
        if (typeof frameId === "undefined") {
            return tabId.toString() + CUSTOM_ID_SEPARATOR + customIdNoTab.toString();
        }
        var out_idWithTabAndFrame = tabId.toString();
        if (customIdNoTab != null && customIdNoTab !== "")
            out_idWithTabAndFrame += gcontext.CUSTOM_ID_SEPARATOR + frameId.toString() + gcontext.CUSTOM_ID_SEPARATOR + customIdNoTab;
        return out_idWithTabAndFrame;
    }
    gcontext.ComputeCustomIdWithTabAndFrame = function (tabId, frameId, customIdNoTab) {
        return gcontext.ComputeCustomIdWithTabAndFrame_Impl(tabId, frameId, customIdNoTab);
    }
    gcontext.SplitCustomIdWithFrame = function (customIdWithFrame) {
        var result = {frameId: 0, customId: ""};
        var idInfo = customIdWithFrame.split(gcontext.CUSTOM_ID_SEPARATOR);
        if (idInfo.length === 2) {
            result.frameId = parseInt(idInfo[0]);
            result.customId = idInfo[1];
        }
        return result;
    }
    gcontext.ExtractTabIdFromCustomId = function (customIdWithTab) {
        var result = {tabId: -1, customIdNoTab: ""};
        var pos = customIdWithTab.indexOf(gcontext.CUSTOM_ID_SEPARATOR);
        if (pos === -1) {
            result.tabId = parseInt(customIdWithTab);
            result.customIdNoTab = '';
        } else {
            result.tabId = parseInt(customIdWithTab.substr(0, pos));
            result.customIdNoTab = customIdWithTab.substr(pos + 1).trim();
        }
        return result;
    }
});

var gcontext = g_globalContext;
var g_functionCallMap = {
    "GetWindowIdForTabId": onGetWindowIdForTabId,
    "GetHtmlIdInfo": onGetHtmlIdInfo,
    "GetHtmlIndex": onGetHtmlIndex,
    "GetHtmlElemById": onGetHtmlElemById,
    //"GetHtmlElemById": onGetHtmlParentElemById,
    "GetHtmlParentElemById": onGetHtmlParentElemById,
    "GetHtmlRectangle": onGetHtmlRectangle,
    "ScrollIntoView": onScrollIntoView,
    "GetHtmlValue": onGetHtmlValue,
    "ClickHtmlElem": onClickHtmlElem,
    "WriteTextHtmlElem": onWriteTextHtmlElem,
    "GetHtmlCollectionById": onGetHtmlCollectionById,
    "GetHtmlAttribute": onGetHtmlAttribute,
    "CheckHtmlElem": onCheckHtmlElem,
    "HtmlGetSelectedItems": onHtmlGetSelectedItems,
    "HtmlSetSelectedItems": onHtmlSetSelectedItems,
    "GetHtmlFromPoint": onGetHtmlFromPoint,
    "IsHtmlElemValid": onIsHtmlElemValid,
    "IsElementInViewport": onIsElementInViewport,
    "GetHtmlAttributesList": onGetHtmlAttributesList,
    "SetHtmlAttribute": onSetHtmlAttribute,
    "GetFocusedHtmlElement": onGetFocusedHtmlElement,
    "SetFocusedHtmlElement": onSetFocusedHtmlElement,
    "GetTextFromScreenRect": onGetTextFromScreenRect,
    "GetRectFromText": onGetRectFromText,
    "GetHtmlDevicePixelRatio": onGetHtmlDevicePixelRatio,
    "IgnoreNextKeystrokeEvent": onIgnoreNextKeystrokeEvent,
    "GetActiveTabId": onGetActiveTabId,
    "GetActiveTabIdUsingAttributes": onGetActiveTabIdUsingAttributes,
    "Navigate": onNavigate,
    "ReplaceTabAndNavigate": onReplaceTabAndNavigate,
    "CreateTabAndNavigate": onCreateTabAndNavigate,
    "CloseBrowser": onCloseBrowser,
    "CloseWindowBrowser": onCloseWindowBrowser,
    "NavigationCommand": onNavigationCommand,
    "InjectAndRunJs": onInjectAndRunJs,
    "GetHtmlAttrValuesList": onGetHtmlAttrValuesList,
    "GetTabCount": onGetTabCount,
    "GetHtmlAncestryInfo": onGetHtmlAncestryInfo,
    "IsBrowserTabActive": onIsBrowserTabActive,
    "IsHtmlElemDisabled": onIsHtmlElemDisabled,
    "GetSelectorAttributeNames": onGetSelectorAttributeNames,
    "IsTabContentAccessible": onIsTabContentAccessible,
    "GetAttributeForElements": onGetAttributeForElements,
    "GetHtmlValueForElements": onGetHtmlValueForElements,
    "GetDocumentHtml": onGetDocumentHtml,
    "GetElementHtml": onGetElementHtml,
    "SimulateEvent": onSimulateEvent,
    "SetShelfEnabled": onSetShelfEnabled,
    "GetDownloadFiles": onGetDownloadFiles,
    "ExtractMetadata": onExtractMetadata,
    "ExtractData": onExtractData
};

var g_OnRuntimeConnectCallback = null;
var g_OnWebNavigationCompletedCallback = null;

chrome.InitializeBackgroundImpl = function () {
    g_OnRuntimeConnectCallback = function (port) {
    }
    g_OnWebNavigationCompletedCallback = function (details) {
        if (gcontext.IsBrowserSettingsUrl(details.url)) {
            gcontext.TraceMessage("OnWebNavigationCompletedCallback: skip chrome:// pages");
            return;
        }
        EnableTracingInTab(details.tabId);
    }
    chrome.runtime.onConnect.addListener(g_OnRuntimeConnectCallback);
    chrome.webNavigation.onCompleted.addListener(g_OnWebNavigationCompletedCallback);
}

chrome.PostContentInitializeImpl = function () {
    InitTracing();
}

chrome.FinalizeBackgroundImpl = function () {
    if (g_OnRuntimeConnectCallback) {
        chrome.runtime.onConnect.removeListener(g_OnRuntimeConnectCallback);
        g_OnRuntimeConnectCallback = null;
    }
    if (g_OnWebNavigationCompletedCallback) {
        chrome.webNavigation.onCompleted.removeListener(g_OnWebNavigationCompletedCallback);
        g_OnWebNavigationCompletedCallback = null;
    }
}

function InitTracing() {
    g_nativeMsgComm.CallFunction("IsTraceEnabled", {}, function (response) {
        if (response.isTraceEnabled === N_TRUE) {
            gcontext.EnableTracing();
            gcontext.TraceMessage("InitTracing: start tracing ...");
            chrome.tabs.query({url: "<all_urls>"}, function (tabsList) {
                for (var i = 0; i < tabsList.length; ++i) {
                    var tab = tabsList[i];
                    if (!gcontext.IsBrowserSettingsUrl(tab.url)) {
                        EnableTracingInTab(tab.id);
                    }
                }
            });
        }
    });
}

function EnableTracingInTab(tabId) {
    gcontext.TraceMessage("EnableTracingInTab tabId: " + tabId);
    if (gcontext.IsTracingEnabled()) {
        var args = {code: "if (typeof g_globalContext !== 'undefined' && typeof g_globalContext.EnableTracing !== 'undefined') g_globalContext.EnableTracing();"};
        if (!gcontext.xbrowser.isModeSingleFrame()) {
            args.allFrames = true;
            args.matchAboutBlank = true;
        }
        chrome.tabs.executeScript(tabId, args, function () {
            if (chrome.runtime.lastError) {
                var errorMsg = chrome.runtime.lastError.message;
                gcontext.TraceMessage("EnableTracingInTab failed for some frames in tabId=" + tabId + ", errorMsg: " + errorMsg);
            }
        });
    }
}

function GetChromePageZoom(tabId, callback) {
    gcontext.TraceMessage("Getting zoom level for tab: " + tabId);
    chrome.tabs.getZoom(tabId, function (out_zoomFactor) {
        if (chrome.runtime.lastError) {
            var errorMsg = chrome.runtime.lastError.message;
            gcontext.TraceMessage("GetChromePageZoom failed for tabId:" + tabId + ", errorMsg: " + errorMsg);
            callback(1.0);
        } else {
            gcontext.TraceMessage(out_zoomFactor + " zoom level for tab: " + tabId);
            callback(out_zoomFactor);
        }
    });
}

function getFileCodeObjectForFrame(scriptName, frameId) {
    var resObj = getFileCodeObject(scriptName);
    if (frameId !== undefined && !gcontext.xbrowser.isModeSingleFrame()) {
        resObj.frameId = frameId;
        resObj.matchAboutBlank = true;
    }
    return resObj;
}

function ExecuteScript(tabId, frameId, scriptName, inputParams, returnFunc) {
    function ExecuteScriptInFrame() {
        gcontext.TraceMessage("ExecuteScript: execute script=\"" + scriptName + "\" in frameId=" + frameId);
        chrome.tabs.executeScript(tabId, getFileCodeObjectForFrame(scriptName, frameId), function () {
            chrome.tabs.executeScript(tabId, getFileCodeObjectForFrame("ProxyCall.js", frameId), function () {
                if (chrome.runtime.lastError) {
                    gcontext.TraceMessage("ExecuteScript: cannot inject script into frame, lastError.message: " + chrome.runtime.lastError.message);
                    return returnFunc(lastErrorResult, frameId);
                }
                inputParams.tabId = tabId;
                inputParams.frameId = frameId;
                gcontext.xbrowser.tabs.sendMessage(tabId, inputParams, frameId, function (outputParams) {
                    gcontext.TraceMessage("ExecuteScript: received response from script=\"" + scriptName + "\" in frameId=" + frameId);
                    if (chrome.runtime.lastError) {
                        gcontext.TraceMessage("ExecuteScript: cannot send message with input arguments to tab/frame, lastError.message: " + chrome.runtime.lastError.message);
                        return returnFunc(lastErrorResult, lastErrorFrameId);
                    }
                    pendingRequests = coFwd.ExtractPendingRequests(pendingRequests, outputParams);
                    if (pendingRequests.length === 0) {
                        gcontext.TraceMessage("ExecuteScript: got final response, no more pending requests");
                        return returnFunc(outputParams, frameId);
                    }
                    var request = pendingRequests.pop();
                    lastErrorResult = request.errorResult;
                    lastErrorFrameId = request.srcFrameId;
                    if (gcontext.xbrowser.isModeSingleFrame()) {
                        gcontext.TraceError("ExecuteScript: Error, received cross-origin frame forwarding request in single frame mode");
                        return returnFunc(lastErrorResult, lastErrorFrameId);
                    }
                    coFwd.GetDestination(request, outputParams, function (fwdDest) {
                        if (!fwdDest) {
                            gcontext.TraceMessage("ExecuteScript: Cannot get call forwarding destination frame");
                            return returnFunc(lastErrorResult, lastErrorFrameId);
                        }
                        if (fwdDest.frameId >= 0) {
                            callFwdCount += 1;
                            if (callFwdCount > maxFwdRetryCount) {
                                gcontext.TraceMessage("ExecuteScript: exceeded cross-origin call forwarding count limit: " + maxFwdRetryCount);
                                fwdDest.frameId = -1;
                            }
                        }
                        if (fwdDest.frameId < 0) {
                            return returnFunc(lastErrorResult, lastErrorFrameId);
                        }
                        frameId = fwdDest.frameId;
                        inputParams = fwdDest.message;
                        return ExecuteScriptInFrame();
                    });
                });
            });
        });
    }

    var callFwdCount = 0;
    var maxFwdRetryCount = 100;
    var pendingRequests = [];
    var lastErrorFrameId;
    var lastErrorResult;
    if (gcontext.xbrowser.isModeSingleFrame()) {
        maxFwdRetryCount = 0;
    }
    try {
        var coFwd = COFwdBackground(tabId);
        ExecuteScriptInFrame();
    } catch (e) {
        gcontext.TraceError("ExecuteScript: caught exception, message: " + e.message);
        return returnFunc(lastErrorResult, lastErrorFrameId);
    }
}

function onEnableContentTracing() {
    chrome.windows.getLastFocused({populate: false}, function (wnd) {
        chrome.tabs.query({windowId: wnd.id}, function (tabsList) {
            for (var i = 0; i < tabsList.length; i++) {
                var tab = tabsList[i];
                if (gcontext.IsBrowserSettingsUrl(tab.url)) {
                    gcontext.TraceMessage("onEnableContentTracing: skipping tab.id: " + tab.id + ", tab.url: " + tab.url);
                } else {
                    ExecuteScript(tab.id, 0, "EnableContentTracing.js", {}, function (outputParams, outputFrameId) {
                    });
                }
            }
        });
    });
}

function onGetWindowIdForTabId(params, returnFunc) {
    var tabId = params.tabId;
    var defaultReturnData = {windowId: -1, retCode: N_FALSE};
    if (tabId === -1) {
        chrome.windows.getLastFocused({populate: false}, function (wnd) {
            returnFunc({windowId: wnd.id, retCode: N_TRUE});
        });
    } else {
        chrome.tabs.get(tabId, function (tab) {
            if (chrome.runtime.lastError) {
                gcontext.TraceMessage("chrome.tabs.get failed in onGetWindowIdForTabId: " + chrome.runtime.lastError.message);
                returnFunc(defaultReturnData);
            } else {
                returnFunc({windowId: tab.windowId, retCode: N_TRUE});
            }
        });
    }
}

function onIsTabContentAccessible(params, returnFunc) {
    var tabId = params.tabId;
    var defaultReturnData = {retCode: N_FALSE};
    gcontext.TraceMessage("onIsTabContentAccessible");
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var args = {code: ""};
    chrome.tabs.executeScript(tabId, args, function () {
        if (chrome.runtime.lastError) {
            var errorMsg = chrome.runtime.lastError.message;
            gcontext.TraceMessage("onIsTabContentAccessible failed for tabId=" + tabId + ", errorMsg: " + errorMsg);
            returnFunc({retCode: N_FALSE});
        } else {
            returnFunc({retCode: N_TRUE});
        }
    });
}

function onGetHtmlIdInfo(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var parentFrameId = gcontext.SplitCustomIdWithFrame(params.parentCustomId).frameId;
    var parentCustomId = gcontext.SplitCustomIdWithFrame(params.parentCustomId).customId;
    var computeIndex = params.computeIndex;
    var defaultReturnData = {tagName: "", attrMap: {}, index: -1, retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    if (parentCustomId.length > 0 && frameId !== parentFrameId) {
        gcontext.TraceMessage("onGetHtmlIdInfo: Element's parent is a frame/iframe element in parentFrameId=" + parentFrameId);
        parentFrameId = frameId;
        parentCustomId = "";
    }
    var inputParams = {parentId: parentCustomId, customId: customId, computeIndex: computeIndex};
    ExecuteScript(tabId, frameId, "GetHtmlIdInfo.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else {
            returnFunc(defaultReturnData);
        }
    });
}

function onGetHtmlIndex(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var parentFrameId = gcontext.SplitCustomIdWithFrame(params.parentCustomId).frameId;
    var parentCustomId = gcontext.SplitCustomIdWithFrame(params.parentCustomId).customId;
    var defaultReturnData = {index: -1, retCode: N_FALSE};
    gcontext.TraceMessage("onGetHtmlIndex: typeof(customId)=[" + typeof (customId) + "] len=" + customId.length);
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    if (parentCustomId.length > 0 && frameId !== parentFrameId) {
        gcontext.TraceMessage("onGetHtmlIndex: Element's parent is a frame/iframe element in parentFrameId=" + parentFrameId);
        parentFrameId = frameId;
        parentCustomId = "";
    }
    if (IsEmptyCustomId(customId)) {
        var inputParams = {attrMap: gcontext.AttributeValueMap(params.attrMap), maxElems: Number.MAX_VALUE, useTagFuzzyLevel: false, tagFuzzyLevel: 0};
        gcontext.TraceMessage("onGetHtmlIndex: tabId=" + tabId + " customId=[" + customId + "] attrMap=" + gcontext.EnumObjectProps(gcontext.ActiveValueStringMap(inputParams.attrMap), true));
        gcontext.TraceMessage("onGetHtmlIndex: calculating tab index");
        gcontext.FindTabCollectionUsingAttributes(inputParams, function (tabResultsCollection) {
            gcontext.TraceMessage("onGetHtmlIndex: resTabs.length=" + tabResultsCollection.GetResults().length);
            var outputParams = {index: -1, retCode: N_FALSE};
            for (var i in tabResultsCollection.GetResults()) {
                if (tabResultsCollection.GetResults()[i].m_tab.id === tabId) {
                    outputParams.index = i;
                    break;
                }
            }
            if (outputParams.index !== -1) {
                outputParams.retCode = N_TRUE;
                if (resTabs.length > 1)
                    ++outputParams.index;
            }
            returnFunc(outputParams);
        });
    } else {
        gcontext.TraceMessage("onGetHtmlIndex: calculating HTML index");
        var inputParams = {parentId: parentCustomId, customId: customId, attrMap: params.attrMap};
        ExecuteScript(tabId, frameId, "GetHtmlIndex.js", inputParams, function (outputParams, outputFrameId) {
            if (outputParams !== undefined)
                returnFunc(outputParams); else
                returnFunc(defaultReturnData);
        });
    }
}

function onGetHtmlElemById(params, returnFunc) {
    var tabId = params.tabId;
    var parentFrameId = gcontext.SplitCustomIdWithFrame(params.parentCustomId).frameId;
    var parentCustomId = gcontext.SplitCustomIdWithFrame(params.parentCustomId).customId;
    var tagName = gcontext.GetActiveValueString(new gcontext.AttributeValue(params.tagName));
    var index = params.index;
    var isCompatible = params.isCompatible;
    var defaultReturnData = {customId: "", isBrowserReady: N_FALSE, retCode: N_FALSE};
    gcontext.DebugMessage("onGetHtmlElemById: tabId: " + tabId + ", tagName: " + tagName + ", index: " + index);
    if (index < 1) {
        returnFunc(defaultReturnData);
        return;
    }
    if (tabId === -1) {
        var inputParams = {attrMap: gcontext.AttributeValueMap(params.attrMap), maxElems: Number.MAX_VALUE, useTagFuzzyLevel: false, tagFuzzyLevel: 0};
        gcontext.FindTabCollectionUsingAttributesByCompatible(isCompatible, inputParams, function (tabResultsCollection) {
            var outputParams = {customId: "", isBrowserReady: N_FALSE, retCode: N_FALSE};
            if (index <= tabResultsCollection.GetResults().length) {
                var tab = tabResultsCollection.GetResults()[index - 1].m_tab;
                outputParams.customId = gcontext.ComputeCustomIdWithTabAndFrame(tab.id, null, null);
                outputParams.isBrowserReady = (tab.status === "complete" ? N_TRUE : N_FALSE);
                outputParams.retCode = N_TRUE;
            }

            gcontext.TraceMessage("onGetHtmlElemById: out_customId=[" + outputParams.customId + "]");
            returnFunc(outputParams);
        });
    } else {
        var inputParams = {parentId: parentCustomId, tagName: tagName, index: index, attrMap: params.attrMap, extendedAttrMap: params.extendedAttributes, isCompatible: params.isCompatible};
        ExecuteScript(tabId, parentFrameId, "GetHtmlElemById.js", inputParams, function (outputParams, outputFrameId) {
            if (outputParams !== undefined) {
                chrome.tabs.get(tabId, function (tab) {
                    outputParams.customId = gcontext.ComputeCustomIdWithTabAndFrame(tabId, outputFrameId, outputParams.customId);
                    if ((tab.status === "complete") && (outputParams.isDocumentReady === N_TRUE)) {
                        outputParams.isBrowserReady = N_TRUE;
                    } else {
                        outputParams.isBrowserReady = N_FALSE;
                    }
                    gcontext.TraceMessage("onGetHtmlElemById: out_customId=[" + outputParams.customId + "]"
                        + ", tab.status: " + tab.status
                        + ", outputParams.isDocumentReady: " + outputParams.isDocumentReady
                        + ", outputParams.isBrowserReady: " + outputParams.isBrowserReady);
                    returnFunc(outputParams);
                });
            } else {
                returnFunc(defaultReturnData);
            }
        });
    }
}

function onGetHtmlParentElemById(params, returnFunc) {
    var tabId = params.tabId;
    var parentFrameId = gcontext.SplitCustomIdWithFrame(params.parentCustomId).frameId;
    var parentCustomId = gcontext.SplitCustomIdWithFrame(params.parentCustomId).customId;
    var tagName = gcontext.GetActiveValueString(new gcontext.AttributeValue(params.tagName));
    var index = params.index;
    var isCompatible = params.isCompatible;
    var defaultReturnData = {customId: "", isBrowserReady: N_FALSE, retCode: N_FALSE};
    gcontext.DebugMessage("onGetHtmlParentElemById: tabId: " + tabId + ", tagName: " + tagName + ", index: " + index);
    if (index < 1) {
        returnFunc(defaultReturnData);
        return;
    }
    if (tabId === -1) {
        var inputParams = {attrMap: gcontext.AttributeValueMap(params.attrMap), maxElems: Number.MAX_VALUE, useTagFuzzyLevel: false, tagFuzzyLevel: 0};
        gcontext.FindTabCollectionUsingAttributesByCompatible(isCompatible, inputParams, function (tabResultsCollection) {
            var outputParams = {customId: "", isBrowserReady: N_FALSE, retCode: N_FALSE};
            if (index <= tabResultsCollection.GetResults().length) {
                var tab = tabResultsCollection.GetResults()[index - 1].m_tab;
                outputParams.customId = gcontext.ComputeCustomIdWithTabAndFrame(tab.id, null, null);
                outputParams.isBrowserReady = (tab.status === "complete" ? N_TRUE : N_FALSE);
                outputParams.retCode = N_TRUE;
            }
            gcontext.TraceMessage("onGetHtmlParentElemById: out_customId=[" + outputParams.customId + "]");
            returnFunc(outputParams);
        });
    } else {
        var inputParams = {parentId: parentCustomId, tagName: tagName, index: index, attrMap: params.attrMap, extendedAttrMap: params.extendedAttributes, isCompatible: params.isCompatible};
        ExecuteScript(tabId, parentFrameId, "GetHtmlParentElemById.js", inputParams, function (outputParams, outputFrameId) {
            if (outputParams !== undefined) {
                chrome.tabs.get(tabId, function (tab) {
                    outputParams.customId = gcontext.ComputeCustomIdWithTabAndFrame(tabId, outputFrameId, outputParams.customId);
                    if ((tab.status === "complete") && (outputParams.isDocumentReady === N_TRUE)) {
                        outputParams.isBrowserReady = N_TRUE;
                    } else {
                        outputParams.isBrowserReady = N_FALSE;
                    }
                    gcontext.TraceMessage("onGetHtmlParentElemById: out_customId=[" + outputParams.customId + "]"
                        + ", tab.status: " + tab.status
                        + ", outputParams.isDocumentReady: " + outputParams.isDocumentReady
                        + ", outputParams.isBrowserReady: " + outputParams.isBrowserReady);
                    returnFunc(outputParams);
                });
            } else {
                returnFunc(defaultReturnData);
            }
        });
    }
}

function onGetHtmlRectangle(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var useClientCoordinates = params.useClientCoordinates;
    var wndLeft_ScreenPhysical = params.windowLeft;
    var wndTop_ScreenPhysical = params.windowTop;

    var curson = params.curson;
    var offsetX = params.offsetX;
    var offsetY = params.offsetY;
    var isscroll = params.isscroll;

    var defaultReturnData = {left: 0, top: 0, right: 0, bottom: 0, retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }

    GetChromePageZoom(tabId, function (zoomLvl) {
        var inputZoomParams = {
            customId: customId,
            curZoom: zoomLvl,
            curson: curson,
            offsetX: offsetX,
            offsetY: offsetY,
            isscroll: isscroll
        };

        ExecuteScript(tabId, frameId, "IsElementInViewport.js", inputZoomParams, function (outputParams, outputFrameId) {
            if (outputParams !== undefined) {
                if (outputParams.isElementInScreen == 1) {
                    var inputParams = {
                        windowLeft: wndLeft_ScreenPhysical,
                        windowTop: wndTop_ScreenPhysical,
                        customId: customId,
                        useClientCoordinates: useClientCoordinates,
                        pageZoomValue: zoomLvl,
                        pageRenderOfsX: params.pageRenderOfsX,
                        pageRenderOfsY: params.pageRenderOfsY
                    };
                    ExecuteScript(tabId, frameId, "GetHtmlRectangle.js", inputParams, function (outputParams1, outputFrameId1) {
                        if (outputParams1 !== undefined) {
                            returnFunc(outputParams1);
                        } else
                            returnFunc(defaultReturnData);
                    });
                } else {
                    // Over the viewport
                    defaultReturnData.retCode = N_TRUE;
                    returnFunc(defaultReturnData);
                }
            } else {
                returnFunc(defaultReturnData);
            }
        });
    });
}

function onScrollIntoView(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var defaultReturnData = {retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {customId: customId,};
    ExecuteScript(tabId, frameId, "ScrollIntoView.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else
            returnFunc(defaultReturnData);
    });
}

function onInjectAndRunJs(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var jsCode = params.jsCode;
    var input = params.input;
    var defaultReturnData = {result: "", isScriptErr: 0, retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {tabId: tabId, customId: customId, jsCode: jsCode, inputData: input};
    ExecuteScript(tabId, frameId, "InjectAndRunJs.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else
            returnFunc(defaultReturnData);
    });
}

function onGetHtmlValue(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var getFullText = params.getFullText;
    var defaultReturnData = {value: "", retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {customId: customId, getFullText: getFullText};
    ExecuteScript(tabId, frameId, "GetHtmlValue.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else
            returnFunc(defaultReturnData);
    });
}

function onClickHtmlElem(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var wndLeft_ScreenPhysical = params.windowLeft;
    var wndTop_ScreenPhysical = params.windowTop;
    var pointX_ScreenPhysical = params.x;
    var pointY_ScreenPhysical = params.y;
    var flags = params.flags;
    var defaultReturnData = {retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {customId: customId, windowLeft: wndLeft_ScreenPhysical, windowTop: wndTop_ScreenPhysical, x: pointX_ScreenPhysical, y: pointY_ScreenPhysical, flags: flags};
    ExecuteScript(tabId, frameId, "ClickHtmlElem.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else {
            returnFunc(defaultReturnData);
        }
    });
}

function onWriteTextHtmlElem(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var text = params.text;
    var append = params.append;
    var defaultReturnData = {retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {customId: customId, text: text, append: append};
    ExecuteScript(tabId, frameId, "WriteTextHtmlElem.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else
            returnFunc(defaultReturnData);
    });
}

function onGetHtmlCollectionById(params, returnFunc) {
    var defaultReturnData = {results: [], retCode: N_TRUE};

    function GetFrameRectangle(tabId, frameId, frameRectangleReturnFunc) {
        gcontext.TraceMessage("onGetHtmlCollectionById: GetFrameRectangle enter tabId=\"" + tabId + "\" frameId=\"" + frameId + "\"");
        var getRectangleInputParams = {
            tabId: tabId,
            customId: frameId + gcontext.CUSTOM_ID_SEPARATOR + "",
            useClientCoordinates: N_FALSE,
            scrollIntoView: N_FALSE,
            windowLeft: params.windowLeft,
            windowTop: params.windowTop,
            pageRenderOfsX: params.pageRenderOfsX,
            pageRenderOfsY: params.pageRenderOfsY
        };
        gcontext.DebugMessage("onGetHtmlCollectionById: GetFrameRectangle getRectangleInputParams :" +getRectangleInputParams);
        onGetHtmlRectangle(getRectangleInputParams, function (getRectangleOutputParams) {
            var out_retCode = getRectangleOutputParams.retCode;
            var out_rcFrame = [0, 0, 0, 0];
            if (out_retCode == N_TRUE) {
                out_rcFrame = [getRectangleOutputParams.left, getRectangleOutputParams.top, getRectangleOutputParams.right, getRectangleOutputParams.bottom];
            }
            gcontext.DebugMessage("onGetHtmlCollectionById: GetFrameRectangle return retCode=\"" + out_retCode + "\" rcFrame=[" + out_rcFrame + "]");
            frameRectangleReturnFunc(out_rcFrame, out_retCode);
            return;
        });
    }

    function GetTabRectangle(tab, tabRectangleReturnFunc) {
        gcontext.TraceMessage("onGetHtmlCollectionById: GetTabRectangle enter tabId=" + tab.id);
        chrome.windows.get(tab.windowId, {}, function (window) {
            var wndLeft = (window.left !== undefined) ? window.left : 0;
            var wndTop = (window.top !== undefined) ? window.top : 0;
            var wndWidth = (window.width !== undefined) ? window.width : 0;
            var wndHeight = (window.height !== undefined) ? window.height : 0;
            var wndRect = {left: wndLeft, top: wndTop, right: (wndLeft + wndWidth), bottom: (wndTop + wndHeight)};
            gcontext.TraceMessage("onGetHtmlCollectionById: window.id: " + window.id + ", wndRect: "
                + " [(" + wndRect.left + ", " + wndRect.top + "), (" + wndRect.right + ", " + wndRect.bottom + ")]");
            var out_rcFrame = [wndRect.left, wndRect.top, wndRect.right, wndRect.bottom];
            tabRectangleReturnFunc(out_rcFrame);
        });
    }

    if (params.tabId === -1) {
        var inputParams = {attrMap: gcontext.AttributeValueMap(params.attrMap), maxElems: params.maxElems, useTagFuzzyLevel: params.useTagFuzzyLevel, tagFuzzyLevel: params.tagFuzzyLevel};
        gcontext.FindTabCollectionUsingAttributes(inputParams, function (tabResultsCollection) {
            gcontext.TraceMessage("onGetHtmlCollectionById: found " + tabResultsCollection.GetResults().length + " elems");
            var outputParams = {results: [], retCode: N_TRUE};
            var i = 0;

            function AppendTab() {
                if (i >= tabResultsCollection.GetResults().length || i >= params.maxElems) {
                    return returnFunc(outputParams);
                }
                var tab = tabResultsCollection.GetResults()[i].m_tab;
                gcontext.TraceMessage("onGetHtmlCollectionById: append tab #" + i + " to collection, tabId=" + tab.id);
                GetTabRectangle(tab, function (out_rcTab) {
                    var tabCustomId = gcontext.ComputeCustomIdWithTabAndFrame(tab.id, null, null);
                    var score = tabResultsCollection.GetResults()[i].m_matchingScore;
                    outputParams.results.push(new gcontext.SearchResult(tabCustomId, score, out_rcTab));
                    i++;
                    AppendTab();
                });
            }

            AppendTab();
        });
    } else {
        var inputParams = {
            parentId: gcontext.SplitCustomIdWithFrame(params.parentCustomId).customId,
            getAllDescendants: params.getAllDescendants,
            tagName: gcontext.GetActiveValueString(new gcontext.AttributeValue(params.tagName)),
            attrMap: params.attrMap,
            maxElems: params.maxElems,
            useTagFuzzyLevel: params.useTagFuzzyLevel,
            tagFuzzyLevel: params.tagFuzzyLevel
        };
        var parentFrameId = gcontext.SplitCustomIdWithFrame(params.parentCustomId).frameId;
        ExecuteScript(params.tabId, parentFrameId, "GetHtmlCollectionById.js", inputParams, function (outputParams, outputFrameId) {
            if (outputParams !== undefined) {
                gcontext.TraceMessage("onGetHtmlCollectionById: get containing frame position, tabId=" + params.tabId + " frameId=" + outputFrameId);
                GetFrameRectangle(params.tabId, outputFrameId.toString(), function (out_rcFrame, out_retCode) {
                    if (out_retCode != N_TRUE) {
                        gcontext.TraceError("onGetHtmlCollectionById: failed to get screen rectangle of tabId=" + params.tabId + " frameId=" + outputFrameId);
                        return returnFunc(defaultReturnData);
                    }
                    var offsetX = out_rcFrame[0];
                    var offsetY = out_rcFrame[1];
                    gcontext.TraceMessage("onGetHtmlCollectionById: found " + outputParams.results.length + " elements");
                    for (i = 0; i < outputParams.results.length; ++i) {
                        outputParams.results[i].m_customId = gcontext.ComputeCustomIdWithTabAndFrame(params.tabId, outputFrameId, outputParams.results[i].m_customId);
                        outputParams.results[i].m_position[0] += offsetX;
                        outputParams.results[i].m_position[1] += offsetY;
                        outputParams.results[i].m_position[2] += offsetX;
                        outputParams.results[i].m_position[3] += offsetY;
                    }
                    returnFunc(outputParams);
                });
            } else {
                returnFunc(defaultReturnData);
            }
        });
    }
}

function onGetAttributeForElements(params, returnFunc) {
    var customIdList = params.customIdList;
    var attributeName = params.attributeName;
    var outputParams = {attributeValues: [], retCode: N_TRUE};
    var OnAllElementsProcessed = function () {
        gcontext.TraceMessage("onGetAttributeForElements: attributeValues.length = " + outputParams.attributeValues.length);
        returnFunc(outputParams);
    };
    var elementCount = customIdList ? customIdList.length : 0;
    if (elementCount == 0) {
        OnAllElementsProcessed();
    } else {
        var ProcessElement = function (i) {
            var extractedInfo = gcontext.ExtractTabIdFromCustomId(customIdList[i]);
            gcontext.TraceMessage("onGetAttributeForElements: " + "customId[" + i + "] = " + customIdList[i] + "; extractedInfo.tabId = " + extractedInfo.tabId + "; extractedInfo.customIdNoTab = " + extractedInfo.customIdNoTab);
            var getAttributeParams = {tabId: extractedInfo.tabId, customId: extractedInfo.customIdNoTab, attrName: attributeName};
            onGetHtmlAttribute(getAttributeParams, function (returnData) {
                outputParams.attributeValues.push(returnData.attrValue);
                if (returnData.retCode === N_FALSE) {
                    outputParams.retCode = N_FALSE;
                }
                OnElementProcessed(i);
            });
        };
        var OnElementProcessed = function (i) {
            if (i === elementCount - 1) {
                OnAllElementsProcessed();
            } else {
                ProcessElement(++i);
            }
        };
        ProcessElement(0);
    }
}

function onGetHtmlValueForElements(params, returnFunc) {
    var customIdList = params.customIdList;
    var getFullText = params.getFullText;
    var outputParams = {htmlValues: [], retCode: N_TRUE};
    var OnAllElementsProcessed = function () {
        gcontext.TraceMessage("onGetAttributeForElements: htmlValues.length = " + outputParams.htmlValues.length);
        returnFunc(outputParams);
    };
    var elementCount = customIdList ? customIdList.length : 0;
    if (elementCount == 0) {
        OnAllElementsProcessed();
    } else {
        var ProcessElement = function (i) {
            var extractedInfo = gcontext.ExtractTabIdFromCustomId(customIdList[i]);
            gcontext.TraceMessage("onGetHtmlValueForElements: " + "customId[" + i + "] = " + customIdList[i] + "; extractedInfo.tabId = " + extractedInfo.tabId + "; extractedInfo.customIdNoTab = " + extractedInfo.customIdNoTab);
            var getHtmlValueParams = {tabId: extractedInfo.tabId, customId: extractedInfo.customIdNoTab, getFullText: getFullText};
            onGetHtmlValue(getHtmlValueParams, function (returnData) {
                outputParams.htmlValues.push(returnData.value);
                if (returnData.retCode === N_FALSE) {
                    outputParams.retCode = N_FALSE;
                }
                OnElementProcessed(i);
            });
        };
        var OnElementProcessed = function (i) {
            if (i === elementCount - 1) {
                OnAllElementsProcessed();
            } else {
                ProcessElement(++i);
            }
        };
        ProcessElement(0);
    }
}

function onGetDocumentHtml(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var defaultReturnData = {retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {};
    ExecuteScript(tabId, frameId, "GetDocumentHtml.js", inputParams, function (outputParams) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else {
            returnFunc(defaultReturnData);
        }
    });
}

function onGetElementHtml(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var defaultReturnData = {retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {customId: customId};
    ExecuteScript(tabId, frameId, "GetElementHtml.js", inputParams, function (outputParams) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else {
            returnFunc(defaultReturnData);
        }
    });
}

function onGetHtmlAttribute(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var attrName = params.attrName;
    var defaultReturnData = {attrValue: "", retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var ExecuteScriptGetAttr = function () {
        var inputParams = {customId: customId, attrName: attrName};
        if (attrName.toLowerCase() === "readystate") {
            getElementReadyState(tabId, frameId, inputParams, function (outputParams) {
                if (outputParams !== undefined) {
                    returnFunc(outputParams);
                } else {
                    returnFunc(defaultReturnData);
                }
            });
        } else {
            ExecuteScript(tabId, frameId, "GetHtmlAttribute.js", inputParams, function (outputParams, outputFrameId) {
                if (outputParams !== undefined) {
                    returnFunc(outputParams);
                } else {
                    returnFunc(defaultReturnData);
                }
            });
        }
    }
    if (customId.length === 0 && (attrName.toLowerCase() === "pagetitle" || attrName.toLowerCase() === "title")) {
        chrome.tabs.get(tabId, function (tab) {
            if (tab.status === "complete" || tab.title != "") {
                returnFunc({attrValue: tab.title, retCode: N_TRUE});
            } else {
                ExecuteScriptGetAttr();
            }
        });
    } else if (customId.length === 0 && attrName.toLowerCase() === "url") {
        chrome.tabs.get(tabId, function (tab) {
            if (tab.status === "complete" || tab.url != "") {
                returnFunc({attrValue: tab.url, retCode: N_TRUE});
            } else {
                ExecuteScriptGetAttr();
            }
        });
    } else {
        ExecuteScriptGetAttr();
    }
}

function getElementReadyState(tabId, frameId, inputParams, returnFunc) {
    chrome.tabs.get(tabId, function (tab) {
        if ((inputParams.customId.length !== 0) && (tab.status === "complete")) {
            ExecuteScript(tabId, frameId, "GetHtmlAttribute.js", inputParams, function (outputParams, outputFrameId) {
                if (outputParams !== undefined) {
                    var documentReadyState = outputParams.attrValue;
                    var retCode = outputParams.retCode;
                    gcontext.TraceMessage("getElementReadyState:" +
                        " tab.status: " + tab.status +
                        ", document.readyState: " + documentReadyState +
                        ", retCode: " + retCode);
                    returnFunc(outputParams);
                } else {
                    returnFunc({attrValue: "", retCode: N_FALSE});
                }
            });
        } else {
            gcontext.TraceMessage("getElementReadyState: tab.status: " + tab.status);
            var tabReadyState = (tab.status === "complete" ? "1" : "0");
            returnFunc({attrValue: tabReadyState, retCode: N_TRUE});
        }
    });
}

function onCheckHtmlElem(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var doCheck = params.doCheck;
    var wndLeft_ScreenPhysical = params.windowLeft;
    var wndTop_ScreenPhysical = params.windowTop;
    var defaultReturnData = {isCheckable: N_FALSE, retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {customId: customId, doCheck: doCheck, windowLeft: wndLeft_ScreenPhysical, windowTop: wndTop_ScreenPhysical};
    ExecuteScript(tabId, frameId, "CheckHtmlElem.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else
            returnFunc(defaultReturnData);
    });
}

function onHtmlGetSelectedItems(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var getAllItems = params.getAllItems;
    var defaultReturnData = {retCode: 0, selectedItems: []};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {customId: customId, getAllItems: getAllItems,};
    ExecuteScript(tabId, frameId, "HtmlGetSelectedItems.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else
            returnFunc(defaultReturnData);
    });
}

function onHtmlSetSelectedItems(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var reset = params.reset;
    var selectIfDisabled = params.selectIfDisabled;
    var selectedItems = params.selectedItems;
    var itemMode = params.itemMode;
    if(!itemMode){
        itemMode = "text";
    }
    var defaultReturnData = {retCode: 0};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {customId: customId, reset: reset, selectIfDisabled: selectIfDisabled, selectedItems: selectedItems,itemMode:itemMode};
    gcontext.TraceMessage("onHtmlSetSelectedItems: reset=" + reset);
    gcontext.TraceMessage("onHtmlSetSelectedItems: selectIfDisabled=" + selectIfDisabled);
    gcontext.TraceMessage("onHtmlSetSelectedItems: selectedItems=" + selectedItems);
    gcontext.TraceMessage("onHtmlSetSelectedItems: itemMode=" + itemMode);
    ExecuteScript(tabId, frameId, "HtmlSetSelectedItems.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else
            returnFunc(defaultReturnData);
    });
}

function onGetHtmlFromPoint(params, returnFunc) {
    var pointX_ScreenPhysical = params.screenX;
    var pointY_ScreenPhysical = params.screenY;
    var windowId = params.windowId;
    var wndLeft_ScreenPhysical = params.windowLeft;
    var wndTop_ScreenPhysical = params.windowTop;
    var defaultReturnData = {customId: "", retCode: N_FALSE, isPointOutOfBounds: N_FALSE};
    gcontext.TraceMessage("onGetHtmlFromPoint: windowId=" + windowId);
    chrome.tabs.query({active: true, windowId: windowId}, function (tabs) {
        if (tabs.length > 0) {
            var tab = tabs[0];
            GetChromePageZoom(tab.id, function (zoomLvl) {
                var inputParams = {
                    windowLeft: wndLeft_ScreenPhysical,
                    windowTop: wndTop_ScreenPhysical,
                    screenX: pointX_ScreenPhysical,
                    screenY: pointY_ScreenPhysical,
                    pageZoomValue: zoomLvl,
                    pageRenderOfsX: params.pageRenderOfsX,
                    pageRenderOfsY: params.pageRenderOfsY,
                    parentTagSelect: params.parentTagSelect
                };
                ExecuteScript(tab.id, 0, "GetHtmlFromPoint.js", inputParams, function (outputParams, frameId) {
                    if (outputParams !== undefined) {
                        outputParams.customId = gcontext.ComputeCustomIdWithTabAndFrame(tab.id, frameId, outputParams.customId);
                        returnFunc(outputParams);
                    } else
                        returnFunc(defaultReturnData);
                });
            });
        }
    });
}

function onIsHtmlElemValid(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var defaultReturnData = {retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    if (IsEmptyCustomId(customId)) {
        GetTab(tabId, function (foundTab) {
            var retCode = foundTab ? N_TRUE : N_FALSE;
            returnFunc({retCode: retCode});
        });
    } else {
        var inputParams = {customId: customId};
        ExecuteScript(tabId, frameId, "IsHtmlElemValid.js", inputParams, function (outputParams, outputFrameId) {
            if (outputParams !== undefined) {
                returnFunc(outputParams);
            } else
                returnFunc(defaultReturnData);
        });
    }
}

function onIsElementInViewport(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var defaultReturnData = {retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }

    if (IsEmptyCustomId(customId)) {
        returnFunc(defaultReturnData);
        return;
    } else {
        chrome.tabs.getZoom(tabId, function (out_zoomFactor) {
            if (chrome.runtime.lastError) {
                out_zoomFactor = 1;
            }
            var inputParams = {customId: customId, curZoom: out_zoomFactor};
            ExecuteScript(tabId, frameId, "IsElementInViewport.js", inputParams, function (outputParams, outputFrameId) {
                if (outputParams !== undefined) {
                    returnFunc(outputParams);
                } else
                    returnFunc(defaultReturnData);
            });
        });
    }
}

function onIsBrowserTabActive(params, returnFunc) {
    var tabId = params.tabId;
    var defaultReturnData = {retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    GetTab(tabId, function (foundTab) {
        var retCode = N_FALSE;
        if (foundTab && foundTab.active) {
            retCode = N_TRUE;
        }
        returnFunc({retCode: retCode});
    });
}

function onIsHtmlElemDisabled(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var checkIfDisabled = params.checkIfDisabled;
    var checkIfReadonly = params.checkIfReadonly;
    var defaultReturnData = {retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    if (IsEmptyCustomId(customId)) {
        returnFunc(defaultReturnData);
        return;
    } else {
        var inputParams = {customId: customId, checkIfDisabled: checkIfDisabled, checkIfReadonly: checkIfReadonly};
        ExecuteScript(tabId, frameId, "IsHtmlElemDisabled.js", inputParams, function (outputParams, outputFrameId) {
            if (outputParams !== undefined) {
                returnFunc(outputParams);
            } else
                returnFunc(defaultReturnData);
        });
    }
}

function onGetHtmlAttrValuesList(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var defaultReturnData = {htmlAttributes: {}, retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {customId: customId};
    ExecuteScript(tabId, frameId, "GetHtmlAttrValuesList.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else
            returnFunc(defaultReturnData);
    });
}

function onGetHtmlAttributesList(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var defaultReturnData = {htmlAttributes: [], retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {customId: customId};
    ExecuteScript(tabId, frameId, "GetHtmlAttributesList.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else
            returnFunc(defaultReturnData);
    });
}

function onGetSelectorAttributeNames(params, returnFunc) {
    var tabId = params.tabId;
    var defaultReturnData = {retCode: N_FALSE, selectorAttributeNames: []};
    var temp = gcontext.SplitCustomIdWithFrame(params.customId);
    if (temp == null) {
        returnFunc(defaultReturnData);
        return;
    }
    var frameId = temp.frameId;
    var customId = temp.customId;
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {customId: customId};
    ExecuteScript(tabId, frameId, "GetSelectorAttributeNames.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else
            returnFunc(defaultReturnData);
    });
}

function onSimulateEvent(params, returnFunc) {
    var tabId = params.tabId;
    var defaultReturnData = {retCode: N_FALSE};
    var temp = gcontext.SplitCustomIdWithFrame(params.customId);
    if (temp == null) {
        returnFunc(defaultReturnData);
        return;
    }
    var frameId = temp.frameId;
    var customId = temp.customId;
    var eventType = params.eventType;
    var eventName = params.eventName;
    var eventArgs = params.eventArgs;
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {customId: customId, eventType: eventType, eventName: eventName, eventArgs: eventArgs};
    ExecuteScript(tabId, frameId, "SimulateEvent.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else {
            returnFunc(defaultReturnData);
        }
    });
}

function onSetShelfEnabled(params, returnFunc) {
    var enable = params.enable;

    if (enable == 0) {
        chrome.downloads.setShelfEnabled(false);
    } else {
        chrome.downloads.setShelfEnabled(true);
    }

    returnFunc({retCode: N_TRUE});
}

function onGetDownloadFiles(params, returnFunc) {
    // 0 普通搜索 1 正则搜索 2 精确搜索
    var mode = (params.mode == 0 || params.mode == 2) ? 'query' : 'filenameRegex';
    var queryField = params.queryField;
    var queryStr = (params.mode == 0 || params.mode == 2) ? [params.query] : params.query;
    var startedAfter = params.startedAfter;
    var endedBefore = params.endedBefore;
    var state = params.state;

    var querys = {};
    querys[mode] = queryStr;
    if (startedAfter) {
        querys['startedAfter'] = startedAfter;
    }
    if (endedBefore) {
        querys['endedBefore'] = endedBefore;
    }
    if (state) {
        querys['state'] = state;
    }

    function getFilename(path) {
        return path.substr(path.lastIndexOf("\\") + 1);
    }

    var defaultReturnData = {ReturnType: "GetDownloadFiles", files: [], retCode: N_TRUE};
    chrome.downloads.search(querys, function (items) {
        for (var i = 0; i < items.length; i++) {
            var item = items[i];
            if (item.filename) {
                var itemctx = {
                    id: item.id,
                    filename: getFilename(item.filename),
                    fullFilename: item.filename,
                    mime: item.mime,
                    startTime: item.startTime,
                    endTime: item.endTime ? item.endTime : "",
                    estimatedEndTime: item.estimatedEndTime ? item.estimatedEndTime : "",
                    state: item.state,
                    exists: item.exists ? item.exists + "" : "false"
                };

                if (params.mode == 2) {
                    if (queryField == "filename" && itemctx.filename !== queryStr[0]) {
                        continue;
                    }
                    if (queryField == "filepath" && itemctx.fullFilename !== queryStr[0]) {
                        continue;
                    }
                }

                defaultReturnData.files.push(itemctx);
            }
        }

        returnFunc(defaultReturnData);
    });
}

function onExtractMetadata(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var defaultReturnData = {
        tableContainerCustomId: "",
        containerCustomId: "",
        metadata: "",
        retCode: 0
    };

    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }

    for (var colId = 0; colId < params.columnDescriptors.length; colId++) {
        var crtColumnDescriptor = params.columnDescriptors[colId];
        var crtColumnElements = crtColumnDescriptor.customIds;
        for (var elementId = 0; elementId < crtColumnElements.length; elementId++) {
            crtColumnElements[elementId] = gcontext.SplitCustomIdWithFrame(crtColumnElements[elementId]).customId;
        }
    }

    var inputParams = {
        customId: customId,
        columnDescriptors: params.columnDescriptors
    };

    ExecuteScript(tabId, frameId, "ExtractMetadata.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            if (!IsEmptyCustomId(outputParams.tableContainerCustomId)) {
                outputParams.tableContainerCustomId = gcontext.ComputeCustomIdWithTabAndFrame(tabId, frameId, outputParams.tableContainerCustomId);
            }
            if (!IsEmptyCustomId(outputParams.containerCustomId)) {
                outputParams.containerCustomId = gcontext.ComputeCustomIdWithTabAndFrame(tabId, frameId, outputParams.containerCustomId);
            }
            returnFunc(outputParams);
        } else {
            returnFunc(defaultReturnData);
        }
    });
}

function onExtractData(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var defaultReturnData = {
        scrapedCustomIds: [],
        extractDatas: "",
        retCode: 0
    };

    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }

    var inputParams = {
        customId: customId,
        metadata: params.metadata,
        exact: params.exact,
        extractType: params.extractType,
        cleanupType: params.cleanupType,
        maxResults: params.maxResults,
        getColName: params.getColName,
        getColEmptyValue: params.getColEmptyValue,
        getScrapedElement: params.getColEmptyValue,
        sessionId: params.sessionId
    };

    ExecuteScript(tabId, frameId, "ExtractData.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            for (var colId = 0; colId < outputParams.scrapedCustomIds.length; ++colId) {
                for (var elementId = 0; elementId < outputParams.scrapedCustomIds[colId].length; ++elementId) {
                    if (!IsEmptyCustomId(outputParams.scrapedCustomIds[colId][elementId])) {
                        var completeCustomId = gcontext.ComputeCustomIdWithTabAndFrame(tabId, frameId, outputParams.scrapedCustomIds[colId][elementId]);
                        outputParams.scrapedCustomIds[colId][elementId] = completeCustomId;
                    }
                }
            }
            returnFunc(outputParams);
        } else {
            returnFunc(defaultReturnData);
        }
    });
}

function onSetHtmlAttribute(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var attrName = params.attrName;
    var attrValue = params.attrValue;
    var defaultReturnData = {retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    if (customId.length === 0 && attrName.toLowerCase() === "url") {
        chrome.tabs.update(tabId, {url: attrValue}, function () {
            returnFunc({retCode: N_TRUE});
        });
    } else {
        var inputParams = {customId: customId, attrName: attrName, attrValue: attrValue};
        ExecuteScript(tabId, frameId, "SetHtmlAttribute.js", inputParams, function (outputParams, outputFrameId) {
            if (outputParams !== undefined) {
                returnFunc(outputParams);
            } else
                returnFunc(defaultReturnData);
        });
    }
}

function onGetFocusedHtmlElement(params, returnFunc) {
    var tabId = params.tabId;
    var defaultReturnData = {customId: "", retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {};
    ExecuteScript(tabId, 0, "GetFocusedHtmlElement.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            outputParams.customId = gcontext.ComputeCustomIdWithTabAndFrame(tabId, outputFrameId, outputParams.customId);
            returnFunc(outputParams);
        } else
            returnFunc(defaultReturnData);
    });
}

function onSetFocusedHtmlElement(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var defaultReturnData = {retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {customId: customId,};
    ExecuteScript(tabId, frameId, "SetFocusedHtmlElement.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else
            returnFunc(defaultReturnData);
    });
}

function onGetTextFromScreenRect(params, returnFunc) {
    var left = params.left;
    var top = params.top;
    var width = params.width;
    var height = params.height;
    var wndLeft_ScreenPhysical = params.windowLeft;
    var wndTop_ScreenPhysical = params.windowTop;
    var windowId = params.windowId;
    var defaultReturnData = {text: "", words: [], wordRects: [], retCode: N_FALSE};
    chrome.tabs.query({highlighted: true, windowId: windowId}, function (tabs) {
        if (tabs.length > 0) {
            var tab = tabs[0];
            GetChromePageZoom(tab.id, function (zoomLvl) {
                var inputParams = {
                    windowLeft: wndLeft_ScreenPhysical,
                    windowTop: wndTop_ScreenPhysical,
                    left: left,
                    top: top,
                    width: width,
                    height: height,
                    pageZoomValue: zoomLvl,
                    pageRenderOfsX: params.pageRenderOfsX,
                    pageRenderOfsY: params.pageRenderOfsY
                };
                ExecuteScript(tab.id, 0, "GetTextFromScreenRect.js", inputParams, function (outputParams, outputFrameId) {
                    if (outputParams !== undefined) {
                        returnFunc(outputParams);
                    } else
                        returnFunc(defaultReturnData);
                });
            });
        }
    });
}

function onGetRectFromText(params, returnFunc) {
    var left = params.left;
    var top = params.top;
    var width = params.width;
    var height = params.height;
    var occurence = params.occurence;
    var wndLeft_ScreenPhysical = params.windowLeft;
    var wndTop_ScreenPhysical = params.windowTop;
    var windowId = params.windowId;
    var defaultReturnData = {left: 0, top: 0, right: 0, bottom: 0, retCode: N_FALSE};
    chrome.tabs.query({highlighted: true, windowId: windowId}, function (tabs) {
        if (tabs.length > 0) {
            var tab = tabs[0];
            GetChromePageZoom(tab.id, function (zoomLvl) {
                var inputParams = {
                    windowLeft: wndLeft_ScreenPhysical,
                    windowTop: wndTop_ScreenPhysical,
                    left: left,
                    top: top,
                    width: width,
                    height: height,
                    occurence: occurence,
                    pageZoomValue: zoomLvl,
                    pageRenderOfsX: params.pageRenderOfsX,
                    pageRenderOfsY: params.pageRenderOfsY,
                    text: params.text
                };
                ExecuteScript(tab.id, 0, "GetRectFromText.js", inputParams, function (outputParams, outputFrameId) {
                    if (outputParams !== undefined) {
                        returnFunc(outputParams);
                    } else {
                        returnFunc(defaultReturnData);
                    }
                });
            });
        }
    });
}

function onGetHtmlAncestryInfo(params, returnFunc) {
    var tabId = params.tabId;
    var frameId = gcontext.SplitCustomIdWithFrame(params.customId).frameId;
    var customId = gcontext.SplitCustomIdWithFrame(params.customId).customId;
    var relativeAncestorFrameId = gcontext.SplitCustomIdWithFrame(params.relativeAncestorCustomId).frameId;
    var relativeAncestorCustomId = gcontext.SplitCustomIdWithFrame(params.relativeAncestorCustomId).customId;
    var getFlags = params.getFlags;
    var defaultReturnData = {nodeHierarchyInfo: [], retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {customId: customId, relativeAncestorFrameId: relativeAncestorFrameId, relativeAncestorCustomId: relativeAncestorCustomId, getFlags: getFlags};
    ExecuteScript(tabId, frameId, "GetHtmlAncestryInfo.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            var nodeHierarchyInfo = outputParams.nodeHierarchyInfo;
            for (var i = 0; i < nodeHierarchyInfo.length; ++i) {
                gcontext.TraceMessage("GetHtmlAncestryInfo: nodeHierarchyInfo[" + i + "].customId = " + nodeHierarchyInfo[i].customId);
            }
            returnFunc(outputParams);
        } else
            returnFunc(defaultReturnData);
    });
}

function onGetHtmlDevicePixelRatio(params, returnFunc) {
    var tabId = params.tabId;
    var defaultReturnData = {devicePixelRatioPercentage: 100, retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {};
    ExecuteScript(tabId, 0, "GetHtmlDevicePixelRatio.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else {
            returnFunc(defaultReturnData);
        }
    });
}

function onIgnoreNextKeystrokeEvent(params, returnFunc) {
    var tabId = params.tabId;
    var uiEventFlagsWithKeyCode = params.uiEventFlagsWithKeyCode;
    var defaultReturnData = {retCode: N_FALSE};
    if (tabId === -1) {
        returnFunc(defaultReturnData);
        return;
    }
    var inputParams = {uiEventFlagsWithKeyCode: uiEventFlagsWithKeyCode,};
    ExecuteScript(tabId, 0, "IgnoreNextKeystrokeEvent.js", inputParams, function (outputParams, outputFrameId) {
        if (outputParams !== undefined) {
            returnFunc(outputParams);
        } else
            returnFunc(defaultReturnData);
    });
}

function onGetActiveTabId(params, returnFunc) {
    var windowId = params.windowId;
    if (windowId === -1) {
        chrome.windows.getLastFocused({populate: false}, function (wnd) {
            chrome.tabs.getSelected(wnd.id, function (tab) {
                returnFunc({tabId: tab.id.toString(), retCode: N_TRUE});
            });
        });
    } else {
        chrome.tabs.getSelected(windowId, function (tab) {
            returnFunc({tabId: tab.id.toString(), retCode: N_TRUE});
        });
    }
}

function onGetActiveTabIdUsingAttributes(params, returnFunc) {
    var windowId = params.windowId;
    var needSwitchTab = params.needSwitchTab;
    var isCompatible = params.isCompatible;
    var inputParams = {attrMap: gcontext.AttributeValueMap(params.attrMap), maxElems: Number.MAX_VALUE, useTagFuzzyLevel: false, tagFuzzyLevel: 0};
    gcontext.TraceMessage("onGetActiveTabIdUsingAttributes: enter windowId=" + windowId + ", needSwitchTab=" + needSwitchTab);

    if (needSwitchTab === 0) {
        if (windowId === -1) {
            chrome.windows.getLastFocused({populate: false}, function (wnd) {
                chrome.tabs.getSelected(wnd.id, function (tab) {
                    if (gcontext.checkTabUsingAttributes(isCompatible, tab, inputParams)) {
                        returnFunc({tabId: tab.id.toString(), retCode: N_TRUE});
                    } else {
                        returnFunc({retCode: N_FALSE});
                    }
                });
            });
        } else {
            chrome.tabs.getSelected(windowId, function (tab) {
                if (gcontext.checkTabUsingAttributes(isCompatible, tab, inputParams)) {
                    returnFunc({tabId: tab.id.toString(), retCode: N_TRUE});
                } else {
                    returnFunc({retCode: N_FALSE});
                }
            });
        }
    } else {
        chrome.windows.getLastFocused({populate: false}, function (wnd) {
            chrome.tabs.getSelected(wnd.id, function (tab) {
                if (gcontext.checkTabUsingAttributes(isCompatible, tab, inputParams)) {
                    returnFunc({tabId: tab.id.toString(), retCode: N_TRUE});
                } else {
                    chrome.tabs.query({windowId: wnd.id}, function (tabsList) {
                        var findTab = null;
                        for (var i in tabsList) {
                            var tab = tabsList[i];
                            if (gcontext.checkTabUsingAttributes(isCompatible, tab, inputParams)) {
                                findTab = tab;
                                break;
                            }
                        }

                        if (findTab) {
                            returnFunc({tabId: findTab.id.toString(), retCode: N_TRUE});
                        } else {
                            returnFunc({retCode: N_FALSE});
                        }
                    });
                }
            });
        });
    }
}

function onNavigate(params, returnFunc) {
    var tabId = params.tabId;
    var url = params.url;
    gcontext.TraceMessage("onNavigate: enter tabId=" + tabId + ", url=" + url);
    var updateTabUrl = function () {
        chrome.tabs.update(tabId, {url: url}, function () {
            gcontext.TraceMessage("onNavigate::updateTabUrl tabId: " + tabId);
            returnFunc({retCode: N_TRUE});
        });
    }
    var timeoutMs = 500;
    var maxTries = 120;
    var tryNavigate = function () {
        chrome.tabs.query({}, function (tabsList) {
            var foundTab = null;
            for (var i in tabsList) {
                var tab = tabsList[i];
                if (tab.id === tabId) {
                    foundTab = tab;
                    break;
                }
            }
            if (foundTab != null) {
                gcontext.TraceMessage("onNavigate::tryNavigate: foundTab.id: " + foundTab.id + ", foundTab.status: " + foundTab.status + ", foundTab.url: " + foundTab.url);
                if (foundTab.url !== undefined) {
                    updateTabUrl();
                } else {
                    --maxTries;
                    if (maxTries > 0) {
                        gcontext.TraceMessage("onNavigate::tryNavigate: retrying for foundTab.id: " + foundTab.id);
                        setTimeout(tryNavigate, timeoutMs);
                    } else {
                        gcontext.TraceMessage("onNavigate::tryNavigate: could not navigate in tabId: " + tabId);
                        returnFunc({retCode: N_FALSE});
                    }
                }
            } else {
                gcontext.TraceMessage("onNavigate::tryNavigate: could not find tabId: " + tabId);
                returnFunc({retCode: N_FALSE});
            }
        });
    }
    canNavigateToUrl(url, function (canNavigate) {
        if (canNavigate) {
            if (gcontext.xbrowser.isEdge()) {
                tryNavigate();
            } else {
                updateTabUrl();
            }
        } else {
            gcontext.TraceError("onReplaceTabAndNavigate: navigation not allowed for url: " + url);
            returnFunc({retCode: N_FALSE});
        }
    });
}

function onReplaceTabAndNavigate(params, returnFunc) {
    var currentTabId = params.tabId;
    var url = params.url;
    gcontext.TraceMessage("onReplaceTabAndNavigate: enter currentTabId=" + currentTabId + ", url=" + url);
    var buildResponseData = function (retCode, newTabId) {
        var data = {tabId: newTabId.toString(), retCode: retCode};
        return data;
    }
    var doChangeTabUrl = function () {
        chrome.tabs.get(currentTabId, function (currentTab) {
            var properties = {windowId: currentTab.windowId, url: url};
            chrome.tabs.create(properties, function (newTab) {
                var newTabId = newTab.id;
                gcontext.TraceMessage("onReplaceTabAndNavigate::doChangeTabUrl newTabId: " + newTabId);
                chrome.tabs.remove(currentTabId, function () {
                    returnFunc(buildResponseData(N_TRUE, newTabId));
                });
            });
        });
    }
    canNavigateToUrl(url, function (canNavigate) {
        if (canNavigate) {
            doChangeTabUrl();
        } else {
            gcontext.TraceError("onReplaceTabAndNavigate: navigation not allowed for url: " + url);
            returnFunc(buildResponseData(N_FALSE, -1));
        }
    });
}

function onCreateTabAndNavigate(params, returnFunc) {
    var currentTabId = params.tabId;
    var url = params.url;
    gcontext.TraceMessage("onCreateTabAndNavigate: enter currentTabId=" + currentTabId + ", url=" + url);
    var buildResponseData = function (retCode, newTabId) {
        var data = {tabId: newTabId.toString(), retCode: retCode};
        return data;
    }
    var doChangeTabUrl = function () {
        chrome.tabs.get(currentTabId, function (currentTab) {
            // Create a new tab in the same window
            var properties = {windowId: currentTab.windowId, url: url};
            chrome.tabs.create(properties, function (newTab) {
                var newTabId = newTab.id;
                gcontext.TraceMessage("onCreateTabAndNavigate::doChangeTabUrl newTabId: " + newTabId);
                returnFunc(buildResponseData(N_TRUE, newTabId));
            });
        });
    }
    canNavigateToUrl(url, function (canNavigate) {
        if (canNavigate) {
            doChangeTabUrl();
        } else {
            gcontext.TraceError("onReplaceTabAndNavigate: navigation not allowed for url: " + url);
            returnFunc(buildResponseData(N_FALSE, -1));
        }
    });
}

function canNavigateToUrl(url, resultCb) {
    if (url.indexOf("file://") == 0) {
        if (typeof chrome.extension.isAllowedFileSchemeAccess != "undefined") {
            chrome.extension.isAllowedFileSchemeAccess(function (isAllowedAccess) {
                resultCb(isAllowedAccess);
            });
        }
    } else {
        resultCb(true);
    }
}

function onCloseBrowser(params, returnFunc) {
    var tabId = params.tabId;
    chrome.tabs.remove([tabId], function () {
        returnFunc({retCode: N_TRUE});
    });
}

function onCloseWindowBrowser(params, returnFunc) {
    var tabId = params.tabId;
    chrome.tabs.get(tabId, function (tab) {
        if (chrome.runtime.lastError) {
            TraceMessage("chrome.tabs.get failed in onCloseWindowBrowser: " + chrome.runtime.lastError.message);
        } else {
            returnFunc({retCode: N_TRUE});
            chrome.windows.remove(tab.windowId, function () {
            });
        }
    });
}

function onGetTabCount(params, returnFunc) {
    chrome.tabs.query({}, function (foundTabs) {
        var count = foundTabs.length;
        returnFunc({retCode: N_TRUE, tabCount: count});
    });
}

function onNavigationCommand(params, returnFunc) {
    var tabId = params.tabId;
    var command = params.command;
    gcontext.TraceMessage("onNavigationCommand: tabId=" + tabId + " command=" + command);
    if (command === "reload" && chrome.tabs.reload) {
        chrome.tabs.reload(tabId, {}, function () {
            returnFunc({retCode: N_TRUE});
        });
    } else if (command === "activate") {
        chrome.tabs.update(tabId, {active: true}, function (tab) {
            returnFunc({retCode: N_TRUE});
        });
    } else if (command === "isready") {
        chrome.tabs.get(tabId, function (tab) {
            var isReady = (tab.status === "complete" ? N_TRUE : N_FALSE);
            returnFunc({retCode: isReady});
        });
    } else if (command === "home") {
        chrome.tabs.update(tabId, {url: "http://www.google.com"}, function () {
            returnFunc({retCode: N_TRUE});
        });
    } else {
        var inputParams = {command: command};
        ExecuteScript(tabId, 0, "NavigationCommand.js", inputParams, function (outputParams, outputFrameId) {
            if (outputParams !== undefined) {
                returnFunc({retCode: N_TRUE});
            } else {
                returnFunc({retCode: N_FALSE});
            }
        });
    }
}

function GetTab(tabId, resultCb) {
    chrome.tabs.get(tabId, function (foundTab) {
        if (chrome.runtime.lastError) {
            var errorMsg = chrome.runtime.lastError.message;
            gcontext.TraceError("GetTab: failed tabId: " + tabId + ", errorMsg: " + errorMsg);
        }
        if (resultCb) {
            resultCb(foundTab);
        }
    });
}

function IsEmptyCustomId(customId) {
    return ((customId === null) || (customId === ""));
}

var gcontext = g_globalContext;

function GetFrameArrayItemById(frameArray, frameId) {
    for (var i = 0; i < frameArray.length; i += 1) {
        if (!frameArray[i].crossOriginError && frameArray[i].frameId === frameId) {
            return frameArray[i];
        }
    }
    return null;
}

function GetFrameArrayItemByIndexInParent(frameArray, parentFrameId, indexInParent) {
    for (var i = 0; i < frameArray.length; i += 1) {
        if (!frameArray[i].crossOriginError && frameArray[i].parentFrameId === parentFrameId && frameArray[i].indexInParent === indexInParent) {
            return frameArray[i];
        }
    }
    return null;
}

function COFwdBackground(tabId) {
    var m_tabId = tabId;
    var m_coFrameArray = null;

    function GetCrossOriginFrameArray(returnFunc) {
        if (m_coFrameArray !== null) {
            return returnFunc(m_coFrameArray);
        }
        chrome.webNavigation.getAllFrames({tabId: m_tabId}, function (frameArray) {
            var framePos = 0;
            var crossOriginErrorCount = 0;

            function GetCrossOriginOneFrameInfo() {
                if (framePos >= frameArray.length) {
                    gcontext.TraceMessage("GetCrossOriginFrameArray: Successfully got frameArray with cross-origin info; length=" + frameArray.length + "; crossOriginErrorCount=" + crossOriginErrorCount);
                    m_coFrameArray = frameArray;
                    return returnFunc(m_coFrameArray);
                }
                if (frameArray[framePos].errorOccurred) {
                    gcontext.TraceMessage("GetCrossOriginFrameArray: Basic info of frame #" + framePos + " has errors. Skip getting cross-origin info.");
                    frameArray[framePos].crossOriginError = N_TRUE;
                    crossOriginErrorCount += 1;
                    framePos += 1;
                    return GetCrossOriginOneFrameInfo();
                }
                chrome.tabs.executeScript(tabId, {
                    code: "g_globalContext.GetCrossOriginFrameInfo();",
                    frameId: frameArray[framePos].frameId,
                    matchAboutBlank: true,
                    runAt: "document_start"
                }, function (result) {
                    if (!chrome.runtime.lastError && result && result[0] && result[0].indexInParent !== undefined) {
                        frameArray[framePos].indexInParent = result[0].indexInParent;
                    } else {
                        var errorMsg = "(empty)";
                        if (chrome.runtime.lastError) {
                            errorMsg = chrome.runtime.lastError.message;
                        }
                        gcontext.TraceMessage("GetCrossOriginFrameArray: Error getting cross-origin info for frame #" + framePos + " frameId=" + frameArray[framePos].frameId + ", lastError.message: " + errorMsg);
                        frameArray[framePos].crossOriginError = N_TRUE;
                        crossOriginErrorCount += 1;
                    }
                    framePos += 1;
                    GetCrossOriginOneFrameInfo();
                });
            }

            GetCrossOriginOneFrameInfo();
        });
    }

    return {
        ExtractPendingRequests: function (pendingRequests, message) {
            if (message != null && message.coFwdRequests != null && message.coFwdRequests.length !== 0) {
                var out_newPendingRequests = pendingRequests.concat(message.coFwdRequests);
                delete message.coFwdRequests;
                return out_newPendingRequests;
            }
            return pendingRequests;
        }, GetDestination: function (request, previousResult, returnFunc) {
            var out_destFrameId = -1;
            var out_coFwdInfo = null;
            if (request == null) {
                gcontext.TraceError("COFwdBackground: Call forwarding request not found. Cannot get destination frame.");
                return returnFunc(null);
            }
            var srcFrameId = request.srcFrameId;
            GetCrossOriginFrameArray(function (coFrameArray) {
                if (!coFrameArray || coFrameArray.length <= 0) {
                    gcontext.TraceMessage("COFwdBackground: Cross-origin frame info not available. Cannot get destination frame.");
                    return returnFunc(null);
                }
                if (request.isParentDestination) {
                    var srcFrame = GetFrameArrayItemById(coFrameArray, srcFrameId);
                    if (!srcFrame) {
                        gcontext.TraceMessage("COFwdBackground: Cannot get frame array item for srcFrameId=" + srcFrameId);
                        return returnFunc(null);
                    }
                    out_destFrameId = srcFrame.parentFrameId;
                    out_coFwdInfo = {isParentSource: false, srcChildIndex: srcFrame.indexInParent};
                    gcontext.TraceMessage("COFwdBackground: composed call forwarding message from srcFrameId=" + srcFrameId + " to parent destFrameId=" + out_destFrameId);
                } else if (request.destChildIndex !== undefined) {
                    var destFrame = GetFrameArrayItemByIndexInParent(coFrameArray, srcFrameId, request.destChildIndex);
                    if (!destFrame) {
                        gcontext.TraceMessage("COFwdBackground: Cannot get child frame for parentFrameId=" + srcFrameId
                            + " indexInParent=" + request.destChildIndex);
                        return returnFunc(null);
                    }
                    out_destFrameId = destFrame.frameId;
                    out_coFwdInfo = {isParentSource: true, srcChildIndex: undefined};
                    gcontext.TraceMessage("COFwdBackground: composed call forwarding message from srcFrameId=" + srcFrameId
                        + " to child destFrameId=" + out_destFrameId + " childIndex=" + request.destChildIndex);
                }
                if (out_destFrameId < 0 || out_coFwdInfo === null) {
                    gcontext.TraceMessage("COFwdBackground: Cannot obtain call forwarding destination, srcFrameId=" + srcFrameId);
                    return returnFunc(null);
                }
                out_coFwdInfo.customData = request.customData;
                out_coFwdInfo.previousResult = previousResult;
                return returnFunc({frameId: out_destFrameId, message: {coFwdInfo: out_coFwdInfo}});
            });
        }
    }
}

WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.EMatchingType = {Invalid: 0, Normal: 1, Regex: 2, Fuzzy: 3, FuzzyWords: 4};
    gcontext.NormalMatcher = function () {
        this.Matches = function (attrInfo, text, caseSensitive, fuzzyScoreStats) {
            var matchResult = gcontext.StringWildcardMatch(attrInfo.value, text, caseSensitive);
            var score = (matchResult === true) ? 1.0 : 0.0;
            if (typeof fuzzyScoreStats !== "undefined") {
                fuzzyScoreStats.accept(score);
            }
            return score >= attrInfo.fuzzyLevel;
        };
    };
    gcontext.RegexMatcher = function () {
        this.m_pattern = null;
        this.m_caseSensitive = true;
        this.m_regex = null;
        this.SetPattern = function (pattern, caseSensitive) {
            pattern = "^" + pattern + "$";
            if (this.m_regex !== null && this.m_pattern === pattern && this.m_caseSensitive === caseSensitive) {
                return;
            }
            gcontext.TraceMessage("RegexMatcher::SetPattern pattern=\"" + pattern + "\" caseSensitive=" + caseSensitive);
            this.m_pattern = pattern;
            this.m_caseSensitive = caseSensitive;
            this.m_regex = RegExp(this.m_pattern, caseSensitive ? "" : "i");
        };
        this.Matches = function (attrInfo, text, caseSensitive, fuzzyScoreStats) {
            caseSensitive = typeof caseSensitive === "undefined" ? true : caseSensitive;

            // 如果两个值相等，直接返回true
            if (attrInfo.value === text) {
                gcontext.TraceMessage("RegexMatcher::Equal text=\"" + text + "\" result=true");
                return true;
            }

            // 兼容老的版本的通配符: http://www.baidu.com/*
            if (gcontext.StringWildcardMatch(attrInfo.value, text, true)) {
                gcontext.TraceMessage("RegexMatcher::StringWildcardMatch=\"" + attrInfo.value + "\" text=\"" + text + "\" result=true");
                return true;
            }

            this.SetPattern(attrInfo.value, caseSensitive);
            var matchResult = this.m_regex.test(text);
            gcontext.TraceMessage("RegexMatcher::Matches pattern=\"" + this.m_pattern + "\" text=\"" + text + "\" result=" + matchResult);
            var score = (matchResult === true) ? 1.0 : 0.0;
            if (typeof fuzzyScoreStats !== "undefined") {
                fuzzyScoreStats.accept(score);
            }
            return score >= attrInfo.fuzzyLevel;
        };
    };
    gcontext.FuzzyMatcher = function () {
        function PreProcess(str) {
            try {
                var res = str.replace(/[~!@#$%^&*()`;':\",./<>?]/gm, " ");
                res = res.trim();
                res = res.toLowerCase();
                return res;
            } catch (e) {
                return "";
            }
        }

        function LevenshteinRatio(str1, str2) {
            var lensum = str1.length + str2.length;
            var distance = LevenshteinEditDistance(str1, str2);
            if (distance < 0) {
                return 0.0;
            }
            if (lensum == 0) {
                return 1.0;
            }
            if (lensum - distance == 0) {
                return 0.0;
            }
            return (lensum - distance) / lensum;
        }

        function LevenshteinEditDistance(a, b) {
            var i, j;
            var distanceMatrix = [];
            for (j = 0; j <= b.length; j++) {
                distanceMatrix[j] = [];
            }
            for (i = 0; i <= a.length; i += 1) {
                distanceMatrix[0][i] = i;
            }
            for (j = 0; j <= b.length; j += 1) {
                distanceMatrix[j][0] = j;
            }
            for (j = 1; j <= b.length; j += 1) {
                for (i = 1; i <= a.length; i += 1) {
                    var indicator = a[i - 1] === b[j - 1] ? 0 : 2;
                    distanceMatrix[j][i] = Math.min(distanceMatrix[j][i - 1] + 1, distanceMatrix[j - 1][i] + 1, distanceMatrix[j - 1][i - 1] + indicator);
                }
            }
            return distanceMatrix[b.length][a.length];
        }

        function TokenSort(a) {
            var tokens = a.split(" ");
            tokens.sort();
            return tokens.join(" ");
        }

        function TokenSortRatio(a, b) {
            var sorted1 = TokenSort(a);
            var sorted2 = TokenSort(b);
            return LevenshteinRatio(sorted1, sorted2);
        }

        function GetUniqueTokens(tokens) {
            var set = new Array();
            for (var i = 0; i < tokens.length; ++i) {
                if (set.indexOf(tokens[i]) == -1) {
                    set.push(tokens[i]);
                }
            }
            return set;
        }

        function GetIntersection(set1, set2) {
            var intersection = new Array();
            for (var i = 0; i < set1.length; ++i) {
                if (set2.indexOf(set1[i]) != -1) {
                    intersection.push(set1[i]);
                }
            }
            return intersection;
        }

        function GetDifference(set1, set2) {
            var difference = new Array();
            for (var i = 0; i < set1.length; ++i) {
                if (set2.indexOf(set1[i]) == -1) {
                    difference.push(set1[i]);
                }
            }
            return difference;
        }

        function TokenSetRatio(a, b) {
            var len1 = a.length;
            var len2 = b.length;
            if (len1 + len2 === 0) {
                return 1.0;
            }
            if (len1 === 0 || len2 === 0) {
                return 0.0;
            }
            var tokens1 = a.split(" ");
            var tokens2 = b.split(" ");
            var set1 = GetUniqueTokens(tokens1);
            var set2 = GetUniqueTokens(tokens2);
            set1.sort();
            set2.sort();
            var intersection = GetIntersection(set1, set2);
            var diff1to2 = GetDifference(set1, set2);
            var diff2to1 = GetDifference(set2, set1);
            var sortedIntersection = intersection.join(" ");
            var sorted1to2 = diff1to2.join(" ");
            var sorted2to1 = diff2to1.join(" ");
            var combined1to2 = sortedIntersection + " " + sorted1to2;
            var combined2to1 = sortedIntersection + " " + sorted2to1;
            sortedIntersection = sortedIntersection.trim();
            combined1to2 = combined1to2.trim();
            combined2to1 = combined2to1.trim();
            var m = Math.max(LevenshteinRatio(sortedIntersection, combined1to2), LevenshteinRatio(sortedIntersection, combined2to1), LevenshteinRatio(combined1to2, combined2to1));
            return m;
        }

        this.Matches = function (attrInfo, text, caseSensitive, fuzzyScoreStats) {
            var fuzzyScore = 0;
            if (attrInfo.value === text) {
                fuzzyScore = 1.0;
            } else {
                var str1 = PreProcess(attrInfo.value);
                var str2 = PreProcess(text);
                var imperfectScale = 0.999;
                var unbaseScale = 0.95;
                var baseRatio = LevenshteinRatio(str1, str2) * imperfectScale;
                var tokenSortRatio = TokenSortRatio(str1, str2) * unbaseScale;
                fuzzyScore = Math.max(baseRatio, tokenSortRatio);
            }
            if (typeof fuzzyScoreStats !== "undefined") {
                fuzzyScoreStats.accept(fuzzyScore);
            }
            return fuzzyScore >= attrInfo.fuzzyLevel;
        };
    };
    gcontext.AttributeValue = function (attrInfo) {
        if (typeof attrInfo === "string") {
            this.m_info = {isNull: false, isActive: true, caseSensitive: true, matchingType: gcontext.EMatchingType.Normal, value: attrInfo, fuzzyLevel: 1.0};
        } else {
            this.m_info = attrInfo;
        }
        this.m_matcher = null;
        this.InitializeMatcher = function () {
            this.m_matcher = null;
            if (this.m_info.isNull) {
                return;
            }
            switch (this.m_info.matchingType) {
                case gcontext.EMatchingType.Regex:
                    this.m_matcher = new gcontext.RegexMatcher();
                    break;
                case gcontext.EMatchingType.Fuzzy:
                case gcontext.EMatchingType.FuzzyWords:
                    this.m_matcher = new gcontext.FuzzyMatcher();
                    break;
                default:
                    this.m_matcher = new gcontext.NormalMatcher();
                    break;
            }
        };
        this.InitializeMatcher();
        this.GetInfo = function () {
            return this.m_info;
        };
        this.SetInfo = function (attrInfo) {
            this.m_info = attrInfo;
            this.InitializeMatcher();
        };
        this.Matches = function (text, fuzzyScoreStats) {
            if (this.m_info.isNull) {
                return false;
            }
            return this.m_matcher.Matches(this.m_info, text, this.m_info.caseSensitive, fuzzyScoreStats);
        };
    };
    gcontext.HasAttributeValue = function (attrValue) {
        if (typeof attrValue === "undefined") {
            return false;
        }
        if (!attrValue instanceof gcontext.AttributeValue) {
            gcontext.TraceError("AttributeValue::HasAttributeValue invalid attrValue type: " + (typeof attrValue));
            return false;
        }
        var attrInfo = attrValue.GetInfo();
        return attrInfo.isNull ? false : attrInfo.isActive;
    };
    gcontext.GetActiveValueString = function (attrValue) {
        return gcontext.HasAttributeValue(attrValue) ? attrValue.GetInfo().value : null;
    };
    gcontext.AttributeValueMap = function (attrInfoMap) {
        var attrValueMap = {};
        Object.keys(attrInfoMap).forEach(function (key, index) {
            attrValueMap[key] = new gcontext.AttributeValue(attrInfoMap[key]);
        });
        return attrValueMap;
    };
    gcontext.ActiveValueStringMap = function (attrValueMap) {
        var activeValueMap = {};
        Object.keys(attrValueMap).forEach(function (key, index) {
            activeValueMap[key] = gcontext.GetActiveValueString(attrValueMap[key]);
        });
        return activeValueMap;
    };
    gcontext.IsUsingFuzzyAttributes = function (attrValueMap) {
        var res = false;
        Object.values(attrValueMap).forEach(function (value) {
            if (value.GetInfo().matchingType === gcontext.EMatchingType.Fuzzy || value.GetInfo().matchingType === gcontext.EMatchingType.FuzzyWords) {
                res = true;
            }
        });
        return res;
    };
});

WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.FUZZY_MAX = 1.0;
    gcontext.FUZZY_MIN = 0.0;
    gcontext.SearchResult = function (customId, matchingScore, position) {
        this.m_customId = customId;
        this.m_matchingScore = matchingScore;
        this.m_position = position;
    };
    gcontext.TabSearchResult = function (tab, matchingScore) {
        this.m_tab = tab;
        this.m_matchingScore = matchingScore;
    };
    gcontext.HtmlSearchResult = function (element, matchingScore) {
        this.m_element = element;
        this.m_matchingScore = matchingScore;
    };
    gcontext.ApproximatelyEqual = function (a, b, epsilon) {
        return Math.abs(a - b) <= Math.max(Math.abs(a), Math.abs(b)) * epsilon;
    };
    gcontext.IsGreaterEqual = function (a, b) {
        return a > b || gcontext.ApproximatelyEqual(a, b, Number.EPSILON);
    }
    gcontext.IsGreater = function (a, b) {
        return a > b && !gcontext.ApproximatelyEqual(a, b, Number.EPSILON);
    }
    gcontext.ResultsCollection = function (maxResults) {
        this.m_maxResults = maxResults;
        this.m_results = new Array();
        this.Accept = function (searchResult) {
            if (typeof searchResult === "undefined") {
                gcontext.TraceError("ResultsCollection:: Unrecognised type of result");
                return false;
            }
            if (this.IsFull()) {
                return false;
            }
            var success = false;
            if (this.IsEmpty()) {
                this.m_results.push(searchResult);
                success = true;
            } else if (gcontext.IsGreaterEqual(this.m_results[this.m_results.length - 1].m_matchingScore, searchResult.m_matchingScore)) {
                if (this.m_results.length < this.m_maxResults) {
                    this.m_results.push(searchResult);
                    success = true;
                }
            } else {
                var i = 0;
                for (i = 0; i < this.m_results.length; ++i) {
                    if (gcontext.IsGreater(searchResult.m_matchingScore, this.m_results[i].m_matchingScore)) {
                        this.m_results.splice(i, 0, searchResult);
                        if (this.m_results.length > this.m_maxResults) {
                            this.m_results.pop();
                        }
                        success = true;
                        break;
                    }
                }
            }
            return success;
        };
        this.GetResults = function () {
            return this.m_results;
        };
        this.IsFull = function () {
            if (this.m_results.length >= this.m_maxResults) {
                if (this.IsEmpty() || gcontext.IsGreaterEqual(this.m_results[this.m_results.length - 1].m_matchingScore, gcontext.FUZZY_MAX)) {
                    return true;
                }
            }
            return false;
        };
        this.IsEmpty = function () {
            return this.m_results.length == 0;
        };
    };
});
