var g_functionNameThatWillBeCalled = "";
var g_functionThatWillBeCalled = null;
var g_globalContext;
var g_isCustomCacheInitialized;
var g_customIdCache;
var g_crtCustomIdValue;
if (g_isCustomCacheInitialized !== true) {
    g_isCustomCacheInitialized = true;
    g_customIdCache = {};
    g_crtCustomIdValue = 0;
}

function WrapInjectedFunction(funcName, func) {
    g_functionNameThatWillBeCalled = funcName;
    g_functionThatWillBeCalled = func;
}

function WrapInGlobalContext(func) {
    if ("undefined" == typeof g_globalContext) {
        g_globalContext = {};
    }
    g_globalContext.__EnrichContextFunc = func;
    g_globalContext.__EnrichContextFunc();
    g_globalContext.__EnrichContextFunc = null;
}

WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.xbrowser = function () {
        var isMozilla = false;
        var isEdgeBrowser = false;
        var modeSingleFrame = false;
        var isIOSplatform = false;
        var chromeVersion = 0;
        return {
            init: function () {
                isEdgeBrowser = typeof CSS !== 'undefined' && CSS.supports("(-ms-ime-align:auto)");
                isMozilla = window.mozInnerScreenX !== undefined;
                chromeVersion = parseInt((/Chrome\/([0-9]+)/.exec(navigator.userAgent) || ["0", "0"])[1]);
                modeSingleFrame = isEdgeBrowser || (chromeVersion > 0 && chromeVersion < 41);
                if (chrome.tabs && !chrome.tabs.getSelected) {
                    chrome.tabs.getSelected = function (wndId, response) {
                        return chrome.tabs.query({active: true, windowId: wndId}, function (tabsArray) {
                            response(tabsArray[0]);
                        });
                    };
                }
                if (chrome.extension && !chrome.extension.onMessage) {
                    chrome.extension.onMessage = {
                        addListener: function (callback) {
                            return chrome.runtime.onMessage.addListener(callback);
                        }, removeListener: function (callback) {
                            return chrome.runtime.onMessage.removeListener(callback);
                        }
                    };
                }
                if (chrome.tabs && !chrome.tabs.getZoom) {
                    chrome.tabs.getZoom = function (tabId, callback) {
                        gcontext.TraceMessage("Warning: chrome.tabs.getZoom() is undefined. Return 100% zoom. User Agent: " + navigator.userAgent);
                        callback(1);
                    };
                }
                var iDevices = ['iPad Simulator', 'iPhone Simulator', 'iPod Simulator', 'iPad', 'iPhone', 'iPod'];
                if (navigator.platform) {
                    while (iDevices.length) {
                        if (navigator.platform === iDevices.pop()) {
                            isIOSplatform = true;
                        }
                    }
                }
            }, tabs: {
                sendMessage: function (tabId, message, frameId, responseCallback) {
                    gcontext.TraceMessage("Single frame mode: \"" + modeSingleFrame + "\", userAgent: " + navigator.userAgent);
                    if (modeSingleFrame) {
                        chrome.tabs.sendMessage(tabId, message, responseCallback);
                    } else {
                        chrome.tabs.sendMessage(tabId, message, {frameId: frameId}, responseCallback);
                    }
                }
            }, isFirefox: function () {
                return isMozilla
            }, isEdge: function () {
                return isEdgeBrowser
            }, isModeSingleFrame: function () {
                return modeSingleFrame;
            }, isIOS: function () {
                return isIOSplatform;
            }
        }
    }();
    gcontext.xbrowser.init();
});

var N_TRUE = 1;
var N_FALSE = 0;
WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.MatchChars = function (c1, c2) {
        // empty pattern like ' ' or /s+
        var bpsPattern = c1.replace(/\s+/ig, "");
        if (bpsPattern === "") {
            var bpsText = c2.replace(/\s+/ig, "");
            return (bpsText === "");
        }

        return (c1 === '?') || (c1 === c2);
    }
    gcontext.MatchCharsPrefix = function (c1, c2) {
        return (c1 === '?') || (c2 === '?') || (c1 === c2);
    }
    gcontext.ComputePrefixFunction = function (pattern, beginPattern, patternLen) {
        var state = -1;
        var pi = new Array(patternLen);
        pi[0] = state;
        var i;
        for (i = 1; i < patternLen; ++i) {
            while (state > -1 && !gcontext.MatchCharsPrefix(pattern[beginPattern + state + 1], pattern[beginPattern + i])) {
                state = pi[state];
            }
            if (gcontext.MatchCharsPrefix(pattern[beginPattern + i], pattern[beginPattern + state + 1])) {
                state++;
            }
            pi[i] = state;
        }
        return pi;
    }
    gcontext.StringWildcardMatch = function (psPattern, psText, caseSensitive) {
        caseSensitive = typeof caseSensitive === "undefined" ? true : caseSensitive;
        if (psPattern == null) {
            psPattern = "";
        }
        if (psText == null) {
            psText = "";
        }

        // 过滤掉特殊字符
        //  ch === '\t' || ch === '\r' || ch === '\n' || ch === ' ' || ch === '\u200E' || ch === '\u2022';
        psPattern = psPattern.trim();
        psText = psText.trim();

        gcontext.TraceMessage("StrWildcardMatch(psPattern: \"" + psPattern + "\" psText: \"" + psText + "\" caseSensitive: " + caseSensitive.toString() + ")");
        // psPattern is null, return true ?
        if (psPattern === "") {
            // return (psText === "");
            return true;
        }

        if (!caseSensitive) {
            psPattern = psPattern.toLowerCase();
            psText = psText.toLowerCase();
        }

        if (psPattern === psText) {
            return true;
        }

        var beginPattern = 0;
        var beginText = 0;
        var endPattern = psPattern.length - 1;
        var endText = psText.length - 1;
        if (psPattern[beginPattern] != '*') {
            while (psPattern[beginPattern] != '*' && beginPattern <= endPattern && beginText <= endText) {
                if (!gcontext.MatchChars(psPattern[beginPattern], psText[beginText])) {
                    return false;
                }
                ++beginPattern;
                ++beginText;
            }
        }
        if (psPattern[endPattern] != '*') {
            while (psPattern[endPattern] != '*' && beginPattern <= endPattern && beginText <= endText) {
                if (!gcontext.MatchChars(psPattern[endPattern], psText[endText])) {
                    return false;
                }
                --endPattern;
                --endText;
            }
        }
        if (beginPattern > endPattern) {
            return (beginText > endText);
        }
        if (psPattern[beginPattern] != '*' || psPattern[endPattern] != '*') {
            return false;
        }
        while (beginPattern <= endPattern) {
            while (psPattern[beginPattern] == '*' && beginPattern <= endPattern) {
                beginPattern++;
            }
            if (beginPattern > endPattern) {
                break;
            }
            var substrLen = 0;
            while (psPattern[beginPattern + substrLen] != '*') {
                ++substrLen;
            }
            var pi = gcontext.ComputePrefixFunction(psPattern, beginPattern, substrLen);
            var state = -1;
            var canMatch = false;
            for (; beginText <= endText; ++beginText) {
                while (state > -1 && !gcontext.MatchChars(psPattern[beginPattern + state + 1], psText[beginText])) {
                    state = pi[state];
                }
                if (gcontext.MatchChars(psPattern[beginPattern + state + 1], psText[beginText])) {
                    state++;
                }
                if (state == substrLen - 1) {
                    canMatch = true;
                    break;
                }
            }
            if (!canMatch) {
                return false;
            }
            beginPattern += substrLen;
            ++beginText;
        }
        return true;
    }
    gcontext.DeleteForbiddenCharacters = function (text) {
        if (text == null || text.length === 0) {
            return "";
        }
        var out_text = text.replace(/\r/g, " ");
        out_text = out_text.replace(/\n/g, " ");
        return out_text;
    }
    gcontext.TruncateStringUsingWildcard = function (text, maxLen) {
        if (text == null) {
            return "";
        }
        if (text.length <= maxLen) {
            return text;
        }
        var out_text = text.slice(0, maxLen);
        out_text += "*";
        return out_text;
    }
    gcontext.ConcatObjects = function (o1, o2) {
        var result = {};
        if (o1 != null) {
            result = o1;
        }
        if (o2 != null) {
            for (var prop in o2) {
                result[prop] = o2[prop];
            }
        }
        return result;
    }
    gcontext.IsObjectEmpty = function (obj) {
        if (obj == null) {
            return true;
        }
        for (var prop in obj) {
            if (obj.hasOwnProperty(prop)) {
                return false;
            }
        }
        return true;
    }
    gcontext.TrimWhiteSpaces = function (text) {
        var out_text = text.trim();
        var whiteSpaceCodes = [0x200E, 0x2022];
        while (out_text.length !== 0 && whiteSpaceCodes.indexOf(out_text.charCodeAt(0)) !== -1) {
            out_text = out_text.slice(1);
        }
        while (out_text.length !== 0 && whiteSpaceCodes.indexOf(out_text.charCodeAt(out_text.length - 1)) !== -1) {
            out_text = out_text.slice(0, out_text.length - 1);
        }
        return out_text;
    }
    gcontext.IsWhiteSpaceCharacter = function (ch) {
        return ch === '\t' || ch === '\r' || ch === '\n' || ch === ' ' || ch === '\u200E' || ch === '\u2022';
    }
    gcontext.UiRect = function UiRect(left, top, width, height) {
        return {
            left: left, top: top, right: left + width, bottom: top + height, getWidth: function () {
                return this.right - this.left;
            }, getHeight: function () {
                return this.bottom - this.top;
            }, Intersects: function (rc2) {
                return (this.right > rc2.left && this.left < rc2.right) && (this.bottom > rc2.top && this.top < rc2.bottom);
            }, Contains: function (point) {
                return ((point.x >= this.left && point.x <= this.right) && (point.y >= this.top && point.y <= this.bottom));
            }, Scale: function (factor) {
                return UiRect(this.left * factor, this.top * factor, this.getWidth() * factor, this.getHeight() * factor);
            }, ScaleInv: function (factor) {
                return UiRect(this.left / factor, this.top / factor, this.getWidth() / factor, this.getHeight() / factor);
            }, IsEqual: function (rc2) {
                return this.left === rc2.left && this.top === rc2.top && this.right === rc2.right && this.bottom === rc2.bottom;
            }, Offset: function (dx, dy) {
                return UiRect(this.left + dx, this.top + dy, this.getWidth(), this.getHeight());
            }, MathRound: function () {
                return UiRect(Math.round(this.left), Math.round(this.top), Math.round(this.getWidth()), Math.round(this.getHeight()));
            }, Union: function (rc2) {
                var resultLeft = Math.min(this.left, rc2.left);
                var resultTop = Math.min(this.top, rc2.top);
                var resultRight = Math.max(this.right, rc2.right);
                var resultBottom = Math.max(this.bottom, rc2.bottom);
                return UiRect(resultLeft, resultTop, resultRight - resultLeft, resultBottom - resultTop);
            }, ContainsRect: function (rc2) {
                var p1 = {x: rc2.left, y: rc2.top};
                var p2 = {x: rc2.left, y: rc2.bottom};
                var p3 = {x: rc2.right, y: rc2.top};
                var p4 = {x: rc2.right, y: rc2.bottom};
                return this.Contains(p1) && this.Contains(p2) && this.Contains(p3) && this.Contains(p4);
            }, toString: function () {
                return "(" + left + " " + top + " " + width + " " + height + ")";
            }
        };
    }
    gcontext.RectToString = function (rect) {
        return "[" + rect.left + " " + rect.top + " " + rect.right + " " + rect.bottom + "]";
    }
    gcontext.UnformatSpecialJsCharacters = function (code) {
        var out_unformattedCode = code;
        out_unformattedCode = out_unformattedCode.replace(/%CR%/g, "\r");
        out_unformattedCode = out_unformattedCode.replace(/%LF%/g, "\n");
        return out_unformattedCode
    }
    gcontext.ExecuteWithRetry = function (predicateFunc, coreFunc, debugTag) {
        var initTimeout = 30000;
        var timeout = 100;
        var maxTries = initTimeout / timeout;
        var fnWrapper = function () {
            if (predicateFunc() === true) {
                coreFunc();
            } else {
                maxTries--;
                if (maxTries >= 0) {
                    gcontext.TraceMessage("ExecuteWithRetry: condition for " + debugTag + " is false; retrying later");
                    setTimeout(fnWrapper, timeout);
                } else {
                    gcontext.TraceMessage("ExecuteWithRetry: timed out while waiting to execute '" + debugTag + "'");
                }
            }
        };
        fnWrapper();
    }
    gcontext.Stopwatch = function () {
        var m_startTime;
        var m_msTimeout;
        var m_bTimeoutElapsed;
        return {
            Start: function (msTimeout) {
                m_msTimeout = msTimeout;
                m_bTimeoutElapsed = N_FALSE;
                m_startTime = new Date().getTime();
            }, TimeoutElapsed: function () {
                if (m_bTimeoutElapsed === N_FALSE) {
                    var crtTime = new Date().getTime();
                    if (crtTime - m_startTime > m_msTimeout)
                        m_bTimeoutElapsed = N_TRUE;
                }
                return m_bTimeoutElapsed;
            }
        };
    }
    gcontext.ChainCalls = function (arr, onEach, onFinal) {
        var isNonEmptyArr = arr && ("number" === typeof (arr.length)) && 0 !== arr.length;
        var max = isNonEmptyArr ? arr.length : 0;
        var process = function (i) {
            if (max === i) {
                onFinal(true, max);
            } else {
                var next = function (itsOk) {
                    if ('boolean' === typeof itsOk && !itsOk) {
                        onFinal(false, i);
                    } else {
                        process(i + 1);
                    }
                }
                onEach(next, i);
            }
        }
        process(0);
    }
});

WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.getAccName = function (e) {
        if (!e) {
            return "";
        }
        var tag = e.tagName.toUpperCase();
        if (!isAaElem()) {
            return replaceNewLines(getShortElementText());
        } else {
            var type = getType();
            if ("TABLE" === tag) {
                return tableAccName();
            } else {
                return computeAccName();
            }
        }

        function getShortElementText() {
            child = e.firstChild;
            texts = [];
            while (child) {
                if (child.nodeType == 3) {
                    texts.push(child.data);
                }
                child = child.nextSibling;
            }
            return texts.join("");
        }

        function getElementText() {
            return e.textContent;
        }

        function tableAccName() {
            var title = getTitle();
            if (title !== "") {
                return title;
            }
            var captions = e.getElementsByTagName("caption");
            if (captions && (captions.length > 0)) {
                return replaceNewLines(captions[0].textContent);
            }
            var headers = e.getElementsByTagName("th");
            var res = "";
            for (var h = 0; h < headers.length; ++h) {
                var crntText = headers[h].textContent;
                if (crntText.length > 0) {
                    crntText = trimText(crntText);
                    if (h > 0) {
                        res += " ";
                    }
                    res += crntText;
                }
            }
            return replaceNewLines(res);
        }

        function trimText(strParam) {
            return strParam.replace(/^\s*/, "").replace(/\s*$/, "");
        }

        function isAaElem() {
            return (("A" === tag) || ("INPUT" === tag) || ("IMG" === tag) || ("BUTTON" === tag) || ("TEXTAREA" === tag) || ("AREA" === tag) || ("SELECT" === tag) || ("TABLE" === tag));
        }

        function sanitizeStringForJSON(theString) {
            var NOT_SAFE_IN_JSON_1_0 = /[^\x09\x0A\x0D\x20-\x7E\x85\xA0-\uD7FF\uE000-\uFDCF\uFDF0-\uFFFD]/gm;
            return theString.replace(NOT_SAFE_IN_JSON_1_0, '');
        }

        function replaceNewLines(text) {
            if ((null === text) || (0 === text.length)) {
                return "";
            }
            var result = text.replace(/\r/g, " ");
            result = result.replace(/\n/g, " ");
            result = sanitizeStringForJSON(result);
            return result;
        }

        function getType() {
            if (("INPUT" === tag) && e.hasAttribute("type")) {
                return e.type.toUpperCase();
            } else {
                return "";
            }
        }

        function getLabel() {
            if (("A" === tag) || ("BUTTON" === tag) || ("SUBMIT" === type) || ("RESET" === type) || ("BUTTON" === type)) {
                return "";
            }
            if (e.id && (e.id !== "")) {
                var doc = e.ownerDocument;
                var labels = doc.getElementsByTagName("label");
                for (var i = 0; i < labels.length; ++i) {
                    var crntLabel = labels[i];
                    if (crntLabel.hasAttribute("for")) {
                        var forID = crntLabel.getAttribute("for");
                        if (forID === e.id) {
                            return replaceNewLines(crntLabel.textContent);
                        }
                    }
                }
            }
            return ""
        }

        function getTitle() {
            if (e.hasAttribute("title")) {
                return replaceNewLines(e.getAttribute("title"));
            } else {
                return "";
            }
        }

        function getAlt() {
            if (e.hasAttribute("alt")) {
                return replaceNewLines(e.getAttribute("alt"));
            } else {
                return "";
            }
        }

        function getText() {
            if (("BUTTON" === type) || ("SUBMIT" === type) || ("RESET" === type)) {
                return replaceNewLines(e.value);
            }
            if (("A" === tag) || ("BUTTON" === tag)) {
                return replaceNewLines(getElementText());
            }
            return "";
        }

        function computeAccName() {
            var label = getLabel();
            var title = getTitle();
            var alt = getAlt();
            var text = getText();
            if (("BUTTON" === type) || ("RESET" === type) || ("SUBMIT" === type) || ("BUTTON" === tag)) {
                return getFirstNotEmpty(title, text);
            }
            if ("IMAGE" === type) {
                return getFirstNotEmpty(title, alt, label);
            }
            if ("IMG" === tag) {
                var res = getFirstNotEmpty(title, alt, label);
                if (res === "") {
                    var parentAnchor = getParentByTag(e, "A");
                    return gcontext.getAccName(parentAnchor);
                }
                return res;
            }
            return getFirstNotEmpty(label, text, title, alt);
        }

        function getFirstNotEmpty() {
            for (var a = 0; a < arguments.length; ++a) {
                var crntArg = arguments[a];
                if (crntArg && crntArg !== "") {
                    return crntArg;
                }
            }
            return "";
        }

        function getParentByTag(elem, parentTag) {
            parentTag = parentTag.toUpperCase();
            var ELEMENT_NODE_TYPE = 1;
            var resultElement = null;
            var crntNode = elem;
            while (true) {
                var parent = crntNode.parentNode;
                if ((parent == null) || (parent.nodeType !== ELEMENT_NODE_TYPE)) {
                    break;
                }
                if (parentTag === parent.tagName.toUpperCase()) {
                    resultElement = parent;
                    break;
                } else {
                    crntNode = parent;
                }
            }
            return resultElement;
        }
    }
});

WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.GetSafeContentDocument = function (frame) {
        var out_doc = null;
        try {
            out_doc = frame.contentDocument;
        } catch (e) {
            out_doc = null;
        }
        return out_doc;
    }
    gcontext.GetDocumentListRecursive = function (doc, out_docList) {
        if (doc == null)
            return;
        var i = 0;
        out_docList.push(doc);
        var frames = doc.getElementsByTagName("iframe");
        for (i = 0; i < frames.length; ++i)
            gcontext.GetDocumentListRecursive(gcontext.GetSafeContentDocument(frames.item(i)), out_docList);
        frames = doc.getElementsByTagName("frame");
        for (i = 0; i < frames.length; ++i)
            gcontext.GetDocumentListRecursive(gcontext.GetSafeContentDocument(frames.item(i)), out_docList);
    }
    gcontext.GetDocumentList = function (rootDoc) {
        if (!gcontext.IsMainFrame(window)) {
            return [rootDoc];
        }
        var docList = [];
        gcontext.GetDocumentListRecursive(rootDoc, docList);
        return docList;
    }
    gcontext.GetFrameListRecursive = function (doc, out_frameList) {
        if (doc == null)
            return;
        var i = 0;
        var frames = doc.getElementsByTagName("iframe");
        for (i = 0; i < frames.length; ++i) {
            var frame = frames.item(i);
            out_frameList.push(frame);
            gcontext.GetFrameListRecursive(gcontext.GetSafeContentDocument(frame), out_frameList);
        }
        frames = doc.getElementsByTagName("frame");
        for (i = 0; i < frames.length; ++i) {
            var frame = frames.item(i);
            out_frameList.push(frame);
            gcontext.GetFrameListRecursive(gcontext.GetSafeContentDocument(frame), out_frameList);
        }
    }
    gcontext.GetFrameList = function (rootDoc) {
        var frameList = [];
        gcontext.GetFrameListRecursive(rootDoc, frameList);
        return frameList;
    }
});

WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.MAX_ATTR_LEN = 64;
    gcontext.UIE_CF_CLICK_MASK = 0x00000003;
    gcontext.UIE_CF_SINGLE = 0x00000000;
    gcontext.UIE_CF_DOUBLE = 0x00000001;
    gcontext.UIE_CF_HOVER = 0x00000002;
    gcontext.UIE_CF_BUTTON_MASK = 0x0000000C;
    gcontext.UIE_CF_LEFT = 0x00000000;
    gcontext.UIE_CF_RIGHT = 0x00000004;
    gcontext.UIE_CF_MIDDLE = 0x00000008;
    gcontext.UIE_CF_SCREEN_COORDS = 0x00000010;
    gcontext.UIE_CF_DOWN = 0x00001000;
    gcontext.UIE_CF_UP = 0x00002000;
    gcontext.UIE_CF_MOD_CTRL = 0x00004000;
    gcontext.UIE_CF_MOD_ALT = 0x00008000;
    gcontext.UIE_CF_MOD_SHIFT = 0x00010000;
    gcontext.HTML_LEFT_BUTTON = 0;
    gcontext.HTML_MIDDLE_BUTTON = 1;
    gcontext.HTML_RIGHT_BUTTON = 2;
    gcontext.HTML_CLICK_SINGLE = 0;
    gcontext.HTML_CLICK_DOUBLE = 1;
    gcontext.HTML_CLICK_HOVERONLY = 2;
    gcontext.CLICK_OFFSET_X = 2;
    gcontext.CLICK_OFFSET_Y = 2;
    gcontext.UI_EVENT = 0;
    gcontext.g_skipAttrInCompatible = ['css-selector', 'readystate', 'role', 'selecteditems', 'url', 'value'];
    gcontext.g_getCustomAttrMap = {
        "url": function (elem) {
            if (elem.ownerDocument)
                return elem.ownerDocument.URL;
            return "";
        }, "htmlwindowname": function (elem) {
            if (window.name) {
                return window.name;
            } else {
                return "";
            }
        }, "title": function (elem) {
            if (elem.ownerDocument)
                return elem.ownerDocument.title;
            return "";
        }, "cookie": function (elem) {
            if (elem.ownerDocument)
                return elem.ownerDocument.cookie;
            return "";
        }, "readystate": function (elem) {
            if (!elem.ownerDocument || elem.ownerDocument.readyState !== "complete") {
                return "0";
            }
            if (gcontext.IsSapFioriElement(elem)) {
                return gcontext.GetSapReadyState(elem);
            }
            return "1";
        }, "innertext": function (elem) {
            return gcontext.DeleteForbiddenCharacters(elem.textContent);
        }, "innertextshort": function (elem) {
            return gcontext.GetAttributeShortValue(elem, "innertext");
        }, "outertext": function (elem) {
            return gcontext.DeleteForbiddenCharacters(elem.textContent);
        }, "outertextshort": function (elem) {
            return gcontext.GetAttributeShortValue(elem, "outertext");
        }, "innerhtml": function (elem) {
            return elem.innerHTML;
        }, "innerhtmlshort": function (elem) {
            return gcontext.GetAttributeShortValue(elem, "innerhtml");
        }, "outerhtml": function (elem) {
            return elem.outerHTML;
        }, "outerhtmlshort": function (elem) {
            return gcontext.GetAttributeShortValue(elem, "outerhtml");
        }, "tag": function (elem) {
            return elem.tagName;
        }, "parentid": function (elem) {
            return gcontext.GetParentAttributeValue(elem, "id");
        }, "parentname": function (elem) {
            return gcontext.GetParentAttributeValue(elem, "name");
        }, "parentclass": function (elem) {
            return gcontext.GetParentAttributeValue(elem, "class");
        }, "parenttag": function (elem) {
            return elem.parentNode ? elem.parentNode.tagName : "";
        }, "tablerow": function (elem) {
            var r = gcontext.GetTableRowAndCol(elem, {getRow: true}).row;
            return r < 0 ? "" : r;
        }, "tablecol": function (elem) {
            var c = gcontext.GetTableRowAndCol(elem, {getCol: true}).col;
            return c < 0 ? "" : c;
        }, "rowname": function (elem) {
            return gcontext.GetTableRowName(elem);
        }, "colname": function (elem) {
            return gcontext.GetTableColName(elem);
        }, "columncount": function (elem) {
            return gcontext.GetTableColCount(elem);
        }, "rowcount": function (elem) {
            return gcontext.GetTableRowCount(elem);
        }, "checked": function (elem) {
            return gcontext.GetCheckedAttribute(elem);
        }, "role": function (elem) {
            return "element";
        }, "aastate": function (elem) {
            if (elem.disabled === true)
                return "disabled";
            return "enabled";
        }, "aaname": function (elem) {
            return gcontext.getAccName(elem);
        }, "aanameshort": function (elem) {
            return gcontext.GetAttributeShortValue(elem, "aaname");
        }, "css-selector": function (elem) {
            return gcontext.getCssSelector(elem);
        }, "xpath": function (elem) {
            return gcontext.getXpathSelector(elem);
        }, "selecteditem": function (elem) {
            return gcontext.GetSelectedItemTxt(elem);
        }, "selecteditems": function (elem) {
            return gcontext.GetSelectedItemsTxt(elem);
        }, "isleaf": function (elem) {
            return (gcontext.isLeafElement(elem) ? "1" : "0");
        }, "ui5-id": function (elem) {
            return gcontext.GetSapId(elem);
        }, "ui5-class": function (elem) {
            return gcontext.GetSapClass(elem);
        }, "ui5-role": function (elem) {
            return gcontext.GetSapRole(elem);
        }, "ui5-type": function (elem) {
            return gcontext.GetSapType(elem);
        }, "ui5-label": function (elem) {
            return gcontext.GetSapLabel(elem);
        }, "ui5-tooltip": function (elem) {
            return gcontext.GetSapTooltip(elem);
        }, "ui5-tablerow": function (elem) {
            return gcontext.GetSapTableRowIndex(elem);
        }, "ui5-tablecol": function (elem) {
            return gcontext.GetSapTableColIndex(elem);
        }, "aria-role": function (elem) {
            return elem.getAttribute("role")
        },
    };
    gcontext.GetSelectedItemTxt = function (e) {
        var items = gcontext.GetSelectedItems(e, 0);
        if (items && items.length > 0) {
            return items[0];
        }
        return "";
    }
    gcontext.GetSelectedItemsTxt = function (e) {
        var items = gcontext.GetSelectedItems(e, 0);
        var txt = "";
        for (var i = 0; i < items.length; ++i) {
            if (txt) {
                txt = txt + ", ";
            }
            txt = txt + "\"";
            txt = txt + items[i];
            txt = txt + "\"";
        }
        txt = "{ " + txt;
        txt = txt + " }";
        return txt;
    }
    gcontext.IsBrowserSettingsUrl = function (url) {
        if (url && ((url.indexOf("chrome://") === 0) || (url.indexOf("edge://") === 0) || (url.indexOf("about:") === 0))) {
            return true;
        }
        return false;
    }
    gcontext.GetAttributeValue = function (element, attrName) {
        var out_attrValue = "";
        var getCustomAttrFunc = gcontext.g_getCustomAttrMap[attrName.toLowerCase()];
        var rawAttrVal;
        var sapAttrPrefix = gcontext.g_sapFioriDefines.propertyBasedAttrPrefix;
        if (getCustomAttrFunc != null)
            rawAttrVal = getCustomAttrFunc(element); else if (attrName.slice(0, sapAttrPrefix.length) === sapAttrPrefix)
            rawAttrVal = gcontext.GetSapPropertyBasedAttribute(element, attrName); else
            rawAttrVal = element.getAttribute(attrName);
        if (typeof (rawAttrVal) === "boolean")
            out_attrValue = (rawAttrVal ? "1" : "0"); else if (rawAttrVal != null && rawAttrVal.toString != null)
            out_attrValue = rawAttrVal.toString();
        return out_attrValue;
    }
    gcontext.GetCssValue = function (element, cssName) {
        var out_attrValue = "";
        if (element.currentStyle) {
            return element.currentStyle[cssName];
        } else if (getComputedStyle) {
            return getComputedStyle(element, false)[cssName];
        }
        return out_attrValue;
    }
    gcontext.GetParentAttributeValue = function (element, attrName) {
        var out_attrValue = "";
        gcontext.ForEachAncestor(element, function (crtAncestor) {
            out_attrValue = gcontext.GetAttributeValue(crtAncestor, attrName);
            if (out_attrValue.length !== 0) {
                return false;
            }
            return true;
        });
        return out_attrValue;
    }
    gcontext.GetParentByTag = function (element, tagName) {
        var out_parentElem = null;
        gcontext.ForEachAncestor(element, function (crtAncestor) {
            if (crtAncestor.tagName.toLowerCase() === tagName) {
                out_parentElem = crtAncestor;
                return false;
            }
            return true;
        });
        return out_parentElem;
    }
    gcontext.GetFirstChildText = function (parentElem, tag, index) {
        var children = parentElem.getElementsByTagName(tag);
        if (children == null) {
            return "";
        }
        if (index > children.length - 1) {
            return "";
        }
        var text = children.item(index).textContent;
        return gcontext.DeleteForbiddenCharacters(text);
    }
    gcontext.GetTableRowCount = function (e) {
        var tagName = e.tagName.toLowerCase();
        if (tagName !== "table") {
            return "";
        }
        var rows = e.getElementsByTagName("tr");
        if (rows !== null) {
            return rows.length.toString();
        }
        return "";
    }
    gcontext.GetTableColCount = function (e) {
        var tagName = e.tagName.toLowerCase();
        if (tagName !== "table") {
            return "";
        }
        var rows = e.getElementsByTagName("tr");
        if ((rows !== null) && (rows.length > 0)) {
            var tds = rows.item(0).getElementsByTagName("td");
            if ((tds !== null) && (tds.length > 0)) {
                return tds.length.toString();
            }
            var ths = rows.item(0).getElementsByTagName("th");
            if ((ths !== null) && (ths.length > 0)) {
                return ths.length.toString();
            }
        }
        return "";
    }
    gcontext.GetTableRowName = function (elem) {
        var parentRow = gcontext.GetParentByTag(elem, "tr");
        if (!parentRow) {
            return "";
        }
        var text = gcontext.GetFirstChildText(parentRow, "th", 0);
        if (text === "") {
            text = gcontext.GetFirstChildText(parentRow, "td", 0);
        }
        return text;
    }
    gcontext.GetTableColName = function (elem) {
        var table = gcontext.GetParentByTag(elem, "table");
        if (!table) {
            return "";
        }
        var colIndex = gcontext.GetTableRowAndCol(elem, {getCol: true}).col;
        if (colIndex < 1) {
            return "";
        }
        var text = gcontext.GetFirstChildText(table, "th", colIndex - 1);
        if (text === "") {
            text = gcontext.GetFirstChildText(table, "td", colIndex - 1);
        }
        return text;
    }
    gcontext.GetTableRowAndCol = function (cellElem, inputFlags) {
        var out_rowAndCol = {row: -1, col: -1};
        var tagName = cellElem.tagName.toLowerCase();
        if (tagName !== "td" && tagName !== "th") {
            var parentCell = gcontext.GetParentByTag(cellElem, "td");
            if (parentCell === null) {
                parentCell = gcontext.GetParentByTag(cellElem, "th");
                if (parentCell === null) {
                    return out_rowAndCol;
                }
            }
            cellElem = parentCell;
        }
        var rowParent = gcontext.GetParentByTag(cellElem, "tr");
        if (rowParent == null)
            return out_rowAndCol;
        if (inputFlags.getCol === true)
            out_rowAndCol.col = gcontext.ComputeIndexInParent(cellElem, rowParent);
        if (inputFlags.getRow === true) {
            var tableParent = gcontext.GetParentByTag(rowParent, "table");
            if (tableParent == null)
                return out_rowAndCol;
            out_rowAndCol.row = gcontext.ComputeIndexInParent(rowParent, tableParent);
        }
        return out_rowAndCol;
    }
    gcontext.ComputeIndexInParent = function (element, parent) {
        var out_index = -1;
        var i;
        var refCustomId = gcontext.GenerateCustomIdForElement(element);
        var children = parent.getElementsByTagName(element.tagName);
        if (children == null)
            return out_index;
        for (i = 0; i < children.length; ++i) {
            if (gcontext.GetCustomIdForElement(children.item(i)) === refCustomId) {
                out_index = i + 1;
                break;
            }
        }
        return out_index;
    };
    gcontext.FindElementUsingXpath = function (xpath, root) {
        function filter(xpathStr) {
            return xpathStr.replace("//*[@id='undefined']", "");
        }

        var doc = root || document;
        var out_element = [];
        var xresult = doc.evaluate(filter(xpath), doc, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
        var currentNode;
        while (currentNode = xresult.iterateNext()) {
            out_element.push(currentNode);
        }
        return out_element;
    };
    gcontext.FilterCssSelector = function (cssSelector) {
        // 过滤css 如果以数字开头，需要用加上ascii码\\3
        // 例： 拾取 #1 > div > a 转换后 #\\31 > div > a
        // 例： 拾取 div#1 > div > a 转换后 div#\\31 > div > a
        // 例： 拾取 #123 > div > a 转换后 #\\31 23 > div > a  (注意中间空格)
        // 例： 拾取 input[name=bugIDList[]] 转换后 input[name=bugIDList\\[\\]]
        // 例： 拾取 #query:abc 转换后 #query\\:abc

        function insert(soure, start, newStr) {
            return soure.slice(0, start) + newStr + soure.slice(start);
        }

        function isStartWithNum(str) {
            return str.match(/^\d/);
        }

        if (cssSelector.indexOf("#") > -1) {
            var filterStrs = cssSelector.split(" > ");
            for (var i = 0; i < filterStrs.length; i++) {
                var pos = filterStrs[i].indexOf("#");
                var prefabricatePrifex = null;
                var prefabricate = null;

                if (pos != 0) {
                    prefabricatePrifex = filterStrs[i].substring(0, pos);
                    prefabricate = filterStrs[i].substr(pos, filterStrs[i].length);
                } else {
                    prefabricatePrifex = "";
                    prefabricate = filterStrs[i];
                }

                if (isStartWithNum(prefabricate.charAt(1))) {
                    var str = prefabricate.trim();
                    var newStr = insert(str, 1, "\\3");
                    if (str.length > 2) {
                        newStr = insert(newStr, 4, " ");
                    }
                    filterStrs[i] = newStr;
                    if (prefabricatePrifex !== "") {
                        filterStrs[i] = prefabricatePrifex + filterStrs[i];
                    }
                }
            }

            cssSelector = filterStrs.join(" > ");
        }

        return cssSelector.replace("[]", "\\[\\]");
    };
    gcontext.FindElementUsingCssSelector = function (cssSelector, root) {
        var doc = root || document;
        var out_element = doc.querySelectorAll(gcontext.FilterCssSelector(cssSelector));
        return out_element == null ? [] : out_element;
    };
    gcontext.ElementHasAttributeValues = function (element, attrMap, fuzzyScoreStats) {
        if (element == null) {
            return false;
        }
        if (gcontext.IsObjectEmpty(attrMap)) {
            if (typeof fuzzyScoreStats !== "undefined") {
                fuzzyScoreStats.accept(1.0);
            }
            return true;
        }
        var out_match = true;
        for (var attrName in attrMap) {
            if (gcontext.g_skipAttrInCompatible.indexOf(attrName) < 0) {
                var crtValue = gcontext.GetAttributeValue(element, attrName);
                var matchRes = gcontext.HasAttributeValue(attrMap[attrName]) && attrMap[attrName].Matches(crtValue, fuzzyScoreStats);
                if (matchRes === false) {
                    var paramValue = gcontext.GetActiveValueString(attrMap[attrName]);
                    // gcontext.TraceMessage("ElementHasAttributeValues: value of " + attrName + " not match --> current:[" + crtValue + "] vs param:[" + paramValue + "]");
                    out_match = false;
                    break;
                }
            }
        }
        return out_match;
    }
    gcontext.FindElementUsingAttributes = function (htmlCollection, index, attrMap) {
        var out_element = null;
        var i;
        if (htmlCollection == null)
            return out_element;
        var crtIndex = 0;
        for (i = 0; i < htmlCollection.length; ++i) {
            var crtElem = htmlCollection[i];
            if (gcontext.ElementHasAttributeValues(crtElem, attrMap) === true) {
                ++crtIndex;
                if (crtIndex === index) {
                    out_element = crtElem;
                    break;
                }
            }
        }
        return out_element;
    };
    gcontext.DoubleSummaryStatistics = function () {
        this.max = 0.0;
        this.min = Number.MAX_VALUE;
        this.average = 0;
        this.sum = 0;
        this.count = 0;
        this.accept = function (value) {
            gcontext.TraceMessage("DoubleSummaryStatistics: accept " + value);
            ++this.count;
            if (value > this.max) this.max = value;
            if (value < this.min) this.min = value;
            this.sum += value;
            this.average = this.sum / this.count;
        };
    };
    gcontext.FindElementCollectionUsingAttributes = function (htmlCollection, params) {
        var out_results = new gcontext.ResultsCollection(params.maxElems);
        if (htmlCollection == null) {
            return out_results;
        }
        var i;
        var crtIndex = 0;
        for (i = 0; i < htmlCollection.length; ++i) {
            var crtElem = htmlCollection[i];
            var fuzzyScoreStats = new gcontext.DoubleSummaryStatistics();
            if (gcontext.ElementHasAttributeValues(crtElem, params.attrMap, fuzzyScoreStats) === true) {
                var matchingScore = fuzzyScoreStats.average;
                gcontext.TraceMessage("FindElementCollectionUsingAttributes: matchingScore =" + matchingScore);
                if (!params.useTagFuzzyLevel || matchingScore >= params.tagFuzzyLevel) {
                    out_results.Accept(new gcontext.HtmlSearchResult(crtElem, matchingScore));
                }
                if (out_results.IsFull()) {
                    gcontext.TraceMessage("FindElementCollectionUsingAttributes: breaking the loop");
                    break;
                }
            }
        }
        return out_results;
    };
    gcontext.checkTabUsingAttributes = function (tab, params) {
        var out_results = true;
        var fuzzyScoreStats = new gcontext.DoubleSummaryStatistics();

        var hasTitleValue = gcontext.HasAttributeValue(params.attrMap["title"]);
        if (hasTitleValue && !params.attrMap["title"].Matches(tab.title, fuzzyScoreStats)) {
            out_results = false;
        }

        var hasUrlValue = gcontext.HasAttributeValue(params.attrMap["url"]);
        if (hasUrlValue && !params.attrMap["url"].Matches(tab.url, fuzzyScoreStats)) {
            out_results = false;
        }

        return out_results;
    };
    gcontext.FindTabCollectionUsingAttributes = function (params, OnFinishedCallback) {
        FindTabCollectionUsingAttributesByCompatible(0, params, OnFinishedCallback);
    };
    gcontext.FindTabCollectionUsingAttributesByCompatible = function (compatible, params, OnFinishedCallback) {
        var out_results = new gcontext.ResultsCollection(params.maxElems);
        var OnAllTabsProcessed = function () {
            gcontext.TraceMessage("GetMatchingTabs: filteredTabs.length=" + out_results.GetResults().length);
            OnFinishedCallback(out_results);
        };
        var queryOptions = {};
        chrome.tabs.query(queryOptions, function (tabList) {
            var tabCount = tabList ? tabList.length : 0;
            if (tabCount == 0) {
                OnAllTabsProcessed();
            } else {
                gcontext.TraceMessage("onGetHtmlElemById: tab count = " + tabList.length);
                var ProcessTab = function (tab) {
                    gcontext.TraceMessage("onGetHtmlElemById:ProcessTab tab.url = " + tab.url);
                    var fuzzyScoreStats = new gcontext.DoubleSummaryStatistics();
                    var MatchesSyncAttributes = function (tab) {
                        if (compatible == 0) {
                            // 新版本tile与url and关系
                            if ((!gcontext.HasAttributeValue(params.attrMap["title"]) || params.attrMap["title"].Matches(tab.title, fuzzyScoreStats)) &&
                                (!gcontext.HasAttributeValue(params.attrMap["url"]) || params.attrMap["url"].Matches(tab.url, fuzzyScoreStats))) {
                                return true;
                            }
                        } else {
                            // 新版本tile与url or关系
                            if (gcontext.HasAttributeValue(params.attrMap["title"]) && params.attrMap["title"].Matches(tab.title, fuzzyScoreStats)) {
                                return true;
                            }

                            if (gcontext.HasAttributeValue(params.attrMap["url"]) && params.attrMap["url"].Matches(tab.url, fuzzyScoreStats)) {
                                return true;
                            }
                        }
                        return false;
                    };
                    if (MatchesSyncAttributes(tab)) {
                        if (!gcontext.HasAttributeValue(params.attrMap["htmlwindowname"])) {
                            var matchingScore = fuzzyScoreStats.average;
                            if (!params.useTagFuzzyLevel || matchingScore >= params.tagFuzzyLevel) {
                                out_results.Accept(new gcontext.TabSearchResult(tab, matchingScore));
                            }
                            OnTabProcessed();
                        } else if (gcontext.IsBrowserSettingsUrl(tab.url)) {
                            gcontext.TraceMessage("onGetHtmlElemById: skipping tab.id: " + tab.id + ", tab.url: " + tab.url);
                            OnTabProcessed();
                        } else {
                            chrome.tabs.executeScript(tab.id, {code: "window.name"}, function (result) {
                                var windowName = '' + result;
                                if (params.attrMap["htmlwindowname"].Matches(windowName, fuzzyScoreStats)) {
                                    var matchingScore = fuzzyScoreStats.average;
                                    if (!params.useTagFuzzyLevel || matchingScore >= params.tagFuzzyLevel) {
                                        out_results.Accept(new gcontext.TabSearchResult(tab, matchingScore));
                                    }
                                }
                                OnTabProcessed();
                            });
                        }
                    } else {
                        OnTabProcessed();
                    }
                };
                var OnTabProcessed = function () {
                    --tabCount;
                    if (tabCount <= 0) {
                        OnAllTabsProcessed();
                    }
                };
                for (var i = 0; i < tabList.length; ++i) {
                    ProcessTab(tabList[i]);
                }
            }
        });
    }
    gcontext.GetIndexForAttributeList = function (htmlCollection, targetCustomId, attrMap) {
        gcontext.TraceMessage("GetIndexForAttributeList: enter targetCustomId=" + targetCustomId);
        var out_index = 0;
        var i = 0;
        var found = false;
        var unique = true;
        for (i = 0; i < htmlCollection.length; ++i) {
            var crtElem = htmlCollection[i];
            var crtCustomId = gcontext.GetCustomIdForElement(crtElem);
            if (found === false && crtCustomId === targetCustomId) {
                gcontext.TraceMessage("GetIndexForAttributeList: element reached");
                found = true;
                ++out_index;
                if (out_index > 1) {
                    unique = false;
                    break;
                }
            } else if (gcontext.ElementHasAttributeValues(crtElem, attrMap)) {
                gcontext.TraceMessage("GetIndexForAttributeList: attributes match");
                if (found) {
                    unique = false;
                    break;
                } else
                    ++out_index;
            }
        }
        if (found === false) {
            out_index = -1;
        } else if (unique === true && out_index === 1) {
            out_index = 0;
        }
        gcontext.TraceMessage("GetIndexForAttributeList: return index=" + out_index);
        return out_index;
    }
    gcontext.GetTruncatedAttributeValue = function (targetElement, attrName) {
        var resValue = null;
        var attrVal = gcontext.GetAttributeValue(targetElement, attrName);
        if (attrVal.length !== 0) {
            resValue = ((attrName === "css-selector" || attrName === "xpath") ? attrVal : gcontext.TruncateStringUsingWildcard(attrVal, gcontext.MAX_ATTR_LEN));
        }
        return resValue;
    }
    gcontext.GetAttributeShortValue = function (element, attrName) {
        const maxAttrValueLength = 512;
        var attrValue = gcontext.GetAttributeValue(element, attrName);
        if (attrValue.length > maxAttrValueLength) {
            return gcontext.TruncateStringUsingWildcard(attrValue, maxAttrValueLength);
        }
        return attrValue;
    }
    gcontext.GetAttrNameShort = function (attrName) {
        function Result(shortAttrName, isDifferent) {
            return {shortAttrName: shortAttrName, isDifferent: isDifferent};
        }

        if (attrName === "innertext") {
            return Result("innertextshort", true);
        } else if (attrName === "outertext") {
            return Result("outertextshort", true);
        } else if (attrName === "innerhtml") {
            return Result("innerhtmlshort", true);
        } else if (attrName === "outerhtml") {
            return Result("outerhtmlshort", true);
        } else if (attrName === "aaname") {
            return Result("aanameshort", true);
        }
        return Result(attrName, false);
    }
    gcontext.GetSelectorAttributeListResult = function (tagName, attrMap, index, retCode) {
        var out_result = {tagName: tagName, attrMap: gcontext.ActiveValueStringMap(attrMap), index: index, retCode: retCode};
        return out_result;
    }
    gcontext.isLeafElement = function (e) {
        if (!e) {
            return false;
        }
        return (e.children.length === 0);
    }
    gcontext.shouldAddAAName = function (e) {
        var t = e.tagName.toLowerCase();
        var acceptedTags = ["a", "label", "img", "input", "button", "textarea", "area", "select", "table", "th"];
        if (acceptedTags.indexOf(t) !== -1) {
            return true;
        }
        if (((t === "div") || (t === "span")) && (e.textContent.length <= 32)) {
            return true;
        }
        var acceptedParentTags = ["a", "label", "button", "select", "th"];
        while (true) {
            var p = e.parentElement;
            if (p === null) {
                break;
            }
            t = p.tagName.toLowerCase();
            if (acceptedParentTags.indexOf(t) !== -1) {
                return true;
            }
            e = p;
        }
        return false;
    }
    gcontext.GetSelectorAttributeList = function (rootDocument, targetCustomId, parentId, targetTagName, computeIndex) {
        gcontext.TraceMessage("GetSelectorAttributeList: enter targetCustomId=[" + targetCustomId + "] parentId=[" + parentId + "] targetTagName=[" + targetTagName + "]");
        if (targetCustomId == null) {
            gcontext.TraceMessage("GetSelectorAttributeList: invalid input, return error");
            return gcontext.GetSelectorAttributeListResult("", {}, -1, N_FALSE);
        }
        var targetElement = gcontext.GetElementFromCustomId(targetCustomId);
        if (targetElement == null) {
            gcontext.TraceMessage("GetSelectorAttributeList: targetCustomId=" + targetCustomId + " not found in the cache");
            return gcontext.GetSelectorAttributeListResult("", {}, -1, N_FALSE);
        }
        var isSapFioriElement = gcontext.IsSapFioriElement(targetElement);
        if (isSapFioriElement) {
            return gcontext.GetSapFioriSelectorAttributeList(rootDocument, targetElement, targetCustomId, parentId, targetTagName, computeIndex);
        }
        var getAllDocuments = gcontext.xbrowser.isModeSingleFrame();
        var htmlCollection = gcontext.GetHtmlCollectionForParentId(rootDocument, getAllDocuments, parentId, targetTagName);
        if (htmlCollection == null) {
            gcontext.TraceMessage("OnGetHtmlIdInfo: GetHtmlCollectionForParentId('" + parentId + "') failed");
            return gcontext.GetSelectorAttributeListResult("", {}, -1, N_FALSE);
        }
        var attrLists = ["tag", "type", "aria-role", "id", "name", "parentid", "parentname"];
        var specificAttrList = ["xpath", "css-selector"];
        if (gcontext.shouldAddAAName(targetElement)) {
            attrLists.push("aaname");
        }
        if (gcontext.isLeafElement(targetElement)) {
            attrLists.push("isleaf");
        }
        attrLists.push("xpath");
        attrLists.push("css-selector");
        attrLists.push("tabindex");
        attrLists.push("tableRow");
        attrLists.push("tableCol");
        attrLists.push("href");
        if (gcontext.ElementIsFrame(targetElement)) {
            attrLists.splice(3, 0, "src");
        } else {
            attrLists.push("src");
        }
        var bestIndex = 1000000;
        if (computeIndex == 0)
            bestIndex = 0;

        var attrMap = {};
        attrLists = gcontext.GetUniqueElementsFromArray(attrLists);
        for (var phaseIdx = 0; phaseIdx < attrLists.length; ++phaseIdx) {
            var crntAttrName = attrLists[phaseIdx];
            var crntAttrValue = gcontext.GetTruncatedAttributeValue(targetElement, crntAttrName);
            if (crntAttrValue) {
                if (crntAttrName === "css-selector" && computeIndex > 0) {
                    if (bestIndex <= 1) {
                        continue;
                    }
                    var cssSelector = crntAttrValue;
                    var getAllDocuments = gcontext.xbrowser.isModeSingleFrame();
                    htmlCollection = gcontext.GetHtmlCollectionForParentId(rootDocument, getAllDocuments, parentId, targetTagName, cssSelector);
                    if (htmlCollection === null) {
                        gcontext.TraceMessage("OnGetHtmlIdInfo: GetHtmlCollectionForParentId('" + parentId + "') failed");
                        return gcontext.GetSelectorAttributeListResult("", {}, -1, N_FALSE);
                    }
                }
                attrMap[crntAttrName] = new gcontext.AttributeValue(crntAttrValue);
                if (computeIndex > 0) {
                    var crntIndex = gcontext.GetIndexForAttributeList(htmlCollection, targetCustomId, attrMap);
                    if (crntIndex === -1) {
                        gcontext.TraceMessage("GetSelectorAttributeList: index == -1, return error");
                        return gcontext.GetSelectorAttributeListResult("", {}, -1, N_FALSE);
                    }
                    if (crntIndex < bestIndex) {
                        bestIndex = crntIndex;
                    } else {
                        delete attrMap[crntAttrName];
                    }
                    if (bestIndex === 0) {
                        gcontext.TraceMessage("GetSelectorAttributeList: index == 0, return success");
                        if (Object.keys(attrMap).length === 1 && gcontext.ElementIsFrame(targetElement)) {
                            var extraAttrList = ["id", "name", "src"];
                            for (var i = 0; i < extraAttrList.length; i += 1) {
                                var attrName = extraAttrList[i];
                                var attrValue = gcontext.GetTruncatedAttributeValue(targetElement, attrName);
                                if (attrValue) {
                                    gcontext.TraceMessage("OnGetHtmlIdInfo: Frame selector has only one attribute. Added extra \"" + attrName + "\"=\"" + attrValue + "\" to make it more precise");
                                    attrMap[attrName] = new gcontext.AttributeValue(attrValue);
                                    break;
                                }
                            }
                            if (Object.keys(attrMap).length === 1) {
                                gcontext.TraceMessage("OnGetHtmlIdInfo: Warning, frame selector has only \"tag\" attribute and extra attributes could not be added");
                            }
                        }

                        attrMap = gcontext.GetAttrValueListForSpecificAttrList(targetElement, specificAttrList, attrMap);
                        return gcontext.GetSelectorAttributeListResult(targetElement.tagName, attrMap, 0, N_TRUE);
                    }
                }
            }
        }

        attrMap = gcontext.GetAttrValueListForSpecificAttrList(targetElement, specificAttrList, attrMap);
        return gcontext.GetSelectorAttributeListResult(targetElement.tagName, attrMap, bestIndex, N_TRUE);
    }
    gcontext.GetAttrValueListForSpecificAttrList = function (targetElement, specificAttrList, attrMap) {
        for (var phaseIdx = 0; phaseIdx < specificAttrList.length; phaseIdx++) {
            var crntAttrName = specificAttrList[phaseIdx];
            if (!attrMap[crntAttrName]) {
                var crntAttrValue = gcontext.GetTruncatedAttributeValue(targetElement, crntAttrName);
                attrMap[crntAttrName] = new gcontext.AttributeValue(crntAttrValue);
            }
        }
        return attrMap;
    }
    gcontext.GetAttrValueListForElement = function (element) {
        var result = {};
        if (element !== null) {
            var attrNames = gcontext.GetAttributeListForElement(element);
            var staticAttrNames = ["innertext", "outertext", "innerhtml", "outerhtml", "tag", "parentid", "class", "parentname", "parentclass", "aaname", "aastate", "role", "cookie", "readystate", "url", "checked", "isleaf", "css-selector", "selecteditem", "selecteditems"];
            var allAttrNames = staticAttrNames.concat(attrNames);
            for (var n = 0; n < allAttrNames.length; ++n) {
                var attrName = allAttrNames[n];
                if (attrName !== gcontext.CUSTOM_ID_ATTR_NAME) {
                    var attrNameShort = gcontext.GetAttrNameShort(attrName).shortAttrName;
                    var crntVal = gcontext.GetAttributeValue(element, attrNameShort);
                    if (crntVal !== null && crntVal.length !== 0) {
                        result[attrName] = crntVal;
                    }
                }
            }
        } else {
            result["title"] = document.title;
            result["url"] = document.URL;
            result["cookies"] = document.cookie;
            result["readystate"] = (document.readyState === "complete" ? "1" : "0");
            result["text"] = (document.body ? gcontext.DeleteForbiddenCharacters(document.body.textContent) : "");
        }
        return result;
    }
    gcontext.GetSelectorAttributeNames = function (element) {
        if (element == null) {
            return [];
        }
        var allAttrNames = ["action", "alt", "aaname", "href", "id", "innertext", "name", "parentid", "parentname", "parentclass", "src", "tabindex", "tableCol", "tableRow", "colName", "rowName", "tag", "title", "type", "class", "css-selector", "isleaf", "aria-label", "aria-role"];
        if (gcontext.IsSapFioriElement(element)) {
            var sapFioriAttrNames = gcontext.GetSapFioriAttributeNames(element);
            allAttrNames = allAttrNames.concat(sapFioriAttrNames);
        }
        return allAttrNames;
    }
    gcontext.GetAllSelectorAttributesForElement = function (element, attrExclusionMap) {
        var result = {};
        if (element !== null) {
            var allAttrNames = gcontext.GetSelectorAttributeNames(element);
            for (var n = 0; n < allAttrNames.length; ++n) {
                var attrName = allAttrNames[n];
                var shortAttrRes = gcontext.GetAttrNameShort(attrName);
                var excludedAttrValue = (attrExclusionMap != null ? attrExclusionMap[attrName] : null);
                if (excludedAttrValue == null) {
                    var crntVal = gcontext.GetAttributeValue(element, shortAttrRes.shortAttrName);
                    if (crntVal !== null && crntVal.length !== 0) {
                        result[shortAttrRes.shortAttrName] = crntVal;
                    }
                } else if (shortAttrRes.isDifferent) {
                    result[shortAttrRes.shortAttrName] = excludedAttrValue;
                }
            }
        }
        return result;
    }
    gcontext.GetAttributeListForElement = function (element) {
        var out_attrList = [];
        if (element == null || element.attributes == null)
            return out_attrList;
        var tagName = element.tagName.toLowerCase();
        if ((tagName === "th") || (tagName === "td") || (gcontext.GetParentByTag(element, "td") !== null) || (gcontext.GetParentByTag(element, "th") !== null)) {
            out_attrList.push("tableRow");
            out_attrList.push("tableCol");
            out_attrList.push("rowName");
            out_attrList.push("colName");
        }
        if (tagName === "table") {
            out_attrList.push("rowCount");
            out_attrList.push("columnCount");
        }
        for (var i = 0; i < element.attributes.length; ++i) {
            var crtAttrName = element.attributes.item(i).nodeName;
            if (crtAttrName != null && crtAttrName.length > 0 && crtAttrName.toLowerCase() !== "checked" && crtAttrName !== gcontext.CUSTOM_ID_ATTR_NAME && crtAttrName !== gcontext.g_sapFioriDefines.SAP_FIORI_CUSTOM_ID_ATTR_NAME) {
                out_attrList.push(crtAttrName);
            }
        }
        if (gcontext.IsSapFioriElement(element)) {
            var sapFioriAttrNames = gcontext.GetSapFioriAttributeNames(element);
            out_attrList = out_attrList.concat(sapFioriAttrNames);
        }
        out_attrList.push("aria-role");
        return out_attrList;
    }
    gcontext.GetHtmlCollectionForParentElement = function (parentElem, tagName, cssSelector) {
        if (!tagName) {
            tagName = "*";
        }
        tagName = tagName.toLowerCase();
        var out_collection = [];
        var i;
        var isCssSelectorValid = ((cssSelector !== undefined) && (cssSelector !== null));
        if (isCssSelectorValid) {
            try {
                var elements = parentElem.querySelectorAll(cssSelector);
                for (i = 0; i < elements.length; ++i) {
                    if ((tagName === "*") || (tagName === elements.item(i).tagName.toLowerCase())) {
                        out_collection.push(elements.item(i));
                    }
                }
            } catch (e) {
                gcontext.TraceMessage("GetHtmlCollectionForParentElement exception: " + e);
                isCssSelectorValid = false;
                out_collection = [];
            }
        }
        if (!isCssSelectorValid) {
            var elements = parentElem.getElementsByTagName(tagName);
            gcontext.TraceMessage("GetHtmlCollectionForParentElement: getElementsByTagName(tag='" + tagName + "') returned " + elements.length + " elements");
            for (i = 0; i < elements.length; ++i) {
                out_collection.push(elements.item(i));
            }
        }
        return out_collection;
    }
    gcontext.GetHtmlCollectionForParentId = function (rootDocument, getAllDocuments, parentId, tagName, cssSelector) {
        gcontext.TraceMessage("GetHtmlCollectionForParentId: enter parentId=" + parentId + " tagName=" + tagName);
        var i;
        var out_collection = [];
        if (parentId != null && parentId.length > 0) {
            var parentElem = gcontext.GetElementFromCustomId(parentId);
            if (parentElem == null) {
                gcontext.TraceMessage("GetHtmlCollectionForParentId: parentId=" + parentId + " not found in the cache");
                return null;
            }
            out_collection = gcontext.GetHtmlCollectionForParentElement(parentElem, tagName, cssSelector);
        } else {
            var docs = [rootDocument];
            if (getAllDocuments && gcontext.IsMainFrame(window)) {
                docs = gcontext.GetDocumentList(rootDocument);
            }
            for (i = 0; i < docs.length; ++i)
                out_collection = out_collection.concat(gcontext.GetHtmlCollectionForParentElement(docs[i], tagName, cssSelector));
            if (out_collection.length === 0)
                out_collection = null;
        }
        gcontext.TraceMessage("GetHtmlCollectionForParentId: return");
        return out_collection;
    }
    gcontext.GetDirectChildrenCollectionForParentElement = function (parentElem, tagName) {
        var i;
        var out_collection = [];
        for (i = 0; i < parentElem.children.length; ++i) {
            var crtElem = parentElem.children.item(i);
            if (tagName == null || tagName.length === 0 || crtElem.tagName.toLowerCase() === tagName)
                out_collection.push(crtElem);
        }
        return out_collection;
    }
    gcontext.GetDirectChildrenCollectionForParentId = function (rootDocument, getAllDocuments, parentId, tagName) {
        gcontext.TraceMessage("GetDirectChildrenCollectionForParentId: enter tagName=[" + tagName + "]");
        var i;
        var out_collection = [];
        if (parentId != null && parentId.length > 0) {
            var parentElem = gcontext.GetElementFromCustomId(parentId);
            if (parentElem == null) {
                gcontext.TraceMessage("GetDirectChildrenCollectionForParentId: parentId=" + parentId + " not found in the cache");
                return null;
            }
            gcontext.TraceMessage("GetDirectChildrenCollectionForParentId: calling GetDirectChildrenCollectionForParentElement on parentId");
            out_collection = gcontext.GetDirectChildrenCollectionForParentElement(parentElem, tagName);
        } else {
            gcontext.TraceMessage("GetDirectChildrenCollectionForParentId: calling GetDirectChildrenCollectionForParentElement on each doc");
            var docs = [rootDocument];
            if (getAllDocuments) {
                docs = gcontext.GetDocumentList(rootDocument);
            }
            for (i = 0; i < docs.length; ++i) {
                var docElem = docs[i].documentElement;
                if (docElem.tagName.toLowerCase() === tagName)
                    out_collection.push(docElem);
                out_collection = out_collection.concat(gcontext.GetDirectChildrenCollectionForParentElement(docElem, tagName));
            }
            if (out_collection.length === 0)
                out_collection = null;
        }
        gcontext.TraceMessage("GetDirectChildrenCollectionForParentId: return");
        return out_collection;
    }
    gcontext.GetFrameParent = function (rootDoc, frameElement) {
        var out_frameParent = null;
        var customIdToSearch = gcontext.GenerateCustomIdForElement(frameElement);
        var frames = gcontext.GetFrameList(rootDoc);
        var frameIdx = 0;
        for (frameIdx = 0; frameIdx < frames.length && out_frameParent == null; ++frameIdx) {
            var crtFrame = frames[frameIdx];
            var crtDoc = gcontext.GetSafeContentDocument(crtFrame);
            if (crtDoc) {
                var children = crtDoc.getElementsByTagName(frameElement.tagName);
                var childIdx = 0;
                for (childIdx = 0; childIdx < children.length; ++childIdx) {
                    var crtElem = children.item(childIdx);
                    var crtCustomId = gcontext.GetCustomIdForElement(crtElem);
                    if (crtCustomId === customIdToSearch) {
                        out_frameParent = crtFrame;
                        break;
                    }
                }
            }
        }
        return out_frameParent;
    }
    gcontext.GetElementClientBoundingCssRectangle = function (rootDoc, element) {
        var htmlRc = element.getBoundingClientRect();
        var out_rc = gcontext.UiRect(htmlRc.left, htmlRc.top, htmlRc.width, htmlRc.height);
        if (gcontext.IsMainFrame(window)) {
            var parent = gcontext.GetFrameParent(rootDoc, element);
            while (parent) {
                htmlRc = parent.getBoundingClientRect();
                gcontext.TraceMessage("GetElementClientCssRectangle: offsetting with (" + htmlRc.left, htmlRc.top + ")");
                out_rc = out_rc.Offset(htmlRc.left, htmlRc.top);
                parent = gcontext.GetFrameParent(rootDoc, parent);
            }
        }
        return out_rc;
    }
    gcontext.GetElementClientInnerCssRectangle = function (element) {
        var htmlRc = element.getBoundingClientRect();
        return gcontext.UiRect(htmlRc.left + element.clientLeft, htmlRc.top + element.clientTop, element.clientWidth, element.clientHeight);
    }
    gcontext.GetTextFromSelection = function (selectElement) {
        var out_text = "";
        if (selectElement.size <= 1 && selectElement.multiple === false) {
            if (selectElement.selectedIndex === -1)
                return out_text;
            out_text = selectElement.item(selectElement.selectedIndex).text;
        }
        return out_text;
    }
    gcontext.GetFullTextFromSelect = function (selectElement) {
        var out_text = "";
        var i;
        var options = selectElement.getElementsByTagName("option");
        for (i = 0; i < options.length; ++i) {
            var option = options.item(i);
            if (option.text && option.text.length > 0)
                out_text += option.text + "\n";
        }
        return out_text;
    }
    gcontext.GetTextContentFromElement = function (element) {
        var out_text = "";
        var tag = element.tagName.toLowerCase();
        if (tag === "select")
            out_text = gcontext.GetTextFromSelection(element); else
            out_text = gcontext.TrimWhiteSpaces(element.textContent);
        return out_text;
    }
    gcontext.GetIntCssProperty = function (style, propName, unitSuffix, defaultValue) {
        var out_intValue = defaultValue;
        var propValue = style.getPropertyValue(propName);
        if (propValue != null && propValue.length > 0) {
            if (propValue.length > unitSuffix.length && propValue.slice(propValue.length - unitSuffix.length) === unitSuffix) {
                var numericPart = propValue.slice(0, propValue.length - unitSuffix.length);
                out_intValue = parseInt(numericPart);
            }
        }
        return out_intValue;
    }
    gcontext.GetElementMarginFromParent = function (htmlWindow, element) {
        var out_marginSize = 0;
        if (element == null || element.parentNode == null)
            return out_marginSize;
        var elementRect = element.getBoundingClientRect();
        for (var ancestor = element.parentNode; ancestor != null && ancestor.nodeType === ancestor.ELEMENT_NODE; ancestor = ancestor.parentNode) {
            var ancestorRect = ancestor.getBoundingClientRect();
            if (ancestorRect.width > elementRect.width && ancestorRect.height > elementRect.height)
                break;
            if (ancestorRect.width === elementRect.width && ancestorRect.height === elementRect.height) {
                var style = htmlWindow.getComputedStyle(ancestor);
                var borderSize = gcontext.GetIntCssProperty(style, "margin-left", "px", 0) +
                    gcontext.GetIntCssProperty(style, "margin-right", "px", 0);
                if (borderSize > out_marginSize)
                    out_marginSize = borderSize;
            }
        }
        return out_marginSize;
    }
    gcontext.TextRectInfo = function (text, rect, lineWidth, endsWithWhitespace) {
        return {text: text, rect: rect, lineWidth: lineWidth, endsWithWhitespace: endsWithWhitespace};
    }
    gcontext.CreateTextExtractorObject = function (htmlWindow, rootDocument, element, separators) {
        var out_textRectInfos = [];
        var LINE_OVERFLOW_TOLERANCE = 1;
        var m_spanElem = null;
        var m_elemRect = null;
        var m_elemCustomId = "", m_parentElemCustomId = "";
        var m_srcStyle = null;
        var m_borderLeft = 0, m_borderTop = 0, m_borderRight = 0;
        var m_initialOffsetForSpacing = {x: 0, y: 0};
        var m_crtOffsetForSpacing = {x: 0, y: 0};
        var m_maxLineRight = 0;
        var m_lineWidth = 0, m_lineHeight = 0;
        var m_totalTextHeight = 0;

        function GetNonWhitespaceWordExtentsUsingSpan(word) {
            m_spanElem.textContent = word;
            var rc = m_spanElem.getBoundingClientRect();
            return {width: rc.width, height: rc.height};
        }

        var DUMMY_BORDER_CHAR = "x";
        var m_dummyBorderCharWidth = 0;

        function GetDummyBorderCharWidth() {
            if (m_dummyBorderCharWidth !== 0)
                return m_dummyBorderCharWidth;
            m_dummyBorderCharWidth = GetNonWhitespaceWordExtentsUsingSpan(DUMMY_BORDER_CHAR).width;
            return m_dummyBorderCharWidth;
        }

        function GetWordExtentsUsingSpan(word) {
            if (word.length === 0)
                return {width: 0, height: 0};
            var extraHeading = "";
            var extraTrailing = "";
            var extraHeadingWidth = 0;
            var extraTrailingWidth = 0;
            if (gcontext.IsWhiteSpaceCharacter(word.charAt(0))) {
                extraHeading = DUMMY_BORDER_CHAR;
                extraHeadingWidth = GetDummyBorderCharWidth();
            }
            if (gcontext.IsWhiteSpaceCharacter(word.charAt(word.length - 1))) {
                extraTrailing = DUMMY_BORDER_CHAR;
                extraTrailingWidth = GetDummyBorderCharWidth();
            }
            var wordExt = GetNonWhitespaceWordExtentsUsingSpan(extraHeading + word + extraTrailing);
            return {width: wordExt.width - extraHeadingWidth - extraTrailingWidth, height: wordExt.height};
        }

        return {
            BeginAccumulateTextRectInfo: function () {
                if (element == null)
                    return false;
                var doc = element.ownerDocument;
                m_srcStyle = htmlWindow.getComputedStyle(element);
                m_spanElem = doc.createElement("span");
                var cssProps = ["font-family", "font-size", "font-size-adjust", "font-stretch", "font-style", "font-variant", "font-weight", "text-align", "text-align-last", "text-decoration", "text-indent", "text-justify", "text-overflow", "text-shadow", "text-transform", "text-autospace", "text-kashida-space", "text-underline-position", "direction", "zoom"];
                for (i = 0; i < cssProps.length; ++i) {
                    var propName = cssProps[i];
                    var propValue = m_srcStyle.getPropertyValue(propName);
                    if (propValue != null && propValue.length > 0) {
                        var propPriority = m_srcStyle.getPropertyPriority(propName);
                        m_spanElem.style.setProperty(propName, propValue, propPriority);
                    }
                }
                m_spanElem.style.setProperty("resize", "both", "");
                m_spanElem.style.setProperty("display", "inline-block", "");
                doc.body.appendChild(m_spanElem);
                m_borderLeft = gcontext.GetIntCssProperty(m_srcStyle, "padding-left", "px", 0);
                m_borderTop = gcontext.GetIntCssProperty(m_srcStyle, "padding-top", "px", 0);
                m_borderRight = gcontext.GetIntCssProperty(m_srcStyle, "padding-right", "px", 0);
                m_elemRect = gcontext.GetElementClientBoundingCssRectangle(rootDocument, element);
                m_elemCustomId = gcontext.GenerateCustomIdForElement(element);
                m_parentElemCustomId = gcontext.GenerateCustomIdForElement(element.parentNode);
                m_initialOffsetForSpacing.x = m_elemRect.left + m_borderLeft;
                m_initialOffsetForSpacing.y = m_elemRect.top + m_borderTop;
                m_maxLineRight = m_elemRect.right - m_borderRight;
                m_crtOffsetForSpacing.x = m_initialOffsetForSpacing.x;
                m_crtOffsetForSpacing.y = m_initialOffsetForSpacing.y;
                m_lineWidth = (m_elemRect.right - m_borderRight) - (m_elemRect.left + m_borderLeft);
                m_lineHeight = gcontext.GetIntCssProperty(m_srcStyle, "line-height", "px", 0);
                m_totalTextHeight = m_lineHeight;
                gcontext.TraceMessage("BeginAccumulateTextRectInfo: m_lineHeight=" + m_lineHeight);
                gcontext.TraceMessage("BeginAccumulateTextRectInfo: m_maxLineRight=" + m_maxLineRight);
                gcontext.TraceMessage("BeginAccumulateTextRectInfo: m_initialOffsetForSpacing=" + gcontext.EnumObjectProps(m_initialOffsetForSpacing, true));
                gcontext.TraceMessage("BeginAccumulateTextRectInfo: m_elemRect=" + m_elemRect.toString());
                gcontext.TraceMessage("BeginAccumulateTextRectInfo: border LTR = (" + m_borderLeft + " " + m_borderTop + " " + m_borderRight + ")");
                return true;
            }, GetRects: function () {
                return out_textRectInfos;
            }, EndAccumulateTextRectInfo: function () {
                if (m_srcStyle != null) {
                    var i = 0;
                    var borderTopCorrection = 0;
                    var verticalAlign = m_srcStyle.getPropertyValue("vertical-align");
                    if (verticalAlign === "middle") {
                        var centeredBorderTop = (m_elemRect.getHeight() - m_totalTextHeight) / 2;
                        gcontext.TraceMessage("GetTextBorderTopCorrectionFromCss: totalTextHeight=" + m_totalTextHeight + " centeredBorderTop=" + centeredBorderTop);
                        borderTopCorrection = centeredBorderTop - m_borderTop;
                    } else if (verticalAlign === "baseline" || verticalAlign === "bottom") {
                        var bottomAlignedBorderTop = m_elemRect.getHeight() - m_totalTextHeight;
                        gcontext.TraceMessage("GetTextBorderTopCorrectionFromCss: totalTextHeight=" + m_totalTextHeight + " bottomAlignedBorderTop=" + bottomAlignedBorderTop);
                        borderTopCorrection = bottomAlignedBorderTop - m_borderTop;
                    }
                    if (borderTopCorrection !== 0) {
                        for (i = 0; i < out_textRectInfos.length; ++i)
                            out_textRectInfos[i].rect = out_textRectInfos[i].rect.Offset(0, borderTopCorrection);
                    }
                }
                if (out_textRectInfos.length !== 0)
                    out_textRectInfos[out_textRectInfos.length - 1].endsWithWhitespace = true;
                if (m_spanElem != null) {
                    element.ownerDocument.body.removeChild(m_spanElem);
                    m_spanElem = null;
                }
                gcontext.TraceMessage("EndAccumulateTextRectInfo: return");
                return out_textRectInfos;
            }, AdvanceTextOffsets: function (advanceX) {
                var newOffsetX = m_crtOffsetForSpacing.x + advanceX;
                var lineOverflow = newOffsetX - m_maxLineRight;
                if (lineOverflow >= LINE_OVERFLOW_TOLERANCE) {
                    m_crtOffsetForSpacing.x = m_initialOffsetForSpacing.x;
                    m_crtOffsetForSpacing.y += m_lineHeight;
                    m_totalTextHeight += m_lineHeight;
                } else
                    m_crtOffsetForSpacing.x = newOffsetX;
            }, AccumulateTextRectInfo: function (text) {
                if (text == null || text.length === 0)
                    return false;
                if (m_spanElem == null)
                    return false;
                var m_crtWordForSpacing = "", m_crtWord = "";
                var CharType = {WORD: 0, SEPARATOR: 1, WHITESPACE: 2};

                function GetCharType(ch) {
                    if (gcontext.IsWhiteSpaceCharacter(ch))
                        return CharType.WHITESPACE;
                    if (separators.indexOf(ch) !== -1)
                        return CharType.SEPARATOR;
                    return CharType.WORD;
                }

                function RectContains(rect, point) {
                    return ((point.x >= rect.left && point.x < rect.right) && (point.y >= rect.top && point.y < rect.bottom));
                }

                function CheckNewLineAndUpdateSpacingOffsets() {
                    var out_wordExtForSpacing = GetWordExtentsUsingSpan(m_crtWordForSpacing);
                    if (m_lineHeight === 0 && out_wordExtForSpacing.height > m_lineHeight) {
                        m_lineHeight = out_wordExtForSpacing.height;
                        m_totalTextHeight = m_lineHeight;
                        gcontext.TraceMessage("AccumulateTextRectInfo::CheckNewLineAndUpdateSpacingOffsets: m_lineHeight=" + m_lineHeight);
                    }
                    var wordExt = GetWordExtentsUsingSpan(m_crtWord);
                    var checkOverlappingElements = true;
                    var INNER_TOLERANCE = 2;
                    if (wordExt.width < (2 * INNER_TOLERANCE) || wordExt.height < (2 * INNER_TOLERANCE)) {
                        checkOverlappingElements = false;
                    }
                    while (checkOverlappingElements === true) {
                        checkOverlappingElements = false;
                        if (m_crtWord.length > 0) {
                            var points = [{
                                x: m_crtOffsetForSpacing.x + wordExt.width / 2,
                                y: m_crtOffsetForSpacing.y + wordExt.height / 2,
                                name: "middle"
                            }, {
                                x: m_crtOffsetForSpacing.x + INNER_TOLERANCE,
                                y: m_crtOffsetForSpacing.y + INNER_TOLERANCE,
                                name: "left-top"
                            }, {
                                x: m_crtOffsetForSpacing.x + wordExt.width - INNER_TOLERANCE,
                                y: m_crtOffsetForSpacing.y + INNER_TOLERANCE,
                                name: "right-top"
                            }, {
                                x: m_crtOffsetForSpacing.x + INNER_TOLERANCE,
                                y: m_crtOffsetForSpacing.y + wordExt.height - INNER_TOLERANCE,
                                name: "left-bottom"
                            }, {x: m_crtOffsetForSpacing.x + wordExt.width - INNER_TOLERANCE, y: m_crtOffsetForSpacing.y + wordExt.height - INNER_TOLERANCE, name: "right-bottom"}];
                            for (var i = 0; i < points.length; ++i) {
                                var crtPoint = points[i];
                                if (crtPoint.x <= m_maxLineRight) {
                                    var elemAtPoint = element.ownerDocument.elementFromPoint(crtPoint.x, crtPoint.y);
                                    if (elemAtPoint != null) {
                                        var htmlRectAtPoint = elemAtPoint.getBoundingClientRect();
                                        var customIdAtPoint = gcontext.GetCustomIdForElement(elemAtPoint);
                                        if (htmlRectAtPoint != null && htmlRectAtPoint.left > -5 && htmlRectAtPoint.top > -5 && htmlRectAtPoint.width > 0 && htmlRectAtPoint.height > 0 && RectContains(htmlRectAtPoint, crtPoint) && customIdAtPoint !== m_elemCustomId && customIdAtPoint !== m_parentElemCustomId) {
                                            var spacingGapX = gcontext.GetElementMarginFromParent(htmlWindow, elemAtPoint);
                                            gcontext.TraceMessage("AccumulateTextRectInfo::CheckNewLineAndUpdateSpacingOffsets: crtWord=[" + m_crtWord +
                                                "]: there is an element with tag [" + elemAtPoint.tagName +
                                                "]");
                                            m_crtOffsetForSpacing.x = htmlRectAtPoint.right + spacingGapX;
                                            checkOverlappingElements = true;
                                            break;
                                        }
                                    }
                                }
                            }
                        }
                        var lineOverflow = (m_crtOffsetForSpacing.x + wordExt.width) - m_maxLineRight;
                        if (lineOverflow >= LINE_OVERFLOW_TOLERANCE) {
                            gcontext.TraceMessage("AccumulateTextRectInfo::CheckNewLineAndUpdateSpacingOffsets: [" + m_crtWord +
                                "] overflows the right margin by " + lineOverflow + " pixels");
                            m_crtOffsetForSpacing.x = m_initialOffsetForSpacing.x;
                            m_crtOffsetForSpacing.y += m_lineHeight;
                            gcontext.TraceMessage("AccumulateTextRectInfo::CheckNewLineAndUpdateSpacingOffsets: m_crtOffsetForSpacing after correction " +
                                gcontext.EnumObjectProps(m_crtOffsetForSpacing, true));
                            m_totalTextHeight += m_lineHeight;
                            if (m_crtOffsetForSpacing.y >= m_elemRect.bottom) {
                                gcontext.TraceMessage("AccumulateTextRectInfo::CheckNewLineAndUpdateSpacingOffsets: m_crtOffsetForSpacing.y=" + m_crtOffsetForSpacing.y +
                                    " overflows the bottom side " + m_elemRect.bottom + " of the element rectangle");
                                break;
                            }
                            checkOverlappingElements = true;
                        }
                    }
                    return out_wordExtForSpacing;
                }

                if (separators == null || separators.length === 0)
                    separators = "`;:'\",.!?/\\|";
                var i = 0;
                var parserState = CharType.WORD;
                var crtXOffsetInWord = 0;
                for (i = 0; i < text.length; ++i) {
                    var ch = text.charAt(i);
                    var chType = GetCharType(ch);
                    if (parserState === CharType.WORD) {
                        if (chType === CharType.SEPARATOR || chType === CharType.WHITESPACE) {
                            if (m_crtWord.length > 0) {
                                var wordExt = CheckNewLineAndUpdateSpacingOffsets();
                                var wordInfo = gcontext.TextRectInfo(m_crtWord, gcontext.UiRect(m_crtOffsetForSpacing.x, m_crtOffsetForSpacing.y, wordExt.width, wordExt.height), m_lineWidth, chType === CharType.WHITESPACE);
                                out_textRectInfos.push(wordInfo);
                                gcontext.TraceMessage("AccumulateTextRectInfo: adding word [" + wordInfo.text +
                                    "] rect " + wordInfo.rect.toString());
                                m_crtWordForSpacing += ch;
                                m_crtWord = ch.toString();
                                crtXOffsetInWord = wordExt.width;
                                parserState = chType;
                            } else {
                                m_crtWordForSpacing = m_crtWord = ch.toString();
                                crtXOffsetInWord = 0;
                                parserState = chType;
                            }
                        } else {
                            m_crtWordForSpacing += ch;
                            m_crtWord += ch;
                        }
                    } else if (parserState === CharType.SEPARATOR) {
                        if (chType === CharType.WORD || chType === CharType.WHITESPACE) {
                            var spacingExt = CheckNewLineAndUpdateSpacingOffsets();
                            var wordExt = GetWordExtentsUsingSpan(m_crtWord);
                            var wordInfo = gcontext.TextRectInfo(m_crtWord, gcontext.UiRect(m_crtOffsetForSpacing.x + crtXOffsetInWord, m_crtOffsetForSpacing.y, wordExt.width, wordExt.height), m_lineWidth, chType === CharType.WHITESPACE);
                            out_textRectInfos.push(wordInfo);
                            m_crtWordForSpacing = m_crtWord = ch.toString();
                            m_crtOffsetForSpacing.x += spacingExt.width;
                            crtXOffsetInWord = 0;
                            parserState = chType;
                        } else {
                            CheckNewLineAndUpdateSpacingOffsets();
                            var wordExt = GetWordExtentsUsingSpan(m_crtWord);
                            var wordInfo = gcontext.TextRectInfo(m_crtWord, gcontext.UiRect(m_crtOffsetForSpacing.x + crtXOffsetInWord, m_crtOffsetForSpacing.y, wordExt.width, wordExt.height), m_lineWidth, false);
                            out_textRectInfos.push(wordInfo);
                            m_crtWordForSpacing += ch;
                            m_crtWord = ch.toString();
                            crtXOffsetInWord += wordExt.width;
                        }
                    } else if (parserState === CharType.WHITESPACE) {
                        if (chType === CharType.WORD || chType === CharType.SEPARATOR) {
                            var spacingExt = CheckNewLineAndUpdateSpacingOffsets();
                            m_crtWordForSpacing = m_crtWord = ch.toString();
                            m_crtOffsetForSpacing.x += spacingExt.width;
                            crtXOffsetInWord = 0;
                            parserState = chType;
                        } else {
                            CheckNewLineAndUpdateSpacingOffsets();
                            m_crtWordForSpacing += ch;
                            m_crtWord = "";
                            crtXOffsetInWord = 0;
                        }
                    }
                }
                var spacingExt = CheckNewLineAndUpdateSpacingOffsets();
                if (parserState !== CharType.WHITESPACE && m_crtWord.length > 0) {
                    var wordExt = GetWordExtentsUsingSpan(m_crtWord);
                    var wordInfo = gcontext.TextRectInfo(m_crtWord, gcontext.UiRect(m_crtOffsetForSpacing.x + crtXOffsetInWord, m_crtOffsetForSpacing.y, wordExt.width, wordExt.height), m_lineWidth, false);
                    out_textRectInfos.push(wordInfo);
                    gcontext.TraceMessage("AccumulateTextRectInfo: adding last word [" + wordInfo.text +
                        "] rect " + wordInfo.rect.toString());
                }
                m_crtOffsetForSpacing.x += spacingExt.width;
                return true;
            }
        }
    }
    gcontext.FormattedTextInfoResult = function () {
        function TextLine(lineWidth) {
            return {
                textInfos: [], lineWidth: lineWidth, AddTextInfo: function (textInfo) {
                    this.textInfos.push(textInfo);
                }, AddTextInfoArray: function (textInfoArray) {
                    this.textInfos = this.textInfos.concat(textInfoArray);
                }, PushTextInfosAtTheStart: function (additionalTextInfos) {
                    var out_overflowingWordsAtTheEnd = [];
                    if (additionalTextInfos.length === 0 || this.textInfos.length === 0)
                        return out_overflowingWordsAtTheEnd;
                    gcontext.TraceMessage("PushTextInfosAtTheStart: additionalTextInfos[0]=" + additionalTextInfos[0].text);
                    gcontext.TraceMessage("PushTextInfosAtTheStart: this.textInfos[0]=" + this.textInfos[0].text);
                    var i = 0;
                    var totalWidth = additionalTextInfos[0].rect.getWidth();
                    for (i = 1; i < additionalTextInfos.length; ++i)
                        totalWidth += additionalTextInfos[i].rect.getWidth();
                    gcontext.TraceMessage("PushTextInfosAtTheStart: totalWidth=" + totalWidth);
                    var startTrimIdx = -1;
                    for (i = 0; i < this.textInfos.length; ++i) {
                        this.textInfos[i].rect = this.textInfos[i].rect.Offset(totalWidth, 0);
                        if (this.textInfos[i].rect.right - this.textInfos[0].rect.left > lineWidth) {
                            startTrimIdx = i;
                            break;
                        }
                    }
                    if (startTrimIdx !== -1)
                        out_overflowingWordsAtTheEnd = this.textInfos.splice(startTrimIdx, this.textInfos.length - startTrimIdx);
                    this.textInfos = additionalTextInfos.concat(this.textInfos);
                    return out_overflowingWordsAtTheEnd;
                }
            };
        }

        return {
            lines: [], AddLine: function (lineWidth) {
                this.lines.push(TextLine(lineWidth));
            }, AddTextInfo: function (textInfo) {
                if (this.lines.length === 0)
                    return;
                this.lines[this.lines.length - 1].AddTextInfo(textInfo);
            }, AddTextInfoArray: function (textInfoArray) {
                if (this.lines.length === 0)
                    return;
                this.lines[this.lines.length - 1].AddTextInfoArray(textInfoArray);
            }, ShiftTextInfosAndReformat: function (lineIdxToShift, numWordsToShift) {
                if (lineIdxToShift >= this.lines.length || numWordsToShift <= 0)
                    return;
                var line = this.lines[lineIdxToShift];
                if (numWordsToShift > line.textInfos.length)
                    return;
                var wordsToShift = line.textInfos.splice(line.textInfos.length - numWordsToShift, numWordsToShift);
                var i = 0, j = 0;
                for (i = lineIdxToShift + 1; i < this.lines.length; ++i) {
                    line = this.lines[i];
                    if (line.textInfos.length !== 0) {
                        var shiftWidth = -(wordsToShift[0].rect.left - line.textInfos[0].rect.left);
                        var shiftHeight = -(wordsToShift[0].rect.top - line.textInfos[0].rect.top);
                        gcontext.TraceMessage("ShiftTextInfosAndReformat: shiftWidth=" + shiftWidth + " shiftHeight=" + shiftHeight);
                        for (j = 0; j < wordsToShift.length; ++j)
                            wordsToShift[j].rect = wordsToShift[j].rect.Offset(shiftWidth, shiftHeight);
                    }
                    wordsToShift = line.PushTextInfosAtTheStart(wordsToShift);
                    if (wordsToShift.length === 0)
                        break;
                }
                if (wordsToShift.length !== 0) {
                    line = this.lines[this.lines.length - 1];
                    if (line.textInfos.length !== 0) {
                        var shiftWidth = -(wordsToShift[0].left - line.textInfos[0].left);
                        var shiftHeight = -(wordsToShift[0].top - line.textInfos[0].top);
                        for (j = 0; j < wordsToShift.length; ++j)
                            wordsToShift[j].rect = wordsToShift[j].rect.Offset(shiftWidth, shiftHeight);
                    }
                    this.AddLine(line.lineWidth);
                    this.AddTextInfoArray(wordsToShift);
                }
            }, GetFilteredText: function (filterRect) {
                var out_text = "";
                var out_textRectInfo = [];
                var lineIdx = 0;
                for (lineIdx = 0; lineIdx < this.lines.length; ++lineIdx) {
                    var crtLine = this.lines[lineIdx];
                    var textInfoIdx = 0;
                    for (textInfoIdx = 0; textInfoIdx < crtLine.textInfos.length; ++textInfoIdx) {
                        textInfo = crtLine.textInfos[textInfoIdx];
                        if (filterRect.Intersects(textInfo.rect)) {
                            out_textRectInfo.push(textInfo);
                            out_text += textInfo.text;
                            if (textInfo.endsWithWhitespace)
                                out_text += " ";
                        }
                    }
                    if (lineIdx !== this.lines.length - 1)
                        out_text += "\r\n";
                }
                return {text: out_text, textRectInfo: out_textRectInfo};
            }
        };
    }
    gcontext.FormatTextRectInfoArray = function (textRectInfo, newLineTolerance, runStopwatch) {
        var out_formattedTextInfo = gcontext.FormattedTextInfoResult();
        textRectInfo.sort(function (e1, e2) {
            var rc1 = e1.rect;
            var rc2 = e2.rect;
            if (rc1.top >= rc2.bottom - newLineTolerance)
                return 1;
            if (rc2.top >= rc1.bottom - newLineTolerance)
                return -1;
            if (rc1.left >= rc2.right - newLineTolerance)
                return 1;
            if (rc2.left >= rc1.right - newLineTolerance)
                return -1;
            return 0;
        });
        var timeoutCheckCounter = 0;
        var i = 0, j = 0, startLineIdx = 0;
        while (startLineIdx < textRectInfo.length) {
            if (timeoutCheckCounter >= 300) {
                if (runStopwatch.TimeoutElapsed())
                    break;
                timeoutCheckCounter = 0;
            }
            var startLineInfo = textRectInfo[startLineIdx];
            var maxLineWidth = startLineInfo.lineWidth;
            var endLineIdx = startLineIdx + 1;
            while (endLineIdx < textRectInfo.length) {
                var endLineInfo = textRectInfo[endLineIdx];
                if (endLineInfo.rect.top >= startLineInfo.rect.bottom - newLineTolerance)
                    break;
                if (endLineInfo.lineWidth > maxLineWidth)
                    maxLineWidth = endLineInfo.lineWidth;
                ++endLineIdx;
            }
            out_formattedTextInfo.AddLine(maxLineWidth);
            for (i = startLineIdx; i < endLineIdx; ++i) {
                var srcTextInfo = textRectInfo[i];
                var destTextInfo = gcontext.TextRectInfo(srcTextInfo.text, srcTextInfo.rect, maxLineWidth, srcTextInfo.endsWithWhitespace);
                timeoutCheckCounter += 1;
                out_formattedTextInfo.AddTextInfo(destTextInfo);
            }
            startLineIdx = endLineIdx;
        }
        for (i = 0; i < out_formattedTextInfo.lines.length - 1; ++i) {
            if (timeoutCheckCounter >= 100) {
                if (runStopwatch.TimeoutElapsed())
                    break;
                timeoutCheckCounter = 0;
            }
            var crtLine = out_formattedTextInfo.lines[i];
            if (crtLine.textInfos.length !== 0) {
                var lastTextWithSpaceIdx = crtLine.textInfos.length - 1;
                while (lastTextWithSpaceIdx >= 0) {
                    if (crtLine.textInfos[lastTextWithSpaceIdx].endsWithWhitespace === true)
                        break;
                    --lastTextWithSpaceIdx;
                }
                if (lastTextWithSpaceIdx >= 0 && lastTextWithSpaceIdx < crtLine.textInfos.length - 1) {
                    var numWordsToShift = crtLine.textInfos.length - lastTextWithSpaceIdx - 1;
                    gcontext.TraceMessage("FormatTextRectInfoArray: starting to shift with word [" + crtLine.textInfos[lastTextWithSpaceIdx + 1].text + "]");
                    timeoutCheckCounter += 1;
                    out_formattedTextInfo.ShiftTextInfosAndReformat(i, numWordsToShift);
                }
            }
        }
        return out_formattedTextInfo;
    }
    gcontext.GetSelectedItems = function (selectElement, getAll) {
        getAll = (getAll !== 0);
        if (gcontext.SapFioriIsElementSelectable(selectElement)) {
            return gcontext.SapFioriGetSelectedItems(selectElement, getAll);
        }
        var out_selectedItems = [];
        var options = selectElement.getElementsByTagName("option");
        for (var i = 0; i < options.length; ++i) {
            var option = options.item(i);
            if (option.text != null) {
                if (getAll === true || (getAll === false && option.selected)) {
                    out_selectedItems.push(option.text);
                }
            }
        }
        return out_selectedItems;
    }
    gcontext.AddHiddenSpansForInputValues = function (htmlDoc) {
        var out_addedNodes = [];
        var i;
        var collection = htmlDoc.getElementsByTagName("input");
        for (i = 0; i < collection.length; ++i) {
            var elem = collection.item(i);
            var type = elem.type;
            var value = elem.value;
            if (type !== "hidden" && type !== "checkbox" && type !== "radio" && type !== "image" && value != null) {
                var tempElem = htmlDoc.createElement("span");
                tempElem.innerText = value;
                if (tempElem.style)
                    tempElem.style.display = "none";
                if (elem.parentNode) {
                    var newNode = elem.parentNode.insertBefore(tempElem, elem);
                    if (newNode)
                        out_addedNodes.push(newNode);
                }
            }
        }
        collection = htmlDoc.getElementsByTagName("textarea");
        for (i = 0; i < collection.length; ++i) {
            var elem = collection.item(i);
            var type = elem.type;
            var value = elem.value;
            if (value != null) {
                var tempElem = htmlDoc.createElement("span");
                tempElem.innerText = value;
                if (tempElem.style)
                    tempElem.style.display = "none";
                if (elem.parentNode) {
                    var newNode = elem.parentNode.insertBefore(tempElem, elem);
                    if (newNode)
                        out_addedNodes.push(newNode);
                }
            }
        }
        return out_addedNodes;
    }
    gcontext.SendKeysToHtmlElement = function (targetElement, htmlWindow, text, append) {
        if (targetElement == null) {
            return;
        }
        gcontext.RaiseUiEvent(targetElement, "focus", htmlWindow);
        var tagName = targetElement.tagName.toLowerCase();
        var setValue = ((tagName === "input" || tagName === "textarea") && targetElement.value !== undefined);
        var isAppendingValue = append;
        var upperCaseText = text.toUpperCase();
        for (var i = 0; i < text.length; ++i) {
            var keyCode = upperCaseText.charCodeAt(i);
            var charCode = text.charCodeAt(i);
            var letter = text[i];
            if (gcontext.RaiseKeyEvent(targetElement, "keydown", htmlWindow, keyCode, 0, letter)) {
                gcontext.RaiseKeyEvent(targetElement, "keypress", htmlWindow, charCode, charCode, letter);
            }
            gcontext.RaiseInputEvent(targetElement, "beforeinput", "insertText", letter, htmlWindow);
            if (!gcontext.xbrowser.isIOS()) {
                gcontext.RaiseTextEvent(targetElement, "textInput", letter, htmlWindow);
            }
            var lastValue = targetElement.value;
            if (setValue === true) {
                if (isAppendingValue) {
                    targetElement.value = targetElement.value + letter;
                } else {
                    targetElement.value = letter;
                }
            }
            isAppendingValue = N_TRUE;
            gcontext.RaiseInputEvent(targetElement, "input", "insertText", letter, htmlWindow, lastValue);
            gcontext.RaiseKeyEvent(targetElement, "keyup", htmlWindow, keyCode, 0, letter);
        }
        if (setValue === true) {
        } else if (targetElement.isContentEditable) {
            if (append) {
                targetElement.innerText = targetElement.innerText + text;
            } else {
                targetElement.innerText = text;
            }
        } else if (gcontext.IsSapFioriElement(targetElement)) {
            gcontext.SapFioriWriteText(targetElement, text, append);
        }
        gcontext.RaiseUiEvent(targetElement, "change", htmlWindow);
    }
    gcontext.RaiseClickEvent = function (element, view, button, clickType, screenX, screenY, clientX, clientY, ctrlOn, altOn, shiftOn) {
        if (view == null || element == null)
            return false;
        var doc = element.ownerDocument;
        if (doc == null)
            return false;
        var types = null;
        if (button == 2 && clickType == gcontext.HTML_CLICK_SINGLE) {
            types = ["mouseover", "mousemove", "mousedown", "mouseup", "contextmenu"];
        } else {
            types = (clickType == gcontext.HTML_CLICK_DOUBLE ? ["mouseover", "mousemove", "mousedown", "mouseup", "click", "mousedown", "mouseup", "click", "dblclick"] : clickType == gcontext.HTML_CLICK_HOVERONLY ? ["mouseover", "mouseenter", "mousemove"] : ["mouseover", "mousemove", "mousedown", "mouseup", "click"]);
        }

        var canBubble = true;
        var cancelable = true;
        var detail = 1;
        var relatedTarget = null;
        for (var i = 0; i < types.length; ++i) {
            try {
                var event = doc.createEvent("MouseEvents");
                if (event == null)
                    return false;
                event.rpaSimulatedEvent = true;
                event.initMouseEvent(types[i], canBubble, cancelable, view, detail, screenX, screenY, clientX, clientY, ctrlOn, altOn, shiftOn, false, button, relatedTarget);
                element.dispatchEvent(event);
            } catch (err) {
                gcontext.TraceMessage("RaiseClickEvent exception: " + err.message);
            }
        }
        return true;
    }
    gcontext.RaiseKeyEvent = function (element, type, view, keyCode, charCode, charStr) {
        if (view == null || element == null) {
            return true;
        }
        var canBubble = true;
        var cancelable = true;
        try {
            var event = new KeyboardEvent(type, {
                "bubbles": canBubble,
                "cancelable": cancelable,
                "view": view,
                "key": charStr,
                "ctrlKey": false,
                "shiftKey": false,
                "altKey": false,
                "charCode": charCode,
                "keyCode": keyCode,
            });
            event.rpaSimulatedEvent = true;
            return element.dispatchEvent(event);
        } catch (err) {
            gcontext.TraceMessage("RaiseKeyEvent exception: " + err.message);
            return false;
        }
    }
    gcontext.RaiseUiEvent = function (element, type, view) {
        if (view == null || element == null)
            return false;
        var doc = element.ownerDocument;
        if (doc == null)
            return false;
        var canBubble = true;
        var cancelable = false;
        var detail = 1;
        var event = doc.createEvent("UIEvents");
        if (event == null)
            return false;
        try {
            event.rpaSimulatedEvent = true;
            event.initUIEvent(type, canBubble, cancelable, view, detail);
            element.dispatchEvent(event);
        } catch (err) {
            gcontext.TraceMessage("RaiseUiEvent exception: " + err.message);
        }
        return true;
    }
    gcontext.RaiseInputEvent = function (element, type, inputType, data, view, lastValue) {
        if (view == null || element == null)
            return false;
        try {
            var event = new InputEvent(type, {inputType: inputType, data: data});
            event.rpaSimulatedEvent = true;
            try {
                event.simulated = true;
                var tracker = element._valueTracker;
                if (lastValue && tracker) {
                    tracker.setValue(lastValue);
                }
            } catch (err) {
                gcontext.TraceMessage("RaiseInputEvent exception: " + err.message);
            }
            element.dispatchEvent(event);
        } catch (err) {
            gcontext.TraceMessage("RaiseInputEvent exception: " + err.message);
        }
        return true;
    }
    gcontext.RaiseTextEvent = function (element, type, data, view) {
        if (view == null || element == null)
            return false;
        var doc = element.ownerDocument;
        if (doc == null)
            return false;
        var bubbles = true;
        var cancelable = true;
        var detail = 0;
        var event = doc.createEvent("TextEvent");
        try {
            event.initTextEvent(type, bubbles, cancelable, view, data, null, null);
            event.rpaSimulatedEvent = true;
            element.dispatchEvent(event);
        } catch (err) {
            gcontext.TraceMessage("RaiseTextEvent exception: " + err.message);
        }
        return true;
    }
    gcontext.getCssSelector = function (e) {
        var isElement = function (e) {
            return e && e.nodeType === Node.ELEMENT_NODE;
        };
        var nthChild = function (el, nth = 1) {
            if (el) {
                return nthChild(el.previousElementSibling, nth + 1); // previousSibling
            } else {
                return nth - 1;
            }
        };
        var elementPath = function (el, path = []) {
            if (isElement(el)) {
                var tag = el.nodeName.toLowerCase(), id = (el.id.length != 0 && el.id);
                if (id) {
                    return elementPath(null, path.concat(['#' + id]));
                } else {
                    return elementPath(el.parentNode, path.concat([tag + ':nth-child(' + nthChild(el) + ')']));
                }
            } else {
                return path.reverse().join(" > ");
            }
        };

        return elementPath(e, []);
    }
    gcontext.getNewCssSelector = function (e) {
        if (!e) {
            return "";
        }

        var doc = e.ownerDocument || document;

        if (e.nodeName == "HTML") {
            return 'html';
        }

        // body --> /html/body
        // 'e == document.body' may not be equal in frameset document, so we add a new expression 'e.nodeName == "BODY"' to check it
        if (e == doc.body || e.nodeName == "BODY") {
            return 'html > body';
        }

        function attr(target, attrName) {
            return gcontext.TryGetAttribute(target, attrName);
        }

        function indexInParent(target) {
            //var siblings = target.parentNode.childNodes; // contain text node
            var siblings = target.parentNode.children; // filter text node
            return {
                isUnique: siblings.length == 1,
                idx: Array.prototype.indexOf.call(siblings, target)
            };
        }

        function isUnique(doc, queryCssSelector) {
            var candidates = doc.querySelectorAll(gcontext.FilterCssSelector(queryCssSelector));
            return candidates.length === 1;
        }

        var path = [];
        while (e && e.tagName !== 'HTML') {
            var selector = e.tagName.toLowerCase();
            if (attr(e, 'id')) {
                var uniqueCl = selector + '#' + attr(e, 'id');
                if (isUnique(doc, uniqueCl)) {
                    path.unshift(uniqueCl);
                    break;
                }
            } else {
                var classStr = attr(e, 'className');
                var nameStr = attr(e, 'name');
                classStr = classStr ? classStr.trim() : '';
                nameStr = nameStr ? nameStr.trim() : '';
                if (classStr !== '' && classStr !== '_selected' && selector !== 'input') {
                    var cl = '.' + classStr.trim().split(/\s+/).join('.');
                    var uniqueCl = selector + cl + (path.length > 0 ? ' > ' + path.join(" > ") : '');
                    if (isUnique(doc, uniqueCl)) {
                        path.unshift(selector + cl);
                        break;
                    }
                } else if (selector === 'input' && nameStr) {
                    var uniqueCl = selector + '[name=' + nameStr + ']';
                    if (isUnique(doc, uniqueCl)) {
                        path.unshift(uniqueCl);
                        break;
                    }
                }
            }

            var result = indexInParent(e);
            if (!result.isUnique) {
                selector += ":nth-child(" + (result.idx + 1) + ")";
            }

            path.unshift(selector);
            e = e.parentNode;
        }

        return path.join(" > ");
    }
    gcontext.getXpathSelector = function (e) {
        if (e.nodeName == "HTML") {
            return '/html';
        }

        if (e.id && e.id !== "") {
            // id --> //*[@id="xPath"]
            return '//*[@id=\"' + e.id + '\"]';
        }

        // body --> /html/body
        // 'e == document.body' may not be equal in frameset document, so we add a new expression 'e.nodeName == "BODY"' to check it
        if (e == document.body || e.nodeName == "BODY") {
            return '/html/' + e.tagName.toLowerCase();
        }

        // position in parent childs
        var index = 1;
        // parent childs
        var siblings = e.parentNode.childNodes;

        for (var i = 0, l = siblings.length; i < l; i++) {
            var sibling = siblings[i];
            if (sibling == e) {
                // find parent xpath
                //return arguments.callee(e.parentNode) + '/' + e.tagName.toLowerCase() + '[' + (index) + ']';
                return gcontext.getXpathSelector(e.parentNode) + '/' + e.tagName.toLowerCase() + '[' + (index) + ']';
            } else if (sibling.nodeType == 1 && sibling.tagName == e.tagName) {
                // not this
                index++;
            }
        }
    }
    gcontext.ElementIsFrame = function (e) {
        var out_isFrame = N_FALSE;
        if (e && e.tagName) {
            var tagName = e.tagName.toLowerCase();
            if (tagName === "frame" || tagName === "iframe")
                out_isFrame = N_TRUE;
        }
        return out_isFrame;
    }
    gcontext.IsMainFrame = function (frameWindow) {
        return (frameWindow.parent === frameWindow || frameWindow.parent === null);
    };
    gcontext.GetCheckedAttribute = function (elem) {
        var targetElement = gcontext.TryGetCheckableFromElement(elem);
        var type = gcontext.TryGetAttributeLowercase(targetElement, "type");
        if (type === "checkbox" || type === "radio") {
            return targetElement.checked;
        } else if (gcontext.SapFioriIsElementCheckable(elem)) {
            return gcontext.SapFioriGetChecked(elem);
        }
        return null;
    };
    gcontext.TryGetCheckableFromElement = function (elem) {
        var targetElement = elem;
        var tagName = gcontext.TryGetAttributeLowercase(elem, "tagName");
        if (tagName === "label") {
            var forId = elem.htmlFor;
            if (forId != null && forId.length !== 0) {
                var labelTarget = elem.ownerDocument.getElementById(forId);
                var type = gcontext.TryGetAttributeLowercase(labelTarget, "type");
                if ((type === "checkbox" || type === "radio") && labelTarget.checked != null) {
                    targetElement = labelTarget;
                }
            }
        }
        return targetElement;
    };
    gcontext.TryGetAttribute = function (target, property) {
        if (target == undefined || target[property] == undefined) {
            return undefined;
        }
        return target[property];
    };
    gcontext.TryGetAttributeLowercas = function (target, property) {
        if (target == undefined || target[property] == undefined) {
            return undefined;
        }
        return target[property].toLowerCase();
    };
    gcontext.ForEachAncestor = function (targetElement, onEachAncestorCb) {
        if (targetElement == null) {
            return;
        }
        var crtElement = targetElement.parentElement;
        while (crtElement != null) {
            if (!onEachAncestorCb(crtElement)) {
                break;
            }
            crtElement = crtElement.parentElement;
        }
    }
    gcontext.HtmlElementToString = function (elem) {
        if (elem == null) {
            return "<null element>";
        }
        var maxInnertextLen = 30;
        var innerText = gcontext.GetAttributeValue(elem, "innertextshort");
        innertext = gcontext.TrimWhiteSpaces(innerText);
        if (innerText.length > maxInnertextLen) {
            innerText = innerText.slice(0, maxInnertextLen) + "...";
        }
        var className = gcontext.GetAttributeValue(elem, "class");
        var htmlId = gcontext.GetAttributeValue(elem, "id");
        return "<" + elem.tagName
            + (innerText !== "" ? " innertext='" + innerText + "'" : "")
            + (className !== "" ? " class='" + className + "'" : "")
            + (htmlId !== "" ? " id='" + htmlId + "'" : "")
            + ">";
    }
    gcontext.GetUniqueElementsFromArray = function (arr) {
        var uniquenessFilter = function (value, index, self) {
            return self.indexOf(value) === index;
        }
        return arr.filter(uniquenessFilter);
    }
});


WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.g_traceEnabled = false;
    gcontext.EnableTracing = function () {
        gcontext.g_traceEnabled = true;
    }
    gcontext.DisableTracing = function () {
        gcontext.g_traceEnabled = false;
    }
    gcontext.IsTracingEnabled = function () {
        return gcontext.g_traceEnabled;
    }
    gcontext.TraceMessage = function (msg) {
        if (gcontext.g_traceEnabled) {
            try {
                console.log("[Content] : " + msg);
            } catch (e) {
            }
        }
    }
    gcontext.DebugMessage = function (msg) {
        if (gcontext.g_traceEnabled) {
            try {
                console.log("[Debug Content] : " + msg);
            } catch (e) {
            }
        }
    }
    gcontext.TraceError = function (msg) {
        if (gcontext.g_traceEnabled) {
            try {
                console.error("[Content] : " + msg);
            } catch (e) {
            }
        }
    }
    gcontext.EnumObjectProps = function (obj, enumValues) {
        if (obj == null) {
            return "<null object>";
        }
        var msg = "";
        for (var prop in obj) {
            var crtObj = null;
            try {
                crtObj = obj[prop];
            } catch (e) {
                crtObj = null;
            }
            if (crtObj == null) {
                continue;
            }
            var propVal = "";
            if (typeof (crtObj) === "function") {
                propVal = "function {...}";
            } else if (crtObj.toString == null) {
                propVal = "<" + typeof (crtObj) + ">";
            } else {
                var MAX_VAL = 30;
                propVal = crtObj.toString();
                if (propVal.length > MAX_VAL) {
                    propVal = propVal.slice(0, MAX_VAL) + "...";
                }
            }
            msg += prop;
            msg += (enumValues === true ? "=[" + propVal + "]\n" : ", ");
        }
        return msg;
    }
});

// ------------------------------------------------------------------------
// window.outerWidth    :   浏览器物理宽度
// window.outerHeight   :   浏览器物理高度（在全屏状态下等于电脑分辨率高度 - 底层导航栏高度）
// window.innerWidth    :   浏览器内部视窗宽度，包含纵向滚动条宽度
// window.innerHeight   :   浏览器内部视窗高度，包含横向滚动条宽度
// ------------------------------------------------------------------------
WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.GetPageRenderOffsets = function (refPageRenderOfsX, refPageRenderOfsY, pageZoomFactor, windowParams) {
        var windowObj = window;
        if (windowParams)
            windowObj = windowParams;
        if (refPageRenderOfsX > 0 || refPageRenderOfsY > 0)
            return {x: refPageRenderOfsX, y: refPageRenderOfsY};
        var innerWidthPixels = windowObj.innerWidth * pageZoomFactor; // 算出来是100%浏览器不放大的宽度
        var innerHeightPixels = windowObj.innerHeight * pageZoomFactor;
        var resizeBorderSizeWidth = (windowObj.outerWidth - innerWidthPixels) / 2; // 浏览器边框
        var resizeBorderSizeHeight = windowObj.outerHeight - innerHeightPixels - resizeBorderSizeWidth; // 浏览器工具栏、tab高度之和

        // pageZoomFactor --> 浏览器缩放
        // windowObj.devicePixelRatio --> 屏幕缩放
        // 返回值需要与屏幕缩放比例相乘得到实际的值
        // 注意: 如果电脑屏幕缩放(1.25)+浏览器缩放(1.5)，那么windowObj.devicePixelRatio取出的值是两者相乘(1.25x1.5=1.875),但这边只能用电脑屏幕缩放相乘
        var clientToCssScaleFactor = windowObj.devicePixelRatio / pageZoomFactor;
        let width = windowObj.outerWidth-windowObj.innerWidth * pageZoomFactor;
        if((/(Edg)/.test(navigator.userAgent) || /(Chrome)/.test(navigator.userAgent)) && width>40){

            let sidebarWidth = 0;
            //console.log(`有侧边栏 pageZoomFactor:${pageZoomFactor} width: ${width}`)
            if(/(Chrome)/.test(navigator.userAgent) && width>350){
                sidebarWidth = 353;//chrome侧边栏最小宽度 TODO 暂时不考虑侧边栏可变问题，侧边栏在左侧问题
            }
            if(/(Edg)/.test(navigator.userAgent) && width>40){
                sidebarWidth=0;
                if(width >=40 && width <400){
                    sidebarWidth = 46;
                }else if(width >=400){
                    sidebarWidth = 434;
                }
            }
            if(sidebarWidth>0 && width>=sidebarWidth){
                resizeBorderSizeWidth = (windowObj.outerWidth - innerWidthPixels - sidebarWidth) / 2; // 浏览器边框
                resizeBorderSizeHeight = windowObj.outerHeight - innerHeightPixels - resizeBorderSizeWidth; // 浏览器工具栏、tab高度之和
            }
        }
        let resp =  {x: resizeBorderSizeWidth * clientToCssScaleFactor, y: resizeBorderSizeHeight * clientToCssScaleFactor};
        //console.log(`resizeBorderSizeWidth: ${resizeBorderSizeWidth} ,resizeBorderSizeHeight: ${resizeBorderSizeHeight} ,resp :${JSON.stringify(resp)}`);
        return resp;
    }
    gcontext.CssToScreenRect = function (cssRect, renderParams, useClientCoordinates, windowParams) {
        var windowObj = window;
        if (windowParams)
            windowObj = windowParams;
        var clientToCssScaleFactor = windowObj.devicePixelRatio;
        var finalRectangle = gcontext.CssToClientRect(cssRect, clientToCssScaleFactor);
        var isFirefox = (windowObj.mozInnerScreenX !== undefined);
        var pageRenderOfs = {x: 0, y: 0};
        if (isFirefox === false) {
            pageRenderOfs = gcontext.GetPageRenderOffsets(renderParams.pageRenderOfsX, renderParams.pageRenderOfsY, renderParams.pageZoomValue, windowParams);
        }
        finalRectangle = finalRectangle.Offset(pageRenderOfs.x, pageRenderOfs.y);
        if (useClientCoordinates === N_FALSE) {
            var windowLeft = isFirefox ? (windowObj.mozInnerScreenX * clientToCssScaleFactor) : renderParams.windowLeft;
            var windowTop = isFirefox ? (windowObj.mozInnerScreenY * clientToCssScaleFactor) : renderParams.windowTop;
            finalRectangle = finalRectangle.Offset(windowLeft, windowTop);
        }
        return finalRectangle;
    }
    gcontext.CssToClientRect = function (cssRect, zoomFactor) {
        return cssRect.Scale(zoomFactor).MathRound();
    }
    gcontext.ScreenToCssPos = function (screenPos, renderParams) {
        var clientToCssScaleFactor = window.devicePixelRatio;
        var isFirefox = (window.mozInnerScreenX !== undefined);
        var windowLeft = isFirefox ? (window.mozInnerScreenX * clientToCssScaleFactor) : (renderParams.windowLeft);
        var windowTop = isFirefox ? (window.mozInnerScreenY * clientToCssScaleFactor) : (renderParams.windowTop);
        var pageRenderOfs = {x: 0, y: 0};
        if (isFirefox == false) {
            pageRenderOfs = gcontext.GetPageRenderOffsets(renderParams.pageRenderOfsX, renderParams.pageRenderOfsY, renderParams.pageZoomValue);
        }
        var screenX = screenPos.x;
        var screenY = screenPos.y;
        var clientPos = {x: screenX - windowLeft - pageRenderOfs.x, y: screenY - windowTop - pageRenderOfs.y};
        var cssPos = gcontext.ClientToCssPos(clientPos, clientToCssScaleFactor);
        return cssPos;
    }
    gcontext.ScreenToCssRect = function (screenRect, renderParams) {
        var clientToCssScaleFactor = window.devicePixelRatio;
        var isFirefox = (window.mozInnerScreenX !== undefined);
        var windowLeft = isFirefox ? (window.mozInnerScreenX * clientToCssScaleFactor) : (renderParams.windowLeft);
        var windowTop = isFirefox ? (window.mozInnerScreenY * clientToCssScaleFactor) : (renderParams.windowTop);
        var pageRenderOfs = {x: 0, y: 0};
        if (isFirefox == false) {
            pageRenderOfs = gcontext.GetPageRenderOffsets(renderParams.pageRenderOfsX, renderParams.pageRenderOfsY, renderParams.pageZoomValue);
        }
        var clientOffsetX = windowLeft + pageRenderOfs.x;
        var clientOffsetY = windowTop + pageRenderOfs.y;
        var clientRect = screenRect.Offset(-clientOffsetX, -clientOffsetY);
        var cssRect = gcontext.ClientToCssRect(clientRect, clientToCssScaleFactor);
        return cssRect;
    }
    gcontext.ClientToCssRect = function (clientRect, zoomFactor) {
        return clientRect.ScaleInv(zoomFactor).MathRound();
    }
    gcontext.ClientToCssPos = function (clientPos, zoomFactor) {
        return {x: Math.round(clientPos.x / zoomFactor), y: Math.round(clientPos.y / zoomFactor)};
    }
    gcontext.GetChromeWindowScreenCoords = function (chromeWindow) {
        return {left: chromeWindow.left, top: chromeWindow.top};
    }
    gcontext.InitKeyboardEvent = function (event, type, canBubble, cancelable, view, keyCode, charCode, ctrlOn, altOn, shiftOn) {
        if (event.initKeyboardEvent) {
            event.initKeyboardEvent(type, canBubble, cancelable, view, ctrlOn, altOn, shiftOn, false, keyCode, charCode);
        } else {
            event.initKeyEvent(type, canBubble, cancelable, view, ctrlOn, altOn, shiftOn, false, keyCode, charCode);
        }
    }
    gcontext.CreateBackgroundPageComm = function (portName) {
        var m_crtRequestId = 0;
        var m_returnMap = {};
        var m_msgPort = chrome.runtime.connect({name: portName});
        m_msgPort.onMessage.addListener(function (message) {
            if (message.returnId !== undefined) {
                DismissReturnCallback(message.returnId, message);
            }
        });

        function RegisterReturnCallback(returnFunc) {
            ++m_crtRequestId;
            m_returnMap[m_crtRequestId] = returnFunc;
            return m_crtRequestId;
        }

        function DismissReturnCallback(returnId, params) {
            var returnFunc = m_returnMap[returnId];
            if (returnFunc !== undefined) {
                returnFunc(params);
                delete m_returnMap[returnId];
            }
        }

        return {
            CallFunction: function (functionName, inputParams, returnFunc) {
                if (returnFunc !== undefined)
                    inputParams.requestId = RegisterReturnCallback(returnFunc);
                inputParams.functionCall = functionName;
                m_msgPort.postMessage(inputParams);
            }, Disconnect: function () {
                m_msgPort.disconnect();
            }
        };
    }
});

WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.CUSTOM_ID_SEPARATOR = "|";
    gcontext.CUSTOM_ID_ATTR_NAME = "rpa_custom_id";
    if (window.parent !== window) {
        gcontext.CUSTOM_ID_ATTR_NAME = "rpa_inframe_custom_id"
    }
    gcontext.ResetCustomIdCache = function () {
        gcontext.g_customIdCache = {};
        gcontext.g_crtCustomIdValue = 0;
    }
    if ("undefined" != typeof g_crtCustomIdValue) {
        gcontext.g_customIdCache = g_customIdCache;
        gcontext.g_crtCustomIdValue = g_crtCustomIdValue;
    } else {
        if (typeof window.g_rpa_wd_cache !== "undefined") {
            gcontext.g_customIdCache = window.g_rpa_wd_cache.g_customIdCache;
            gcontext.g_crtCustomIdValue = window.g_rpa_wd_cache.g_crtCustomIdValue;
        } else {
            console.error("assert: you should not be on this branch");
        }
    }
    gcontext.GenerateCustomId = function () {
        if ("undefined" != typeof g_crtCustomIdValue) {
            g_crtCustomIdValue++;
            gcontext.g_crtCustomIdValue = g_crtCustomIdValue;
        } else {
            if (typeof window.g_rpa_wd_cache !== "undefined") {
                window.g_rpa_wd_cache.g_crtCustomIdValue++;
                gcontext.g_crtCustomIdValue = window.g_rpa_wd_cache.g_crtCustomIdValue;
            } else {
                console.error("GenerateCustomId: assert: you should not be on this branch");
            }
        }
        return gcontext.g_crtCustomIdValue.toString();
    }
    gcontext.GenerateCustomIdForElement = function (elem) {
        var out_customId = "";
        if (elem == null || elem.nodeType !== elem.ELEMENT_NODE)
            return out_customId;
        var attrCheck = gcontext.GetCustomIdForElement(elem);
        if (attrCheck != "") {
            out_customId = attrCheck;
        } else {
            out_customId = gcontext.GenerateCustomId();
            elem.setAttribute(gcontext.CUSTOM_ID_ATTR_NAME, out_customId);
            if (gcontext.IsSapFioriFramework(elem)) {
                gcontext.SapFioriAddHtmlDomAttribute(elem, gcontext.CUSTOM_ID_ATTR_NAME, out_customId);
            }
            gcontext.g_customIdCache[out_customId] = elem;
        }
        return out_customId;
    }
    gcontext.GetCustomIdForElement = function (elem) {
        var out_customId = "";
        if (elem == null || elem.nodeType !== elem.ELEMENT_NODE)
            return out_customId;
        var attrCheck = elem.getAttribute(gcontext.CUSTOM_ID_ATTR_NAME);
        if (attrCheck == null) {
            attrCheck = elem.getAttribute(gcontext.g_sapFioriDefines.SAP_FIORI_CUSTOM_ID_ATTR_NAME);
            if (attrCheck != null) {
                elem.setAttribute(gcontext.CUSTOM_ID_ATTR_NAME, attrCheck);
            }
        }
        if (attrCheck != null)
            out_customId = attrCheck;
        return out_customId;
    }
    gcontext.GetElementFromCustomId = function (customId) {
        var element = gcontext.g_customIdCache[customId];
        if (element && gcontext.IsSapFioriElement(element)) {
            element = document.getElementById(element.id);
            gcontext.g_customIdCache[customId] = element;
        }
        return element;
    }
    gcontext.ComputeCustomIdWithTabAndFrame_Impl = function (tabId, frameId, customIdNoTab) {
        if (typeof frameId === "undefined") {
            return tabId.toString() + CUSTOM_ID_SEPARATOR + customIdNoTab.toString();
        }
        var out_idWithTabAndFrame = tabId.toString();
        if (customIdNoTab != null && customIdNoTab !== "")
            out_idWithTabAndFrame += gcontext.CUSTOM_ID_SEPARATOR + frameId.toString() + gcontext.CUSTOM_ID_SEPARATOR + customIdNoTab;
        return out_idWithTabAndFrame;
    }
    gcontext.ComputeCustomIdWithTabAndFrame = function (tabId, frameId, customIdNoTab) {
        return gcontext.ComputeCustomIdWithTabAndFrame_Impl(tabId, frameId, customIdNoTab);
    }
    gcontext.SplitCustomIdWithFrame = function (customIdWithFrame) {
        var result = {frameId: 0, customId: ""};
        var idInfo = customIdWithFrame.split(gcontext.CUSTOM_ID_SEPARATOR);
        if (idInfo.length === 2) {
            result.frameId = parseInt(idInfo[0]);
            result.customId = idInfo[1];
        }
        return result;
    }
    gcontext.ExtractTabIdFromCustomId = function (customIdWithTab) {
        var result = {tabId: -1, customIdNoTab: ""};
        var pos = customIdWithTab.indexOf(gcontext.CUSTOM_ID_SEPARATOR);
        if (pos === -1) {
            result.tabId = parseInt(customIdWithTab);
            result.customIdNoTab = '';
        } else {
            result.tabId = parseInt(customIdWithTab.substr(0, pos));
            result.customIdNoTab = customIdWithTab.substr(pos + 1).trim();
        }
        return result;
    }
});

window.chrome = window.chrome || window.browser;
chrome.InitializeContentImpl = function (tab) {
}

chrome.FinalizeContentImpl = function (tab) {
}

WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.GetChildFrameIndexInParent = function (frameWindow) {
        if (gcontext.IsMainFrame(frameWindow))
            return -1;
        var childrenArray = frameWindow.parent.frames;
        for (var i = 0; i < childrenArray.length; i++) {
            if (childrenArray[i] === frameWindow) {
                return i;
            }
        }
        return -1;
    }
    gcontext.GetCrossOriginFrameInfo = function () {
        var indexInParent = gcontext.GetChildFrameIndexInParent(window);
        gcontext.TraceMessage("CrossOriginContent: Cross-origin frame info: indexInParent=" + indexInParent);
        return {indexInParent: indexInParent};
    }
    gcontext.GetChildFrameElementByIndex = function (childFrameIndex) {
        var childWindow = window.frames[childFrameIndex];
        if (childWindow === undefined) {
            return null;
        }
        var frameElementArray = window.document.getElementsByTagName("iframe");
        for (var i = 0; i < frameElementArray.length; i += 1) {
            if (frameElementArray[i].contentWindow === childWindow) {
                return frameElementArray[i];
            }
        }
        frameElementArray = window.document.getElementsByTagName("frame");
        for (var i = 0; i < frameElementArray.length; i += 1) {
            if (frameElementArray[i].contentWindow === childWindow) {
                return frameElementArray[i];
            }
        }
        return null;
    }
    gcontext.COFwdContent = function () {
        return {
            GetFwdRequestInfo: function (message) {
                if (message != null && message.coFwdInfo != null) {
                    var out_coFwdInfo = message.coFwdInfo;
                    gcontext.TraceMessage("COFwdContent: Successfully read call forwarding info from " + (out_coFwdInfo.isParentSource ? "parent" : "childIndex=" + out_coFwdInfo.srcChildIndex));
                    return out_coFwdInfo;
                }
                return null;
            }, GetSrcChildElementFromRequest: function (coFwdInfo) {
                return coFwdInfo != null ? gcontext.GetChildFrameElementByIndex(coFwdInfo.srcChildIndex) : null;
            }, AppendFwdRequestToParentFrame: function (srcFrameId, customData, errorResult, out_result) {
                gcontext.TraceMessage("COFwdContent: Created call forwarding request message to parent");
                if (out_result.coFwdRequests == null)
                    out_result.coFwdRequests = [];
                out_result.coFwdRequests.push({srcFrameId: srcFrameId, isParentDestination: true, customData: customData, errorResult: errorResult});
            }, AppendFwdRequestToChildFrame: function (srcFrameId, destChildElement, customData, errorResult, out_result) {
                var destWindow = destChildElement.contentWindow;
                if (!destWindow) {
                    gcontext.TraceError("COFwdContent: Call forwarding destination child element's \"contentWindow\" attribute is null/undefined");
                    return false;
                }
                var childIndex = gcontext.GetChildFrameIndexInParent(destWindow);
                if (childIndex < 0) {
                    gcontext.TraceError("COFwdContent: Cannot get call forwarding destination child frame index in parent");
                    return false;
                }
                gcontext.TraceMessage("COFwdContent: Created call forwarding request message to child element with index=" + childIndex);
                if (out_result.coFwdRequests == null)
                    out_result.coFwdRequests = [];
                gcontext.TraceMessage("CoFwdContent: errorResult " + gcontext.EnumObjectProps(errorResult, true));
                out_result.coFwdRequests.push({srcFrameId: srcFrameId, isParentDestination: false, destChildIndex: childIndex, customData: customData, errorResult: errorResult});
                return true;
            }
        }
    }
});

WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.EMatchingType = {Invalid: 0, Normal: 1, Regex: 2, Fuzzy: 3, FuzzyWords: 4};
    gcontext.NormalMatcher = function () {
        this.Matches = function (attrInfo, text, caseSensitive, fuzzyScoreStats) {
            var matchResult = gcontext.StringWildcardMatch(attrInfo.value, text, caseSensitive);
            var score = (matchResult === true) ? 1.0 : 0.0;
            if (typeof fuzzyScoreStats !== "undefined") {
                fuzzyScoreStats.accept(score);
            }
            return score >= attrInfo.fuzzyLevel;
        };
    };
    gcontext.RegexMatcher = function () {
        this.m_pattern = null;
        this.m_caseSensitive = true;
        this.m_regex = null;
        this.SetPattern = function (pattern, caseSensitive) {
            pattern = "^" + pattern + "$";
            if (this.m_regex !== null && this.m_pattern === pattern && this.m_caseSensitive === caseSensitive) {
                return;
            }
            gcontext.TraceMessage("RegexMatcher::SetPattern pattern=\"" + pattern + "\" caseSensitive=" + caseSensitive);
            this.m_pattern = pattern;
            this.m_caseSensitive = caseSensitive;
            this.m_regex = RegExp(this.m_pattern, caseSensitive ? "" : "i");
        };
        this.Matches = function (attrInfo, text, caseSensitive, fuzzyScoreStats) {
            caseSensitive = typeof caseSensitive === "undefined" ? true : caseSensitive;

            // 如果两个值相等，直接返回true
            if (attrInfo.value === text) {
                gcontext.TraceMessage("RegexMatcher::Equal text=\"" + text + "\" result=true");
                return true;
            }

            // 兼容老的版本的通配符: http://www.baidu.com/*
            if (gcontext.StringWildcardMatch(attrInfo.value, text, true)) {
                gcontext.TraceMessage("RegexMatcher::StringWildcardMatch=\"" + attrInfo.value + "\" text=\"" + text + "\" result=true");
                return true;
            }

            this.SetPattern(attrInfo.value, caseSensitive);
            var matchResult = this.m_regex.test(text);
            gcontext.TraceMessage("RegexMatcher::Matches pattern=\"" + this.m_pattern + "\" text=\"" + text + "\" result=" + matchResult);
            var score = (matchResult === true) ? 1.0 : 0.0;
            if (typeof fuzzyScoreStats !== "undefined") {
                fuzzyScoreStats.accept(score);
            }
            return score >= attrInfo.fuzzyLevel;
        };
    };
    gcontext.FuzzyMatcher = function () {
        function PreProcess(str) {
            try {
                var res = str.replace(/[~!@#$%^&*()`;':\",./<>?]/gm, " ");
                res = res.trim();
                res = res.toLowerCase();
                return res;
            } catch (e) {
                return "";
            }
        }

        function LevenshteinRatio(str1, str2) {
            var lensum = str1.length + str2.length;
            var distance = LevenshteinEditDistance(str1, str2);
            if (distance < 0) {
                return 0.0;
            }
            if (lensum == 0) {
                return 1.0;
            }
            if (lensum - distance == 0) {
                return 0.0;
            }
            return (lensum - distance) / lensum;
        }

        function LevenshteinEditDistance(a, b) {
            var i, j;
            var distanceMatrix = [];
            for (j = 0; j <= b.length; j++) {
                distanceMatrix[j] = [];
            }
            for (i = 0; i <= a.length; i += 1) {
                distanceMatrix[0][i] = i;
            }
            for (j = 0; j <= b.length; j += 1) {
                distanceMatrix[j][0] = j;
            }
            for (j = 1; j <= b.length; j += 1) {
                for (i = 1; i <= a.length; i += 1) {
                    var indicator = a[i - 1] === b[j - 1] ? 0 : 2;
                    distanceMatrix[j][i] = Math.min(distanceMatrix[j][i - 1] + 1, distanceMatrix[j - 1][i] + 1, distanceMatrix[j - 1][i - 1] + indicator);
                }
            }
            return distanceMatrix[b.length][a.length];
        }

        function TokenSort(a) {
            var tokens = a.split(" ");
            tokens.sort();
            return tokens.join(" ");
        }

        function TokenSortRatio(a, b) {
            var sorted1 = TokenSort(a);
            var sorted2 = TokenSort(b);
            return LevenshteinRatio(sorted1, sorted2);
        }

        function GetUniqueTokens(tokens) {
            var set = new Array();
            for (var i = 0; i < tokens.length; ++i) {
                if (set.indexOf(tokens[i]) == -1) {
                    set.push(tokens[i]);
                }
            }
            return set;
        }

        function GetIntersection(set1, set2) {
            var intersection = new Array();
            for (var i = 0; i < set1.length; ++i) {
                if (set2.indexOf(set1[i]) != -1) {
                    intersection.push(set1[i]);
                }
            }
            return intersection;
        }

        function GetDifference(set1, set2) {
            var difference = new Array();
            for (var i = 0; i < set1.length; ++i) {
                if (set2.indexOf(set1[i]) == -1) {
                    difference.push(set1[i]);
                }
            }
            return difference;
        }

        function TokenSetRatio(a, b) {
            var len1 = a.length;
            var len2 = b.length;
            if (len1 + len2 === 0) {
                return 1.0;
            }
            if (len1 === 0 || len2 === 0) {
                return 0.0;
            }
            var tokens1 = a.split(" ");
            var tokens2 = b.split(" ");
            var set1 = GetUniqueTokens(tokens1);
            var set2 = GetUniqueTokens(tokens2);
            set1.sort();
            set2.sort();
            var intersection = GetIntersection(set1, set2);
            var diff1to2 = GetDifference(set1, set2);
            var diff2to1 = GetDifference(set2, set1);
            var sortedIntersection = intersection.join(" ");
            var sorted1to2 = diff1to2.join(" ");
            var sorted2to1 = diff2to1.join(" ");
            var combined1to2 = sortedIntersection + " " + sorted1to2;
            var combined2to1 = sortedIntersection + " " + sorted2to1;
            sortedIntersection = sortedIntersection.trim();
            combined1to2 = combined1to2.trim();
            combined2to1 = combined2to1.trim();
            var m = Math.max(LevenshteinRatio(sortedIntersection, combined1to2), LevenshteinRatio(sortedIntersection, combined2to1), LevenshteinRatio(combined1to2, combined2to1));
            return m;
        }

        this.Matches = function (attrInfo, text, caseSensitive, fuzzyScoreStats) {
            var fuzzyScore = 0;
            if (attrInfo.value === text) {
                fuzzyScore = 1.0;
            } else {
                var str1 = PreProcess(attrInfo.value);
                var str2 = PreProcess(text);
                var imperfectScale = 0.999;
                var unbaseScale = 0.95;
                var baseRatio = LevenshteinRatio(str1, str2) * imperfectScale;
                var tokenSortRatio = TokenSortRatio(str1, str2) * unbaseScale;
                fuzzyScore = Math.max(baseRatio, tokenSortRatio);
            }
            if (typeof fuzzyScoreStats !== "undefined") {
                fuzzyScoreStats.accept(fuzzyScore);
            }
            return fuzzyScore >= attrInfo.fuzzyLevel;
        };
    };
    gcontext.AttributeValue = function (attrInfo) {
        if (typeof attrInfo === "string") {
            this.m_info = {isNull: false, isActive: true, caseSensitive: true, matchingType: gcontext.EMatchingType.Normal, value: attrInfo, fuzzyLevel: 1.0};
        } else {
            this.m_info = attrInfo;
        }
        this.m_matcher = null;
        this.InitializeMatcher = function () {
            this.m_matcher = null;
            if (this.m_info.isNull) {
                return;
            }
            switch (this.m_info.matchingType) {
                case gcontext.EMatchingType.Regex:
                    this.m_matcher = new gcontext.RegexMatcher();
                    break;
                case gcontext.EMatchingType.Fuzzy:
                case gcontext.EMatchingType.FuzzyWords:
                    this.m_matcher = new gcontext.FuzzyMatcher();
                    break;
                default:
                    this.m_matcher = new gcontext.NormalMatcher();
                    break;
            }
        };
        this.InitializeMatcher();
        this.GetInfo = function () {
            return this.m_info;
        };
        this.SetInfo = function (attrInfo) {
            this.m_info = attrInfo;
            this.InitializeMatcher();
        };
        this.Matches = function (text, fuzzyScoreStats) {
            if (this.m_info.isNull) {
                return false;
            }
            return this.m_matcher.Matches(this.m_info, text, this.m_info.caseSensitive, fuzzyScoreStats);
        };
    };
    gcontext.HasAttributeValue = function (attrValue) {
        if (typeof attrValue === "undefined") {
            return false;
        }
        if (!attrValue instanceof gcontext.AttributeValue) {
            gcontext.TraceError("AttributeValue::HasAttributeValue invalid attrValue type: " + (typeof attrValue));
            return false;
        }
        var attrInfo = attrValue.GetInfo();
        return attrInfo.isNull ? false : attrInfo.isActive;
    };
    gcontext.GetActiveValueString = function (attrValue) {
        return gcontext.HasAttributeValue(attrValue) ? attrValue.GetInfo().value : null;
    };
    gcontext.AttributeValueMap = function (attrInfoMap) {
        var attrValueMap = {};
        Object.keys(attrInfoMap).forEach(function (key, index) {
            attrValueMap[key] = new gcontext.AttributeValue(attrInfoMap[key]);
        });
        return attrValueMap;
    };
    gcontext.ActiveValueStringMap = function (attrValueMap) {
        var activeValueMap = {};
        Object.keys(attrValueMap).forEach(function (key, index) {
            activeValueMap[key] = gcontext.GetActiveValueString(attrValueMap[key]);
        });
        return activeValueMap;
    };
    gcontext.IsUsingFuzzyAttributes = function (attrValueMap) {
        var res = false;
        Object.values(attrValueMap).forEach(function (value) {
            if (value.GetInfo().matchingType === gcontext.EMatchingType.Fuzzy || value.GetInfo().matchingType === gcontext.EMatchingType.FuzzyWords) {
                res = true;
            }
        });
        return res;
    };
});

WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.FUZZY_MAX = 1.0;
    gcontext.FUZZY_MIN = 0.0;
    gcontext.SearchResult = function (customId, matchingScore, position) {
        this.m_customId = customId;
        this.m_matchingScore = matchingScore;
        this.m_position = position;
    };
    gcontext.TabSearchResult = function (tab, matchingScore) {
        this.m_tab = tab;
        this.m_matchingScore = matchingScore;
    };
    gcontext.HtmlSearchResult = function (element, matchingScore) {
        this.m_element = element;
        this.m_matchingScore = matchingScore;
    };
    gcontext.ApproximatelyEqual = function (a, b, epsilon) {
        return Math.abs(a - b) <= Math.max(Math.abs(a), Math.abs(b)) * epsilon;
    };
    gcontext.IsGreaterEqual = function (a, b) {
        return a > b || gcontext.ApproximatelyEqual(a, b, Number.EPSILON);
    }
    gcontext.IsGreater = function (a, b) {
        return a > b && !gcontext.ApproximatelyEqual(a, b, Number.EPSILON);
    }
    gcontext.ResultsCollection = function (maxResults) {
        this.m_maxResults = maxResults;
        this.m_results = new Array();
        this.Accept = function (searchResult) {
            if (typeof searchResult === "undefined") {
                gcontext.TraceError("ResultsCollection:: Unrecognised type of result");
                return false;
            }
            if (this.IsFull()) {
                return false;
            }
            var success = false;
            if (this.IsEmpty()) {
                this.m_results.push(searchResult);
                success = true;
            } else if (gcontext.IsGreaterEqual(this.m_results[this.m_results.length - 1].m_matchingScore, searchResult.m_matchingScore)) {
                if (this.m_results.length < this.m_maxResults) {
                    this.m_results.push(searchResult);
                    success = true;
                }
            } else {
                var i = 0;
                for (i = 0; i < this.m_results.length; ++i) {
                    if (gcontext.IsGreater(searchResult.m_matchingScore, this.m_results[i].m_matchingScore)) {
                        this.m_results.splice(i, 0, searchResult);
                        if (this.m_results.length > this.m_maxResults) {
                            this.m_results.pop();
                        }
                        success = true;
                        break;
                    }
                }
            }
            return success;
        };
        this.GetResults = function () {
            return this.m_results;
        };
        this.IsFull = function () {
            if (this.m_results.length >= this.m_maxResults) {
                if (this.IsEmpty() || gcontext.IsGreaterEqual(this.m_results[this.m_results.length - 1].m_matchingScore, gcontext.FUZZY_MAX)) {
                    return true;
                }
            }
            return false;
        };
        this.IsEmpty = function () {
            return this.m_results.length == 0;
        };
    };
});

WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.ExecuteFunctionInPageContext = function (element, callbackFunction, inputParam) {
        gcontext.pageContextReturnData = {retCode: false, result: null};
        var codeToExecute = "var __data = null;                                                                " +
            "try {                                                                             " +
            "       var __r = (" + callbackFunction + ")(" + JSON.stringify(inputParam) + ");  " +
            "       __data = { retCode : true, result : __r };                                 " +
            "}                                                                                 " +
            "catch (ex) {                                                                      " +
            "      __data = { retCode : false, result : ex.toString() };                       " +
            "}                                                                                 " +
            "document.dispatchEvent(new CustomEvent('__RpaPageToContentEvent',              " +
            "                       {detail: JSON.stringify(__data)}));                        ";
        var doc = element.ownerDocument || document;
        var eventListener = function (e) {
            var data = JSON.parse(e.detail);
            gcontext.TraceMessage('ExecuteFunctionInPageContext: received = ' + e.detail);
            if (data.retCode === false) {
                gcontext.TraceMessage('ExecuteFunctionInPageContext failed!');
            }
            gcontext.pageContextReturnData = data;
        };
        doc.addEventListener('__RpaPageToContentEvent', eventListener);
        var script = doc.createElement("script");
        script.text = codeToExecute;
        (doc.head || doc.documentElement).appendChild(script);
        script.remove();
        doc.removeEventListener('__RpaPageToContentEvent', eventListener);
        return gcontext.pageContextReturnData;
    };
    gcontext.InjectFunctionInPageContext = function (element, callbackFunction, functionName) {
        var code = 'var ' + functionName + ' = ' + callbackFunction + ';';
        var doc = element.ownerDocument || document;
        var script = doc.createElement("script");
        script.text = code;
        (doc.head || doc.documentElement).appendChild(script);
    };
});

WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.g_sapFioriDefines = {
        propertyBasedAttrPrefix: "ui5p-",
        staticAttrPrefix: "ui5-",
        SAP_FIORI_CUSTOM_ID_ATTR_NAME: "data-" + gcontext.CUSTOM_ID_ATTR_NAME,
        pageContextInitFlagAttrName: "__rpa_sap_fiori_initialized_"
    };
    gcontext.SapFioriUtilities = function (version) {
        this.m_version = version;
        this.m_propertyBasedAttrPrefix = "ui5p-";
        this.sUIDPrefix = null;
        this.rGeneratedUID = null;
        this.m_selectReturnCodes = {SELECT_FAILURE: 0, SELECT_SUCCESS: 1, SELECT_NOT_SUPPORTED: 2, SELECT_ITEMS_NOT_FOUND: 3, SELECT_ITEM_DISABLED: 4};
        this.m_customDataPrefix = "data-";
        this.GetVersion = function () {
            return this.m_version;
        };
        this.IsSapUiAvailable = function () {
            if ((typeof sap != 'undefined') && (typeof sap.ui != 'undefined')) {
                return true;
            } else {
                return false;
            }
        };
        this.GetElementFromId = function (params) {
            var elem = null;
            if (params.htmlId != null) {
                elem = document.getElementById(params.htmlId);
            } else {
                var cssSelector = params.elementTag + "[" + params.customIdAttributeName + "=\"" + params.customId + "\"]";
                elem = document.querySelector(cssSelector);
                if (elem == null) {
                    cssSelector = params.elementTag + "[" + this.m_customDataPrefix + params.customIdAttributeName + "=\"" + params.customId + "\"]";
                    elem = document.querySelector(cssSelector);
                }
            }
            return elem;
        };
        this.GetSapElementFromHtmlElement = function (element) {
            return $(element).control(0);
        };
        this.GetSapElementFromHtmlElementCustomId = function (params) {
            var element = this.GetElementFromId(params);
            return this.GetSapElementFromHtmlElement(element);
        };
        this.IsSapFioriElement = function (element) {
            if (element == null || element.id == null) {
                return false;
            }
            var core = sap.ui.getCore();
            var sapElement = core.byId(element.id);
            if (sapElement != null) {
                return true;
            }
            return false;
        };
        this.IsSapFioriElementFromId = function (params) {
            var element = this.GetElementFromId(params);
            return this.IsSapFioriElement(element);
        };
        this.GetSapId = function (element) {
            if (element == null) {
                return "";
            }
            var core = sap.ui.getCore();
            var sapElement = core.byId(element.id);
            if (sapElement != null) {
                return sapElement.getId();
            }
            return "";
        };
        this.GetSapIdFromId = function (params) {
            var element = this.GetElementFromId(params);
            return this.GetSapId(element);
        };
        this.GetSapClass = function (element) {
            if (element == null) {
                return "";
            }
            var core = sap.ui.getCore();
            var sapElement = core.byId(element.id);
            if (sapElement != null && typeof sapElement.getMetadata == 'function') {
                var elementMetaData = sapElement.getMetadata();
                if (elementMetaData != null) {
                    return elementMetaData.getElementName();
                }
            }
            return "";
        };
        this.GetSapClassFromId = function (params) {
            var element = this.GetElementFromId(params);
            return this.GetSapClass(element);
        };
        this.GetSapRole = function (element) {
            if (element == null) {
                return "";
            }
            var core = sap.ui.getCore();
            var sapElement = core.byId(element.id);
            if (sapElement != null && typeof sapElement.getAccessibilityInfo == 'function') {
                var accessibilityInfo = sapElement.getAccessibilityInfo();
                if (accessibilityInfo != null) {
                    return accessibilityInfo.role;
                }
            }
            return "";
        };
        this.GetSapRoleFromId = function (params) {
            var element = this.GetElementFromId(params);
            return this.GetSapRole(element);
        };
        this.GetSapType = function (element) {
            if (element == null) {
                return "";
            }
            var core = sap.ui.getCore();
            var sapElement = core.byId(element.id);
            if (sapElement != null && typeof sapElement.getAccessibilityInfo == 'function') {
                var accessibilityInfo = sapElement.getAccessibilityInfo();
                if (accessibilityInfo != null) {
                    return accessibilityInfo.type;
                }
            }
            return "";
        };
        this.GetSapTypeFromId = function (params) {
            var element = this.GetElementFromId(params);
            return this.GetSapType(element);
        };
        this.GetSapLabel = function (element) {
            if (element == null) {
                return "";
            }
            var core = sap.ui.getCore();
            var sapElement = core.byId(element.id);
            if (sapElement == null) {
                return "";
            }
            if (typeof sapElement.getLabels == 'function') {
                var labels = sapElement.getLabels();
                if (labels.length > 0) {
                    return labels[0].getText();
                }
            }
            var jQuerySelector = "label[for*=" + sapElement.getId() + "]";
            var labels = jQuery(jQuerySelector);
            for (var i = 0; i < labels.length; i++) {
                var sapLabel = this.GetSapElementFromHtmlElement(labels[i]);
                if (sapLabel != null && typeof sapLabel.getLabelFor == 'function') {
                    if (sapLabel.getLabelFor() == sapElement.getId()) {
                        return sapLabel.getText();
                    }
                } else if (labels[i].getAttribute('for') == sapElement.getId()) {
                    return jQuery(labels[i]).text();
                }
            }
            return "";
        };
        this.GetSapLabelFromId = function (params) {
            var element = this.GetElementFromId(params);
            return this.GetSapLabel(element);
        };
        this.GetSapTooltip = function (element) {
            if (element == null) {
                return "";
            }
            var core = sap.ui.getCore();
            var sapElement = core.byId(element.id);
            if (sapElement != null) {
                if (typeof sapElement.getTooltip_Text == 'function') {
                    var tooltip = sapElement.getTooltip_Text();
                    if (tooltip != "((AltText))") {
                        return tooltip;
                    }
                }
                if (typeof sapElement.getTooltip_AsString == 'function') {
                    var tooltip = sapElement.getTooltip_AsString();
                    if (tooltip != "((AltText))") {
                        return tooltip;
                    }
                }
            }
            return "";
        };
        this.GetSapTooltipFromId = function (params) {
            var element = this.GetElementFromId(params);
            return this.GetSapTooltip(element);
        };
        this.GetSapTableRowIndex = function (element) {
            if (element == null) {
                return "";
            }
            var core = sap.ui.getCore();
            var sapElement = core.byId(element.id);
            if (sapElement != null) {
                var tableCellProxy = this.GetTableCellProxyForElement(sapElement);
                if (tableCellProxy != null) {
                    return tableCellProxy.GetRowIndex();
                }
            }
            return "";
        };
        this.GetSapTableRowIndexFromId = function (params) {
            var element = this.GetElementFromId(params);
            return this.GetSapTableRowIndex(element);
        };
        this.GetSapTableColIndex = function (element) {
            if (element == null) {
                return "";
            }
            var core = sap.ui.getCore();
            var sapElement = core.byId(element.id);
            if (sapElement != null) {
                var tableCellProxy = this.GetTableCellProxyForElement(sapElement);
                if (tableCellProxy != null) {
                    return tableCellProxy.GetColIndex();
                }
            }
            return "";
        };
        this.GetSapTableColIndexFromId = function (params) {
            var element = this.GetElementFromId(params);
            return this.GetSapTableColIndex(element);
        };
        this.GetSapReadyState = function (element) {
            var sapElement = sap.ui.getCore().byId(element.id);
            for (var i = 0; sapElement && i < 10000; i++) {
                if (typeof sapElement.getBusy == 'function' && sapElement.getBusy()) {
                    return "0";
                }
                sapElement = sapElement.getParent();
            }
            return "1";
        };
        this.GetSapReadyStateFromId = function (params) {
            var element = this.GetElementFromId(params);
            return this.GetSapReadyState(element);
        };
        this.GetSapDynamicAttributesList = function (element) {
            if (element == null) {
                return [];
            }
            var core = sap.ui.getCore();
            var sapElement = core.byId(element.id);
            if (sapElement == null || typeof sapElement.getMetadata != 'function') {
                return [];
            }
            var sapDynamicAttributes = [];
            if (this.GetTableCellProxyForElement(sapElement) != null) {
                sapDynamicAttributes.push("ui5-tableCol");
                sapDynamicAttributes.push("ui5-tableRow");
            }
            var elementMetaData = sapElement.getMetadata();
            while (elementMetaData != null) {
                var crtElementName = elementMetaData.getElementName();
                if ((crtElementName === "sap.ui.core.Control") || (crtElementName === "sap.ui.core.Element") || (crtElementName === "sap.ui.base.ManagedObject")) {
                    break;
                }
                var properties = elementMetaData.getProperties();
                for (var key in properties) {
                    var propertyName = properties[key].name;
                    var sapAttributename = this.m_propertyBasedAttrPrefix + propertyName;
                    sapDynamicAttributes.push(sapAttributename);
                }
                elementMetaData = elementMetaData.getParent();
            }
            return sapDynamicAttributes;
        };
        this.GetSapDynamicAttributesListFromId = function (params) {
            var element = this.GetElementFromId(params);
            return this.GetSapDynamicAttributesList(element);
        };
        this.GetSapPropertyBasedAttribute = function (element, attrName) {
            if (element == null || attrName == null) {
                return "";
            }
            var core = sap.ui.getCore();
            var sapElement = core.byId(element.id);
            if (sapElement == null) {
                return "";
            }
            var elementMetaData = sapElement.getMetadata();
            var properties = elementMetaData.getProperties();
            if (typeof sapElement.getProperty == 'function') {
                var propertyName = attrName.slice(this.m_propertyBasedAttrPrefix.length);
                if (!elementMetaData.hasProperty(propertyName)) {
                    for (var key in properties) {
                        var crtPropertyName = properties[key].name;
                        if (crtPropertyName.toLowerCase() == propertyName) {
                            propertyName = crtPropertyName;
                            break;
                        }
                    }
                }
                return sapElement.getProperty(propertyName);
            }
            return "";
        };
        this.GetSapPropertyBasedAttributeFromId = function (params) {
            var element = this.GetElementFromId(params);
            return this.GetSapPropertyBasedAttribute(element, params.attrName);
        };
        this.IsStableSapId = function (sId) {
            if (typeof sap.ui.base.ManagedObjectMetadata.isGeneratedId == 'function') {
                return !sap.ui.base.ManagedObjectMetadata.isGeneratedId(sId);
            }
            var escapeRegExp = function (sString) {
                var rEscapeRegExp = /[[\]{}()*+?.\\^$|]/g;
                return sString.replace(rEscapeRegExp, "\\$&");
            };
            this.sUIDPrefix = this.sUIDPrefix || sap.ui.getCore().getConfiguration().getUIDPrefix();
            this.rGeneratedUID = this.rGeneratedUID || new RegExp("(^|-{1,3})" + escapeRegExp(this.sUIDPrefix));
            return !this.rGeneratedUID.test(sId);
        };
        this.GetSapPropertyBasedSelectorAttributeNames = function (element) {
            if (element == null) {
                return [];
            }
            var core = sap.ui.getCore();
            var sapElement = core.byId(element.id);
            if (sapElement == null) {
                return [];
            }
            var reliableSelectorAttribute = {
                "sap.m.Breadcrumbs": ["currentLocationText", "separatorStyle"],
                "sap.suite.ui.microchart.DeltaMicroChart": ["title1", "title2"],
                "sap.m.CustomListItem": ["highlightText"],
                "sap.m.FeedContent": ["contentText"],
                "sap.m.FeedInput": ["buttonTooltip"],
                "sap.m.FeedListItem": ["sender"],
                "sap.m.GenericTile": ["header", "imageDescription"],
                "sap.m.GroupHeaderListItem": ["count"],
                "sap.m.image": ["alt"],
                "sap.m.ListBase": ["headerText", "footerText", "mode"],
                "sap.m.NewsContent": ["contentText"],
                "sap.m.NotificationListBase": ["authorName", "authorPicture"],
                "sap.m.ObjectHeader": ["intro", "number", "numberUnit"],
                "sap.m.ObjectNumber": ["number", "numberUnit", "unit"],
                "sap.m.Panel": ["headerText", "accessibleRole"],
                "sap.m.QuickViewGroup": ["heading"],
                "sap.m.RadioButton": ["groupName"],
                "sap.m.Tree": ["headerText"],
                "sap.m.UploadCollectionItem": ["documentId", "url"]
            };
            var IsElementOfType = function (elementMetaData, elementType) {
                while (elementMetaData != null) {
                    var crtElementType = elementMetaData.getName();
                    if (crtElementType == elementType) {
                        return true;
                    }
                    elementMetaData = elementMetaData.getParent();
                }
                return false;
            };
            var elementMetaData = sapElement.getMetadata();
            var attrNames = [];
            for (var elementType in reliableSelectorAttribute) {
                if (IsElementOfType(elementMetaData, elementType)) {
                    var crtAttrNames = reliableSelectorAttribute[elementType];
                    for (var i = 0; i < crtAttrNames.length; ++i) {
                        if (attrNames.indexOf(crtAttrNames[i]) == -1) {
                            attrNames.push(crtAttrNames[i]);
                        }
                    }
                }
            }
            var defaultReliableAttributes = ["text", "title", "name", "tooltip", "label", "placeholder", "type", "description", "info", "src", "role", "htmlText", "icon", "value", "displayValue"];
            elementMetaData = sapElement.getMetadata();
            for (var i = 0; i < defaultReliableAttributes.length; ++i) {
                if (elementMetaData.hasProperty(defaultReliableAttributes[i]) && (attrNames.indexOf(defaultReliableAttributes[i]) == -1)) {
                    attrNames.push(defaultReliableAttributes[i]);
                }
            }
            for (var i = 0; i < attrNames.length; ++i) {
                attrNames[i] = this.m_propertyBasedAttrPrefix + attrNames[i];
            }
            return attrNames;
        };
        this.GetSapPropertyBasedSelectorAttributeNamesFromId = function (params) {
            var element = this.GetElementFromId(params);
            return this.GetSapPropertyBasedSelectorAttributeNames(element);
        };
        this.GetNextInterestingParent = function (element) {
            if (element == null) {
                return null;
            }
            var core = sap.ui.getCore();
            var sapElement = core.byId(element.id);
            if (sapElement == null) {
                return null;
            }
            if (sap.m && sap.m.ListItemBase && (sapElement instanceof sap.m.ListItemBase)) {
                return sapElement.getParent();
            } else if (sap.ui.core && sap.ui.core.Item && (sapElement instanceof sap.ui.core.Item)) {
                return sapElement.getParent();
            } else if (sap.ui.commons && sap.ui.commons.TreeNode && (sapElement instanceof sap.ui.commons.TreeNode)) {
                return sapElement.getTree();
            } else if (sap.ui.table && sap.ui.table.Row && (sapElement instanceof sap.ui.table.Row)) {
                return sapElement.getParent();
            }
            return null;
        };
        this.GetNextInterestingParentFromId = function (params) {
            var element = this.GetElementFromId(params);
            return this.GetNextInterestingParent(element);
        };
        this.SapElementToResult = function (sapElement, params) {
            if (sapElement == null) {
                return {};
            }
            var element = sapElement.getDomRef();
            if (element == null) {
                return {};
            }
            if (element.hasAttribute(params.customIdAttributeName)) {
                return {customId: element.getAttribute(params.customIdAttributeName)};
            } else if (element.hasAttribute("id")) {
                return {htmlId: element.getAttribute("id")};
            }
            return {};
        };
        this.AddHtmlDomAttribute = function (element, params) {
            if (element == null) {
                return false;
            }
            var sapElement = sap.ui.getCore().byId(element.id);
            if (sapElement == null) {
                return true;
            }
            sapElement.data(params.attrName, params.attrValue, true);
            return true;
        };
        this.AddHtmlDomAttributeForId = function (params) {
            var element = this.GetElementFromId(params);
            return this.AddHtmlDomAttribute(element, params);
        };
        this.IsElementCheckable = function (element) {
            if (element == null) {
                return false;
            }
            var sapElement = sap.ui.getCore().byId(element.id);
            if (sapElement == null) {
                return false;
            }
            if (sap.m && sap.m.CheckBox && sapElement instanceof sap.m.CheckBox) {
                return true;
            } else if (sap.m && sap.m.RadioButton && sapElement instanceof sap.m.RadioButton) {
                return true;
            } else if (sap.m && sap.m.Switch && sapElement instanceof sap.m.Switch) {
                return true;
            } else if ((typeof sapElement.setSelected == 'function') && (typeof sapElement.getSelected == 'function')) {
                return true;
            }
            return false;
        };
        this.IsElementCheckableFromId = function (params) {
            var element = this.GetElementFromId(params);
            return this.IsElementCheckable(element);
        };
        this.IsElementSelectable = function (element) {
            if (element == null) {
                return false;
            }
            var sapElement = sap.ui.getCore().byId(element.id);
            if (sapElement == null) {
                return false;
            }
            if (sap.m && sap.m.ComboBox && sapElement instanceof sap.m.ComboBox) {
                return true;
            } else if (sap.m && sap.m.MultiComboBox && sapElement instanceof sap.m.MultiComboBox) {
                return true;
            } else if (sap.m && sap.m.Select && sapElement instanceof sap.m.Select) {
                return true;
            } else if (sap.m && sap.m.ListBase && sapElement instanceof sap.m.ListBase) {
                return true;
            } else if ((typeof sapElement.getItems == 'function') && (typeof sapElement.getSelectedItem == 'function') && (typeof sapElement.setSelectedItem == 'function')) {
                return true;
            }
            return false;
        };
        this.IsElementSelectableFromId = function (params) {
            var element = this.GetElementFromId(params);
            return this.IsElementSelectable(element);
        };
        this.WriteText = function (element, params) {
            if (element == null) {
                return false;
            }
            var sapElement = sap.ui.getCore().byId(element.id);
            if (sapElement == null) {
                return false;
            }
            var automationControl = this.GetAutomationControlForElement(sapElement);
            return automationControl.WriteText(params.text, params.append);
        };
        this.WriteTextForId = function (params) {
            var element = this.GetElementFromId(params);
            return this.WriteText(element, params);
        };
        this.Click = function (element) {
            if (element == null) {
                return false;
            }
            var sapElement = sap.ui.getCore().byId(element.id);
            if (sapElement == null) {
                return false;
            }
            var automationControl = this.GetAutomationControlForElement(sapElement);
            return automationControl.Click();
        };
        this.ClickForId = function (params) {
            var element = this.GetElementFromId(params);
            return this.Click(element);
        };
        this.GetSelectedItems = function (element, params) {
            if (element == null) {
                return [];
            }
            var sapElement = sap.ui.getCore().byId(element.id);
            if (sapElement == null) {
                return [];
            }
            var automationControl = this.GetAutomationControlForElement(sapElement);
            return automationControl.GetSelectedItems(params.getAll);
        };
        this.GetSelectedItemsForId = function (params) {
            var element = this.GetElementFromId(params);
            return this.GetSelectedItems(element, params);
        };
        this.SelectItems = function (element, params) {
            if (element == null) {
                return this.m_selectReturnCodes.SELECT_FAILURE;
            }
            var sapElement = sap.ui.getCore().byId(element.id);
            if (sapElement == null) {
                return this.m_selectReturnCodes.SELECT_FAILURE;
            }
            var automationControl = this.GetAutomationControlForElement(sapElement);
            return automationControl.SelectItems(params.reset, params.selectIfDisabled, params.items);
        };
        this.SelectItemsForId = function (params) {
            var element = this.GetElementFromId(params);
            return this.SelectItems(element, params);
        };
        this.GetChecked = function (element) {
            if (element == null) {
                return false;
            }
            var sapElement = sap.ui.getCore().byId(element.id);
            if (sapElement == null) {
                return false;
            }
            var automationControl = this.GetAutomationControlForElement(sapElement);
            return automationControl.GetChecked();
        };
        this.GetCheckedForId = function (params) {
            var element = this.GetElementFromId(params);
            return this.GetChecked(element);
        };
        this.Check = function (element, params) {
            if (element == null) {
                return false;
            }
            var sapElement = sap.ui.getCore().byId(element.id);
            if (sapElement == null) {
                return false;
            }
            var automationControl = this.GetAutomationControlForElement(sapElement);
            return automationControl.Check(params.doCheck);
        };
        this.CheckForId = function (params) {
            var element = this.GetElementFromId(params);
            return this.Check(element, params);
        };
        this.GetAutomationControlForElement = function (element) {
            if (sap.m && sap.m.ComboBox && element instanceof sap.m.ComboBox) {
                return new SapMComboBox(element, this.m_selectReturnCodes);
            } else if (sap.m && sap.m.MultiComboBox && element instanceof sap.m.MultiComboBox) {
                return new SapMMultiComboBox(element, this.m_selectReturnCodes);
            } else if (sap.m && sap.m.Tree && element instanceof sap.m.Tree) {
                return new SapMTree(element, this.m_selectReturnCodes);
            } else if (sap.m && sap.m.ListBase && element instanceof sap.m.ListBase) {
                return new SapMListBase(element, this.m_selectReturnCodes);
            } else if (sap.m && sap.m.Switch && element instanceof sap.m.Switch) {
                return new SapMSwitch(element, this.m_selectReturnCodes);
            } else if (sap.m && sap.m.RadioButton && element instanceof sap.m.RadioButton) {
                return new SapMRadioButton(element, this.m_selectReturnCodes);
            } else if (sap.m && sap.m.ObjectAttribute && element instanceof sap.m.ObjectAttribute) {
                return new SapMObjectAttribute(element, this.m_selectReturnCodes);
            } else {
                return new AutomationControlBase(element, this.m_selectReturnCodes);
            }
        };

        function AutomationControlBase(element, selectReturnCodes) {
            this.m_element = element;
            this.m_selectReturnCodes = selectReturnCodes;
        };AutomationControlBase.prototype.FireWriteTextEvents = function (text) {
            if (typeof this.m_element.fireLiveChange == 'function') {
                try {
                    this.m_element.fireLiveChange({value: text, newValue: text});
                } catch (e) {
                }
            }
            if (typeof this.m_element.fireChange == 'function') {
                try {
                    this.m_element.fireChange({value: text, valid: true});
                } catch (e) {
                }
            }
            if (typeof this.m_element.fireSubmit == 'function') {
                try {
                    this.m_element.fireSubmit({value: text});
                } catch (e) {
                }
            }
            if (typeof this.m_element.fireSearch == 'function') {
                try {
                    this.m_element.fireSearch({query: text});
                } catch (e) {
                }
            }
        };
        AutomationControlBase.prototype.WriteText = function (text, append) {
            if (typeof this.m_element.setValue !== 'function') {
                return false;
            }
            if (append) {
                text = this.m_element.getValue() + text;
            }
            this.m_element.setValue("");
            this.m_element.setValue(text);
            this.FireWriteTextEvents(text);
            return true;
        };
        AutomationControlBase.prototype.Click = function () {
            return true;
        };
        AutomationControlBase.prototype.GetTextFromItem = function (item) {
            if (item == null) {
                return null;
            }
            var text = null;
            if (typeof item.getText == 'function') {
                text = item.getText();
            } else if (typeof item.getTitle == 'function') {
                text = item.getTitle();
            }
            return text;
        };
        AutomationControlBase.prototype.GetSelectedItems = function (getAll) {
            if ((typeof this.m_element.getItems !== 'function') || (typeof this.m_element.getSelectedItem !== 'function')) {
                return [];
            }
            var items = [];
            if (getAll) {
                var selectableItems = this.m_element.getItems();
                for (var i = 0; i < selectableItems.length; i++) {
                    var text = this.GetTextFromItem(selectableItems[i]);
                    if (text != null) {
                        items.push(text);
                    }
                }
            } else {
                var selectedItem = this.m_element.getSelectedItem();
                var text = this.GetTextFromItem(selectedItem);
                if (text != null) {
                    items.push(text);
                }
            }
            return items;
        };
        AutomationControlBase.prototype.FireSelectionEvents = function (itemToSelect) {
            if (typeof this.m_element.fireChange == 'function') {
                try {
                    this.m_element.fireChange({selectedItem: itemToSelect, value: this.GetTextFromItem(itemToSelect), itemPressed: itemToSelect});
                } catch (e) {
                }
            }
            if (typeof this.m_element.fireSelectionChange == 'function') {
                try {
                    this.m_element.fireSelectionChange({selectedItem: itemToSelect});
                } catch (e) {
                }
            }
            if (typeof this.m_element.fireItemPress == 'function') {
                try {
                    this.m_element.fireItemPress({item: itemToSelect});
                } catch (e) {
                }
            }
        };
        AutomationControlBase.prototype.SelectItems = function (reset, selectIfDisabled, items) {
            if ((typeof this.m_element.getItems !== 'function') || (typeof this.m_element.setSelectedItem !== 'function')) {
                return this.m_selectReturnCodes.SELECT_NOT_SUPPORTED;
            }
            var selectableItems = this.m_element.getItems();
            var itemToSelect = null;
            for (var i = 0; i < selectableItems.length; i++) {
                var text = this.GetTextFromItem(selectableItems[i]);
                if (text == items[0]) {
                    if (!selectIfDisabled && !selectableItems[i].getEnabled()) {
                        return this.m_selectReturnCodes.SELECT_ITEM_DISABLED;
                    }
                    itemToSelect = selectableItems[i];
                    break;
                }
            }
            if (itemToSelect == null) {
                return this.m_selectReturnCodes.SELECT_ITEMS_NOT_FOUND;
            }
            this.m_element.setSelectedItem(itemToSelect);
            this.FireSelectionEvents(itemToSelect);
            return this.m_selectReturnCodes.SELECT_SUCCESS;
        };
        AutomationControlBase.prototype.FireCheckEvents = function (doCheck) {
            if (typeof this.m_element.fireSelect == 'function') {
                try {
                    this.m_element.fireSelect({selected: doCheck});
                } catch (e) {
                }
            }
        };
        AutomationControlBase.prototype.Check = function (doCheck) {
            if (typeof this.m_element.setSelected !== 'function') {
                return false;
            }
            this.m_element.setSelected(doCheck);
            this.FireCheckEvents(doCheck);
            return true;
        };
        AutomationControlBase.prototype.GetChecked = function () {
            if (typeof this.m_element.getSelected !== 'function') {
                return false;
            }
            return this.m_element.getSelected();
        };

        function SapMObjectAttribute(element, selectReturnCodes) {
            AutomationControlBase.call(this, element, selectReturnCodes);
        };

        SapMObjectAttribute.prototype = Object.create(AutomationControlBase.prototype);
        SapMObjectAttribute.prototype.FireClickEvents = function () {
            if (typeof this.m_element.firePress == 'function') {
                try {
                    this.m_element.firePress();
                } catch (e) {
                }
            }
        };
        SapMObjectAttribute.prototype.Click = function () {
            this.FireClickEvents();
            return true;
        };

        function SapMComboBox(element, selectReturnCodes) {
            AutomationControlBase.call(this, element, selectReturnCodes);
        };

        SapMComboBox.prototype = Object.create(AutomationControlBase.prototype);
        SapMComboBox.prototype.WriteText = function (text, append) {
            var selectResult = this.SelectItems(true, false, [text]);
            if (selectResult != this.m_selectReturnCodes.SELECT_SUCCESS) {
                return AutomationControlBase.prototype.WriteText.call(this, text, append);
            }
            return true;
        };

        function SapMMultiComboBox(element, selectReturnCodes) {
            AutomationControlBase.call(this, element, selectReturnCodes);
        };

        SapMMultiComboBox.prototype = Object.create(AutomationControlBase.prototype);
        SapMMultiComboBox.prototype.WriteText = function (text, append) {
            var reset = !append;
            var selectResult = this.SelectItems(reset, false, [text]);
            if (selectResult != this.m_selectReturnCodes.SELECT_SUCCESS) {
                return AutomationControlBase.prototype.WriteText.call(this, text, append);
            }
            return true;
        };
        SapMMultiComboBox.prototype.FireSelectionEvents = function (itemsToSelect) {
            if (typeof this.m_element.fireSelectionChange == 'function') {
                for (var i = 0; i < itemsToSelect.length; i++) {
                    try {
                        this.m_element.fireSelectionChange({changedItem: itemsToSelect[i], selected: true});
                    } catch (e) {
                    }
                }
            }
            if (typeof this.m_element.fireSelectionFinish == 'function') {
                try {
                    this.m_element.fireSelectionFinish({selectedItems: itemsToSelect});
                } catch (e) {
                }
            }
        };
        SapMMultiComboBox.prototype.SelectItems = function (reset, selectIfDisabled, items) {
            var selectableItems = this.m_element.getItems();
            var itemsToSelect = [];
            for (var i = 0; i < selectableItems.length; i++) {
                for (var j = 0; j < items.length; j++) {
                    if (selectableItems[i].getText() == items[j]) {
                        if (!selectIfDisabled && !selectableItems[i].getEnabled()) {
                            return this.m_selectReturnCodes.SELECT_ITEM_DISABLED;
                        }
                        itemsToSelect.push(selectableItems[i]);
                        break;
                    }
                }
            }
            if (itemsToSelect.length != items.length) {
                return this.m_selectReturnCodes.SELECT_ITEMS_NOT_FOUND;
            }
            if (reset) {
                this.m_element.clearSelection();
            }
            for (var i = 0; i < itemsToSelect.length; i++) {
                this.m_element.addSelectedItem(itemsToSelect[i]);
            }
            this.FireSelectionEvents(itemsToSelect);
            return this.m_selectReturnCodes.SELECT_SUCCESS;
        };
        SapMMultiComboBox.prototype.GetSelectedItems = function (getAll) {
            var items = [];
            if (getAll) {
                var selectableItems = this.m_element.getItems();
                for (var i = 0; i < selectableItems.length; i++) {
                    items.push(selectableItems[i].getText());
                }
            } else {
                var selectedItems = this.m_element.getSelectedItems();
                for (var i = 0; i < selectedItems.length; i++) {
                    items.push(selectedItems[i].getText());
                }
            }
            return items;
        };

        function SapMListBase(element, selectReturnCodes) {
            AutomationControlBase.call(this, element, selectReturnCodes);
        };

        SapMListBase.prototype = Object.create(AutomationControlBase.prototype);
        SapMListBase.prototype.FireSelectionEvents = function (itemsToSelect) {
            if (typeof this.m_element.fireSelect == 'function') {
                try {
                    this.m_element.fireSelect({listItem: itemsToSelect[0]});
                } catch (e) {
                }
            }
            if (typeof this.m_element.fireSelectionChange == 'function') {
                try {
                    this.m_element.fireSelectionChange({listItem: itemsToSelect[0], listItems: itemsToSelect, selected: true});
                } catch (e) {
                }
            }
            if (typeof this.m_element.fireItemPress == 'function') {
                try {
                    this.m_element.fireItemPress({listItem: itemsToSelect[0]});
                } catch (e) {
                }
            }
        };
        SapMListBase.prototype.SelectItems = function (reset, selectIfDisabled, items) {
            var selectableItems = this.m_element.getItems();
            var itemsToSelect = [];
            for (var i = 0; i < selectableItems.length; i++) {
                for (var j = 0; j < items.length; j++) {
                    if (selectableItems[i].getTitle() == items[j]) {
                        itemsToSelect.push(selectableItems[i]);
                        break;
                    }
                }
            }
            if (itemsToSelect.length != items.length) {
                return this.m_selectReturnCodes.SELECT_ITEMS_NOT_FOUND;
            }
            if (reset) {
                this.m_element.removeSelections(true);
            }
            for (var i = 0; i < itemsToSelect.length; i++) {
                this.m_element.setSelectedItem(itemsToSelect[i]);
            }
            this.FireSelectionEvents(itemsToSelect);
            return this.m_selectReturnCodes.SELECT_SUCCESS;
        };
        SapMListBase.prototype.GetSelectedItems = function (getAll) {
            var items = [];
            if (getAll) {
                var selectableItems = this.m_element.getItems();
                for (var i = 0; i < selectableItems.length; i++) {
                    items.push(selectableItems[i].getTitle());
                }
            } else {
                var selectedItems = this.m_element.getSelectedItems();
                for (var i = 0; i < selectedItems.length; i++) {
                    items.push(selectedItems[i].getTitle());
                }
            }
            return items;
        };

        function SapMTree(element, selectReturnCodes) {
            SapMListBase.call(this, element, selectReturnCodes);
        };

        SapMTree.prototype = Object.create(SapMListBase.prototype);
        SapMTree.prototype.SelectItems = function (reset, selectIfDisabled, items) {
            return SapMListBase.prototype.SelectItems.call(this, reset, selectIfDisabled, items);
        };
        SapMTree.prototype.GetSelectedItems = function (getAll) {
            return SapMListBase.prototype.GetSelectedItems.call(this, getAll);
        };

        function SapMSwitch(element, selectReturnCodes) {
            AutomationControlBase.call(this, element, selectReturnCodes);
        };

        SapMSwitch.prototype = Object.create(AutomationControlBase.prototype);
        SapMSwitch.prototype.FireCheckEvents = function (doCheck) {
            if (typeof this.m_element.fireChange == 'function') {
                try {
                    this.m_element.fireChange({state: doCheck});
                } catch (e) {
                }
            }
        };
        SapMSwitch.prototype.Check = function (doCheck) {
            this.m_element.setState(doCheck);
            this.FireCheckEvents(doCheck);
            return true;
        };
        SapMSwitch.prototype.GetChecked = function () {
            return this.m_element.getState();
        };

        function SapMRadioButton(element, selectReturnCodes) {
            AutomationControlBase.call(this, element, selectReturnCodes);
        };

        SapMRadioButton.prototype = Object.create(AutomationControlBase.prototype);
        SapMRadioButton.prototype.Check = function (doCheck) {
            if (!doCheck) {
                return true;
            }
            return AutomationControlBase.prototype.Check.call(this, doCheck);
        };
        this.s_tableCellProxyTypeList = [TableCellProxy_SapUiTable, TableCellProxy_SapMTable,];
        this.GetTableCellProxyForElement = function (element) {
            for (var i = 0; i < this.s_tableCellProxyTypeList.length; i++) {
                var cellProxy = this.s_tableCellProxyTypeList[i].CreateForElement(element);
                if (cellProxy != null) {
                    return cellProxy;
                }
            }
            return null;
        }

        function TableCellProxyBase(table, rowIndex, colIndex) {
            this.m_table = table;
            this.m_rowIndex = rowIndex;
            this.m_colIndex = colIndex;
        };TableCellProxyBase.prototype.GetRowIndex = function () {
            return this.m_rowIndex;
        };
        TableCellProxyBase.prototype.GetColIndex = function () {
            return this.m_colIndex;
        };

        function TableCellProxy_SapUiTable(table, rowIndex, colIndex) {
            TableCellProxyBase.call(this, table, rowIndex, colIndex);
        };

        TableCellProxy_SapUiTable.prototype = Object.create(TableCellProxyBase.prototype);
        TableCellProxy_SapUiTable.CreateForElement = function (element) {
            if ((typeof sap == 'undefined') || (typeof sap.ui == 'undefined') || (typeof sap.ui.table == 'undefined') || (typeof sap.ui.table.Table == 'undefined')) {
                return null;
            }
            var isTreeTableLoaded = (typeof sap.ui.table.TreeTable != 'undefined');
            for (; element != null; element = element.getParent()) {
                var row = element.getParent();
                if (!(row instanceof sap.ui.table.Row)) {
                    continue;
                }
                var table = row.getParent();
                if (!(table instanceof sap.ui.table.Table)) {
                    continue;
                }
                if (isTreeTableLoaded && (table instanceof sap.ui.table.TreeTable)) {
                    continue;
                }
                var rowIndex = row.getIndex();
                var colIndex = row.indexOfCell(element);
                if (rowIndex < 0 || colIndex < 0) {
                    continue;
                }
                return new TableCellProxy_SapUiTable(table, rowIndex, colIndex);
            }
            return null;
        }

        function TableCellProxy_SapMTable(table, rowIndex, colIndex) {
            TableCellProxyBase.call(this, table, rowIndex, colIndex);
        };

        TableCellProxy_SapMTable.prototype = Object.create(TableCellProxyBase.prototype);
        TableCellProxy_SapMTable.CreateForElement = function (element) {
            if ((typeof sap == 'undefined') || (typeof sap.m == 'undefined') || (typeof sap.m.Table == 'undefined')) {
                return null;
            }
            for (; element != null; element = element.getParent()) {
                var row = element.getParent();
                if (!(row instanceof sap.m.ColumnListItem)) {
                    continue;
                }
                var table = row.getParent();
                if (!(table instanceof sap.m.Table)) {
                    continue;
                }
                var rowIndex = table.indexOfItem(row);
                var colIndex = row.indexOfCell(element);
                if (rowIndex < 0 || colIndex < 0) {
                    continue;
                }
                return new TableCellProxy_SapMTable(table, rowIndex, colIndex);
            }
            return null;
        }
    };
    gcontext.InitializePageContent = function (element) {
        var version = gcontext.GetVersion();
        gcontext.TraceMessage("Initializing SAP Fiori utilities version: " + version + " in page context!");
        gcontext.InjectFunctionInPageContext(element, gcontext.SapFioriUtilities, "__SapFioriUtilities");
        var response = gcontext.ExecuteFunctionInPageContext(element, function (version) {
            window.__sapFioriUtilities = new __SapFioriUtilities(version);
            return true;
        }, version);
        var initSuccesfully = gcontext.GetResultOrDefault(response, false);
        if (initSuccesfully) {
            var doc = element.ownerDocument || document;
            var initFlagAttrName = gcontext.g_sapFioriDefines.pageContextInitFlagAttrName;
            doc.documentElement.setAttribute(initFlagAttrName, version);
        }
        return initSuccesfully;
    };
    gcontext.IsPageContentInitialized = function (element) {
        var doc = element.ownerDocument || document;
        var initFlagAttrName = gcontext.g_sapFioriDefines.pageContextInitFlagAttrName;
        var version = gcontext.GetVersion();
        var isInitialized = doc.documentElement.getAttribute(initFlagAttrName) === version;
        return isInitialized;
    };
    gcontext.EnsurePageContentIsInitialized = function (element) {
        if (gcontext.IsPageContentInitialized(element)) {
            return true;
        }
        if (gcontext.IsSapFioriFramework(element)) {
            return gcontext.InitializePageContent(element);
        }
        return false;
    };
    gcontext.GetResultOrDefault = function (response, defaultResult) {
        if (response.retCode) {
            return response.result;
        }
        return defaultResult;
    };
    gcontext.IsSapFioriFramework = function (element) {
        var doc = element.ownerDocument || document;
        var hasSapUiBrowserAttr = doc.documentElement.hasAttribute("data-sap-ui-browser");
        if (hasSapUiBrowserAttr === false) {
            return false;
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            if ((typeof sap != 'undefined') && (typeof sap.ui != 'undefined')) {
                return true;
            } else {
                return false;
            }
        });
        var isSapFioriFrameworkAvailable = gcontext.GetResultOrDefault(response, false);
        return isSapFioriFrameworkAvailable;
    };
    gcontext.IsSapFioriElement = function (element) {
        if (!element.hasAttribute("data-sap-ui") && !element.hasAttribute("data-sap-ui-preserve")) {
            return false;
        }
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return false;
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.IsSapFioriElementFromId(params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('IsSapFioriElement elementId: ' + element.id + ' result: ' + response.result);
        return gcontext.GetResultOrDefault(response, false);
    };
    gcontext.HtmlElementFromSapElementResult = function (response) {
        var result = gcontext.GetResultOrDefault(response, {});
        if (result.customId) {
            return gcontext.GetElementFromCustomId(result.customId);
        } else if (result.htmlId) {
            return document.getElementById(result.htmlId);
        }
        return null;
    };
    gcontext.GetSapFioriElement = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return null;
        }
        var customId = gcontext.GenerateCustomIdForElement(element);
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            var sapElement = window.__sapFioriUtilities.GetSapElementFromHtmlElementCustomId(params);
            return window.__sapFioriUtilities.SapElementToResult(sapElement, params);
        }, {elementTag: element.tagName, customId: customId, customIdAttributeName: gcontext.CUSTOM_ID_ATTR_NAME});
        gcontext.TraceMessage('GetSapFioriElement customId: ' + customId + ' result: ' + response.result);
        return gcontext.HtmlElementFromSapElementResult(response);
    };
    gcontext.GetSapFioriAttributeNames = function (element) {
        var sapFioriStaticAttrNames = gcontext.GetSapFioriStaticAttributeNames();
        var sapFioriDynamicAttrNames = gcontext.GetSapFioriDynamicAttributeNames(element);
        var sapFioriAttrNames = sapFioriStaticAttrNames.concat(sapFioriDynamicAttrNames);
        return sapFioriAttrNames;
    };
    gcontext.GetSapFioriStaticAttributeNames = function () {
        var sapStaticAttrNames = ["ui5-label", "ui5-tooltip", "ui5-role", "ui5-type", "ui5-class"];
        return sapStaticAttrNames;
    };
    gcontext.GetSapFioriDynamicAttributeNames = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return [];
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.GetSapDynamicAttributesListFromId(params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('GetSapDynamicAttributesListFromId elementId:  ' + element.id + ' result: ' + response.result);
        var sapFioriDynamicAttrNames = gcontext.GetResultOrDefault(response, []);
        return sapFioriDynamicAttrNames;
    };
    gcontext.GetSapFioriSelectorAttributeNames = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return [];
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.GetSapPropertyBasedSelectorAttributeNamesFromId(params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('GetSapFioriSelectorAttributeNames elementId: ' + element.id + ' result: ' + response.result);
        var sapDynamicAttributes = gcontext.GetResultOrDefault(response, []);
        var sapSelectorAttributes = gcontext.GetSapFioriStaticAttributeNames();
        if (gcontext.ElementIsFrame(element)) {
            sapSelectorAttributes.push("name");
            sapSelectorAttributes.push("src");
        }
        for (var i = 0; i < sapDynamicAttributes.length; ++i) {
            sapSelectorAttributes.push(sapDynamicAttributes[i]);
        }
        return sapSelectorAttributes;
    };
    gcontext.GetSapId = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return "";
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.GetSapIdFromId(params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('GetSapId elementId: ' + element.id + ' result: ' + response.result);
        return gcontext.GetResultOrDefault(response, "");
    };
    gcontext.GetSapClass = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return "";
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.GetSapClassFromId(params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('GetSapClass elementId:  ' + element.id + ' result: ' + response.result);
        return gcontext.GetResultOrDefault(response, "");
    };
    gcontext.GetSapRole = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return "";
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.GetSapRoleFromId(params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('GetSapRole elementId: ' + element.id + ' result: ' + response.result);
        return gcontext.GetResultOrDefault(response, "");
    };
    gcontext.GetSapType = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return "";
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.GetSapTypeFromId(params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('GetSapRole elementId:  ' + element.id + ' result: ' + response.result);
        return gcontext.GetResultOrDefault(response, "");
    };
    gcontext.GetSapLabel = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return "";
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.GetSapLabelFromId(params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('GetSapLabel elementId: ' + element.id + ' result: ' + response.result);
        return gcontext.GetResultOrDefault(response, "");
    };
    gcontext.GetSapTooltip = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return "";
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.GetSapTooltipFromId(params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('GetSapTooltip elementId: ' + element.id + ' result: ' + response.result);
        return gcontext.GetResultOrDefault(response, "");
    };
    gcontext.GetSapTableRowIndex = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return "";
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.GetSapTableRowIndexFromId(params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('GetSapTableRowIndex elementId: ' + element.id + ' result: ' + response.result);
        return gcontext.GetResultOrDefault(response, "");
    };
    gcontext.GetSapTableColIndex = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return "";
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.GetSapTableColIndexFromId(params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('GetSapTableColIndex elementId: ' + element.id + ' result: ' + response.result);
        return gcontext.GetResultOrDefault(response, "");
    };
    gcontext.GetSapReadyState = function (element) {
        var readyStateDefault = "1";
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return readyStateDefault;
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.GetSapReadyStateFromId(params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('GetSapReadyState elementId:  ' + element.id + ' result: ' + response.result);
        return gcontext.GetResultOrDefault(response, readyStateDefault);
    };
    gcontext.GetSapPropertyBasedAttribute = function (element, attrName) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return "";
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.GetSapPropertyBasedAttributeFromId(params);
        }, {htmlId: element.id, attrName: attrName});
        gcontext.TraceMessage('GetSapPropertyBasedAttribute elementId: ' + element.id + ' result: ' + response.result);
        return gcontext.GetResultOrDefault(response, "");
    };
    gcontext.IsStableSapId = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return false;
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (elementId) {
            return window.__sapFioriUtilities.IsStableSapId(elementId);
        }, element.id);
        gcontext.TraceMessage('IsStableSapId sapId: ' + element.id + ' result: ' + response.result);
        return gcontext.GetResultOrDefault(response, false);
    };
    gcontext.DoesMapContainSapFioriAttributes = function (attrMap) {
        var sapStaticAttrPrefix = gcontext.g_sapFioriDefines.staticAttrPrefix;
        var sapPropAttrPrefix = gcontext.g_sapFioriDefines.propertyBasedAttrPrefix;
        for (var attrName in attrMap) {
            if ((attrName.slice(0, sapStaticAttrPrefix.length) === sapStaticAttrPrefix) || (attrName.slice(0, sapPropAttrPrefix.length) === sapPropAttrPrefix)) {
                return true;
            }
        }
        return false;
    };
    gcontext.GetSapFioriHtmlCollectionForParentId = function (rootDocument, parentId, tagName, getAllDescendants, cssSelector) {
        var getAllDocuments = gcontext.xbrowser.isModeSingleFrame();
        var sapFioriCssSelector = null;
        if ((getAllDescendants === N_TRUE) || cssSelector) {
            if (cssSelector != null) {
                sapFioriCssSelector = cssSelector + "[data-sap-ui]," + cssSelector + "[data-sap-ui-preserve]";
            } else {
                sapFioriCssSelector = "[data-sap-ui], [data-sap-ui-preserve]";
            }
        } else {
            sapFioriCssSelector = "[" + gcontext.CUSTOM_ID_ATTR_NAME + "=\"" + parentId + "\"] > [data-sap-ui]," +
                "[" + gcontext.CUSTOM_ID_ATTR_NAME + "=\"" + parentId + "\"] > [data-sap-ui-preserve]," +
                "[" + gcontext.g_sapFioriDefines.SAP_FIORI_CUSTOM_ID_ATTR_NAME + "=\"" + parentId + "\"] > [data-sap-ui]," +
                "[" + gcontext.g_sapFioriDefines.SAP_FIORI_CUSTOM_ID_ATTR_NAME + "=\"" + parentId + "\"] > [data-sap-ui-preserve]";
        }
        var htmlCollection = gcontext.GetHtmlCollectionForParentId(rootDocument, getAllDocuments, parentId, tagName, sapFioriCssSelector);
        return htmlCollection;
    };
    gcontext.GetSapFioriSelectorAttributeList = function (rootDocument, element, customId, parentId, tagName, computeIndex) {
        var htmlCollection = gcontext.GetSapFioriHtmlCollectionForParentId(rootDocument, parentId, null, N_TRUE, null);
        var isElementIdStable = gcontext.IsStableSapId(element);
        var attrLists = null;
        if (isElementIdStable) {
            attrLists = ["id"];
        } else {
            attrLists = gcontext.GetSapFioriSelectorAttributeNames(element);
        }
        var bestIndex = (computeIndex == 0) ? 0 : 1000000;
        var selectorAttrMap = {};
        if ((attrLists.length == 0) && computeIndex != 0) {
            bestIndex = gcontext.GetIndexForAttributeList(htmlCollection, customId, selectorAttrMap);
            if (bestIndex === -1) {
                gcontext.TraceMessage("GetSapFioriSelectorAttributeList: index == -1, return error");
                return gcontext.GetSelectorAttributeListResult("", {}, -1, N_FALSE);
            }
        }
        for (var phaseIdx = 0; phaseIdx < attrLists.length; ++phaseIdx) {
            var crntAttrName = attrLists[phaseIdx];
            var crntAttrValue = null;
            if (crntAttrName !== "id") {
                crntAttrValue = gcontext.GetTruncatedAttributeValue(element, crntAttrName);
            } else {
                crntAttrValue = gcontext.GetAttributeValue(element, crntAttrName);
            }
            if (!crntAttrValue) {
                continue;
            }
            selectorAttrMap[crntAttrName] = new gcontext.AttributeValue(crntAttrValue);
            if (computeIndex > 0) {
                var crntIndex = gcontext.GetIndexForAttributeList(htmlCollection, customId, selectorAttrMap);
                if (crntIndex === -1) {
                    gcontext.TraceMessage("GetSapFioriSelectorAttributeList: index == -1, return error");
                    return gcontext.GetSelectorAttributeListResult("", {}, -1, N_FALSE);
                }
                if (crntIndex < bestIndex) {
                    bestIndex = crntIndex;
                } else {
                    delete selectorAttrMap[crntAttrName];
                }
                if (bestIndex === 0) {
                    gcontext.TraceMessage("GetSapFioriSelectorAttributeList: index == 0, return success");
                    return gcontext.GetSelectorAttributeListResult("", selectorAttrMap, 0, N_TRUE);
                }
            }
        }
        return gcontext.GetSelectorAttributeListResult("", selectorAttrMap, bestIndex, N_TRUE);
    };
    gcontext.GetNextSapFioriInterestingParentForSelector = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return null;
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            var sapElement = window.__sapFioriUtilities.GetNextInterestingParentFromId(params);
            return window.__sapFioriUtilities.SapElementToResult(sapElement, params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('GetNextSapFioriInterestingParentForSelector elementId: ' + element.id + ' result: ' + response.result);
        return gcontext.HtmlElementFromSapElementResult(response);
    };
    gcontext.SapFioriAddHtmlDomAttribute = function (element, attrName, attrValue) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return false;
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.AddHtmlDomAttributeForId(params);
        }, {htmlId: element.id, attrName: attrName, attrValue: attrValue});
        gcontext.TraceMessage('SapFioriAddHtmlDomAttribute elementId: ' + element.id + ' result: ' + response.result);
        return gcontext.GetResultOrDefault(response, false);
    };
    gcontext.SapFioriWriteText = function (element, text, append) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return null;
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.WriteTextForId(params);
        }, {htmlId: element.id, text: text, append: append === N_TRUE});
        gcontext.TraceMessage('SapFioriWriteText elementId: ' + element.id + ' result: ' + response.result);
        var result = gcontext.GetResultOrDefault(response, false);
        return result;
    };
    gcontext.SapFioriClick = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return null;
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.ClickForId(params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('SapFioriClick elementId: ' + element.id + ' result: ' + response.result);
        var result = gcontext.GetResultOrDefault(response, false);
        return result;
    };
    gcontext.SapFioriGetSelectedItems = function (element, getAll) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return null;
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.GetSelectedItemsForId(params);
        }, {htmlId: element.id, getAll: getAll});
        gcontext.TraceMessage('SapFioriGetSelectedItems elementId: ' + element.id + ' result: ' + response.result);
        var result = gcontext.GetResultOrDefault(response, []);
        return result;
    };
    gcontext.SapFioriSelectItems = function (element, reset, selectIfDisabled, items) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return null;
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.SelectItemsForId(params);
        }, {htmlId: element.id, reset: reset, selectIfDisabled: selectIfDisabled, items: items});
        gcontext.TraceMessage('SapFioriSelectItems elementId: ' + element.id + ' result: ' + response.result);
        var result = gcontext.GetResultOrDefault(response, 0);
        return result;
    };
    gcontext.SapFioriGetChecked = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return null;
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.GetCheckedForId(params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('SapFioriGetChecked elementId: ' + element.id + ' result: ' + response.result);
        var result = gcontext.GetResultOrDefault(response, false);
        return result;
    };
    gcontext.SapFioriCheck = function (element, doCheck) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return null;
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.CheckForId(params);
        }, {htmlId: element.id, doCheck: doCheck === N_TRUE});
        gcontext.TraceMessage('SapFioriCheck elementId: ' + element.id + ' result: ' + response.result);
        var isCheckable = gcontext.GetResultOrDefault(response, false);
        return isCheckable ? N_TRUE : N_FALSE;
    };
    gcontext.SapFioriIsElementCheckable = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return false;
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.IsElementCheckableFromId(params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('SapFioriIsElementCheckable elementId: ' + element.id + ' result: ' + response.result);
        return gcontext.GetResultOrDefault(response, false);
    };
    gcontext.SapFioriIsElementSelectable = function (element) {
        if (!gcontext.EnsurePageContentIsInitialized(element)) {
            return false;
        }
        var response = gcontext.ExecuteFunctionInPageContext(element, function (params) {
            return window.__sapFioriUtilities.IsElementSelectableFromId(params);
        }, {htmlId: element.id});
        gcontext.TraceMessage('SapFioriIsElementSelectable elementId: ' + element.id + ' result: ' + response.result);
        return gcontext.GetResultOrDefault(response, false);
    };
});

WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.ExtractData = function (topContainer, extractInputParams) {
        var maxResults = extractInputParams.maxResults;
        var extractType = extractInputParams.extractType;
        var cleanupType = extractInputParams.cleanupType; // sample, cleanup, cleanup-column0
        var metadata = extractInputParams.metadata;
        var sessionId = extractInputParams.sessionId;

        if (extractType === "extract-table") {
            gcontext.TraceMessage("ExtractTable: maxResults = " + maxResults + ", metadata = " + metadata);

            if (topContainer.tagName.toUpperCase() !== "TABLE") {
                gcontext.TraceMessage("ExtractTable: Table object expected!");
                throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.InvalidArgument);
            }

            var getColName = (extractInputParams.getColName) ? extractInputParams.getColName : true;   // 是否获取列的名字
            var getColEmptyValue = (extractInputParams.getColEmptyValue) ? extractInputParams.getColEmptyValue : false; // 是否获取空的列的值

            return {
                scrapedCustomIds: [],
                extractDatas: gcontext.ExtractTable(topContainer, getColName, getColEmptyValue, maxResults, sessionId),
                retCode: gcontext.DataScrapingRetCode.Success
            };
        } else if (extractType === "extract-data") {
            gcontext.TraceMessage("ExtractData: maxResults = " + maxResults + ", metadata = " + metadata);
            var getScrapedElement = extractInputParams.getScrapedElement ? extractInputParams.getScrapedElement : true;   // 是否获取抓取元素的ID
            var onlyExactAndNotChangeColor = (extractInputParams.exact === undefined) ? false : true; // 是否只是获取数据不变色
            var inputData = gcontext.GetStructuredDataExtractionAttributes(metadata, getScrapedElement, onlyExactAndNotChangeColor, sessionId);
            return gcontext.ExtractStructuredData(topContainer, inputData, maxResults);
        } else if (extractType === "cleanup") {
            gcontext.TraceMessage("ExtractCleanup => " + cleanupType);

            if (cleanupType === "sample") {
                // 点击"完成拾取",只清空本列样本元素,并把本列相似元素变色信息备份
                gcontext.CleanupSampleElementColor();
            } else if (cleanupType === "cleanup") {
                // 点击"重新拾取"清除全部颜色
                gcontext.CleanupSampleAndSimilarElementColor(true);
            } else {
                // 1、点击"ESC",只清空本列全部颜色
                // 2、点击旧列删除，删除旧列的全部颜色
                var columnNameArray = cleanupType.split(gcontext.CustomColumnSeparator);
                if (columnNameArray.length != 2) {
                    gcontext.TraceMessage("ExtractCleanup invalid argument, not found any column name.");
                    throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.InvalidArgument);
                }
                gcontext.CleanupSampleAndSimilarElementColor(false, columnNameArray[1]);
            }

            return {
                scrapedCustomIds: [],
                extractDatas: [],
                retCode: gcontext.DataScrapingRetCode.Success
            };
        } else {
            throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.InvalidArgument);
        }
    };
    gcontext.DOM_NodeType = {
        "Element": 1,
        "Text": 3
    };
    gcontext.TryGetAttributeLowercase = function (target, property) {
        if (target == undefined || target[property] == undefined) {
            return undefined;
        }
        return target[property].toLowerCase();
    };
    gcontext.GetAllElemsByTagFallback = function (c, t) {
        var result = c.getElementsByTagName(t);
        try {
            result.length;
        } catch (e) {
            var allDescendants = c.getElementsByTagName("*");
            if (typeof allDescendants === "undefined") {
                return [];
            }
            result = [];
            var index;
            for (index = 0; index < allDescendants.length; index++) {
                var currentTagName = gcontext.TryGetAttributeLowercase(allDescendants[index], "tagName");
                if (currentTagName === t.toLowerCase()) {
                    result.push(allDescendants[index]);
                }
            }
        }
        return result;
    };
    gcontext.GetAllElemsByTagArray = function (c, tagArray) {
        var allDescendants = c.getElementsByTagName("*");
        if (typeof allDescendants === "undefined") {
            return [];
        }
        var indexOf = function (targetArray, elem) {
            for (var index = 0; index < targetArray.length; index++) {
                if (targetArray[index] === elem) {
                    return index;
                }
            }
            return -1;
        };
        var elements = [];
        var index;
        for (index = 0; index < allDescendants.length; index++) {
            var currentTagName = gcontext.TryGetAttributeLowercase(allDescendants[index], "tagName");
            if (indexOf(tagArray, currentTagName) >= 0) {
                elements.push(allDescendants[index]);
            }
        }
        return elements;
    };
    gcontext.GetAllElemsByTag = function (container, tag) {
        if ((typeof container.all !== "undefined") && (typeof container.all.tags !== "undefined")) {
            return container.all.tags(tag);
        } else {
            return gcontext.GetAllElemsByTagFallback(container, tag);
        }
    };
    gcontext.Trim = function (text) {
        return text.replace(/^\s+|\s+$/g, '');
    };
    gcontext.GetInnerText = function (element) {
        if (typeof element.innerText !== "undefined") {
            return element.innerText;
        } else {
            return element.textContent;
        }
    };
    gcontext.GetSlotText = function (e) {
        if (e instanceof HTMLSlotElement) {
            var slots = e.assignedElements();
            var retValue = '';
            for (i = 0; i < slots.length; i++) {
                var slot = slots[i];
                retValue += gcontext.GetInnerText(slot);
            }
            return retValue;
        } else {
            var concatenatedTexts = '';
            var children = e.children;
            for (i = 0; i < children.length; i++) {
                var child = children[i];
                concatenatedTexts += gcontext.GetSlotText(child);
            }
            return concatenatedTexts;
        }
        return "";
    };
    gcontext.ExtractTable = function (table, getColName, getColEmptyValue, maxResults, sessionId) {
        var createTableMatrix = function () {
            var headers = [];
            var matrix = [];
            var isSameSession = false;
            return {
                setSameSessionFlag: function (s) {
                    isSameSession = s;
                },
                reset: function () {
                    matrix = [];
                    isSameSession = false;
                },
                setAt: function (i, j, v) {
                    if (matrix[i] === undefined) {
                        matrix[i] = [];
                    }
                    matrix[i][j] = v;
                },
                getAt: function (i, j) {
                    if (matrix[i] && (matrix[i][j] !== undefined)) {
                        return matrix[i][j];
                    }
                    return null;
                },
                getRowAt: function (i) {
                    if (matrix[i]) {
                        return matrix[i];
                    }
                    return null;
                },
                toJsonObject: function () {
                    if (isSameSession) {
                        throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.EncounterSameSession);
                    }

                    function addColumnToValues(rowInfo, columnName, columnValue, index) {
                        rowInfo[columnName] = {attrs: ["text"], values: [columnValue], index: index};
                    }

                    var headerColumnsFun = getColumnsName(table, true);
                    var extractDatas = [];
                    for (var i = 0; i < matrix.length; i++) {
                        if (matrix[i]) {
                            var rowInfo = {};
                            for (var j = 0; j < matrix[i].length; j++) {
                                addColumnToValues(rowInfo, headerColumnsFun(j), matrix[i][j], j);
                            }
                            extractDatas.push(rowInfo);
                        }
                    }

                    return extractDatas;
                },
                toColumnNames: function () {
                    var columns = [];
                    var rows = {};
                    for (var r = 0; r < matrix.length; ++r) {
                        if (matrix[r]) {
                            rowString = "";
                            for (var c = 0; c < matrix[r].length; ++c) {
                                if (matrix[r][c]) {
                                    rowString += matrix[r][c];
                                }
                            }
                            if (typeof (rows[rowString]) !== 'undefined') {
                                continue;
                            }
                            rows[rowString] = true;
                            for (var c = 0; c < matrix[r].length; ++c) {
                                if (matrix[r][c]) {
                                    if (columns[c] === undefined) {
                                        columns[c] = matrix[r][c];
                                    } else {
                                        columns[c] += (" " + matrix[r][c]);
                                    }
                                }
                            }
                        }
                    }
                    return columns;
                }
            };
        };
        var getColumnsName = function (t, gcn) {
            var columns = [];
            if (gcn) {
                var headerMatrix = extractMatrix(t, filterHeaderRow, true, true);
                columns = headerMatrix.toColumnNames();
            }
            return function (i) {
                if (columns[i]) {
                    return columns[i];
                } else {
                    return "Column-" + i;
                }
            };
        };
        var filterHeaderRow = function (row) {
            var columns = gcontext.GetAllElemsByTagArray(row, ["td", "th"])
            if (gcontext.TryGetAttributeLowercase(row.parentElement, "tagName") === "thead") {
                return columns;
            }

            for (var i = 0; i < columns.length; ++i) {
                var cell = columns[i];
                if (gcontext.TryGetAttributeLowercase(cell, "tagName") !== 'th') {
                    return null;
                }
            }

            return columns;
        }
        var filterBodyRow = function (row) {
            if (gcontext.TryGetAttributeLowercase(row.parentElement, "tagName") === "thead") {
                return null;
            }

            var columns = gcontext.GetAllElemsByTagArray(row, ["td", "th"])
            var hasBodyCell = false;
            for (var i = 0; i < columns.length; ++i) {
                var cell = columns[i];
                if (gcontext.TryGetAttributeLowercase(cell, "tagName") === 'td') {
                    hasBodyCell = true;
                    break;
                }
            }
            if (hasBodyCell) {
                return columns;
            }

            return null;
        }
        var tableHasSlotElements = function (htmlTable) {
            var slots = htmlTable.getElementsByTagName('slot');
            var hasSlots = (slots && slots.length > 0);
            return hasSlots;
        }
        var extractMatrix = function (htmlTable, filter, skipRowSpans, ignoreSessionId) {
            skipRowSpans = (skipRowSpans === true) ? skipRowSpans : false;
            ignoreSessionId = (ignoreSessionId === true) ? ignoreSessionId : false;

            var tableMatrix = createTableMatrix();
            var rows = htmlTable.rows;
            var lastColumnsToExpandRowIndex = [];
            var lastColumnsToExpandCount = [];
            var hasSlotElements = tableHasSlotElements(htmlTable);
            var getTextFunc = hasSlotElements ? gcontext.GetSlotText : gcontext.GetInnerText;
            if (rows) {
                var maxColumns = 0;
                var actualRows = 0;
                for (var r = 0; r < rows.length; ++r) {
                    var cols = filter(rows[r]);
                    if (cols) {
                        var tc = 0;
                        for (var c = 0; c < cols.length; ++c) {
                            var crntCell = cols[c];
                            if (!ignoreSessionId && (sessionId !== undefined && sessionId !== "")) {
                                if (gcontext.HasSessionAttribute(crntCell, sessionId, "text")) {
                                    tableMatrix.setSameSessionFlag(true);
                                    continue;
                                }
                                gcontext.SetSessionAttribute(crntCell, sessionId, "text");
                            }
                            while (tableMatrix.getAt(r, tc) !== null) {
                                tc++;
                            }
                            var cs = 1;
                            if (crntCell.colSpan) {
                                var colSpan = parseInt(crntCell.colSpan);
                                if (!isNaN(colSpan)) {
                                    cs = colSpan;
                                }
                            }
                            var rs = 1;
                            if (crntCell.rowSpan) {
                                var rowSpan = parseInt(crntCell.rowSpan);
                                if (!isNaN(rowSpan)) {
                                    rs = rowSpan;
                                }
                            }
                            var lastColumnInRow = (c == cols.length - 1);
                            if (lastColumnInRow && maxColumns <= tc) {
                                maxColumns = tc + 1;
                            }
                            var shouldBeExpandedLater = (lastColumnInRow && cs > 1);
                            if (shouldBeExpandedLater) {
                                var expandCount = cs - 1;
                                cs = 1;
                            }
                            var crntCellTxt = gcontext.Trim(getTextFunc(crntCell));
                            for (var i = 0; i < cs; ++i) {
                                for (var j = 0; j < rs; ++j) {
                                    tableMatrix.setAt(r + j, tc, ((skipRowSpans && j > 0) ? "" : crntCellTxt));
                                    if (shouldBeExpandedLater) {
                                        lastColumnsToExpandRowIndex.push(r + j);
                                        lastColumnsToExpandCount.push(expandCount);
                                    }
                                }
                                tc++;
                            }
                        }
                        actualRows++;
                        if (actualRows >= maxResults) break;
                    }
                }
            }
            for (var i = 0; i < lastColumnsToExpandRowIndex.length; ++i) {
                var rowIndex = lastColumnsToExpandRowIndex[i];
                var currentRow = tableMatrix.getRowAt(rowIndex);
                if (currentRow === null) {
                    continue;
                }
                var firstColumn = currentRow.length;
                var lastColumn = firstColumn + lastColumnsToExpandCount[i];
                if (lastColumn > maxColumns) {
                    lastColumn = maxColumns;
                }
                var textToExpand = tableMatrix.getAt(rowIndex, firstColumn - 1);
                for (var colIndex = firstColumn; colIndex < lastColumn; ++colIndex) {
                    tableMatrix.setAt(rowIndex, colIndex, textToExpand);
                }
            }
            return tableMatrix;
        };

        return extractMatrix(table, filterBodyRow).toJsonObject();
    };
    gcontext.ExtractStructuredData = function (topContainer, inputData, maxResults) {
        var scrapedCustomIds = [];
        var similarElements = [];
        var similarColumnNames = [];
        var addScrapedElementFun = function (columnNo, element) {
            var customId = gcontext.GenerateCustomIdForElement(element);
            if (scrapedCustomIds[columnNo] != null) {
                scrapedCustomIds[columnNo].push(customId);
            } else {
                scrapedCustomIds[columnNo] = [customId];
            }

            similarColumnNames.push(inputData.columns[columnNo].name[0]);
            similarElements.push(element);
        };

        var addElementToValues = function (rowInfo, element, columnInfo, columnId) {
            var columnData = {attrs: [], values: []};

            for (var key in columnInfo.attr) {
                var attrName = columnInfo.attr[key];
                var attrValue = gcontext.GetElemAttribute(element, attrName);
                columnData.attrs.push(attrName);
                columnData.values.push(attrValue ? attrValue : "");
            }

            rowInfo[columnInfo.name[0]] = columnData;
        };

        var fillEmptyStringToArray = function (arrayLength) {
            var emptyStringArray = [];
            for (var i = 0; i < arrayLength; i++) {
                emptyStringArray[i] = "";
            }
            return emptyStringArray;
        };

        var makeExtractSane = function (rowDatas) {
            // get all column
            var columnNames = [];
            var emptyStringToArrayMap = {};
            for (var i = 0; i < rowDatas.length; i++) {
                var rowData = rowDatas[i];
                for (var columnName in rowData) {
                    columnNames.push(columnName);
                    if (!emptyStringToArrayMap[columnName]) {
                        emptyStringToArrayMap[columnName] = {
                            attrs: rowData[columnName].attrs,
                            values: fillEmptyStringToArray(rowData[columnName].values.length)
                        };
                    }
                }
            }

            columnNames = gcontext.GetUniqueElementsFromArray(columnNames);
            columnNames = columnNames.sort();

            // set value by all column name. if original data has not the column, we will get a empty value.
            for (var i = 0; i < rowDatas.length; i++) {
                var rowData = rowDatas[i];
                for (var j = 0; j < columnNames.length; j++) {
                    var columnName = columnNames[j];
                    if (!rowData[columnName]) {
                        rowData[columnName] = emptyStringToArrayMap[columnName];
                    }
                }
            }

            return rowDatas;
        }

        var extractDatas = [];
        var noOfExtractedRows = 0;
        var isSameSession = false;

        if (inputData.row && inputData.row.path) {
            var rowTag = inputData.row.path[inputData.row.path.length - 1].tag;
            var rowAll = gcontext.GetAllElemsByTag(topContainer, rowTag);
            for (var r = 0; r < rowAll.length; ++r) {
                var crntRow = rowAll[r];
                if (gcontext.CheckHierarchy(crntRow, topContainer, inputData.row)) {
                    var foundMatches = false;
                    var rowInfo = {};
                    isSameSession = gcontext.SearchMatchingElementsInContainer(crntRow, topContainer, inputData, function matchFoundCallback(element, columnId) {
                        addElementToValues(rowInfo, element, inputData.columns[columnId], columnId);

                        if (inputData.getScrapedElement) {
                            addScrapedElementFun(columnId, element);
                        }

                        foundMatches = true;
                        return false;
                    });

                    if (foundMatches) {
                        extractDatas.push(rowInfo);
                        noOfExtractedRows++;
                        if (noOfExtractedRows >= maxResults) {
                            break;
                        }
                    }
                }
            }
        } else {
            if (inputData.columns.length == 0) {
                gcontext.TraceMessage("ExtractData: No row info provided");
                throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.InvalidArgument);
            }

            isSameSession = gcontext.SearchMatchingElementsInContainer(topContainer, topContainer, inputData, function matchFoundCallback(element, columnId) {
                var rowInfo = {};
                addElementToValues(rowInfo, element, inputData.columns[columnId], columnId);

                if (inputData.getScrapedElement) {
                    addScrapedElementFun(columnId, element);
                }

                extractDatas.push(rowInfo);
                noOfExtractedRows++;
                if (noOfExtractedRows > maxResults) {
                    return false;
                }

                return true;
            });
        }

        if (isSameSession) {
            throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.EncounterSameSession);
        }

        gcontext.TraceMessage("ExtractStructuredData: maxResults = " + maxResults + ", found = " + noOfExtractedRows);

        if (!inputData.onlyExactAndNotChangeColor) {
            gcontext.MarkedSimilarElementByColor(similarElements, similarColumnNames);
        }

        return {
            scrapedCustomIds: scrapedCustomIds,
            extractDatas: makeExtractSane(extractDatas),
            retCode: gcontext.DataScrapingRetCode.Success
        };
    };
    gcontext.GetStructuredDataExtractionAttributes = function (metadata, getScrapedElement, onlyExactAndNotChangeColor, sessionId) {
        var inputData = {
            sessionId: sessionId,
            row: {exact: true, path: null},
            columns: [],
            getScrapedElement: getScrapedElement,
            onlyExactAndNotChangeColor: onlyExactAndNotChangeColor
        };
        for (var j = 0; j < metadata.length; j++) {
            var theColumn = metadata[j];

            // row info
            if (theColumn["name"] == "_row_") {
                inputData.row.path = gcontext.GetPathList(theColumn.path);
                continue;
            }

            // column info
            var theColumnData = {name: [], attr: []};
            var maxNoOfAttributes = 10;
            for (var i = 0; i < maxNoOfAttributes; ++i) {
                var name = "name" + ((i === 0) ? "" : (i + 1));
                var columnName = theColumn[name];
                if (!columnName) {
                    if (i == 0) {
                        gcontext.TraceMessage("Column name required in json input data");
                        throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.InvalidArgument);
                    } else {
                        break;
                    }
                }
                theColumnData.name[i] = columnName;
            }

            theColumnData.sessionId = theColumn.sessionId;
            theColumnData.attr = theColumn.attr;
            theColumnData.exact = (theColumn.exact !== undefined) ? theColumn.exact == N_TRUE : false;
            theColumnData.path = gcontext.GetPathList(theColumn.path);
            inputData.columns.push(theColumnData);
        }

        return inputData;
    };
    gcontext.GetPathList = function (paths) {
        var pathRes = [];

        if (!paths || paths.length == 0) {
            gcontext.TraceMessage("Invalid path in json data");
            throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.InvalidArgument);
        }

        for (var i = 0; i < paths.length; i++) {
            var thePath = paths[i];
            var thePathData = {};

            var tag = thePath['tag'];
            var cls = thePath['class'];
            var cssSelector = thePath['css-selector'];
            var idx = thePath['idx'];
            var txt = thePath['text'];

            if (!tag) {
                gcontext.TraceMessage("Invalid tag name in json data");
                throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.InvalidArgument);
            }

            thePathData.tag = tag.toLowerCase();
            thePathData.cls = cls;
            thePathData.cssSelector = cssSelector;
            if (idx) {
                thePathData.index = parseInt(idx) - 1;
                if (isNaN(thePathData.index)) {
                    gcontext.TraceMessage("Invalid index in json data");
                    throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.InvalidArgument);
                }
            }
            thePathData.text = txt;

            pathRes.push(thePathData);
        }

        return pathRes;
    };
    gcontext.SearchMatchingElementsInContainer = function (containerToSearch, topContainer, inputData, matchFoundCallback) {
        gcontext.TraceMessage("ExtractData: Searching in container: " + containerToSearch);
        for (var columnId = 0; columnId < inputData.columns.length; ++columnId) {
            var crntColInfo = inputData.columns[columnId];
            gcontext.TraceMessage("ExtractData:  Searching column: " + columnId + " with info: " + JSON.stringify(crntColInfo));
            var colTag = crntColInfo.path[crntColInfo.path.length - 1].tag;
            var allElements = gcontext.GetAllElemsByTag(containerToSearch, colTag);
            for (var elementId = 0; elementId < allElements.length; ++elementId) {
                var crntElem = allElements[elementId];
                if (gcontext.CheckHierarchy(crntElem, topContainer, crntColInfo)) {
                    if (crntColInfo.sessionId !== undefined && crntColInfo.sessionId !== "") {
                        for (var attrId = 0; attrId < crntColInfo.attr.length; ++attrId) {
                            if (gcontext.HasSessionAttribute(crntElem, crntColInfo.sessionId, crntColInfo.attr[attrId])) {
                                return true;
                            } else {
                                gcontext.SetSessionAttribute(crntElem, crntColInfo.sessionId, crntColInfo.attr[attrId]);
                            }
                        }
                    }
                    if (inputData.getScrapedElement) {
                        crntElem.setAttribute("data-extract-result-name", crntColInfo.name[0]);
                    }
                    gcontext.TraceMessage("ExtractData: Found matching element: " + crntElem.tagName);
                    if (!matchFoundCallback(crntElem, columnId)) {
                        break;
                    }
                }
            }
        }
        return false;
    };
    gcontext.GetMatchingElements = function (containerToSearch, topContainer, columnsPaths, maxResults) {
        var elements = [];

        function matchFoundCallback(element, columnId) {
            elements.push(element);
            if (maxResults === elements.length) {
                return false;
            }
            return true;
        }

        var inputData = {
            columns: columnsPaths,
            getScrapedElement: false
        };
        gcontext.SearchMatchingElementsInContainer(containerToSearch, topContainer, inputData, matchFoundCallback);
        return elements;
    };
    gcontext.CheckHierarchy = function (elem, topContainer, columnInfo) {
        var crntElem = elem;
        var c = columnInfo.path.length - 1;
        if (!gcontext.CheckElemData(crntElem, columnInfo.path[c], topContainer)) {
            return false;
        }
        c = c - 1;
        while (c >= 0) {
            crntElem = crntElem.parentElement;
            if (!crntElem || gcontext.IsSameNode(crntElem, topContainer)) {
                return false;
            }
            if (!gcontext.CheckElemData(crntElem, columnInfo.path[c], topContainer)) {
                if (columnInfo.exact) {
                    return false;
                }
            } else {
                c = c - 1;
            }
        }
        if (columnInfo.exact) {
            return gcontext.IsSameNode(crntElem.parentElement, topContainer);
        }
        return true;
    };
    gcontext.GetElemAttribute = function (e, attrName) {
        if (attrName === "text") {
            return gcontext.GetInnerText(e);
        } else if (attrName === "href") {
            while (true) {
                var href = e.getAttribute(attrName);
                if (href) {
                    return href;
                }
                e = e.parentElement;
                if (!e) {
                    return "";
                }
            }
        } else {
            return e.getAttribute(attrName);
        }
    };
    gcontext.IndexInParent = function (elem, columnData, topContainer) {
        var parent = elem.parentElement;
        var children = gcontext.GetChildrenByTag(parent, elem.tagName);
        var copyColumnData = {
            tag: columnData.tag
        };
        if (columnData.cls) {
            copyColumnData.cls = columnData.cls;
        }
        if (columnData.cssSelector) {
            copyColumnData.cssSelector = columnData.cssSelector;
        }
        if (columnData.text) {
            copyColumnData.text = columnData.text;
        }
        var index = 0;
        for (var c = 0; c < children.length; ++c) {
            var crntChild = children[c];
            if (gcontext.IsSameNode(elem, crntChild)) {
                break;
            }
            if (gcontext.CheckElemData(crntChild, copyColumnData, topContainer)) {
                index++;
            }
        }
        return index;
    }
});
WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.DataScrapingRetCode = {
        Fail: 0,
        Success: 1,
        ExceptionThrown: 2,
        InvalidArgument: 3,
        CannotFindSampleElements: 4,
        DifferentTagsForSampleElements: 5,
        UncorrelatedSamples: 6,
        JSONParseError: 7,
        CannotFindPattern: 8,
        NeedMoreSamples: 9,
        EncounterSameSession: 10
    };

    gcontext.CustomColumnSeparator = "-";
    gcontext.MarkedSampleKey = "rpa_marked_sample";
    gcontext.MarkedSimilarKey = "rpa_marked_similar";

    gcontext.MarkedSimilarBackgroundCss = "rgba(75, 110, 175, 0.4)";
    gcontext.MarkedSimilarBorderCss = "1px solid rgb(75, 110, 175)";
    gcontext.MarkedSampleBackgroundCss = "rgba(73, 156, 84, 0.4)";
    gcontext.MarkedSampleBorderCss = "1px solid rgb(73, 156, 84)";

    gcontext.JsonStringEscape = function (text) {
        var mapEscapes = {
            "\b": "\\b",
            "\f": "\\f",
            "\n": "\\n",
            "\r": "\\r",
            "\t": "\\t",
            "\"": "\\\"",
            "\\": "\\\\"
        };
        return text.replace(/[\b]|\f|\n|\r|\t|\"|\\/g, function (matched) {
            return mapEscapes[matched];
        });
    };

    gcontext.DataScrapingException = function (dataScrapingRetCode, message) {
        this.dataScrapingRetCode = dataScrapingRetCode;
        this.message = (message != null) ? message : "";
    };

    gcontext.ExtractMetadata = function (columnDescriptors, topContainerParam) {
        if (columnDescriptors.length === 0 || columnDescriptors[0].elements.length === 0) {
            gcontext.TraceMessage("ExtractMetadata: No sample elements provided");
            throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.InvalidArgument);
        }

        for (var columnId = 0; columnId < columnDescriptors.length; ++columnId) {
            gcontext.TraceMessage("ExtractMetadata: columnDescriptors[" + columnId + "] = " + JSON.stringify(columnDescriptors[columnId]));
        }

        gcontext.TraceMessage("ExtractMetadata: Searching table ancestor");
        var tableCustomId = "";
        if (columnDescriptors.length === 1) {
            var sampleElement = columnDescriptors[0].elements[0];
            var tableElement = gcontext.GetParentByTag(sampleElement, "table");
            tableCustomId = tableElement ? gcontext.GenerateCustomIdForElement(tableElement) : "";
        }

        gcontext.TraceMessage("ExtractMetadata: Verifying sample elements");
        gcontext.VerifySampleElements(columnDescriptors);

        gcontext.TraceMessage("ExtractMetadata: Determining top container element");
        var topContainer = gcontext.DetermineTopContainerElement(columnDescriptors, topContainerParam);
        if (!topContainer) {
            throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.CannotFindPattern);
        }

        var rowsInfo = {
            rowElements: null,
            rowSampleElements: null,
            commonRowPath: null
        };

        if (columnDescriptors.length > 1) {
            gcontext.TraceMessage("ExtractMetadata: Determining rows common path");
            rowsInfo = gcontext.DetermineRowPath(columnDescriptors, topContainer, rowsInfo);
        }

        gcontext.TraceMessage("ExtractMetadata: Determining columns common path");
        gcontext.DetermineColumnsPath(columnDescriptors, topContainer, rowsInfo, function (paths) {
            var npath = [];
            for (var i = 0; i < paths.length; i++) {
                var tag = paths[i].tag;
                var index = paths[i].index;
                if (index || index == 0) {
                    npath.push({tag: tag, idx: index + 1}); // from 1 for first index
                } else {
                    npath.push({tag: tag});
                }
            }
            return npath;
        });

        gcontext.TraceMessage("ExtractMetada: Finished all steps, return the metadata json...");
        gcontext.CleanupSampleAndSimilarElementColor(false);
        gcontext.FilterDuplicateColumnDescriptors(columnDescriptors);
        gcontext.MarkedSampleElementByColor(columnDescriptors);

        return {
            tableContainerCustomId: tableCustomId,
            containerCustomId: gcontext.GenerateCustomIdForElement(topContainer),
            metadata: gcontext.CreateMetadata(rowsInfo.commonRowPath, columnDescriptors),
            retCode: gcontext.DataScrapingRetCode.Success
        };
    };
    gcontext.ArrayContains = function (arrays, elem) {
        for (var i = 0; i < arrays.length; i++) {
            if (arrays[i].element === elem) {
                return true;
            }
        }

        return false;
    };
    gcontext.FindAttachedObject = function (targetParentKey) {
        var holder = window.top || window;
        targetParentKey = targetParentKey ? targetParentKey : "rpa_attach_color_key";

        if (!(targetParentKey in holder)) {
            holder[targetParentKey] = {};
        }

        return holder[targetParentKey];
    };
    gcontext.removeAttachedObject = function () {
        var holder = window.top || window;
        delete holder["rpa_attach_color_key"];
        delete holder["rpa_current_pick_key"];
    };
    gcontext.FindAttachedObjectWith = function (targetKey, targetDefaultValue) {
        var attachedObject = gcontext.FindAttachedObject();

        if (!(targetKey in attachedObject)) {
            attachedObject[targetKey] = targetDefaultValue;
        }

        return attachedObject[targetKey];
    };
    gcontext.SetCurrentColumnNameToAttachedObject = function (currentColumnName) {
        var attachedObject = gcontext.FindAttachedObject("rpa_current_pick_key");

        if (currentColumnName) {
            attachedObject["column_name"] = currentColumnName;
        }
    };
    gcontext.getCurrentColumnNameFromAttachedObject = function () {
        var attachedObject = gcontext.FindAttachedObject("rpa_current_pick_key");
        return attachedObject["column_name"];
    };
    gcontext.MarkedSimilarElementByColor = function (similarElements, similarColumnNames) {
        for (var i = 0; i < similarElements.length; i++) {
            var element = similarElements[i];
            if (element && element.getAttribute(gcontext.MarkedSampleKey) !== "1" && element.getAttribute(gcontext.MarkedSimilarKey) !== "1") {
                var similarColumnName = similarColumnNames.length == 1 ? similarColumnNames[0] : similarColumnNames[i];
                var attachedObject = gcontext.FindAttachedObjectWith(similarColumnName, {similars: [], samples: []});

                var oldBackgroundCss = element.style.background;
                var oldBorderCss = element.style.border;
                element.style.background = gcontext.MarkedSimilarBackgroundCss;
                element.style.border = gcontext.MarkedSimilarBorderCss;
                element.setAttribute(gcontext.MarkedSimilarKey, "1");
                attachedObject.similars.push({
                    oldBackgroundCss: oldBackgroundCss,
                    oldBorderCss: oldBorderCss,
                    element: element
                });
            }
        }
    };
    gcontext.FilterDuplicateColumnDescriptors = function (columnDescriptors) {
        function filterDuplicate(targetElements) {
            if (targetElements) {
                var newTargetElements = [];
                for (var elementId = 0; elementId < targetElements.length; ++elementId) {
                    var isDuplicate = false;
                    for (var newElementId = 0; newElementId < newTargetElements.length; ++newElementId) {
                        if (targetElements[elementId] === newTargetElements[newElementId]) {
                            isDuplicate = true;
                        }
                    }
                    if (!isDuplicate) {
                        newTargetElements.push(targetElements[elementId]);
                    }
                }

                targetElements = newTargetElements;
            }

            return targetElements;
        }

        for (var columnId = 0; columnId < columnDescriptors.length; ++columnId) {
            columnDescriptors[columnId].elements = filterDuplicate(columnDescriptors[columnId].elements);
            columnDescriptors[columnId].sampleElements = filterDuplicate(columnDescriptors[columnId].sampleElements);
        }
    };
    gcontext.MarkedSampleElementByColor = function (columnDescriptors) {
        for (var columnId = 0; columnId < columnDescriptors.length; ++columnId) {
            var crtSampleElems = columnDescriptors[columnId].sampleElements; // only change sample elements color not all matching
            if (crtSampleElems) {
                var attachedObject = gcontext.FindAttachedObjectWith(columnDescriptors[columnId].names[0], {similars: [], samples: []});
                for (var elementId = 0; elementId < crtSampleElems.length; ++elementId) {
                    var oldBackgroundCss = crtSampleElems[elementId].style.background;
                    var oldBorderCss = crtSampleElems[elementId].style.border;
                    crtSampleElems[elementId].style.background = gcontext.MarkedSampleBackgroundCss;
                    crtSampleElems[elementId].style.border = gcontext.MarkedSampleBorderCss;
                    crtSampleElems[elementId].setAttribute(gcontext.MarkedSampleKey, "1");
                    attachedObject.samples.push({
                        oldBackgroundCss: oldBackgroundCss,
                        oldBorderCss: oldBorderCss,
                        element: crtSampleElems[elementId]
                    });
                }
            }
        }

        gcontext.SetCurrentColumnNameToAttachedObject(columnDescriptors[columnDescriptors.length - 1].names[0]);
    };
    gcontext.CleanupSampleElementColor = function () {
        function changeCssToOldOnlySample(objs) {
            for (var i = 0; i < objs.length; i++) {
                objs[i].element.style.background = objs[i].oldBackgroundCss;
                objs[i].element.style.border = objs[i].oldBorderCss;
                objs[i].element.removeAttribute(gcontext.MarkedSampleKey);
                objs[i].element.removeAttribute(gcontext.MarkedSimilarKey);
                copySampleToSimilar.push(objs[i].element);
            }
        }

        var similarColumnName = gcontext.getCurrentColumnNameFromAttachedObject();
        var copySampleToSimilar = [];
        var attachedObject = gcontext.FindAttachedObject();
        for (var columnName in attachedObject) {
            if (columnName === similarColumnName) {
                changeCssToOldOnlySample(attachedObject[columnName].samples);
                attachedObject[columnName].samples = [];
            }
        }

        gcontext.MarkedSimilarElementByColor(copySampleToSimilar, [similarColumnName]);
    };
    gcontext.CleanupSampleAndSimilarElementColor = function (cleanupAll, cleanupColumnName) {
        function changeCssToOld(objs) {
            for (var i = 0; i < objs.length; i++) {
                if (objs[i].oldBackgroundCss !== gcontext.MarkedSimilarBackgroundCss && objs[i].oldBorderCss !== gcontext.MarkedSimilarBorderCss) {
                    objs[i].element.style.background = objs[i].oldBackgroundCss;
                    objs[i].element.style.border = objs[i].oldBorderCss;
                }

                objs[i].element.removeAttribute(gcontext.MarkedSampleKey);
                objs[i].element.removeAttribute(gcontext.MarkedSimilarKey);
            }
        }

        cleanupColumnName = !cleanupColumnName ? gcontext.getCurrentColumnNameFromAttachedObject() : cleanupColumnName;

        var attachedObject = gcontext.FindAttachedObject();
        var attachedObjectKeys = Object.keys(attachedObject);
        for (var m = attachedObjectKeys.length-1; m >=0 ; m--) {
            var columnName =  attachedObjectKeys[m];
            if (columnName === cleanupColumnName || cleanupAll) {
                changeCssToOld(attachedObject[columnName].samples);
                changeCssToOld(attachedObject[columnName].similars);
                attachedObject[columnName].samples = [];
                attachedObject[columnName].similars = [];
            }
        }

        if (cleanupAll) {
            gcontext.removeAttachedObject();
        }
    };
    gcontext.CreateMetadata = function (commonRowPath, columnDescriptors) {
        var metadata = [];

        function addPathToTarget(target, names, attributes, pathInfo) {
            for (var nameId = 0; nameId < names.length; ++nameId) {
                var name = "name" + ((nameId === 0) ? "" : (nameId + 1));
                target[name] = names[nameId];
            }

            if (attributes.length != 0) {
                target.attr = attributes;
            }

            target.path = pathInfo.path;
            target.exact = pathInfo.exact ? N_TRUE : N_FALSE;
        }

        if (commonRowPath) {
            var rowInfo = {};
            addPathToTarget(rowInfo, ["_row_"], [], commonRowPath);
            metadata.push(rowInfo);
        }

        for (var columnId = 0; columnId < columnDescriptors.length; ++columnId) {
            var columnInfo = {};
            var columnDescriptor = columnDescriptors[columnId];
            addPathToTarget(columnInfo, columnDescriptor.names, columnDescriptor.attributes, columnDescriptor.pathInfo);
            metadata.push(columnInfo);
        }

        return metadata;
    };
    gcontext.VerifySampleElements = function (columnDescriptors) {
        for (var columnId = 0; columnId < columnDescriptors.length; ++columnId) {
            var crtColumnSampleElems = columnDescriptors[columnId].elements;
            if (!gcontext.ElementsHaveSameTag(crtColumnSampleElems)) {
                for (var elementId = 0; elementId < crtColumnSampleElems.length; ++elementId) {
                    crtColumnSampleElems[elementId] = gcontext.SkipFormating(crtColumnSampleElems[elementId]);
                }
                if (!gcontext.ElementsHaveSameTag(crtColumnSampleElems)) {
                    gcontext.LevelUpSampleElements(crtColumnSampleElems);
                    if (!gcontext.ElementsHaveSameTag(crtColumnSampleElems)) {
                        throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.DifferentTagsForSampleElements);
                    }
                }
            }
        }
    };
    gcontext.DetermineTopContainerFromMultipleSamples = function (columnDescriptors) {
        var sampleElements = [];
        for (var columnId = 0; columnId < columnDescriptors.length; ++columnId) {
            var crtColumnSampleElems = columnDescriptors[columnId].elements;
            for (var elementId = 0; elementId < crtColumnSampleElems.length; ++elementId) {
                sampleElements.push(crtColumnSampleElems[elementId]);
            }
        }
        return gcontext.GetCommonParentOfElems(sampleElements);
    };
    gcontext.DetermineTopContainerElement = function (columnDescriptors, topContainerParam) {
        var topContainer = null;
        if ((columnDescriptors.length === 1) && (columnDescriptors[0].elements.length === 1)) {
            var searchResult = gcontext.SearchTopContainerAndSimilarElements(columnDescriptors[0].elements[0]);
            topContainer = topContainerParam ? topContainerParam : searchResult.topContainer;
            columnDescriptors[0].elements = searchResult.similarElements;
        } else {
            topContainer = topContainerParam ? topContainerParam : gcontext.DetermineTopContainerFromMultipleSamples(columnDescriptors);
        }

        gcontext.TraceMessage("ExtractMetada: Determined top container based on sample elements: " + topContainer);
        return topContainer;
    };
    gcontext.DetermineColumnsPath = function (columnDescriptors, topContainer, rowsInfo, pathInfoFilter) {
        for (var columnId = 0; columnId < columnDescriptors.length; ++columnId) {
            var crtColumnSampleElems = columnDescriptors[columnId].elements;
            var commonPathInfo = null;
            if (crtColumnSampleElems.length > 1 || columnDescriptors.length === 1) {
                commonPathInfo = gcontext.GetColumnPathFromMultipleSamples(crtColumnSampleElems, topContainer);
            } else {
                commonPathInfo = gcontext.GetColumnPathFromOneSample(crtColumnSampleElems[0], rowsInfo);
            }

            commonPathInfo.path = pathInfoFilter(commonPathInfo.path);
            gcontext.TraceMessage("ExtractMetada: Path for column id: " + columnId + " is: " + JSON.stringify(commonPathInfo));
            columnDescriptors[columnId].pathInfo = commonPathInfo;
        }
    };
    gcontext.DetermineRowPath = function (columnDescriptors, topContainer) {
        if (columnDescriptors.length <= 1) {
            gcontext.TraceMessage("ExtractMetadata: Invalid number of column descriptors in DetermineRowPath");
            throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.InvalidArgument);
        }
        var rowSampleElements = gcontext.GroupRowSamples(columnDescriptors, topContainer);
        var rowElements = [];
        var completeRowSamplesId = 0;
        for (var rowId = 0; rowId < rowSampleElements.length; ++rowId) {
            var crtRowSampleElems = rowSampleElements[rowId];
            if (crtRowSampleElems.length < columnDescriptors.length) {
                continue;
            }
            completeRowSamplesId = rowId;
            var rowElement = gcontext.GetCommonParentOfElems(crtRowSampleElems);
            rowElements.push(rowElement);
            gcontext.TraceMessage("ExtractMetada: Found row element id: " + rowElements.length);
            gcontext.TraceMessage(rowElement);
        }
        if (rowElements.length === 0) {
            gcontext.TraceMessage("Not enough samples to determine a complete row");
            throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.NeedMoreSamples);
        }
        if (rowElements.length < 2) {
            var lastColumnSample = rowSampleElements[completeRowSamplesId][columnDescriptors.length - 1];
            gcontext.SearchMoreRowElements(rowSampleElements, rowElements, topContainer, lastColumnSample, columnDescriptors.length);
        }
        var rowPaths = [];
        for (var rowId = 0; rowId < rowElements.length; ++rowId) {
            if (!topContainer.contains(rowElements[rowId])) {
                gcontext.TraceMessage("ExtractMetadata: row id: " + rowId + "is not valid");
                gcontext.TraceMessage(rowElements[rowId]);
                throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.UncorrelatedSamples);
            }
            var rowPath = gcontext.GetElemPathToParent(rowElements[rowId], topContainer);
            rowPaths.push(rowPath);
            gcontext.TraceMessage("ExtractMetada: Path for row id: " + rowId + " is: " + JSON.stringify(rowPath));
        }
        var commonRowPath = gcontext.GetCommonPath(rowPaths);
        gcontext.TraceMessage("ExtractMetada: Common row path is: " + JSON.stringify(commonRowPath));
        if (commonRowPath === null) {
            throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.UncorrelatedSamples);
        }
        var rowsInfo = {
            rowElements: rowElements,
            rowSampleElements: rowSampleElements,
            commonRowPath: commonRowPath
        };
        return rowsInfo;
    };
    gcontext.GetColumnPathFromMultipleSamples = function (columnSampleElems, topContainer) {
        var samplePaths = [];
        for (var elementId = 0; elementId < columnSampleElems.length; ++elementId) {
            if (!topContainer.contains(columnSampleElems[elementId])) {
                gcontext.TraceMessage("ExtractMetadata: sample element id: " + elementId + "is not valid");
                gcontext.TraceMessage(columnSampleElems[elementId]);
                throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.UncorrelatedSamples);
            }
            var path = gcontext.GetElemPathToParent(columnSampleElems[elementId], topContainer);
            samplePaths.push(path);
        }

        return gcontext.GetCommonPath(samplePaths);
    };
    gcontext.GetColumnPathFromOneSample = function (sampleElement, rowsInfo) {
        var rowElement = null;
        for (var rowId = 0; rowId < rowsInfo.rowElements.length; ++rowId) {
            if (rowsInfo.rowElements[rowId].contains(sampleElement)) {
                rowElement = rowsInfo.rowElements[rowId];
                break;
            }
        }
        if (rowElement == null) {
            gcontext.TraceMessage("Could not find corresponding row element for sample: ");
            gcontext.TraceMessage(sampleElement);
            throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.Fail);
        }
        var path = gcontext.GetElemPathToParent(sampleElement, rowElement);
        var commonPath = rowsInfo.commonRowPath.path.concat(path);
        return {
            "path": commonPath,
            "exact": rowsInfo.commonRowPath.exact
        };
    };
    gcontext.GroupRowSamples = function (columnDescriptors, topContainer) {
        var firstColElements = columnDescriptors[0].elements;
        var maxNoOfRowsToCompute = 500;
        var maxRowNo = Math.min(firstColElements.length, maxNoOfRowsToCompute);
        var rowSampleElements = [];
        for (var rowId = 0; rowId < maxRowNo; ++rowId) {
            rowSampleElements[rowId] = [firstColElements[rowId]];
        }
        for (var columnId = 1; columnId < columnDescriptors.length; ++columnId) {
            var crtColumnSampleElems = columnDescriptors[columnId].elements;
            var maxSampleNo = Math.min(crtColumnSampleElems.length, maxNoOfRowsToCompute);
            var groupedSamplesNoPerRow = [];
            for (var rowId = 0; rowId < maxRowNo; ++rowId) {
                groupedSamplesNoPerRow[rowId] = 0;
            }
            for (var elementId = 0; elementId < maxSampleNo; ++elementId) {
                var crtSampleElem = crtColumnSampleElems[elementId];
                var minDepth = Number.MAX_VALUE;
                var crtSampleRowId = -1;
                for (var rowId = 0; rowId < maxRowNo; ++rowId) {
                    var commonParent = gcontext.GetCommonParentOfElems([crtSampleElem, firstColElements[rowId]]);
                    if ((topContainer !== commonParent) && topContainer.contains(commonParent)) {
                        var depth = gcontext.GetElementDepth(crtSampleElem, commonParent);
                        if (depth < minDepth) {
                            minDepth = depth;
                            crtSampleRowId = rowId;
                        } else if ((depth === minDepth) && (columnId !== (columnDescriptors.length - 1))) {
                            crtSampleRowId = -1;
                        }
                    }
                }
                if (crtSampleRowId !== -1) {
                    rowSampleElements[crtSampleRowId].push(crtSampleElem);
                    groupedSamplesNoPerRow[crtSampleRowId]++;
                    if (groupedSamplesNoPerRow[crtSampleRowId] >= 2) {
                        rowSampleElements[crtSampleRowId] = gcontext.FilterOutWrongSampleMapping(rowSampleElements[crtSampleRowId], topContainer);
                    }
                }
            }
        }
        return rowSampleElements;
    };
    gcontext.SearchMoreRowElements = function (rowSampleElements, rowElements, topContainer, lastColumnSample, columnsCount) {
        var completeRow = rowElements[0];
        var completeRowDepth = gcontext.GetElementDepth(completeRow, topContainer);
        var completeRowTag = completeRow.tagName.toLowerCase();
        var pathToLastColumn = gcontext.GetElemPathToParent(lastColumnSample, completeRow);
        var lastColumnSampleTag = lastColumnSample.tagName.toLowerCase();
        for (var rowId = 0; rowId < rowSampleElements.length; ++rowId) {
            var crtRowSampleElems = rowSampleElements[rowId];
            if (crtRowSampleElems.length >= columnsCount) {
                continue;
            }
            var rowElement = gcontext.GetCommonParentOfElems(crtRowSampleElems);
            var rowDepth = gcontext.GetElementDepth(rowElement, topContainer);
            var depthDiff = rowDepth - completeRowDepth;
            if (depthDiff > 0) {
                rowElement = gcontext.GetAncestorWithTag(rowElement, completeRowTag, depthDiff);
            }
            if (rowElement) {
                var allPossibleElems = gcontext.GetAllElemsByTag(rowElement, lastColumnSampleTag);
                for (var elementId = 0; elementId < allPossibleElems.length; ++elementId) {
                    var crntElem = allPossibleElems[elementId];
                    if (gcontext.CheckHierarchy(crntElem, rowElement, {
                        path: pathToLastColumn,
                        exact: true
                    })) {
                        rowElements.push(rowElement);
                        gcontext.TraceMessage("ExtractMetada: Found row element id: " + rowElements.length);
                        gcontext.TraceMessage(rowElement);
                        break;
                    }
                }
            }
        }
    };
    gcontext.SearchTopContainerAndSimilarElements = function (sampleElement) {
        var ancestor = sampleElement.parentElement;
        var foundSimilarElements = [sampleElement];
        var foundContainer = ancestor;
        var maxResults = 100;
        while (ancestor) {
            var path = gcontext.GetElemPathToParent(sampleElement, ancestor);
            delete path[0].index;
            var crtSimilarElements = gcontext.GetMatchingElements(ancestor, ancestor, [{path: path, exact: true}], maxResults);
            if (crtSimilarElements.length > foundSimilarElements.length) {
                foundSimilarElements = crtSimilarElements;
                foundContainer = ancestor;
                if (maxResults === foundSimilarElements.length) {
                    break;
                }
            }
            ancestor = ancestor.parentElement;
        }
        return {
            topContainer: foundContainer,
            similarElements: foundSimilarElements
        };
    };
    gcontext.SearchSimilarElements = function (sampleElements) {
        var similarElements = [];
        return similarElements;
    };
    gcontext.OwnText = function (e) {
        var trim = function (text) {
            return text.replace(/^\s+|\s+$/g, "");
        };
        var n = e.firstChild;
        var t = "";
        while (n) {
            if (n.nodeType === 3) {
                t += n.nodeValue;
            }
            n = n.nextSibling;
        }
        return trim(t);
    };
    gcontext.GetChildrenByTag = function (e, t) {
        t = t.toLowerCase();
        var children = e.children;
        if (typeof children.tags !== "undefined") {
            return children.tags(t);
        } else {
            var result = [];
            for (var c = 0; c < children.length; ++c) {
                if (children[c].tagName.toLowerCase() === t) {
                    result.push(children[c]);
                }
            }
            return result;
        }
    };
    gcontext.IndexInParent = function (elem, columnData, topContainer) {
        var parent = elem.parentElement;
        var children = gcontext.GetChildrenByTag(parent, elem.tagName);
        var copyColumnData = {
            tag: columnData.tag
        };
        if (columnData.cls) {
            copyColumnData.cls = columnData.cls;
        }
        if (columnData.cssSelector) {
            copyColumnData.cssSelector = columnData.cssSelector;
        }
        if (columnData.text) {
            copyColumnData.text = columnData.text;
        }
        var index = 0;
        for (var c = 0; c < children.length; ++c) {
            var crntChild = children[c];
            if (gcontext.IsSameNode(elem, crntChild)) {
                break;
            }
            if (gcontext.CheckElemData(crntChild, copyColumnData, topContainer)) {
                index++;
            }
        }
        return index;
    };
    gcontext.CheckElemData = function (elem, columnData, topContainer) {
        if (elem.tagName.toLowerCase() !== columnData.tag) {
            return false;
        }
        if (columnData.cls && (columnData.cls !== elem.className)) {
            return false;
        }
        if (columnData.cssSelector) {
            var candidates = topContainer.querySelectorAll(columnData.cssSelector);
            var found = false;
            for (var it = 0; it < candidates.length; it++) {
                if (candidates[it] === elem) {
                    found = true;
                }
            }
            if (found === false) {
                return false;
            }
        }
        if (columnData.text && (columnData.text !== gcontext.OwnText(elem))) {
            return false;
        }
        if ((typeof (columnData.index) !== "undefined") && (columnData.index !== gcontext.IndexInParent(elem, columnData, topContainer))) {
            return false;
        }
        return true;
    };
    gcontext.IsSameNode = function (e1, e2) {
        if (typeof e1.sourceIndex !== "undefined") {
            return (e1.sourceIndex === e2.sourceIndex);
        } else if (typeof e1.isSameNode !== "undefined") {
            return e1.isSameNode(e2);
        } else {
            return e1 === e2;
        }
    };
    gcontext.GetAllElemsByTagFallback = function (c, t) {
        var result = c.getElementsByTagName(t);
        try {
            result.length;
        } catch (e) {
            allDescendants = c.getElementsByTagName("*");
            if (typeof allDescendants === "undefined") {
                return [];
            }
            result = [];
            var index;
            for (index = 0; index < allDescendants.length; index++) {
                var currentTagName = gcontext.TryGetAttributeLowercase(allDescendants[index], "tagName");
                if (currentTagName === t.toLowerCase()) {
                    result.push(allDescendants[index]);
                }
            }
        }
        return result;
    };
    gcontext.GetCommonPath = function (paths) {
        for (var pathId = 0; pathId < paths.length; ++pathId) {
            if (paths[pathId].length === 0) {
                return null;
            }
        }
        var commonData = function (dataArray) {
            for (var dataId = 1; dataId < dataArray.length; ++dataId) {
                if (dataArray[dataId].tag !== dataArray[0].tag) {
                    return null;
                }
            }
            var data = {
                tag: dataArray[0].tag
            };
            var addText = true;
            for (var dataId = 1; dataId < dataArray.length; ++dataId) {
                if (dataArray[dataId].text !== dataArray[0].text) {
                    addText = false;
                    break;
                }
            }
            if (addText && dataArray[0].text) {
                data.text = dataArray[0].text;
            }
            if (addText) {
                var addIdx = true;
                for (var dataId = 1; dataId < dataArray.length; ++dataId) {
                    if (dataArray[dataId].index !== dataArray[0].index) {
                        addIdx = false;
                        break;
                    }
                }
                if (addIdx) {
                    data.index = dataArray[0].index;
                }
            }
            return data;
        };
        var patternElementsData = [];
        for (var pathId = 0; pathId < paths.length; ++pathId) {
            var data = paths[pathId].pop();
            patternElementsData.push(data);
        }
        var lastCd = commonData(patternElementsData);
        if (!lastCd) {
            throw new gcontext.DataScrapingException(gcontext.DataScrapingRetCode.CannotFindPattern);
        }
        var minPathLen = paths[0].length;
        for (var pathId = 1; pathId < paths.length; ++pathId) {
            if (paths[pathId].length < minPathLen) {
                minPathLen = paths[pathId].length;
            }
        }
        var common = [];
        for (var i = 0; i < minPathLen; ++i) {
            var dataArray = [];
            for (var pathId = 0; pathId < paths.length; ++pathId) {
                dataArray.push(paths[pathId][i]);
            }
            var cd = commonData(dataArray);
            if (cd) {
                common.push(cd);
            } else {
                break;
            }
        }
        common.push(lastCd);
        var sameLength = true;
        for (var pathId = 1; pathId < paths.length; ++pathId) {
            if (paths[pathId].length !== paths[0].length) {
                sameLength = false;
                break;
            }
        }
        var exact = false;
        if (sameLength && ((common.length - 1) === paths[0].length)) {
            exact = true;
        }
        return {
            "path": common,
            "exact": exact
        };
    };
    gcontext.GetElemPathToParent = function (e, p) {
        var indexInParent = function (elem, elemData) {
            var matchData = function (elemData, childData) {
                if (elemData.text && (elemData.text !== childData.text)) {
                    return false;
                }
                return true;
            };
            var parent = elem.parentElement;
            var children = gcontext.GetChildrenByTag(parent, elem.tagName);
            var index = 0;
            for (var c = 0; c < children.length; ++c) {
                var crntChild = children[c];
                if (gcontext.IsSameNode(elem, crntChild)) {
                    break;
                }
                var childData = getElemData(crntChild);
                if (matchData(elemData, childData)) {
                    index++;
                }
            }
            return index;
        };
        var getElemData = function (e, noText) {
            var elemData = {
                tag: e.tagName.toLowerCase()
            };
            if (!noText) {
                elemData.text = gcontext.OwnText(e);
            }
            return elemData;
        };
        var path = [];
        var noText = true;
        while (true) {
            if (gcontext.IsSameNode(e, p)) {
                break;
            }
            var d = getElemData(e, noText);
            noText = false;
            d.index = indexInParent(e, d);
            path.push(d);
            e = e.parentElement;
            if (!e) {
                break;
            }
        }
        path.reverse();
        return path;
    };
    gcontext.GetCommonParentOfElems = function (elems) {
        var parentsList = function (e) {
            if (!e) {
                return [];
            }
            var plist = [];
            while (true) {
                e = e.parentElement;
                if (!e) {
                    break;
                }
                plist.push(e);
            }
            plist.reverse();
            return plist;
        };
        var pls = [];
        var minLen = 1000000;
        for (var e = 0; e < elems.length; ++e) {
            var pl = parentsList(elems[e]);
            pls.push(pl);
            if (minLen > pl.length) {
                minLen = pl.length;
            }
        }
        var comnPrnt = null;
        var i = 0;
        while (i < minLen) {
            var crntPrnt = pls[0][i];
            var exitWhile = false;
            for (var pl = 0; pl < pls.length; ++pl) {
                if (!gcontext.IsSameNode(crntPrnt, pls[pl][i])) {
                    exitWhile = true;
                    break;
                }
            }
            if (exitWhile) {
                break;
            }
            comnPrnt = crntPrnt;
            i += 1;
        }
        return comnPrnt;
    };
    gcontext.SkipFormating = function (n) {
        var t = n.tagName.toLowerCase();
        if ((t === "b") || (t === "u") || (t === "i") || (t === "strong") || (t === "font") || (t === "em")) {
            n = n.parentElement;
        }
        return n;
    };
    gcontext.ElementsHaveSameTag = function (elements) {
        if (!elements || elements.length === 0) {
            return true;
        }
        var firstTagName = elements[0].tagName.toLowerCase();
        for (var elementId = 1; elementId < elements.length; ++elementId) {
            if (firstTagName !== elements[elementId].tagName.toLowerCase()) {
                return false;
            }
        }
        return true;
    };
    gcontext.GetElementDepth = function (element, ancestor) {
        var depth = 0;
        while (ancestor != element) {
            element = element.parentElement;
            if (!element && ancestor) {
                return -1;
            }
            depth++;
        }
        return depth;
    };
    gcontext.GetAncestorWithTag = function (element, ancestorTag, maxLevel) {
        var foundAncestor = null;
        while (element && (maxLevel >= 0)) {
            if (element.tagName.toLowerCase() === ancestorTag) {
                foundAncestor = element;
            }
            element = element.parentElement;
            maxLevel--;
        }
        return foundAncestor;
    };
    gcontext.LevelUpSampleElements = function (sampleElements) {
        var minElemDepth = Number.MAX_VALUE;
        var minElemTag = null;
        var elementDepths = [];
        for (var sampleId = 0; sampleId < sampleElements.length; ++sampleId) {
            var depth = gcontext.GetElementDepth(sampleElements[sampleId]);
            elementDepths[sampleId] = depth;
            if (depth < minElemDepth) {
                minElemDepth = depth;
                minElemTag = sampleElements[sampleId].tagName.toLowerCase();
            }
        }
        for (var sampleId = 0; sampleId < sampleElements.length; ++sampleId) {
            var depthDiff = elementDepths[sampleId] - minElemDepth;
            if (depthDiff > 0) {
                var ancestorWithSameTag = gcontext.GetAncestorWithTag(sampleElements[sampleId], minElemTag, depthDiff);
                if (ancestorWithSameTag) {
                    sampleElements[sampleId] = ancestorWithSameTag;
                }
            }
        }
    };
    gcontext.FilterOutWrongSampleMapping = function (rowSampleElements, topContainer) {
        var sample1 = rowSampleElements.pop();
        var sample2 = rowSampleElements.pop();
        gcontext.TraceMessage("ExtractMetada: One of these samples are incorrectly grouped:");
        gcontext.TraceMessage(sample1);
        gcontext.TraceMessage(sample2);
        var rowSamples1 = rowSampleElements.concat([sample1]);
        var rowSamples2 = rowSampleElements.concat([sample2]);
        var commonParent1 = gcontext.GetCommonParentOfElems(rowSamples1);
        var commonParent2 = gcontext.GetCommonParentOfElems(rowSamples2);
        gcontext.TraceMessage("ExtractMetada: Common parent candidates:");
        gcontext.TraceMessage(commonParent1);
        gcontext.TraceMessage(commonParent2);
        var depth1 = gcontext.GetElementDepth(commonParent1, topContainer);
        var depth2 = gcontext.GetElementDepth(commonParent2, topContainer);
        gcontext.TraceMessage("ExtractMetada: Incorrectly grouped sample:");
        gcontext.TraceMessage((depth1 < depth2) ? sample1 : sample2);
        return (depth1 < depth2) ? rowSamples2 : rowSamples1;
    };
    gcontext.GetAncestryUpToTagOrCustomId = function (targetElem, tagToReach, relativeAncestorCustomId) {
        function Result(nextInterestingAncestor, hasReachedRelativeAncestor, intermediateAncestors) {
            return {
                nextInterestingAncestor: nextInterestingAncestor,
                hasReachedRelativeAncestor: hasReachedRelativeAncestor,
                intermediateAncestors: intermediateAncestors
            };
        }

        if (targetElem == null) {
            return null;
        }
        var out_nextInterestingAncestor = null;
        var out_hasReachedCustomId = false;
        var out_intermediateAncestors = [];
        gcontext.ForEachAncestor(targetElem, function (crtAncestor) {
            if (relativeAncestorCustomId != null && relativeAncestorCustomId !== "") {
                var crtAncestorId = gcontext.GetCustomIdForElement(crtAncestor);
                if (crtAncestorId == relativeAncestorCustomId) {
                    out_nextInterestingAncestor = crtAncestor;
                    out_hasReachedCustomId = true;
                    return false;
                }
            }
            if (tagToReach != null && tagToReach !== "") {
                var crtAncestorTag = crtAncestor.tagName.toLowerCase();
                if (crtAncestorTag === tagToReach) {
                    out_nextInterestingAncestor = crtAncestor;
                    return false;
                }
            }
            if (crtAncestor.shadowRoot && targetElem && targetElem.getRootNode() === crtAncestor.shadowRoot) {
                out_nextInterestingAncestor = crtAncestor;
                return false;
            }
            out_intermediateAncestors.push(crtAncestor);
            return true;
        });
        return Result(out_nextInterestingAncestor, out_hasReachedCustomId, out_intermediateAncestors);
    };
    gcontext.GetInterestingHierarchyForSelector = function (targetElem, relativeAncestorCustomId) {
        var out_result = null;
        var tagName = targetElem.tagName.toLowerCase();
        if (tagName === "td" || tagName === "th" || tagName === "tr") {
            out_result = gcontext.GetAncestryUpToTagOrCustomId(targetElem, "table", relativeAncestorCustomId);
        } else if (tagName === "option") {
            out_result = gcontext.GetAncestryUpToTagOrCustomId(targetElem, "select", relativeAncestorCustomId);
        } else {
            out_result = gcontext.GetAncestryUpToTagOrCustomId(targetElem, null, relativeAncestorCustomId);
        }
        if (out_result == null) {
            return null;
        }
        out_result.nextInterestingAncestorId = (out_result.nextInterestingAncestor != null ? gcontext.GenerateCustomIdForElement(out_result.nextInterestingAncestor) : "");
        return out_result;
    };
    gcontext.GetSessionAttributeName = function (sessionId, attrName) {
        return "rpa-data-session-" + attrName + "-" + sessionId;
    };
    gcontext.HasSessionAttribute = function (crntElem, sessionId, attrName) {
        if (crntElem.nodeType !== gcontext.DOM_NodeType.Element) return false;
        var attrNode = crntElem.getAttribute(gcontext.GetSessionAttributeName(sessionId, attrName));
        if (attrNode !== null && attrNode !== "") {
            return true;
        }
        return false;
    };
    gcontext.SetSessionAttribute = function (crntElem, sessionId, attrName) {
        crntElem.setAttribute(gcontext.GetSessionAttributeName(sessionId, attrName), "true");
    }
});


WrapInGlobalContext(function () {
    var gcontext = this;
    gcontext.GetVersion = function () {
        return '2021.1.0';
    }
});
